(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    962566,      20336]
NotebookOptionsPosition[    959480,      20230]
NotebookOutlinePosition[    960345,      20260]
CellTagsIndexPosition[    960302,      20257]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[StyleBox["SciDraw examples: Tutorials",
 FontFamily->"Times New Roman",
 FontSize->36]], "Text",
 CellChangeTimes->{{3.4912582924375*^9, 3.4912582936875*^9}, {
  3.4912586879375*^9, 3.49125868853125*^9}, {3.4990222156875*^9, 
  3.499022216765625*^9}, {3.51812290828125*^9, 3.518122909421875*^9}, {
  3.5197650775625*^9, 3.519765079140625*^9}, {3.52094678934375*^9, 
  3.520946790578125*^9}, {3.567028496327821*^9, 3.567028497435423*^9}},
 FontSize->10],

Cell[TextData[{
 StyleBox["M. A. Caprio, ", "SmallText",
  FontFamily->"Times New Roman",
  FontSize->12],
 "Department of Physics, University of Notre Dame\nrev.July 28, 2013"
}], "Text",
 CellChangeTimes->{{3.39552255203125*^9, 3.3955225581875*^9}, {
   3.396878383875*^9, 3.39687838403125*^9}, 3.397586352671875*^9, {
   3.39854548165625*^9, 3.398545486203125*^9}, {3.430247945015625*^9, 
   3.430247947875*^9}, {3.436820309328125*^9, 3.436820313328125*^9}, {
   3.443996368375*^9, 3.443996375046875*^9}, {3.47108965090625*^9, 
   3.471089655984375*^9}, {3.49722506396875*^9, 3.4972250644375*^9}, {
   3.566683046623477*^9, 3.566683046888677*^9}, {3.566926106442788*^9, 
   3.5669261066299887`*^9}, {3.5670285025210314`*^9, 
   3.5670285026146317`*^9}, {3.5840542280856085`*^9, 3.5840542291308107`*^9}}],

Cell[CellGroupData[{

Cell["Package initialization", "Section"],

Cell[TextData[{
 "If you have not already loaded the SciDraw package since starting this ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " session, you must do so now.  See the user guide for information first on \
installing the package and then on loading it at the beginning of each ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " session."
}], "Text",
 CellChangeTimes->{{3.4921245209375*^9, 3.492124756234375*^9}, {
  3.492124799609375*^9, 3.492124838453125*^9}, {3.495659733515625*^9, 
  3.495659808359375*^9}, {3.5181229165*^9, 3.51812291978125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", "\"\<SciDraw`\>\"", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.492124284765625*^9, 3.49212429721875*^9}, 
   3.492124551328125*^9, {3.51812292428125*^9, 3.51812292534375*^9}}],

Cell[BoxData[
 FrameBox[
  TemplateBox[{TagBox[
     GridBox[{{
        StyleBox[
         TemplateBox[{
           StyleBox[
           "\"\[ScriptCapitalS]\[ScriptC]\[ScriptI]\[ScriptCapitalD]\[ScriptR]\
\[ScriptA]\[ScriptW]:\"", StripOnInput -> False, FontFamily -> "Times", 
            FontWeight -> "Bold"], 
           "\" Publication\[Dash]quality scientific figures with \
Mathematica\""}, "RowDefault"], StripOnInput -> False, FontFamily -> 
         "Courier"]}, {
        StyleBox[
        "\"M. A. Caprio, University of Notre Dame\"", StripOnInput -> False, 
         FontFamily -> "Courier"]}, {
        StyleBox[
        "\"Version 0.0.0 (November 24, 2013)\"", StripOnInput -> False, 
         FontFamily -> "Courier"]}, {
        RowBox[{
          ButtonBox[
           StyleBox[
            RowBox[{"View", " ", "color", " ", "palette"}], FontFamily -> 
            "Times"], Active -> True, Appearance -> {Automatic, "DialogBox"}, 
           ButtonFunction :> (NamedColors`NamedColorPalette[]& ), ButtonNote -> 
           "Named color palette", Evaluator -> Automatic, ImageSize -> 
           Automatic], 
          TagBox[
           ButtonBox[
            StyleBox[
             RowBox[{"Visit", " ", "home", " ", "page"}], FontFamily -> 
             "Times"], Active -> True, Appearance -> {Automatic, "DialogBox"},
             ButtonData :> {
              URL["http://scidraw.nd.edu/landing/scidraw-0.0.0.html"], None}, 
            ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
            "http://scidraw.nd.edu/landing/scidraw-0.0.0.html", ImageSize -> 
            Automatic], DisplayForm]}]}}, 
      GridBoxAlignment -> {
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}}], DisplayForm],"\"  \"",GraphicsBox[{{{
        FaceForm[None], 
        RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
        InsetBox[
         GraphicsBox[{
           EdgeForm[None], 
           FaceForm[
            RGBColor[1., 0.894101, 0.709799]], 
           RectangleBox[{0., 0.}, {93.1764705882353, 72.}]}, Frame -> False, 
          ImageSize -> {95.1764705882353, 74.}, 
          PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0, 
         0}]}, {
        FaceForm[None], 
        RectangleBox[{0., 0.}, {93.1764705882353, 72.}], 
        InsetBox[
         GraphicsBox[{{
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             GraphicsBox[{{
                GrayLevel[0], 
                AbsoluteThickness[1], 
                Dashing[{}], 
                CapForm[None], 
                JoinForm[{"Miter", 3.25}], 
                
                LineBox[{{14.782805429864256`, 46.24615384615386}, {
                 43.58047834518423, 46.24615384615386}}]}, {
                GrayLevel[0], 
                AbsoluteThickness[1], 
                Dashing[{}], 
                CapForm[None], 
                JoinForm[{"Miter", 3.25}], 
                
                LineBox[{{20.54234001292825, 36.150000000000006`}, {
                 23.54234001292825, 36.150000000000006`}, {25.54234001292825, 
                 32.400000000000006`}, {44.34001292824823, 
                 32.400000000000006`}, {46.34001292824823, 
                 36.150000000000006`}, {49.34001292824823, 
                 36.150000000000006`}}]}, {
                GrayLevel[0], 
                AbsoluteThickness[1], 
                Dashing[{}], 
                CapForm[None], 
                JoinForm[{"Miter", 3.25}], 
                
                LineBox[{{26.301874595992246`, 18.553846153846155`}, {
                 55.099547511312224`, 18.553846153846155`}}]}, {
                EdgeForm[{
                  GrayLevel[0], 
                  AbsoluteThickness[1], 
                  Dashing[{}], 
                  CapForm[None], 
                  JoinForm[{"Miter", 3.25}]}], 
                FaceForm[
                 GrayLevel[0.5]], 
                
                PolygonBox[{{34.418791692075665`, 46.24615384615386}, {
                 29.704026666036818`, 46.24615384615386}, {
                 37.415840042594645`, 33.886479882377664`}, {
                 36.90680088862935, 33.568865116143016`}, {
                 40.700711053652235`, 32.400000000000006`}, {
                 41.31847355632861, 36.321526423509994`}, {40.80943440236331, 
                 36.00391165727534}}]}, {
                EdgeForm[{
                  GrayLevel[0], 
                  AbsoluteThickness[1], 
                  Dashing[{}], 
                  CapForm[None], 
                  JoinForm[{"Miter", 3.25}]}], 
                FaceForm[
                 GrayLevel[0.5]], 
                
                PolygonBox[{{32.97890804630967, 32.400000000000006`}, {
                 28.26414302027082, 32.400000000000006`}, {35.97595639682864, 
                 20.040326036223817`}, {35.466917242863346`, 
                 19.722711269989166`}, {39.26082740788623, 
                 18.553846153846155`}, {39.87858991056261, 
                 22.47537257735614}, {39.369550756597306`, 
                 22.157757811121492`}}]}}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{0., 0.}, {93.17647058823529, 72.}], 
            InsetBox[
             GraphicsBox[{{
                EdgeForm[None], 
                FaceForm[
                 RGBColor[0.5, 0.539994, 0.53]], 
                PolygonBox[CompressedData["
1:eJx13Xk0F9//B3B7CG1SSqgkpCxFRZpRoYVIUrQoaaNFIoqkQiupT4lKpLK0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                 "]]}, {
                RGBColor[1, 0, 0], 
                AbsoluteThickness[1], 
                Dashing[{}], 
                CapForm[None], 
                JoinForm[{"Miter", 3.25}], 
                LineBox[CompressedData["
1:eJx13XlUD9//B/B2lcpSIlIhSaKFQslMqCylJGlBJFtZkiJKQmUt8VEKKSFl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                 "]]}}, Frame -> False, ImageSize -> {93.17647058823529, 72.},
               PlotRange -> {{0., 93.17647058823529}, {0., 72.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, 
           InsetBox[
            FrameBox[
             StyleBox[
              StyleBox[
               TagBox[
               "\"\[ScriptCapitalS]\[ScriptC]\[ScriptI]\[ScriptCapitalD]\
\[ScriptR]\[ScriptA]\[ScriptW]\"", DisplayForm], StripOnInput -> False, 
               ShowAutoStyles -> False, SingleLetterItalics -> False, 
               FontFamily -> "Times", FontSize -> 14.5, FontWeight -> Bold, 
               FontSlant -> Plain, FontTracking -> "Extended"], StripOnInput -> 
              False, ShowContents -> False], Background -> None, 
             ContentPadding -> False, FrameMargins -> {{0, 0}, {0, 0}}, 
             FrameStyle -> None, RoundingRadius -> {0, 0}, StripOnInput -> 
             False], {4.658823529411765, 64.8}, {-1, 1}, Automatic, {1, 0}], 
           InsetBox[
            FrameBox[
             StyleBox[
              TagBox[
              "\"\[ScriptCapitalS]\[ScriptC]\[ScriptI]\[ScriptCapitalD]\
\[ScriptR]\[ScriptA]\[ScriptW]\"", DisplayForm], StripOnInput -> False, 
              ShowAutoStyles -> False, SingleLetterItalics -> False, 
              FontFamily -> "Times", FontSize -> 14.5, FontWeight -> Bold, 
              FontSlant -> Plain, FontTracking -> "Extended"], Background -> 
             None, ContentPadding -> False, FrameMargins -> {{0, 0}, {0, 0}}, 
             FrameStyle -> None, RoundingRadius -> {0, 0}, StripOnInput -> 
             False], {4.658823529411765, 64.8}, {-1, 1}, Automatic, {1, 0}]}, 
          Frame -> False, ImageSize -> {93.1764705882353, 72.}, 
          PlotRange -> {{0., 93.1764705882353}, {0., 72.}}], {0, 0}, {0, 
         0}]}, {
        FaceForm[None], 
        RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
        InsetBox[
         GraphicsBox[{}, Frame -> False, ImageSize -> {95.1764705882353, 74.},
           PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0, 
         0}]}, {
        FaceForm[None], 
        RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
        InsetBox[
         GraphicsBox[{{
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{0., 0.}, {0., 72.}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{}, {}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{93.1764705882353, 0.}, {93.1764705882353, 72.}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{}, {}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{0., 0.}, {93.1764705882353, 0.}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{}, {}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{0., 72.}, {93.1764705882353, 72.}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{}, {}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}]}}, Frame -> False, 
          ImageSize -> {95.1764705882353, 74.}, 
          PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0, 
         0}]}}, {}}, AspectRatio -> 0.7775030902348578, Background -> None, 
     DisplayFunction -> Identity, Frame -> False, 
     ImageSize -> {95.1764705882353, 74.}, 
     PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}]},
   "RowDefault"],
  Background->GrayLevel[0.85],
  FrameMargins->10,
  FrameStyle->None,
  StripOnInput->False]], "Print",
 CellChangeTimes->{
  3.5836975247152205`*^9, 3.5836975855053053`*^9, {3.5836978099906197`*^9, 
   3.5836978300456476`*^9}, {3.5836980407155433`*^9, 
   3.5836980640005755`*^9}, {3.594306312365898*^9, 3.5943063176659055`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Tutorial 1: A plot of Bessel functions \
\>", "Section",
 CellChangeTimes->{3.567028608757218*^9}],

Cell[CellGroupData[{

Cell["Main example figure", "Subsection",
 CellChangeTimes->{{3.5670286165104313`*^9, 3.5670286180236344`*^9}, {
  3.5670382083628836`*^9, 3.5670382091928844`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"panel", " ", "label"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"FigLabel", "[", 
        RowBox[{
         RowBox[{"Scaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.2", ",", "0.85"}], "}"}], "]"}], ",", 
         RowBox[{"Subscript", "[", 
          RowBox[{
           RowBox[{"textit", "[", "\"\<J\>\"", "]"}], ",", "\"\<\[Nu]\>\""}], 
          "]"}], ",", 
         RowBox[{"FontSize", "\[Rule]", "15"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"horizontal", " ", "rule"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"FigRule", "[", 
        RowBox[{"Horizontal", ",", "0", ",", "All"}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "plots", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"FigGraphics", "[", 
        RowBox[{"Plot", "[", 
         RowBox[{
          RowBox[{"BesselJ", "[", 
           RowBox[{"0", ",", "x"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "0", ",", "20"}], "}"}], ",", 
          RowBox[{"PlotStyle", "\[Rule]", "Firebrick"}]}], "]"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"FigGraphics", "[", 
        RowBox[{"Plot", "[", 
         RowBox[{
          RowBox[{"BesselJ", "[", 
           RowBox[{"1", ",", "x"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "0", ",", "20"}], "}"}], ",", 
          RowBox[{"PlotStyle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Firebrick", ",", "Dashed"}], "}"}]}]}], "]"}], "]"}], 
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"inset", " ", "panel"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"panel", " ", "label"}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"FigLabel", "[", 
            RowBox[{
             RowBox[{"Scaled", "[", 
              RowBox[{"{", 
               RowBox[{"0.2", ",", "0.85"}], "}"}], "]"}], ",", 
             RowBox[{"Subscript", "[", 
              RowBox[{
               RowBox[{"textit", "[", "\"\<Y\>\"", "]"}], ",", 
               "\"\<\[Nu]\>\""}], "]"}], ",", 
             RowBox[{"FontSize", "\[Rule]", "12"}]}], "]"}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"horizontal", " ", "rule"}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"FigRule", "[", 
            RowBox[{"Horizontal", ",", "0", ",", "All"}], "]"}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", "plots", " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"FigGraphics", "[", 
            RowBox[{"Plot", "[", 
             RowBox[{
              RowBox[{"BesselY", "[", 
               RowBox[{"0", ",", "x"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"x", ",", "0", ",", "20"}], "}"}], ",", 
              RowBox[{"PlotStyle", "\[Rule]", "Firebrick"}]}], "]"}], "]"}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"FigGraphics", "[", 
            RowBox[{"Plot", "[", 
             RowBox[{
              RowBox[{"BesselY", "[", 
               RowBox[{"1", ",", "x"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"x", ",", "0", ",", "20"}], "}"}], ",", 
              RowBox[{"PlotStyle", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Firebrick", ",", "Dashed"}], "}"}]}]}], "]"}], "]"}],
            ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"PanelRegion", "->", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0.55", ",", "0.95"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0.55", ",", "0.95"}], "}"}]}], "}"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"XPlotRange", "->", 
          RowBox[{"{", 
           RowBox[{"0", ",", "20"}], "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"YPlotRange", "->", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.6"}], ",", "1.1"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"YTicks", "->", 
          RowBox[{"LinTicks", "[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1", ",", "0.5", ",", "5"}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"FontSize", "\[Rule]", "12"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Background", "\[Rule]", "LightGray"}]}], 
        "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"XPlotRange", "->", 
      RowBox[{"{", 
       RowBox[{"0", ",", "20"}], "}"}]}], ",", 
     RowBox[{"XFrameLabel", "->", 
      RowBox[{"textit", "[", "\"\<x\>\"", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"YPlotRange", "->", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.6"}], ",", "1.1"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"YTicks", "->", 
      RowBox[{"LinTicks", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1", ",", "0.5", ",", "5"}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"FontSize", "\[Rule]", "15"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Background", "\[Rule]", "Moccasin"}]}], "\[IndentingNewLine]", 
    "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"CanvasSize", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"5", ",", "3.5"}], "}"}]}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.395095660953125*^9, 3.395095674*^9}, {
   3.395521201609375*^9, 3.395521219546875*^9}, {3.395521484265625*^9, 
   3.395521484265625*^9}, {3.5165608799375*^9, 3.516561289578125*^9}, {
   3.516561367203125*^9, 3.51656143996875*^9}, {3.5165615648125*^9, 
   3.51656159890625*^9}, {3.51656165578125*^9, 3.516561684609375*^9}, {
   3.516561736796875*^9, 3.51656176128125*^9}, {3.51656182196875*^9, 
   3.51656184021875*^9}, {3.516562109421875*^9, 3.516562176015625*^9}, {
   3.518120479046875*^9, 3.518120490453125*^9}, 3.518562728439125*^9, {
   3.5204484336875*^9, 3.52044843615625*^9}, 3.520448550328125*^9, 
   3.520448590953125*^9, {3.520448623734375*^9, 3.52044870559375*^9}, 
   3.5204487371875*^9, {3.5663380284029846`*^9, 3.5663380304465885`*^9}, {
   3.5663382102525043`*^9, 3.5663382784090242`*^9}, {3.5666831570648704`*^9, 
   3.5666831894037275`*^9}, {3.566683244128623*^9, 3.566683245064625*^9}, {
   3.566683290335904*^9, 3.5666833547328176`*^9}, {3.566684339205373*^9, 
   3.566684341061776*^9}, {3.5666886390420675`*^9, 3.5666886614374113`*^9}, {
   3.5667608876953278`*^9, 3.566760905005352*^9}, {3.566761579296296*^9, 
   3.5667615963663197`*^9}, {3.5667683037651644`*^9, 
   3.5667683344852076`*^9}, {3.566768377475268*^9, 3.56676847937541*^9}, {
   3.5669324752698116`*^9, 3.5669325148002815`*^9}, {3.5669356113299065`*^9, 
   3.566935615409912*^9}, {3.566938132947299*^9, 3.5669381367395163`*^9}, {
   3.566938583104047*^9, 3.566938587937323*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
      GraphicsBox[
       {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
        RectangleBox[{0., 0.}, {360., 252.}]},
       Frame->False,
       ImageSize->{504, 396.},
       PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {360., 252.}]}, InsetBox[
      GraphicsBox[{{
         {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
          GraphicsBox[
           {EdgeForm[None], FaceForm[GrayLevel[0.85]], 
            RectangleBox[{198.00000000000003`, 138.60000000000002`}, \
{342., 239.39999999999998`}]},
           Frame->False,
           ImageSize->{504, 396.},
           PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], 
          RectangleBox[{198.00000000000003`, 138.60000000000002`}, \
{342., 239.39999999999998`}]}, InsetBox[
          GraphicsBox[{
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{198.00000000000003`, 174.1764705882353}, {342., 
              174.1764705882353}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            GeometricTransformationBox[{{}, {}, 
              {RGBColor[0.698004, 0.133305, 0.133305], LineBox[CompressedData["
1:eJwVV3c8ld8ft0pG2SNZ17rCxb00UJ0PoYykoZCsykgRGjIaqIxklNXOyIqI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                "]]}}, {{{7.199999999999999, 0.}, {0., 59.29411764705879}}, {
              198.00000000000003`, 174.1764705882353}}], 
            GeometricTransformationBox[{{}, {}, 
              {RGBColor[0.698004, 0.133305, 0.133305], 
               Dashing[{Small, Small}], LineBox[CompressedData["
1:eJwVV3k81F8btSe7SrJvYxvbMLIU7pPiVxGllEoqyVoqKQrtKCEia1GWkrVk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                "]]}}, {{{7.199999999999999, 0.}, {0., 59.29411764705879}}, {
              198.00000000000003`, 174.1764705882353}}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox[
                 SubscriptBox[
                  TagBox[
                   StyleBox["\<\"Y\"\>",
                    FontSlant->"Italic"],
                   StyleForm[#, FontSlant -> "Italic"]& ], "\<\"\[Nu]\"\>"],
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->12,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {226.80000000000004`, 224.27999999999997`}, {0, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox[
                SubscriptBox[
                 TagBox[
                  StyleBox["\<\"Y\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ], "\<\"\[Nu]\"\>"],
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->12,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {226.80000000000004`, 224.27999999999997`}, {0, 0}, 
             Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{143.99999999999997`, 100.79999999999995`},
           
           PlotRange->{{198.00000000000003`, 342.}, {138.60000000000002`, 
            239.39999999999998`}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{504, 396.},
           PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
          GraphicsBox[{
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{198.00000000000003`, 138.60000000000002`}, {
              198.00000000000003`, 239.39999999999998`}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{198.61200000000002`, 138.60000000000002`}, {
              198.00000000000003`, 138.60000000000002`}}], 
             LineBox[{{199.22400000000002`, 144.5294117647059}, {
              198.00000000000003`, 144.5294117647059}}], 
             LineBox[{{198.61200000000002`, 150.4588235294118}, {
              198.00000000000003`, 150.4588235294118}}], 
             LineBox[{{198.61200000000002`, 156.38823529411766`}, {
              198.00000000000003`, 156.38823529411766`}}], 
             LineBox[{{198.61200000000002`, 162.31764705882355`}, {
              198.00000000000003`, 162.31764705882355`}}], 
             LineBox[{{198.61200000000002`, 168.24705882352941`}, {
              198.00000000000003`, 168.24705882352941`}}], 
             LineBox[{{199.22400000000002`, 174.1764705882353}, {
              198.00000000000003`, 174.1764705882353}}], 
             LineBox[{{198.61200000000002`, 180.1058823529412}, {
              198.00000000000003`, 180.1058823529412}}], 
             LineBox[{{198.61200000000002`, 186.03529411764706`}, {
              198.00000000000003`, 186.03529411764706`}}], 
             LineBox[{{198.61200000000002`, 191.96470588235294`}, {
              198.00000000000003`, 191.96470588235294`}}], 
             LineBox[{{198.61200000000002`, 197.8941176470588}, {
              198.00000000000003`, 197.8941176470588}}], 
             LineBox[{{199.22400000000002`, 203.8235294117647}, {
              198.00000000000003`, 203.8235294117647}}], 
             LineBox[{{198.61200000000002`, 209.75294117647059`}, {
              198.00000000000003`, 209.75294117647059`}}], 
             LineBox[{{198.61200000000002`, 215.68235294117645`}, {
              198.00000000000003`, 215.68235294117645`}}], 
             LineBox[{{198.61200000000002`, 221.61176470588234`}, {
              198.00000000000003`, 221.61176470588234`}}], 
             LineBox[{{198.61200000000002`, 227.54117647058823`}, {
              198.00000000000003`, 227.54117647058823`}}], 
             LineBox[{{199.22400000000002`, 233.4705882352941}, {
              198.00000000000003`, 233.4705882352941}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{342., 138.60000000000002`}, {342., 
              239.39999999999998`}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{341.388, 138.60000000000002`}, {342., 
              138.60000000000002`}}], 
             LineBox[{{340.776, 144.5294117647059}, {342., 
              144.5294117647059}}], 
             LineBox[{{341.388, 150.4588235294118}, {342., 
              150.4588235294118}}], 
             LineBox[{{341.388, 156.38823529411766`}, {342., 
              156.38823529411766`}}], 
             LineBox[{{341.388, 162.31764705882355`}, {342., 
              162.31764705882355`}}], 
             LineBox[{{341.388, 168.24705882352941`}, {342., 
              168.24705882352941`}}], 
             LineBox[{{340.776, 174.1764705882353}, {342., 
              174.1764705882353}}], 
             LineBox[{{341.388, 180.1058823529412}, {342., 
              180.1058823529412}}], 
             LineBox[{{341.388, 186.03529411764706`}, {342., 
              186.03529411764706`}}], 
             LineBox[{{341.388, 191.96470588235294`}, {342., 
              191.96470588235294`}}], 
             LineBox[{{341.388, 197.8941176470588}, {342., 
              197.8941176470588}}], 
             LineBox[{{340.776, 203.8235294117647}, {342., 
              203.8235294117647}}], 
             LineBox[{{341.388, 209.75294117647059`}, {342., 
              209.75294117647059`}}], 
             LineBox[{{341.388, 215.68235294117645`}, {342., 
              215.68235294117645`}}], 
             LineBox[{{341.388, 221.61176470588234`}, {342., 
              221.61176470588234`}}], 
             LineBox[{{341.388, 227.54117647058823`}, {342., 
              227.54117647058823`}}], 
             LineBox[{{340.776, 233.4705882352941}, {342., 
              233.4705882352941}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{198.00000000000003`, 138.60000000000002`}, {342., 
              138.60000000000002`}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{198.00000000000003`, 139.824}, {198.00000000000003`, 
              138.60000000000002`}}], 
             LineBox[{{205.20000000000002`, 139.21200000000002`}, {
              205.20000000000002`, 138.60000000000002`}}], 
             LineBox[{{212.40000000000003`, 139.21200000000002`}, {
              212.40000000000003`, 138.60000000000002`}}], 
             LineBox[{{219.60000000000002`, 139.21200000000002`}, {
              219.60000000000002`, 138.60000000000002`}}], 
             LineBox[{{226.8, 139.21200000000002`}, {226.8, 
              138.60000000000002`}}], 
             LineBox[{{234.00000000000003`, 139.824}, {234.00000000000003`, 
              138.60000000000002`}}], 
             LineBox[{{241.20000000000002`, 139.21200000000002`}, {
              241.20000000000002`, 138.60000000000002`}}], 
             LineBox[{{248.40000000000003`, 139.21200000000002`}, {
              248.40000000000003`, 138.60000000000002`}}], 
             LineBox[{{255.60000000000002`, 139.21200000000002`}, {
              255.60000000000002`, 138.60000000000002`}}], 
             LineBox[{{262.8, 139.21200000000002`}, {262.8, 
              138.60000000000002`}}], 
             LineBox[{{270., 139.824}, {270., 138.60000000000002`}}], 
             LineBox[{{277.20000000000005`, 139.21200000000002`}, {
              277.20000000000005`, 138.60000000000002`}}], 
             LineBox[{{284.40000000000003`, 139.21200000000002`}, {
              284.40000000000003`, 138.60000000000002`}}], 
             LineBox[{{291.6, 139.21200000000002`}, {291.6, 
              138.60000000000002`}}], 
             LineBox[{{298.8, 139.21200000000002`}, {298.8, 
              138.60000000000002`}}], 
             LineBox[{{306., 139.824}, {306., 138.60000000000002`}}], 
             LineBox[{{313.20000000000005`, 139.21200000000002`}, {
              313.20000000000005`, 138.60000000000002`}}], 
             LineBox[{{320.40000000000003`, 139.21200000000002`}, {
              320.40000000000003`, 138.60000000000002`}}], 
             LineBox[{{327.6, 139.21200000000002`}, {327.6, 
              138.60000000000002`}}], 
             LineBox[{{334.8, 139.21200000000002`}, {334.8, 
              138.60000000000002`}}], 
             LineBox[{{342., 139.824}, {342., 138.60000000000002`}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{198.00000000000003`, 239.39999999999998`}, {342., 
              239.39999999999998`}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{198.00000000000003`, 238.176}, {198.00000000000003`, 
              239.39999999999998`}}], 
             LineBox[{{205.20000000000002`, 238.78799999999998`}, {
              205.20000000000002`, 239.39999999999998`}}], 
             LineBox[{{212.40000000000003`, 238.78799999999998`}, {
              212.40000000000003`, 239.39999999999998`}}], 
             LineBox[{{219.60000000000002`, 238.78799999999998`}, {
              219.60000000000002`, 239.39999999999998`}}], 
             LineBox[{{226.8, 238.78799999999998`}, {226.8, 
              239.39999999999998`}}], 
             LineBox[{{234.00000000000003`, 238.176}, {234.00000000000003`, 
              239.39999999999998`}}], 
             LineBox[{{241.20000000000002`, 238.78799999999998`}, {
              241.20000000000002`, 239.39999999999998`}}], 
             LineBox[{{248.40000000000003`, 238.78799999999998`}, {
              248.40000000000003`, 239.39999999999998`}}], 
             LineBox[{{255.60000000000002`, 238.78799999999998`}, {
              255.60000000000002`, 239.39999999999998`}}], 
             LineBox[{{262.8, 238.78799999999998`}, {262.8, 
              239.39999999999998`}}], 
             LineBox[{{270., 238.176}, {270., 239.39999999999998`}}], 
             LineBox[{{277.20000000000005`, 238.78799999999998`}, {
              277.20000000000005`, 239.39999999999998`}}], 
             LineBox[{{284.40000000000003`, 238.78799999999998`}, {
              284.40000000000003`, 239.39999999999998`}}], 
             LineBox[{{291.6, 238.78799999999998`}, {291.6, 
              239.39999999999998`}}], 
             LineBox[{{298.8, 238.78799999999998`}, {298.8, 
              239.39999999999998`}}], 
             LineBox[{{306., 238.176}, {306., 239.39999999999998`}}], 
             LineBox[{{313.20000000000005`, 238.78799999999998`}, {
              313.20000000000005`, 239.39999999999998`}}], 
             LineBox[{{320.40000000000003`, 238.78799999999998`}, {
              320.40000000000003`, 239.39999999999998`}}], 
             LineBox[{{327.6, 238.78799999999998`}, {327.6, 
              239.39999999999998`}}], 
             LineBox[{{334.8, 238.78799999999998`}, {334.8, 
              239.39999999999998`}}], 
             LineBox[{{342., 238.176}, {342., 239.39999999999998`}}]}, 
            InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"-0.5\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 144.5294117647059}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 174.1764705882353}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.5\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 203.8235294117647}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"1.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 233.4705882352941}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\" 0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\" 5\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {234.00000000000003`, 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"10\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {270., 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"15\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {306., 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"20\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {342., 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"-0.5\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 144.5294117647059}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 174.1764705882353}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.5\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 203.8235294117647}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"1.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 233.4705882352941}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\" 0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\" 5\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {234.00000000000003`, 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"10\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {270., 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"15\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {306., 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"20\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {342., 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{504, 396.},
           PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 88.94117647058822}, {360., 88.94117647058822}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        GeometricTransformationBox[{{}, {}, 
          {RGBColor[0.698004, 0.133305, 0.133305], LineBox[CompressedData["
1:eJwVl3c81f8Xx8lI9ihlr2td4nJVSL1PohTfhtCSJFkhlYoSTSJKRWbJKpVR
skdv817XxbVXNIyMjIxk5vf5+cfj9fB5v895nfM85/Oh4HDB8twaNja2Zxxs
bP///cLfgVvHMW5n8L9V4mcSVbXIWxyV90Vss8dNxwi9Svt8V14+GA25Doh/
JLTg07wPvJ1PUW0z/5UDhH5RFibHJR+DvJ8H21f9m0Sak46PVp0T0DXhE92i
hO4VfPlvuSMJST6i9RusTCLS63VbF5dSUYm5vb/B8iRy33HF46/cWxR1kT1d
ZGkSfWr9njK7Ox3NC9V7VixMosXzFj1TzlmoRVKbYT4/iV6x9wT/Nf2IGhx7
SjPmJpFJ/RPluY5s9Cmm+eDw7CQajt5bPuuag3brH7uzND2JQh1XbGeWclHg
w+VjQ78nUcuSS8RvuULE+d/+NfvGJtFVuixl8mMRalzn3/t5ZBJJPmtlju8u
QYPcgx4CQ5PIgQwcv5wxko28VaH3YxKtWbrOmvUrQxtv3Xsi8HUStX63lpk1
LUcssxMauHsS+aTzFU53VKDee9s601sm0f6nP7mnX1WiPwuH54dZk0jap9xq
yrUKOW9xXFlhTqKy3dd+Ty5VowmFjy3ZlZNo7Zc+1XE5BkpZvRFm9nESdZaV
XhkbZiDjqJEsi/RJ9O51dOWvj7XodqrigvqbSXTg0oHTo7vrUN+TrSpe8ZPo
+bqi50POLHQb9nFr3p9EOdf2X7q8qRGFXAvwWfSfRPGj2yRm/BrRNl3jc0k+
k8izUdR52rQJOZtE9fqfn0Si8TVrpjqakeJxleTzByfRkmDeWy+jFsQjdmXX
WrNJNHA7+dDvVy2oqrAF+8EkynP2fznp2op6DpRG/KFMohNUPcOJpTZUGOy7
VV54EiXWJlz8JdeFxKi1f53oE2g2Opf8LbQL9VqYKbaWTKA9zsz+5oUuVLt1
5P2G7Ak0xvHXuqilG+lTSIbi8RNIf8cBw+CgHrTj6OygkOcEasxaXqM6+Q3t
PFFFX1o3gUTROjsBre9IunlXfNHyONquEmEY5Pgd+cnreR2cHEePZt/OXG/6
jpZUBR8utYwjvSdt5xze/0D9ekcb7ePGUUCt5n6d0/3oMV9w93XFcZT2MV/l
fWQ/0vXfzZMmOo6ao405lOv6Ucz1ae2MNeOI5HysZJPBAPp7NPsv6htDtRz3
tNjEBpHGt0GThwljSHzHF1EW7SdyFbGo7RQdQ5lZwV/ctUbRBz3cc7p3FI2K
jobuPzOKMgoiuam1o0j16v6dahGjaKdByPOhvFH0yogvsX9hFPXubvb983gU
PWWEOp2o/oVIgnKH02AUXe1/PLXXdhy9LN0i9DB+BCXwMe+KmP5Gmm7Rv63R
MHJGTTFjl2bQbrkRa3XDQcSWNFf05eEMOtAEEusVBlE0p3RPbcoMuhf9M+rX
2kFUw3CSfds+g+ZMDl4/0zaA1KyWk84ZzqJrmzPKPC4MoGEX1fSv7H+QqjRV
hvKqH7k9vfm5MXwOJf+3eynhzw/kOajen5O5gMbqaU6af3oQr8I91W/6bNCZ
rXktML4W1Rg90fY3ZYPnNV03b6nVosBjL7fJWLLB7sk9ds9yGGhNeMHek+fZ
QPXvdwZ3fQ1a/Dfm3PGCDfre5PIYrtLQrx7rNNYadsh3nBn3d61EddGq6mV1
7NAfcvrH29wC9EiYSU6054DjzNrFtWfv4MJtMrkHPDngLreQx7R7MB6wu4CW
b3CAlg77Cks/HG/PELM6GsUBuxuCgoK2ROHhfbY3BRo4wL1hTbVuUBLefXec
5budE14IugTwCX7A83+ErliKc0G+73Z1buFSrCTjsLqqxAWmBVtFDbtK8QGT
nOAMHS4I0N3dEpH4Gac+PfaS5z8uuHXb60XPxjJsqZ1I/3yXCyjk9zbMV+U4
w0VXUmOKCzZ3uIkZvqjCDl+sMEcdN9ztfhj/ZXst5o374XGxixsu5g6V8ofX
4uwTntLffnKDzUrWx/L+WszRHeRbxL4WLpF/LeQEM3FKZxH14ra1YLvcl53N
qsM/2+TTviathbQ2+ZW43Sz8KDLDxuLDWgh46aDW8JiFt1obchWVroWRG7Yn
/L6wcFDrEYfIzrVwfzb1fqp+I1ZrCZS2EOSBES+pYktmI3ZrHAsv9OUB2++N
b+b7m7BouC9SDeKBgVr1uE6uZlx0kHsiIoIHgprFD1xWbcZ8LDlzrywe+Kt0
W7/TtRmn11tyqQ7yAI++zeaTv5rxRG2Bb8ShdfB3wkdX/kcLfh5iqrbGbh3Y
XVTLiPrXgnfub26/cH4dKF2rNadLteLHjF9U88B1sG/G69wB61ZMqZGdYC9Z
BydOzu2er2rFF6vvOVxQ5YWzpXm5L5+3YdmBPdxzVF7g53zw9mtGG2auWffO
D3hhy+N8169VbVgZwqaCj/PCnmv9K9LTbbirKPJWykNeOG/tcjxiXzve9eH1
y65JXtiqfiDbdqwdTzS4GNsv8wI14dN8+Go7jhsn//zJwwf9x9+suSfagf+Q
szbPKvBBcZmZzuttHfhtan6JoBUf1L6Rp3f5d2CRuJru3QV8cF/97sIftk78
uTDEv7aKD3p170+KCHfi850Wioeb+CArZlx5TLYTV29ocrUb5YNXRz1Mv2zv
xL7hXfM+0vzQ21jAnXKpE6tkxcWvqvGDEGfHp48Bnbil/hQEbuGHboPeJzdD
O/Fmvr6gZwf4ISq3su9gaif+cX9UPPMWP8xem+b41tKJH6WkF+mF8QNX+2v7
r1878fZKT7viGH7Y7M7GFj/SiSPZZlJrsvnhMp+1hOW/TrzvxpJe/wA/rC82
tHlH6sJzMaWdrlP8MHlDxzF+cxdOLgjw+73CD6JHng5ZbO3CK384qlbEBSCg
OOfiyJ4u/NGL/8imfQIQ83jta5FzXbguVsw3w0YAGnnxzRD3LvyzSjLB2FEA
xBvF0/Iud2FJCfVf7gECYPUgeqv67S6st5sisiZMAKovXi+9ENSFD3ps2xYV
KwDbV873uIZ14XvlpnfLcwVg+mOUtm90F375y+KtTaUA/OOUCn30ogsXbLBi
/WoUAK73qOloUhduRif/3PoqAMrig+vbXnfhcVcHKfExAfA2jfPgft+FeSJc
d71fEIApj6TpX5ldWPGzlzOsFYTcxNHi+9ld2Gj4WljbekE4dUWsryW3C9uI
BnxyUxSEL8nn/dsLurCXUWDXqrYglH34/S6suAuHOIWtRuwQhBcPDtxZKO3C
KeERymRzQViV+yYnWdaFcVGcOT4mCHHC7xImy7tw90DSRSsnQcB6jrLXK7vw
rOC7qJHLgvBo14XCwqouLGjwsdT/tiCwn+56lFndhdXOFvSLPRaE6s+2pcdo
Xdg4DK97Gy8IxjqnHQsIbZtP0975ThCmCqaS6wl99Ue9dUu+IFhLN8ZHE/oJ
X9sNl2pBkLtq7yVB6PQtPYkrzYJQUpkNh4j7aaf76U+/C8LFS7coO4j434NH
x1UnBKFqVOPs94ouvPhpSqx0SRBMJMuWDYj813+dN7BcJwRVS5MK+3EX1uJh
sx8SFwJVWfF5YcK/me7aQD+SENiq66U+KurCZ20F00V0heDrmemDlfld2D9w
Q/NrJASd5AS5rJwuHP1Ben77f0JwLFDLyPIjwQ+nhomTixBwCP/79/ktwY+W
rtvSFSFwZp6af5DahdmOG4SH3xWCGvWvA7yJXXhLxt6eopdCcJHrvsm2qC58
qOPAmkPpQqBu0y/U96QLu7HbqA0WCsHD7kZ/01CCH2tHb6E2IRi/m/dv6y2C
n4DzsSl9QnDOfty92rcLt7y9VGbwWwhsSrUNBAheOQOAO5tLGNzZ1TMYjl1Y
ZL1JjB+/MOxwEMvfeaoLy77dq7lXTBi4113o97DuwvotByx75IWhfCzOc8mk
C5u6WA6+VhUG66A7eieMurDlirXPRS1heDbC8esytQu7q556yW0kDCs1if86
5btw4o3zo5SjwvCch/rpwnwnppStmw86JQyP2vnlz0104jLONK5vZ4Wh8cNQ
l9xAJ/4eNiAf5iUMRye//h5s6MSyr04dHQkWhtEi7tHCxE6cObDkCOHCkCu3
ZvFrZCfeoR57Keq5MMSI1HXXBndi2+z2MNNkYXiq97Xzr1cnjq06WJVYIgzH
J2TPpRt1YvK6iab5CmHYfPjTcwHtTlz4X+i3gwxh6Msm6W9T6MSd7TWLK23C
cPEBZ9IAZycWH9mlc2JSGHQtt/NnMjrwUwG9l6KKIlA0XHxKc18HVrRsfu+q
JgI+oQ4JWvod+ONzr8IyLRHQ7I7vWVbpwI1yGa2e20XAJtfI8B9HBxbUVeFj
WolA371V9bjidhxis8nnbpAI6Fg+N/dWaMd3EpYPz46JQPd3UxdXRis+RCm4
qDEjAoeENeO7s1uxbPnlJw4LIvBd71qGQnwrLuobbWzkEoWPZlsu63q24mnl
roMZsqJQsWXP0DnhVuyQnvuf0yFROLtyUuvQfy14V6Hnvs5PovD92i+SzPsm
zNbyHUqui8G6IwXt/wnU4XsjnxOv3xaDKZ1txrtrmXgd24s1Bg/EwJHOMcwW
xMSim49X5UaKwdrcCb7O1VqsHNS0N+uDGFjEfRrim2Tg/dsrDiT9FIPNKplu
RlV0/Cw52faB5Xr4s9N+r/3BSqzi7eRjRd4AfYes91E1c/DAnygbvlJxOFHi
wW8lm46SdlEv91aKQ+qhH8+DDTPQ6bCGx1m14lA0siC+wSYTdZO4GEc6xUE+
k0fliekH1HTk0vb4GXHYEflni8PVbPT5o4X8ZvJGOK5t1tZSnYeiPNhHD0Rt
BFViFo1FMbIqjOdWeLmReJ9XaHE+w0iUS19pJmUjXA82Op60rgw9ive0jcre
CJrix2dkg8vQPeaXhm/1G2Ftss/s3L1y5KWe98mLcxNclfD5GH2hEu0fdLv5
9OIm+Hih/XsQPx3tuamUbuKzCU4/ZRzJMqYj4w093XP+m6B8YG9ToA8dGZr+
p38ydBMk/9Ve2N1PR+RU7RmlN5tAPuXJ45GcGsR3btYlt2cTOJkffuVrVot4
VtKjnPs3QdWugP9cfWsRZ+Q5msToJigzyHzP/q4WLVe1K/n/3QTmVx7TybxM
NEYq/LpHVAIuT/A3WNKYqG7gplXnXgm44la0krC5HtX4bb0bckAC8n1MW0aO
1aOq9ZMfjawlwN4nnaP9bj0qMbEXSnSQgGSHXZwRnfUoPcW41vWmBMh1Md/F
32xAYY5rYSlbAmKehZlF5rJQyDL2zCiUgNqx6vov3SwUGOHz4nQZEf9krTNe
ZSH/qpHFynoJuBh/+agWqRF5kupyQ4clYKO2RN1lt0Z0YCBcQ1ZWEgoiP/re
Hm9EdRoDrbYkSbg8t+vOzFIjMr+8zT+OLAlbdK/l6/M2IbM1Xxs3bZMEjTAD
cyOVJmQsr3FV7JAkGLf/faNs24TKnP3lLG0k4ZJ5aJKWaxNCWU014baSIFNQ
IsV7tQkZ7fSREnSVhPU14tv1HzehLbbVZTx3JIGttUvmAm5COcmb3PY+kARH
hSuL65hNSPfXebHAR5IQtU678mp7E9K6LurEEScJhVfmOqrHmpBa9Gm+f58k
IfJu72n9jc1IunXBemZQEhwCy3sdzjajWKn/VnXGJOHuDdXKDe7NSOLsqzSv
aUn4WfC1Isa7GYlP71ka/ycJqivsY+vvNyNh4YhXwxulwFi1cL49uRk9Ojq0
T1VWCvpKtpeLvG9GAgmGM+dIUsC92usok92MeLV+mPZTpMA8UF3lDfG1wGGh
9at3nxQcmCzjutfZjO48ux0hfUgK3lVJSph+bUZsX1p3nLSRguuz5IH2/ma0
7HojvNNBCjJLZ6PcJ5rR9Y8NBhtdpSBiO/dNr5lmtDCv0G99QQoaim6Kms43
o7mgmi0tN6TgfoSghT17C/JmSX0TuSMFtPaZyddcLWhG/MKDQw+kgLO0fffn
dS3od+qGL/URUiBfMrJqJ9KCPMdd7vHHEeeFj54fXt+CxvVKNpsnSoG7uVGY
8aYWNFrpcKsmQwoiVRNXXWRbkNyTTrdHOVLAZbeWfkGhBVnZHbC2KpYCcFtZ
2UlqQcEaVUiyQgpqDKjv2lVa0Od5A/L3Gik4y5xs2qpO5FOdtf41SwrcuET8
Tmu0ILVnyqvn26Wg1Z/vw6HNLeiUfdyITq8UNFqMXuHVbkFPN4u0/u2XAtH6
A+2hlBZEXwz8XDoqBeMXvLo7dFrQMn057e6UFETflA79pduCdCIvPds3LwUr
X3P/0KktyMlh+KbQKuH/u56ih14LitO2c2njkgaOPyoyXwjduNxiGccvDdt8
M6dFtrQg7tp9O86ISQPvxTtZ/9fbo7CqqqQ0PNw3Yd9NPO/luEV0XF4a3oY3
rXcn9Gud98vZqtJQkp/QRSPiffknP+SjJQ0r9NOfR4l8hOueN+3cIg3HZNKb
/5+vaQx/CaeRNAjLZqs8Ivxcd7rzutZYGpIndJgChN8s6nx4+D5psFbzb7Ih
6jHA5nnD5pA0/Htww9yVqJdEQ/856aPSsCftlbkpUc8DcccP9Z2SBqPkPwOj
RL3vurAM0xylYVO9mMYJoh8FW0yVPc9Lg6mtsu4zol/ja4qF9C5Jw871g4LP
iX4qNlIWF3ykYe/Ui3YHqRYU6ibNuh8oDeYb5/xPEDyUb3taaB4mDbI2C6H3
hVvQHCdPikiENDydLvl+nb8F2SfM+LxIlCZ48iyq4mhBke6uZ8+mScMtf71L
EqvNqNbg23/qWdIwyeXaor/YjPRaaxVzS6ShL/XrUsdkM3JNBIEbldJwrsdu
4ehoM3rpmfcXaqVB0ozJnzzQjHjWJdXVdUjD93c/h2KJ+end4Xt1YFoaTL4P
Zq7/3IxE+Sbt3y0Q91//FPU7rxmZdTqae7HJgGaWR3B0VjPKvnRIfllABrRN
DvH996oZBb5RrRVTl4EPqZPIIqAZFXu/yOnSlgHz/gdKoVeb0e9dYgkJW2Wg
9yu3coxHMzrR8++yhokMCMkKiUudbEZaIu0yu0/LQLjvky8V1Gb0M+znnchz
MsDXV+KjQG5GL3j/Dg2dl4H75xzqreSbET/npuxQHxlwt8CKhvzNaHTu+J72
JzIQx33YkKOvCaX29Hq6VslATvsLg8z7Tcj2+ERLca0M3JA3LHXxbULr2//p
CzYR57d+N1h0b0J3WHIcn3plIKThZHHSkSZkX3EmanlOBlyi9HcKyjUh6bRB
/FhdFsQspE5fzmxEraQ5Up+2LAgVHHr2IaERPUzkDtHbKgtRFg229PBGtBir
atVlLAubP593uHOpEXWGuQ4r2sqCoyZtM1WvET27PC6c90gW2rkt/h46w0K8
6M+ZnhlZWPLQOXhBth757FLjyVuUhVlHTSfWbB36uftk5mN2OYhhd6nvr61D
FWbli8ZCcnB0KO6TxtU6dN0y7Nlbshx4HI/ZuJfBRL/OKVdfPSMHe8K271Fz
qEV1odZqIiw56BC3Cn3uQEd7x0/8VbSWB6vctQmCZWWos8KR/YSmAjxK37pL
PO8p0a9uyZvaCnBi/40nRavhaG35Qb1XugrQmrcgz/vsEdqKDZ1/6hN/3/VD
z7A4CEUUC9dfMlWA8KSZ87oK3uhgTkn0QzsF2GQ4snpb/Tampa6nlIYrQF/n
CnXT50Sc+6DKTv6PAtRNP+Cdq8nFafuZm4LmFUD6oNz5t3p5OJa/uXl8SQGG
Ndz1eV7l4Vvh3/YUr1GEQ9/+Pa68ko8tohe1bIQVIX5OJEdEphD3vaGsPtRQ
hAGTwRqxEyVYkB6f8PeMIvTkNtA37S7H7MHJx+3OKcKmYJGCuEvleHb/O7Fq
F0WQKGzx7E8sx10N+UFPLyiCihYv4NVynNLefGHzTUX4Xf2RP66gAhv+5IGz
0YpQmG6VcV22CjtxXfne0KAInrOqiZ/zaVhSjtGx1KQIb52S+M/00HCDvgxL
rU0RrOLl0yvZ6Hire3XpnS+KUNOrZVZjRsfcLRvitg4rgprugTO0NjpOfZVn
/ZJdCQZeXs8/0l+DjxXx/sfkVAL5yGcubRwMzN9qZzK/VglSnd+/EiUxsPfa
tVRLQeL5ky1PP59lYBPPo8LcUkoQKhes0PaNgQe2z9d66ClBPzXWqqq2Fkdb
W1TEblOC2XdNOd9+1mKLC68K6YZKcKd5Kil7DRPnJJmlKexSAv5sPhN/Aya+
ty7mftt/SnBbjnXrdTITkzoMYIezEihebQjjd6vDnb/Dtrm5KUGYuuHdoNt1
OJS3TyvKQwlkp/9j5EXX4dkdITJTl5Ug18btqQ6tDleldC+m3FKC0cuzB5/J
1OOzl27k8scqQWGOeF5/aT3eqvs1V/2FEoRrV8zqNtZj3mnI2/NKCRzknoht
66vHHy5y5996rQRDk4ZXTnE14GWvJwWz2UqAlM1D5MwaMIsyWyCSpwS7vF8G
ih5rwEm/bQq1CpXAzH3Vr9C5Ae/zki5ywUrw+82DacXABvz8wpviHqYSlPV7
nT2DG7CrNm/JQoMSRL38FjZV14CNJt1LxJuJ+EG2i3rdDbjfU7f0UKcSrEQb
mbfNNGCKZ+nnqgElmJvf3eSrxMIcWvL4x5ASPBep4EvSYuH28Tv436gS/GDF
/vMzYGE/D7My/SkleDGzt33/ARZmuLeUp68oAcdEwqyJNwvHa26tYLCRYG3T
xDP2myzsNRZd8ZODBBpy5uFe91lY3N2uUp6XBK8aLW6di2ThEY3yyh0CJNj6
sPncr3gWLvmlVHVCmATWpiqhSiks7HB+pCpCnAT2Db8D331k4S0aFtUfJYj7
U8SOLOSzMM+vzOoGaRKUgu3BxVIW7nknQvslR4J1zAu+GZUsnOXmTeNRIsHY
jXSWKIOF75A7aMoqJHANUz9MbmBhm1EDurE6CS5tzF+ZaWbhZddVup82CTKd
v3e/+MLCLHWHmhhdEoiLFQj6f2PhpJGqmrwtJBgY3egt3M/CV9+qMlr0SfB8
zXlB658svM81hPF7Owl6Elt/mI+wsLT6OEMAkWCnPGVm9hcL/x4+WEs2JoEA
FjY7NMHClWnZtXtNSVB8u/znqd8s/NxlA9PRjAQBnKbtMtMs7Krmw7xtTgLb
w9ay4TMsbDTczXx5gAR+n87Sc2ZZWChtR13xYRJMPIjufviHhfucX9V1WpHg
o2jLmQ1zLJyrylH/5ygJNHe/dT5M6AdD5+pFT5Lgb4jzX0Ro2zc19dp2JOBK
EZb5QZzXdtZosDhDAq2Tpwb1CP3VVe5ChiMJmpXGkhSJeKHuYsKCLiRQEjh7
JZfIz/DC2o+e50ng4NR2YZzIf+Ti0mGWJwlotodf1xL+or0np7UvkWA4/tvm
/8ZYeM+1/mfhV0jwbOqO9BWiPrO+HXpTPkR/vm0LNibql+zHbDvsR/Rv1+zD
3D4WtgzAV7MDSNDV+XpHw1cWZrvzaaPYXRLcGd1aENrNwpn33hRcDiSBSO1d
8ak2Fj4VFHe8NZgEiecdvZcaWZg/5PGiXhgJ+idfT7xnsnBR6N24yHASbNAS
Tl5DY+GNT8/32kQRfE7ob00uZGFaxGn//FgSRLkdtB7PZmHvqCNym16SAO4Y
aH99z8JN8dvPdKWQIHyu4GUOweutBO01hmkkkN2y1y82goW1kpSSY9+TIHAl
JkU1lIUfvuEbPJlN8N4/ckH/OlGvd6v3S3JJwNno5VDixcLD6TMqMoUkkEtu
2DnsxMKm2V9cvmISLIR72+lbsvBqyfsx+3oSpB52EMIkwi9OCCtvJAF3HZd8
0CaifxXPtBRbSUAR8L4/z8fChfQbXv3dJFD48HFD51QDvtxsPntumARJqlWT
jwsbsGIbiqT9Ivin2JukvWvAjR3UraqTJEiRdX52Pq4Bb+6V8hn+QwKd0ymc
szca8NDQryU3DmV4zFBJFDUg9s3ot3gmtzIMektTglUbsMl4yw5NXmVIeG0X
nb6hASdOFweMCyuDbmL/7OLvenxy5SGHl6wyHHbmFypNrscsUU2+KwbKcGjk
rIzYYh3e6eExEmekDEOlL9WXB+pwJj2TXoGUIYrWFPOKVYcf+encE96jDHJ5
6YnSKXXY4ufWlfeWyrDF3dZyeF8dri3cNdl3nriPYmzBE8zEhuvv1q+7oAwo
IvMI7QITv/Osek+5pAyqd+VndtswcbDSXhd/H2WQ90mVClBkYrMwix8S95XB
zmxUZiW/FlfbH2059FIZ9AfPiJzoYGC94uiP1xKVQdO2+oNeEQOnbOh+/DJF
GdwKv2W2xDPwvVpbi7F3xPOsMj77MwxsrOdQHZSvDH2fukyKh2pw2VqP/M+N
yhA0lGVcPULHxZl34jQ5VCDvxfyRsOpqzG1hLRnFrQLcT7fTI15W48MjqjHs
vCrQ13tB/+y1ajykVP+8XVgFwny5/tmoVWOxmI1Pb8mqwJ+Lrs/fBFXh83fT
H7QaqIBd85rKE0aVWOpY+xU/LxX4EZP/8MntMnyDnXyorlcFxi/PKrfr5GLe
nutmnjmq0EYj+X3tC0Vbr70VeJyvCqPFLybGqh+jM6KdzVlFqvB3Z4iMitUT
VGC25dRUmSpcia7/6rUlAjnlTl70rlcFabpc2ZGZGFT+yDHu+k9VGPS8uS4t
PYn43jswEbhJDYSHyxPhSwZK6fH79EZKDXhb0jPhYSZiXXvvUyOrBnBff8s3
wyykksnDwausBoHx7vE+Fh9Qi2TlxjAdNbCLJD6p0z4irdltu57tV4OVs1DM
aZ2DBl8rRCT4Ebqy5L+WgEI0du/HAsctNTBfPJWw3F6Iph0ST7vcVYNKd0o4
a3MRYpNT0NAJUYNHVzVeeXYXIcko+YqKKDU4F/547Jp2CToUJPd7MFsNSt7c
Dpqgf0YlzjIWmiNqcLs9zk63vRxVmvZ+DB9TgyVmyd2gpXJUq/Ri459JNRhh
X+1Jlq9AHd+k+0vn1MD+4ZFkilsFmj4qff0gpzpk+rNGHi9WIDUzqbRLcuqQ
uHNkVVS4CkWoSXAWWqtDQIzq6c98NGRrp/Km/5g69P9NdbJSpSFSBHW/oK06
bM76ezXLmIZyVv8LP+ugDsFd8fiTDw21tt+RFrygDnecvC5O/KAhsftjemcf
qMOJGo+Ti2l01F200BH2UB3SPE7VVJfRUdJv7hsFj9TBVHBTsWUnHenaKpQL
RKqDZH+f0wfuGmRJtfmvIFEdGNl9Hlfsa9DTH/icQLE68GtLsK+sZaATG+t5
9D+rw/Iu00O1Ugyk+F/3e4dyQv/l3m2jzUDZBbNT+XR1CNt35OJbawZqfqzu
79CqDhs+Dr/RT2Cg2OqtCmEd6lCvIECb+8BADku7q/K71UGn+ofVpQoGmnay
4xX4oQ5yMe+3JQ4wkMjOZ8/zx9XhmcZB227lWtR5+ZVB3291YDsyYHprSy16
9Tajh39WHbhCQ6P6TGoRZUONosOiOqR/9Vr6Qvx/cGhsOZN/LRlijwelvoyr
RZsUeS238ZIBs699T3pbi74f3fjnjAAZAt5gQ6e8WuRVqbM9X4wM7xrynks1
1qLwWCf6GXky+OeF5FuwMdG1q3cu+ymRQTPxUctlPiays3wpF6VCBqeRMd9j
4kykydt+rU6TDJ13nsmc0GAihq+p2jYDMvxwSB01smSiD9ZnWg8bkeGT39aA
AyeZKFrn5i13RIbdQuqyMo5M5DSS05loSoZBD5W9U95MtOY4KZjfkgxCsa7L
l58x0YgebFG1JsNb5aDn7rFM1Chs+2PXMTKkrTPvV0hkooSaZwbX7MiwNPfV
uyKDiQJTsgafnCGDaeqB9xmfmMjzFvNJuiMZDs4kX7MuZCIjfY7RH25k6FDS
LOmuZCKl9XLPlz3IsMGGR6Oghol4fxsab7xIBulCaRnLeiaaYtpM6HiToYl2
6HFaExN1vrkUa3GNDPlrNwcUtzERvvtoj/N1MoRyfxkN6WKi16ffTd++SYZz
xspN4r1M9Gg77WX8LTLYyF3TOf2dia5s7Nuff5cML9t6+Bz7mch2ZmWuKZAM
dqc5zij/ZCITlkTyWDAZ2hz1dZOHmUjj/ZaDa8OIfFTdbveOMpFo0OElhXAy
3HRVPdw6xkQLDh5vjJ6RYefxhJSgCSb6vjP4yNHnZODyTgz4O8lEdMnU1Ysx
ZCh0f/FTaYqJMufK3ofGk2FOMPkr/zQTRTb3HH2TQAZOBQePbEL7Zc5zVCSR
4bQJOWb9DBM5hqz/0JNKhsrWURcqoc2dKLZ/08hQV607IEhoXeK1I5pOBvEA
itgb4rykrEuOZhYZ5vM+/lsi4rEv3rXfm03wZ670QYDQw20J/A65ZLgh9USn
h8iP9bG4wK+A8N+dGuZM5J8X1uEYVUyG1KF3rCzC3wvXGeHsz2TgV3jAkUv4
v2cqVFpXTobenMot14j6nFfQcB2qIsPd6duX5waZyHJlz4Y1NWTIkbhfq0vU
17DLoVyaSYbNapv3aRL1V8j199jWQIaV1Gv/+nqYiOdJrIRlExnOeq0u2BD9
++2eV+3eSgaju8vmD4j+fiZNyCR1E7wV7tmmRPCQysZbW9JLBoMLYrOhBC+h
PcpXO76TQUPS6kAOwdOJiFMN/ENkiKwfVDMieJP+xCt1fpQMjFPqe+UIHr81
5TszxsnQ+jsoPiedqK+QKHvgLBnWPy+0nXvJRCpa+L+Bv2RYM5XLnhxF8G/h
Hmu8RAZjXjnLNeEEzyE06iq7Bpw6mnupK4CJKG8v3zrFpQHLRTl3D19johm6
fH0xjwZctKoq9/NkIh+uG04+QhqwT7nx4Dgxf3duacdMSWtAz9nydEMqwVtC
z+BBeQ1YrHopcUiNidZ+DtbNVNIAZGz5VUKG8LfUz3QjawB9csN6JhcTPb8a
/a9/mwZo1yt8T2upRcciTc2Nt2vApkrR3HO0WiSVMx31aqcGyJZ5QGcBsa+m
LHROmWrANXqD/rf4WvTWnd2x3ZK4/5KZyPUztcj9YeYHPRsNqMzk+jNyuBZp
vTu58vS4BpgZu8qLGNei7KHc5wftNSCLPVA5UKEWlTi4MWo8NGDlSvZf4V4G
ajzWolX8QAO6zgln9OxhoKfXbt2QCNWAvJ3HvnzRZSDr55trrj3WgIjnPtzP
ZRmouyXojN5zDQinXjth9KcGDRwwishI1oCmYJLVsYQaNG+SupDwWQNipePz
eYfoyK844W5VuQbsTDnffb2Rjth0YwVGqjRg4JdweXYhHa2Ve6ygy9SAb1wv
W64/pCPxBZ99VR0aUNxr/u+SJh1RMyxihn9rwCpZ+LGRIw15bpjV11HShGT6
sVnxjCo0/XCiwlpFE95fiyhjD69CV9aMWFxX1wRVvX6e0ktVyG+y175SWxNU
vIaNX2+rQg8Z9AfWRppwp51v2BxXorSbcZ2+1ppwZcLwtTqtAvUPGvtUBGlC
6hPJJK+cMmSc0JBEfqgJ/rMXeRQfl6FXx07UP32kCUcib3e+cS1DdsyLimcj
NWE8hn5DV7YMdX94VceRrAmZXCGJr3gxar7xT970syYM9+puU40uQRUiRQz6
rCZ0boq/OnkzHyXt0JGqP7MZijN89zGt3qKM+1dEnDdrQWRjQ+BY4Cs8ZnTq
zn2KFpR620jOqyZizVmTmWSqFuhdb7Zi1CTidw7r274baIH73L6KvHXJOA19
ij6xRwviwkPLnz1IxSkLv+UOnNaCYN3NE7y+73Csh7vWlidacEToyexpgWzc
TbJKOBKhBfc42Oitx7KxRM924UtRWsAsyTPfkJKNo/fzTWe+0IIlMaW3cwaf
cKTqu1y1d1qw3xBuqZ7NweE/hoykK7WA5e395+27PBxkfdac448WuK291RO5
rhgnHeyxPTevBS4Xj28etyzGJfusPelLWvBsu8vhibhiPL1j75OHa7ThHW1q
YVSzBNuqaHSICWvDrkdnjxbsL8W6f6cdSBraIP/aQHnJG+Ov0Xeum57RhvKz
5PQwXI4Xni49fOOoDaPW5l/lv5bj9WHeL9a5aINy0dibm8vleN9tp7J6T22g
15bhp/oVOMd1P7eNnzbk0EnHFDMrcIih6FOnKG0Y9z3GGfGoEm/pSXwbVK8N
1lzvDzEVq7Gwlst8VqM2ZK3pe3NNvxqPBWjt7WzRhqCOG3/H/qvGKUrFA2rd
2qC1TCnX8anG68+3ytX+1IbUgnVDsrXVeNGPw5ybjQKxdecj7M/S8HCq06VY
dgrwqNvsCrpCw+0NjBgtDgqcyO/S9A6i4Wz58GEbbgocC+ZXfvWOht2qpAPf
8FNgt+JCgNEEDXfxbS03k6CAWwTfH2c3OqbpxQz3SFLgqJJ2wg8fOs45tSx0
UZoCOxhp9nJBdByeVWEXI0eBXaX7cn4m0bHZkYPLI8pEfAHxkMQOOt7ql63k
r0oBM+GX7foDdExK3WAuqk6BeDOj089+0zHb3y8xhppEvAGXiic8Nbgg1mXb
Q10KpBuV7vq4pQa/rmTayelRYMKZq+c01OCIMa3AT1soEOx3cKVxfw322vmn
9Ys+BRgC9PuLdjVYre/2JU1ExJsRee1yrwaL8w3GlAEFgnavcVcPq8Gcembl
VsYUuCZsR06PrMHf7wsK3zSlQADbA6u/qTU4Wj0uo96cAtP533uTKmvw7Mye
1Lv/UWCbtXYfG7MGH/w8HW9wkAJ01YRnG5prMPeR/aGplkS+nL9qHb7VYAeZ
ubsnrShQffusQdxgDf48lHhDxIYC3jpbVUJ+1eArfgtuN49T4AXnSeuHczW4
cU+qA/UkBSpE/gW+WKrBmiKHT4zYUoCq/mKDExsDP/iyfDjBjgLLsLA4wMnA
A6lp+6ztKVA58FZHch0Dg5fVLj4Hwo+2TC6XAAPHGbIZlJ+lQGpF1O03wgw8
x5lOuXaOAg7FehGrYgxsyTqqttmZAjUpg6MCGxk4M4ZDvt+FAmtcLt1rlmDg
dY5ZG2PcKMBu6Gv/nzQDO2qdFDroTsQL9Azwl2XgsnnutVyeFFDvju87J8/A
0pXZ/4ouUMCTRgrlUGRgnzC7Oa+LFDCsWfY/qsTArUd5J1QuU8BUberzGRID
ayvmDfZ4UyCpO/mQojIDh4yd6X16lQLRJ0MNYgj9M0+gzcyHAgohfwNohDa+
XVj3z5cCSwFrNd4R+qX5uaqcG4Qf50/GJoRe3CBS4naTAvYH6KwI4n7r7yWf
5AMoUPy3/0scEf/DO5f37bcoEPLW/+JxIj/+K+uTQ+9Q4NTC97h6In8XVBZr
fI9CvN/VnOcJf5Xr3J/O36eApdDe712Ef9nWjSGZQRQIjWXfcEmSga+/rLzt
GEzUo+23WDlRv3aXC76SDykwHHRrjLaegXWpUhcbQynQajeZeVeEgUfol+yN
winwetOdrYq8DGzyVPbY9BMKiDgjeU5uBn5lW3sw7RkF+qUFd7xgZ+BjUwpo
fRQFTo+ud/jztwbnFNdvrY2mQO/mS5E50zVYKNBX61YsBZyDyZYa4zWYJtkk
M/aCAhJSv2joRw1WHPTbkJRAgfG6mA+93TX4ZpaawLFECkS1TgZSW2uwnsmt
5coUCtx2qjy3llaDwwU1Z31fE/crnXp9/3MN/tXZ8Us7jQIXm9p2l+TV4CQP
7S9x7ykgn3ZB8MjrGvxv25fmwxkUEPy34fqnFzX4+Jqg2rVZFGDiFFwXUYOF
o74WXs4m5uHgHjvynRocUBYWbV5IgTi3C58jj9fg0d6yiIUiCoRNUWdmDtRg
m6WZ8DclFBAvLk8TNCH433oimKOMAoNRQZrXN9fgzvcq14tpFJjn0v+yeYWO
dzOOX3WtocCRpXRrb2J/ZP4MvbSxlpg3Z2q4Tz8d31eYcbtcTwFpxeTpoho6
1o3CJzVaif1lVXZIM5yOX+RMH+1qo8CeYd93527TMU+zslVQBwVa+L5R7C7R
8Tf+UIv+bgrsndEOCjtCx6F3ju2I+0EBuY7fnaOidPzTY0qWb5ICXRnvjBvu
0/DhhySpwt8UODQwUSB6mYZL0o5udJ4m9pnhuQIJexp+1l8qVPmH4Pn99l1e
BjQMx0PYbiwTPLb+UtwzUo1jTZT6RtfpgKpbjn/djmr8n5R1ai1JBxxkY/Nl
Sypx9IBW2UkVHVg0WO6fTq7EAxk8X8ZUdYBkliYc87AS+0GJsJCGDrAlHXOz
PVGJ088p+R3R0YEAJy9d2p8KzPthyrJnhw54+ymusSdVYLrJI7YJGx1Q+Rtl
Fu5Qhnd50k+KBOvAUfYPuw/9LMCLnSN7qkJ04MCnoum8FwU4Zze/7rVQHbhe
7fOq16oAq0gc5ul9rAON6xKOelbkY/6q7py05zpgK8Q/mxObhzslJgQghTh/
YanuOeRgr+r1ZZ5YB1Z0X4Q8ZmXiBGkHUt0fHfBV6jXccCwSkyrfPD9wUhec
Xl1/r/f1HWrQnE/psdWF+YuLK5Tz75HPc7NPbna6cOKfjMS3v+8R03WEFXhG
F5qPuPiYC2egS8Ia67CzLjwQ2pMLO7IQPpV5Q9tbFz69V/BFlR/Rifkce+Ew
XeAb5eeh/cxFnA5cF14+0oW+qqsMVdU8lMm0vqkZrgtv/XljDjjnIfaEuRiz
Z7qw6XEI/8jPPJRmqt9yK0YXavsN+Xf156M/T4tNp1J1QSnSt3CFVYjCN1eQ
mz/rwoa7+a0NV0pRmv7JdXfKdCHEf2Okb3Ypwrtnh3QqdCGnZ7t97UQpmjiu
kvqkWhfo4x8fnnT6jMwDQ+QO1+nCJbw+lXwYI+5vlusbu3Sh34l2wTekDMmM
/poO+KILMBQm051ahvT+3GvS7tWFsLbUBZ7yMnSWL//R4++6oGyeJtk4V4bK
tkmtOzikC7QPeTrLp8vRjfD+lfpZXVjedEL3sVoFehrn13NzTheOLsesfIQK
9O71huLN87rgGO/x6eWxCtRZstcnbEkXGqPk+1uDKtDWkffTFmuoMJo3+Cyj
vwL93uU9xBSiAtPgw9Ge8ErE858A7YYIFS5Us+Jup1YiuWOvUzTEqCD2d7/y
eGElOuDZeeahOBWS5ZO2iPdVovexRj37ZajgRJ7OeKddhZxmOJsYZCoUrKju
zMZVyO6dSYOtJhU8Wo8cvMeqQjZn7jEnN1Nh/YDHPYVvVWgPi4O2QYcK34QX
m0pWqpDK+zXFZ7ZRQUI4zPayfjWSdTAumNWngv/e5F+xe6qRuMSd3CBDKoTm
nIoLtapG3EHsHzJ2UKFMWWKw/kI1GnRgS13YTQUF3LhQlVyNeiQgKdSUCptY
Nx0MP1Sj1saABLm9VJBnWvL6llSjqp2rMab7qZDxvuvD4dZqlCL579GTQ1Sg
Suu89WCnofimHaEkSyq8PLXlKJmfhiIe3AzOP0IFepzq/SxxGro3t3y314YK
ak7X+cQ0aMixeclH/RQVli8WhBgdpiHb4O1XS+yo0PPDeMXwBA1ZwY3LB+2p
wCmhdIT9LA2ZZC56XDlLhXufpxwHL9OQ0TnD8zznqFBxwISNw4+G9KSvu8Q5
UaFfKXfH8F0aIoUsOJS7Ev6GPp9d94yGpHcZ2Fudp0K+gQzFNJaG1s/7nBpy
p4Iig+RklkhDnE7zRwW8qPDkRWVPSiYN9e/6a3H8KhXs+USzc2g01D2/df/Y
NSqsac25T66joeasq3sDfKnw3dbb3bmJhipk5nal+lHh41Mfy61faKiodQvS
96fCaZtc45pvNJT98IoRM4AKJuKrqgoDNJS0MLt16g4VioYLC1XHaCj2g57e
vXtEPThDT7ZN0tBTZ2+djYGEX73NvftmaChENkfrXRAVaD2ZhvfnaOhO24zG
jmAqXHqQ5RW0QEPXQ6nqjSFEvwdO+B1apqFLuy+rnA2lgkGJ68nv/2jIbTFb
aS6MqMeMAv82djpy+DgtH/yYCnf8bcKsOOjI/c6R5f1PqCBwNfiGBxcdXTmS
08H/jAqnZraroLV05E/a8KkhgpgHpsEjBg8dPfhz5VH4cyoEvlTP5eelo6e0
dlfLaCpwF4e+4OGjo7iobabrY6mwby3eX0roFJdo+fY4KsT/mCsj89NRpsHC
UtQLKoSzmXIdJnQB74mO4wlU0DoUIUMhdPmXomypRCqk1L0VriHO16ZLPepN
ogKcIP3cROjWm36uCSlUmIn1e61IxO890Gty5jUVlMs5Tw4S+f2U2ymvlEbw
Yz8scIbI//fvl0sDb6lgaKBZG0n4WyhfbX/9ngp8PJlxdwn/a57ZZ7tkUGF4
H+kxmagPv2N5GDmLCu6cstkhRP02bFF0HftAhcYHa8RSlmhIlvuuSWY2FUr0
RMqvztOQWke/nFcOwT/lTN2aPzSkk2aypJNHhcsaP0zNpgh+93Nn5xYS/LNO
M1eHaeiAlHPYtWIqlI55rlwkeDg6RncxKKWCw7GGkRcEL26PguVKywge0lv2
KLXRkPfp0UX/CiokWRkO+LFo6CbFvB2qqLBf4lJkOIOGwpv5w6roVJh2Xo78
WULwlOzhEsigQpho7ib1PBpK9m7YbcakQuUxXnGVLBrKEw9fZDYQ++Ka+++D
r2iobOh3W1gjFazf+qy9GU1DjILDHw82E/Et5QTOhdNQzwkxl5Y2Yp9t2HnG
KYCGfmp4747soMKe47t+B1ylocnlVtmjXVSoDZidsPKgoTUJz9u6e4j5NPGq
1iHmWbVfYndfPxXijkjXFlFoiJJzXTZlkNiHC+ZVn5RpyPD+l4VzQ0T8AOWj
rpI0ZKH64sPIKBU2mtwb5eUgeD4vLzs1RQXGrUUPzaZq5Gd0eyF7hgrNP8fr
Bauq0X2BvlbvP8T+iHdUzMqrRtFZyQ/n54n5s0o+R46rRkm3OJ2LFol+fy/N
4QqrRu8PnzP2W6bCp8DVggT/apSjSJPZ+Y8Kj2/dTJkn9uPnGZWF1VUqLMYL
vxM+U43+B02n3N0=
            "]]}}, {{{18., 0.}, {0., 148.23529411764704`}}, {0., 
          88.94117647058822}}], GeometricTransformationBox[{{}, {}, 
          {RGBColor[0.698004, 0.133305, 0.133305], Dashing[{Small, Small}], 
           LineBox[CompressedData["
1:eJwVl3c8Vf8fx41SGWXTwL3WtS7u1VDS552yCpVSyghltERRoqGShKy+RkYa
ZMsqoXzsy+XapFBcRYlkZvud31/n8bznnPd4vce5H7LDZXNHLg4OjmBuDo7/
XxNuO/DQzsbtWbz1/2vQnqo2kskJ0g20eAw9PkQ6h1ZqSu+TSI9Q5xL/I07i
94SyxzKrSU/Rt9dT2x/JPEIXdT0v/ZNJQ6a+jE9rpJ+itgWX//7KFKG/duU9
dMk0tKabTRmVqUPLee+/rXAUoRfMRPffMp+RrqB9eGNSLZqKeavyLfgzMjDq
Tr3IV4cMnOsHWueI+5VDl9vd69AI9z+L4rYvyCBL8+mSLhNp65rtevSwB3Wp
njV91laPmt8sclHGvqGfPP4FpyYb0R2m2gHa6QG05Uz3Fc87rSg1t1AxI3IA
3dZJmg7JbkWtMXrcCg0DKLAwWdS3txXJO1t+kNz5He1lVUYN7WpDTG4/dQ6R
H+jS0W2sssk2JK7bLdxUM4jkYnTtDGw6UPabR90X1YeRqu9JmTUCXWhYeDj4
gP0wMtpT5flMqwtRrh3Yo/TfMGp+KXJm7aku9Hw334uBuWE0/IP1y/x1F4qo
C3Y6Vf0bxemWCpbs/oyuDYSOG1qPopKn78zi7b6gRL76+0L6f5Hpb9br7ns9
aI+uj7Wv7V/kv/HmIf1XPajHVXXb2PW/KH/YIehGZQ+SbA0abEj/i2rtDnUB
dy8KjzExDhAcRztaryTu9+1F9xUa1690j6MKe02Z8ctfkTNqeTpyZRIpyoR3
6gj3IY6XM8XdQZPoskqre4p0H4pZtaWHmTSJVERzrGdU+lBtnZN0Wuck2ibg
06K7rw8pHVt86bhrCiW8vC7mfqUP/XShZH7lnEafT8gUWtb3Id96ExZr0zQy
Cv57/m9HH5JUv/Lng9Y0Sl56YXy+rw8ZTX7QjHOcRuvn/AxWTfehtFvmb0/U
TSORKO/7TVv60fmIW6XNYTOoQfrv7FunfsQ1/fIbTptB29/v23bucj+KPVHL
8aZiBr2r0clfut6PmFtE9j2emkEPrCX1mAH9SDUllWFs+Q+9vjl86m9qP6pa
1/hT2/0fkujbYp6Z04+sL06uUwr8h1IOalKN3/ejYNoeE54P/5BpbOZZBUY/
Gilpa66QmUX8jhdKnQb6kZ/03Hiu9izqqHV8rzTcj7bclRZ5cWQWvWJOGtb/
7UcmBucs7tyfRV/99VbnLfWjrOblzzpDs8hhIF50tTgbGWjJL6hwzCHzEfcO
5mY2+hppvGXTxjlUekh+1I3MRuut/rOdPTCHMlIv8tiqsZHrD+WBguw5dFzV
SqsE2KjP9vPa8ro5NCgvjH7ps9HRrgB11vc5dK0zvWX8ABtp1w/d+LFpHqnI
Jl+NOMZGGfujE8e3zaPcHxPXVU6ykXSpQfXS4XnkVDk/Em/DRty5yYLiD+eR
OL1VXMiJja6pWGyXfTmP2CtGlcLn2ejnq1XW6h/nkfr52qY/l9ioMepMisHk
PKq/Nr6wzZONQFCEZb5+Ad2eWhJ74cVG+Y8qJmyVF5Aro8tv0IeNYm6S91w/
vYA8D909yXGPjXhnms/c915A3xMufWj3Y6Nbl30fhUYuoEeXHV3vP2Sjvz81
3sTlLKA1Wa2u/IFs5ODwrT2lfgE5pl37eDmYjdq7Q+bzBxdQ4pbzp7JC2MjQ
Yg+pjHMRvZKSMqgOYyM1o4QLXTsW0d+27QJ+/7HRs3KT8O/mi2iNGf23ShQb
Ceksvvt7aRGZsMSlMqPZyK8go2cxYBHx1a1NXvOUjWaoVlzrkhZRU9/9B7qx
bHQuhVdJDC8ii+ZT5aZxbNRDKjYlf1lEeQ6FVtrxbGQWe+4qdXoRxZ3dZLlE
cLnIxqc7BZdQd6RVcXwCG219XFuqr7qEZp6m+Ys/Y6PXPF7fjxgsod9Dj8rP
E7zRl8Jra7+EdhR1XX5KcPBcp8b5m0vo57/aqJcEL1/xt7gWvYT+qH7X8SfY
fWSbz728JfTUmddxP8HfHX88D2EtIbrWFclewt/xb//VxP5cQo3XU60PE1xr
uX/kNfcyMjkXpv2MiE+ndVIoX3oZXb58Jr+GyCf74KsdeOcyMl2f215H5Euq
NrepP7aM3rBsk1IIPSL2cN3/dHkZdcukqtjFsNHq97mpA4HLyMFQ2m2S0NOL
Zt84lryM1Han3rKPZKPhdMGphTLi/dB71ulP2Mhavmzj2p5ldOowEm8MZ6Om
hMtI9N8ykh2pLmgIZSM9CRlHkvAKOiJ8VO/1YzYqCGsMVKOuoEv/edWdCmIj
Cu/tHG2jFeRgIGUxHMBGsfepnfvPrKDu3pt/j/mz0Z1rwWSbpyuois79oMSX
jSbGdAzPFayg/AijqMJbbHT23O+Lnk0rSLzzwVCINxspqCv01HBxgPTVqltN
V4l+JPtRvmlzwFaj/JmnZwm9dodr3NbnAJpsTVaRHRv5Wz7bIWVOsP21yiJr
NuIKe29odYEDzHzoulbEfM0vjzh/SuCAajXnz/J6bPR+0/zla+kcINo2N2Gk
S8zT9jVeYoUckBMZ2GmqTcR3iRxwtJkDokymts1T2eh3j0VqExcnzJzyW/gq
wUbpsw45rhs44aXT+Fo+YTZyEXV7L7CFE45RtltJ8hP1PhhYe3AbJ/g16Qh+
WulHPcWlPxnOnCBrIxc9+KMfNcRQlMsaOKGdz67AJrMfBRZspZ3+TNi7bGbw
OqkfGTXv3bn8gxOS5rigJZ7Yh2usjXevcMKqqYcljcH96MO1sHPvaVzA8UBW
7PwFYn8dm0vLieICp29/pbfJ9aOLbjx5h15xgf/fE5uzN/YjlWCR4j9vuMCm
8UYPr2A/el1JZarVcUG3dROf22IfekZ3GE5d4AIun86K3219KESwXuWFHTdI
9bieKb3Vh4p2SL01c+WGLxunZoLd+9B328to0YcbPr02Qbsd+5BOlsixE9Hc
oBGq46VrQnxfjK1vCTRyw5/dH2wbJfvQvvujTTd0VsGefI6FCMtvaHZ6g6e5
+GrYxBm2y8anF8lJOaysyK2G7qqrqwutepHZ/oJHWbTVEFbd2tat04uSIyyf
rTVdDerlbY0PF3qQucYLRun91UB+HP/iilcPynKhb1IdXw3TX2f0+1y6kUP3
MczdwAN869kJkYqfEW9c/yX3zzzQ19Jsncn5GeWdct3ybZAHxnx6eeJ6uhD3
l4c3ijnXQLpG4GPOiC6U1FWs5b5jDbzdNRqyNP8JDXaQUr++XAOS5aEp3DWd
6HzzSFjRjbUgfcX2zU+9duRe7edwmcILkVsLA3O7WSjXjf+opLEAnLobw/w7
lYsaYkVuZB0XAP2zObu1IRcNVm1K1DsrACzuTcbJQTlo00bl3xfvCMDch8Dw
Uf1s5Feuf7/8rQAEXI2qPZCSio4L38k/L7sepnfmvfSej0Xz+eMiHxfWw8I+
H4vpwTD8wufCsOYJQQixzdu2wF+ENcvWzT60EQRd/Itp+aIIl61KXf3tjCBc
D/rPHbYV477H30mP3QRhIGD0XppVCZZ+bnPi1yNBEEISQ5UvP+LYqkNVLz4I
wo5U99Qn/OU4QmDrM2FZIahuan+deagay5q3ZpxTEgIP5UxDz/BqnBvlVlSm
LgRjfLTzE63VuFkmq91VRwg23nU7staiBq+nK/LVHxOC4FnpZ5EWDBx4XNLr
/kMh+P3ezLTZsA7fS1w8MjUiBK+Osql4tAEf1nzvrjopBK0qqz8ryLOwdPnV
cIc5ITgnefPb9lMsXMwebm5eLQyOZT8ij1ez8ITC50NZ0sKg0WE/ey+6ETtk
vjV1OiwMf80uHH4p1ow1dd0vJRwXhpppXQ1R9Wa8zFJ73G4tDF0b1sVYGjTj
2LFXDXrnhEG2//ZFy2vNuJUecVDmnjAMUQzmNdqb8d4iV+OufGH4sXyAKf2w
Ba8/oHJuQ7Ew3H86OZUS34J7vvwIMCgThu1tHy5y5rVgr0Xr2oIGYRBrG62Q
72nBOeigYfgPYeiZ+R6nrN6KSTUU/QMSIsR+KZsQqmvFf44PnL0rJQJZlW6F
4d2t+MPQM7/3ciKw0Lnp37fRVmy5TrxKUVMEFOsL7g4JteEwk1X7uI1FgLT+
tujzE22Yo60PPniLwPb0HOlXn9uw36/SF953RaD4kcvNg8NteB1HAtfOAMIe
KfVn4XwbFqaerHobKQKJsy9Ceja1Y4WHLYZvckRA+N6rRHPLdpye8Cb1UqEI
lEbdXZR0bsfqBY/XqZWKwDc995KXnu1Yu9+4PrVeBHwT20U5ItrxAZ0Ks5eD
IqDQOWbSx2jHjUeev7EbFYHAizYs3N6Oj7rcFpSZEgHDE+YqDv3t2DpyV2sc
pyicrXilNzbXjl3H8iwit4hCgGRbsLJSB55YHf7uqJwoLKfIPZbW6sDXt1yW
EFYRhfl9vnyduh3Y11j1c8gOURD7WGIbbN6Bn7x6ZR1gLgrsmVUBYjc6sGTx
3Y8GJ0Vhir0jQepeB45vPi292k4URqpE54YCO/Drpc19dy+JgkxlgUdlXAdW
EZ0H8BAFweMTj9tfdeA3Kl0vlr1F4Wd6Y19KRgd+f+K/Mz4BorD3OD81srgD
73a9UrUzVBTUnzLk35R34HK/wwqzkaIQYtxhHlTbgZm5/EMer0Qh48tBi8CO
DmxWO2yolS4KZP3falndHbjta23qeI4oDE8b743o78A9fA/Ou5aKQtwdG+qr
kQ5sJ3umXq1aFOL7yQJN4x34h/Zetd/1ojBqUbXz40wH/uO4NOr8WRS6/ziH
9a104Ks3u80U+0Th6y5ThtiqTjwbUfTm+6Ao1EZ2nRVY24k5yzzd7adEodrQ
aGrfhk7s33m0VWaBeB76/t0T7sS8ozStr5xiUKb+4IGfWCcO5Rb8L36tGLTr
h6UYSXZi0U1/pk5tEIPmkkmXpk2dOEazwWKjuBjcidjVISnViaUM09992iIG
Ng4Bs/IynfilTYBElJwYfJV9+m2S1IkVPZy8jqmIQcR4WfQD2U5M3fXtaKKm
GOholptUy3XirRyWGsPbxWDHLUZ7k3wn1qlp5t2mKwaZigK7kxU6sV6w8eCd
fWKwSXpPqL5iJzY2ryhnGouBSINXdw7BhyV1EsQOi8GZflP1IYJPfM33sjsu
BmOUssifBNsmqR3LsBaD0iP7SW8JdjyfrDHjIAZQV9ZjQvBFTWm+vefEoPLW
4y9vCH9XZ6IGgy6LwYbcq8pfiXi8P2yo6PQUA77KrM+fiHjv3gtIIN8UA7w4
uBBP5BNgxHnj4j0xOHFK5wWVTOi33vtYYYAYbD+2o/sRoUdU+4QGV6gYxLz+
VJJL6JUQe4HPNFIM3m58ZJG8uRMn2X0fjI4TgxoDpZKzGztxhqJNBfuFGCja
cnL8Fe/EeSMdCdRUMfD83bTDULQTF+WZ3fDKFgOFmNJr54U6cZkX41hlgRjQ
x5xaTq7vxI2rivhOlovBofyr6glrOnEHkzb0iiEG8me0rMe5O3FPWHrFH5YY
vC9zWBTi6MTDW+Jv+H0RA+PM22Pv/3XgcbaoRVOfGFy5rOWOJjvwbOpjzU1D
YpBYPlQR8acDr952Z+jNpBhEugdpP//egfkX/lXMz4mBsFNKyKlvHVi43O2Z
Poc4tPhv3sj+3IFJpg4W3fziMCGzeuvJRmJ+HPUreRTF4acBr9dwQQfep1r6
7IiaOEwKyJ4Vyu7AB8a3e8fTxYFpdcyeJ6UDW95SotGROHxx3LvaKqYDe0Ty
JdpYikORXKJ+nlcH9rHy8061FYfufD5eU7cOfI+8ZDF5Vhzg95POd84dOCzr
D/8jd3FwvSrNN2vRgTOrW7wLAsWhqet8yFbNDvx9Ovo430dxWDOunF7Q3Y5f
7tW62lspDnWt3zafbGrHpx83hr5hisOdx6zkmop2/EV+dd3RLnGg/dlRt5Ta
jluOXtGJnxQHJ4tr3f1X2nFprgmJqiIBP02c9r5ZbMM3l4Z2r2hKwGHZnCdL
I214p/H9ky07JODrJ99jkr1tuKCvKMJTXwI+3X20tuBDG07fQFldaicBcklR
SYE32nD0Jc5hs2gJeHD20cNfv1rxsaJ4HvIzCbi+4Qhj06dWLLxaW24ySQLs
GR0GW6pacUi8q3V0ngQYeMmvC09oxX713Y3fWBKQrXOiycisFbspv8t3WyUJ
f1b/cFZLacEHfpy/FeEuCV6n30nmajdjg1tymfu9JEGPaTDWT2rGemI9X2Zu
S8I+vZIjo2ub8S59U22rYEmgJC99VM5twirJGpNyKZLgcq3ypO1II+ZznHJ5
2yMJ6EK3bpIFCzd8v3Wsy3AjbOC/6dj1rw6bfQ9TlZbeBGDJGSj9rAIPVzr4
1mZthhs5VvXhiQlYJpwoTMFmmDJmarpFxOFjtmYWx0o2Q9fSqkd3HzzFpbM7
VfpqN8PBXh6HoxcjcQRVqP3fwGYIe5jMmegdiHWiMYWyaQuUz20Pn7nqgoLP
b2l64L8Frm/9W3Aj7gVSF+qU2ndaChL+TFhWK71Hg48H70U6SgE7beyXd9R7
lMD7b2joghQIJnok9XAXIf5VknnBXlJQpiNX/ry3CA3PnDToDJeC+HW1i4KP
S1ByT6/ruSop+DHZ9w1/KUVbUn/gUGVpOFFLee4bWYHa5Wfk2RrScF/EXWRX
TQUKesETuHW7NPyO+aVfMlOB5mMpxz7rSUNqof4+kROVqOvxuZ+y1tKwPtZP
d71YFXpydVTwXYg0xOtWyH56UI140bR9z6Q0pLP4AgW0a5HXXqW17+alYS1l
KNj5bC0a3GeVHcopAwM+6e7uYbWowqh8Xm+DDHQYWmk9GapF3uaPn6SpyECe
r8d67og69NtRofqavQw48HBs0PnERKdcLC8cdpGBa9nTPQ7LTFR7PkhI5bIM
+BdMGW5VqEdJl8dtem/KwIRmnn+rez2yvvFxZl+MDDCT07sneBpQQ7CFklCT
DKjqygxdJ7HQrtCAxuEOGbjneemdoB4LpYaXeFT1yMBf7uo+0zMs5BdFLr8+
LAPKqc83FSSxkHTzjNoYFwksuBZVlOQaUefnimoLaRK8bbDxvbK+CQlY9cRU
kElwYFRVUFOlCe3vmb6goUCCrInbjMf6TSjvq5LwOjUS8JByq5V8mlDIQIjt
h50ksD50d6SzvwkZjp76J2tBguSSVLerZs3omej9tjuWJJjmFF4ndrIZTelk
vOmxIoGqtvtf/zPN6HnggnOUAwnaL5Dtuq83o3lKfNc6NxIwPxQ17H/WjA4f
qipwukoCH8tktlNKM3p9bSSs8hoJuhXJHy1zmtHR6t3Gt26RIN/Xwy+jvBll
OvQW/Q0kwZ8e2y987GbEFbg6yjSEBPvXLIWk/2pGlrnUK+nhJLgozJ8oOd6M
VnPcVjkbQwKnoPbXDivNyJrymqc8jgSLDQ8D9/C0oDyzRrZUIglOPE188Yu/
BdkmSMd9SibBfa5sw6yNLaigyuD61jQSWOnW11TLtCDeEdej4ZkkuLUn9mSW
Qgsq3IX5DuaTYK+55fNfmi1IsOv0zdIyEhjNd24U129BTisPLTdXkcCR0yb2
tXEL+qCYs9WLQQJS7M61PGYt6JwnxyitkQTuQW9e0o63oLJ4pbqQFhJoXZqo
XzrZgsSrDif/bieBf8/X7hibFlQh/MImuZsE4ftxts7ZFiS5q24n1zcS5Cz6
Xdnn3IJc7cfFTrNJYBASLb3pfAuqCtg4UfKD0L8wowBfbEGbc/Y2Sv4iAaqZ
3771cgu68ulcuucICZbu6KVed29Btcvh/q1jJJBdqeILvNqCpBWLHTQmSdAU
Z+R4wbMFeZiy9wTPEPVlSBRtvt6CmB68m3/NEfUY5OCP82pBpHj6P/0lElzZ
e/zMrxst6FrlqbaXHGSQrhut4vFpQazhe29WuMkwu0jaMUmwvHBGkPUaMqyp
aSjLvtmCvHe2ORfxkiH14JFzO2+1oGa7hX3i68kw3BCu/YRgxQA50lUhMqi6
T23/QPDNNwcXm0TJ0KHgcKmA4NbOq11qkmTYYm/ww4dgpeW4gkebybB6VWiq
MMF3FKrCBqXJ0KyQWe5F+Os0Gbm4T5YMnF2hOtlEPGoeosbPFcjwYW02Od+7
Bd2L262wpESGsG2Ldx4S+XRVnOU8pUaGEybjDqpEvn/3ftl0S4MMH0lPZ4qv
taA15Ye2PqeToWZdmSuJ0Esaqk0rtxH23Qo6rQg9t+NdzoPaZFgSUdx1idDb
bE+O77rdZFgcVUg+RtTD8aNCrBoigzuHorzwpRb0X4kg64o+GY6uagvf4NKC
Mnf5D0YakWHjS8O4Q44tqLJoYeX9QeK+68E/jg4taKJwkL5yhAxb/+Sli1m3
oHU7rE1kLcgwfvsb7Y0lUZ93LY76lmSQf6a2R8aiBR0q+BATZEuGhU/tCvdN
iX7Voudl25Nh+9dJ8nWiX2/npdS3nCVD7Pfi73uJfs7MiViWuEDob/+F23o3
MQ9ZLmeTrpOB+7tSUpJSC5JV+3qL4U2GlMWixsNyLWhnxtHo4VtksCnPPtYu
1YJc0vYwNf3IwFQQqLIXbkE1yaKaH8PIELTScitmrhl9lQ807ntC6Del3Mg5
2YymX604cEeToUWuRWHfSDOSfzkcaZxAhmcLdYZmX5vRvWdlCx1pZJDQMpkM
KGtGsVLbxeYyyXBV96Hk2/fNKDc+Q31LDhlK/mWuKSb2SV9slL3DOzJMeiZl
mD1vRnuiLzL+VJBBkeffVPKtZnRcnN0nVEMG0YqGI3EezehS5In5rXVksBo7
eOT8hWYU/0SP6tNEhusLEhmRlsQ+C5V8sqaHDFwvj3Mo0JrR24AqW9I0GcRO
PJi6+64JpR6ol3w4SwbZ+VSFpoQmFMvf2jq6QAZH3YkPNX5NyDfsm0EJlyzU
bNDyenekCZnEzKsfF5SFwed36l4MNSJ2iuZKkKosXHNSYP/jbkQd53YUTajL
wojTXpbYIAvVqu65epIuC8mRtb8GGCyU9ebgkOJOWcjpLTWICGQhr0KnpnID
WZhJ2p6ux89C6xnxif/sZYFn0vqqKWcD4nz06qStoyxsiHX6+exrPZo6kC5S
7SILrLvalJSSevS5sfBhxGVZoJzxrOj1IL5fna2Xqbdk4aEo5+exASbaNbgW
zsTIgnjrxS0Cb+uQ02rPvsZGWbDNrfb0UWSgTTJ1nxZaZIE/+RCH83INatSW
alLqkIUfopacpM4atP1i9cd73bLQ0eUotuhXg3jaxOK2/5SFzC1V9i591Sj5
+TuLZ5xywBm7+717SBX6rjPLvLRVDnat7ly2YpajM1d83vLHysHdu/FDV98V
Ig1n1UYTe3m4UOAqTxpzw1/PyVzOOisPe9qtr79Mv46DL4oIrneRh7Cz5c+q
zt7Gv9wXjjS5ykM/R+z6Q8MP8Kub9R1HbsrDwMCDFkpqOJaIuNB7PFoeOLZb
lF+eeYZXPmSM2LHkAVc9eUsNzMTZOPFxebM8nA5UOJh7IgtbVzxRl22Xh4zS
+2ll8tm4iOHjNvBFHtLOWot5f3yDr7YenHL8KQ/ffvFmPPbIxUNDvxfOcyvA
tfzR3QlPCnCTsBqf504FuJ3TMEaLKcZ7Ll36RawgWC93UfjiWDHOZmQzKpAC
vP75Z+G4QQkOuUnzEzRQgCzBH1y7J0uwyeD2pQxzBSgQP6pGNf6ImUV7x9gX
FGBnT9lOzh8YV9udaDv8TAE2xD3/lHyhAm8ticm9/kIBktg+AlHhFThJ7Evo
syQFOK5juuZoYQX2Y1qbjKQrwHCS1RSNqxLrbXWoflioAE/ow2HekZW4bM2l
wtJmBRARP3V/LLcKl2Tfi1PjVoT++hu6B8tqMI+JxaZoHkXoapVya+qvwUd+
UZ5y8iqC5nDtXn5uBh6SY0V1CirCHntD9+z9DCzyVCLCV1oRmMPDc0FVDHzh
fmZA+05FSJNuOuD0rha/I91Zg3QVwezdq0KztlrMWXrEPw0UwUY2YGB4rBZH
z87cv22oCGPtcqd1lepw5aW9d5QsFEHMStFpX2Qd3mzZ6XnTTRGSC4wzY+2Y
2Gk6dWrwqiK4bf0ymujFxLkRPlePXFeE9NuF48fCmNiQRXJXvK0I0eNK9qxS
Jr6qd+Fic5AipFRGzo5L1OPSb7q/d4UqwsGS6tOXqfV43S3B88kRRLwSogOx
evU4sfCts/dTRcjzfH9z4UI9rlfjOCOfogji/nFDvcX1WJzZ2h+Srgin76SK
Mlj12N452W4uS5E4L72btO6rx/9eHLBtLFCEvU8Y8iGrGrCcRORJrwoi368F
wlzGDdi1wLmLXa0Izzu3PDI52YCLjuw6YVqnCPxS2n565xrwoeBvx2SbFWHf
uKCfZkAD9uFUOdzQqwijg10gVNGAB/fzdSn2E/YFXnp4NjXgwwEjp+9+VwQO
x5pjD3sasPyGN5e3/1aECtuOovzpBhxiHvYv7A+h168uwUZOFp6NdL/ze1wR
RArPvY8UIM4rW7aGPp9VBLtQwxQ1eRbebicmsbCgCIG+XxkL6iz8/NXMM4sV
RdDJjvp9fScLe6oUZfPyUGDc6MfsNVMWltbe0+ghQoERuxq/EHcWDvCROd4k
ToFg5nehqhssPFHK8VV5EwXWzDygv77Lwgz9ytGvJApk+T5f4xbGwvRHSZ47
5SkQ84Qr40Q0C8c3PFh6QqFAYfl7/DuBhd2OGgkYq1PgHaNbfmM6C3+JUo58
RaPAAxmnC3lvWHj/F16p5a0U+Oh2Z8NsAQtnS40kWWpTYPeda+uHi1h4oz1L
LV+HAhsO+zoFlLKwX1J2gQCigJDge/G2Chb+MxS620WPAttmpWWYNSxsqepe
VaFPAXONeN9LTBaucDU3kTKmgH/a4u6PLBZWy9Nqv25CPL968nhRMwtHTYta
tx6iwCNHiVb7Nhbm2DkzoHaUAq8PDOW962DhCzc/XXh4nAI2ztXLhZ9YuBO/
n+w/SYGrHnMljp9ZGLhjfXbbUCCeM2ccf2HhdAMf7mg7Ckzsm0+p6WZh0UDr
oPEzRPxs1tCNHha+zdIVMXGmQNXHVSWfCf4pKBP3+jwFXEus1QYJNj/GIcfp
SoEu/+uGiQR/jO5Pt3KnAMvii+RqgpW6K+jvPAh9UkezJAj7EdJJxYJeFJhb
vST6iYhn0f6B3gUfCigXb7fZ18XCTslOzOrbFNgfnBFl3cnCzT8NzUn3KFBy
zaxVtp2Fd6kpf/F+QAF9qylyVAsLJ13mdegIoACz4GjMu0YW3pD/+5dGMGHf
YJWxXz0Le880uAeGUuBe/W2jFQYLf9+ZPfc9ggJ/4rdkUqpY+H2Z27rYpxRo
SA6Y8y1hYdlV5uFT8RQoiz4nnPeOhYMNtTYeek6BdeERo2G5LGzfOK20KoUC
h+uvm1u+JvpZ6FOObToFPE/pCu99TvSzxXvtoiwKSJZZc3Q9ZWHeHm8j1wIK
HFoDvYLBxP3raQKhhRSYSmy+tvUBYU+4q/VNMRHvfY8DQreJeIy22YyXUWBl
ZBvvP1ci3oEzssJVxPsPhKgczkR+dyKG6AwKvPzh86/CltDr7Zi7B4sC/xzD
/nkS8xFxWHpHZDMFenlkzjntJ+rx22TxbRsF2otXzQvqEPWVTff/95mIl/p6
9j8KC5eHnI3zHqQAX0DgKuulBjyi/MQu7hcF3OOfryFPNGDJ6nKFDyOE/dNK
2i8GiX2yIJ2zNEEBnZ+hBW2NDXiLy+cq3xUK3HLJ11sd34C99pr98ZdUglM7
7s5/VG7AST0381M2K0GO09Bxo00NuOl6hlettBLsStzvEcbbgBWz13LzKijB
m4McmaeG63HbpkqJxzQlaN15x7DndT1Wn9qx98kBJYiX7uzGIvX4VKgTT4Gp
EtTmjZnpctTjByqR9e2HlYBcaf/GZ4SJe+wmLMRPKMGd1LsSu6uYOJCVef7p
GSXwirMrbXFj4h+vyf8l3lQC3Yrr3H6ldXjEr3+O21cJOk5YUTST6/CEw4vT
LveVYPDSo0dRQXWYQ4asSgtUgteHZc2fnKjDm6JJFRXRSiCgt1b6+EgtPvxQ
5u+PPCVYPyyBTNbV4g/OUiZqv5Qg43CdkY9IDa7U780NGyHef2TavHmiGjPl
EiSmx5Tg+b4ZtXvN1fjTty0DH2eUILBKgPtlcDWeOLHF+9AqZah+Sg3byVWN
lYw2p16RUQaWmfc1hYFK/J/SxlVFFsrwwKTj7cztcmxtq5gyYKkMo1a87PqT
5Vj+P60D662VYfe84k3vreW4YMU07IyDMlzEXbcdf5Xh9s57W9ZfVoZ8ka3u
t46UYZEHI1vPBCgDg2tBX2J7KY7ox44CJYS/GOnoOrUiHBbrxLAnqcCK9q2b
qSJZ+NR/No38QyqAUkVFLxyOR1vyeTdfGFaBCmn2V0pFAvrWUuhcN6oCrN/H
fRy0EtHZDcKc/lMq8I9n7BmJ9wVyDazRWuFUhRdbQqdih16he74aT8e3qMLc
+Y2O+k/SUNpFzrOd5qqQl3r74/ShPHQxKDtn63FVcJSiP3d7nYfU062WIk6q
goLtX8hczEN5Q2+jDtmpQvJcqKhDaj764HC+rvaSKpQ47o7NXixAzZZt6iUB
qtBunBvFFVOIZvcnzyWWqsKTpLX/3X3yAd0sSbxfVa4K2U69Cru7PyAOeqzA
rypVSDtlV5Ii+xGtkQkl0+tVobO70io05yMSn/MyrvqkChvkBwNCakuRVpbJ
059/ifi6FPjsPMqQq9iUNk1ODfxL+3R7r1SgiaA/FRaKalDYPlhAD69Anly/
TLyV1WCq67L6iTcV6OZYr12lhhp8EA2V5P9dgYLqGAEWu9UgsC7cXdquEqXe
iuu6YaEGL5QN5DOhCg380POqeKgGNQGzuqWfq5FeYuNLlSA10KZ6f/KcrEbP
LU+xIkLUYGskH+dv/hpkW+8ueyZSDT4eX8MhgGrQl5znDdyv1GBvwv1ipec1
qNVnmaRfqgb7L5lJBVowEG1b4MGscjWI5jvcvnSegcL+iF0Tq1aDs1RFR1Vf
BjKzp9b/qFcDyfFUvfw0BmIaWHv6f1aDkU/fbd3mGKhCqLiOMaUGWs9sTl4L
qkXkev0pjVk1GL94tMEtvhb5+rVIxyyoQQrnGZpsVi3a8+/nVRcuKrS0Nm1N
Y9Wi4h4J6XWCVMhkfFi1n68ObYx6ZeQuQgX9mYDB8Y11yOuQxtXP4lSQnN0Z
ZaFUh7ZXGNSmSVFBT0GtV3d/HcpL8bxyQJUK9UbdaSFedUjInjMhT50KR+Lc
I4f86pDbpseMTXQq5N5/azcdVofUHydt+a1Nhak+Uw2N1Dr02EDT8OhuKvzL
NeS0yq9DIysl7iWICsnUXYd1SutQ+pW2miADKiTmF/JtbKtD69ROj08aU+Gu
0kdT8d465PJjeLO1KRXAKaeQMViHFC253NWOUaHvCi40mKtDL3Vpm1n2hL2Q
TQ/zNzFRhRnv/YWzVNjYV+fWQmYi9umBYWUXKpQn7qnLVGIiuXuRxf6uVDih
OfosbhsT7X/iKvvWnQpprty8b3SY6GySYeCABxUGOWLwnb1MlFQzdxJ8iHyx
/KilCRNVfWotd71N+DurZWl/hIm+/8xQTrhLBTWz0UnF40y0at4vvN6PCird
d0rSTjGRPJ/t3NxDKvgm4fRftoS/LTvslYKowHVNqXTQgfBHFaw7HkKFbQa9
E8+dmCj5UEVM/n9U2GoxX2hyiYlq7OI42NFUuDj9W3+PGxMNunu4CMZRifPC
7r8jV5iI575p855nVHDcc6TQ0pOJFP9T1L70ggoGozvi715nIoPklcS4JCpY
zL967nyDiZzeda1hplDhZs1YDa8PE/kzci/PplPB88AW4Qs3meh1V+AnxWwq
XFlufhBwi/D/6wyyyKWCcpmV4pnbhP/53Sn3C6hgVJgzO08wD7/4hrxCKpzU
Ps91+A4TUaTGrvUVU2E5udbYgWAj9dqv60uJ+h7O66AR7IJeGOiWE/U9lp9V
SrwfcNg7+0IV0W/Xlj6vJTjV/qh4LIMKeMn5jCDhv/aK2u1aJhVcQi8f7SDi
/Xl/9eAMiwpz3NsLTngz0drIr6YKLVRI2nMvLNqLiZReF7492k6FBM6yyf+u
Ef4Lw6TufaKCbPnKr0MehP/acw9yvlCh12PmTq074f+z3ujXXipUOy9VLLsy
UdrwZguBfirY8giXT1xgIubC1Aed71Rwy+gISHJhomH+RvnzQ1TQvPBYWdSR
iXilU4JjhqnQ1EPO32vPRCoavlM1o1S4x5beTrVhogNw0nr6LxVmLudXdloy
0fkj9Cq5KSpoH8q9tOcYE6Vf/f7Ed54KX0et7Y0OEP78Pi5kL1HhveGXluH9
hL/IqDO9HOpgmHI68yBiItX3Rlq71qgDjUNsykiLiUzqyHEuvOpgYkR+/EON
iS5+meeKFlCHQ69Hh0CRiTIXM1snRdRBM85p71ZJJmoQ8N8lK6EOAnaTbg2C
TDQiffrl4U2E/aWVSrl1TKS2V+hKFkkd8i5r6QoS85X1wFPImaoOLPcJ74EO
Yn5329x7oKkO27pPJqc01CG1qf2Tr7TUoUG69ZB6JTHPDqIdfTvVYQGvib3/
pg6lovyYUwbqYN4bePzIgzr0cyZ23Q1jdfis9aBZzbsOUbLveUebqMO+xYOV
9a516PUWc+t2c3X4N6oVe+xEHUqa+ytjdlod/tvG3RupUIe+53SFXXRQh5Ys
4V9hknVIzqWMM8hRHb7KyAceJvbby87QAcYFdbi7vkZO+m8tSsxXT9nrpQ7+
dx4uz7yrRbGXLqpvC1eHsxG3bCt31qIv8scSj/6nDkJNNwo2KdeijT06glei
1cH7sBLaKVmLYg7wTWQnqMNyx+fMhmkGiqSkv1VKV4ehmi9S5tnEPu8f2r2l
Uh0iuyKfc4kx0EOLMwe5pwn7tEwz1+Jq9PJQj7XjrDrQ53s7hF9Uow/GFq7E
wQza/+3xu/mwGk3oGoYHcWlAvsNyxPOj1chaUfWTiKAGzEi92rv1VxWi/5tw
kFfVgI8Pp2Rb11WhrzH3vPXtNeA7z+/1RnIVaC5iISjlrAZoCzQ0buOuQKKP
PRLWuWjAmpKg3El2OTK+61TGctUAWslbh/4X5ajg3AGe4zc1YM+TZblQqXIU
uEs4wilaA0yt1NSC+MvQtp4XaQ9ZGvA7mLE3LboECaq7zL5p1oBOvtNTguYl
aOSOumFXmwZMculiHf4SlCRX8l3piwZI8ba79N4pRqIX2mWYgxrQpDBUcPZs
EZq/yX2Qh0MTRnZlCsnKFaLPfNvLjTZqwm2JunHHm3koRjkui3VQE45/HPE2
D32B7pQ9jjlYpAlvLKXanDnT8HBv2X9zxZpwNvpr55GXafj4wmRYygdN+GZg
mjqgl47Vtp96xF2mCeE7+1r+3cvAXRmK3iU1mmD2fPZw3nIWpkdjK9V2TShX
8jXwds/Fg5fGpfnGNMGa4rIvWPkdPhIkv7noryZ8PON38duVd/hD6gkJ5wlN
eCmXu2Ok5B1+MvBxQ+W0JkTfsX2mYVqI4WQgh88i8fwy/36ji+9x7H459vA6
Gox+sQ6VjC/GppstkpnyNDiZWrVa7mMpjvmuTmxOGoxs0Bjjmi3F37PWdo9Q
aBB4Z+ldOB3jm/BBcIMqDVbX8VYXvcY401Hu5lEaDfLEeZ9H6Jdh3pxx8x5d
Gtz4rtC0QC7Hx2/UX7qEaODXLTpYubscv9RLDlgGGhzc8P7M6RPleGeHZSlp
Pw1691Kfbwguxy7zWNnxAA2edl+JMJssx4z9IRx/jtNg5XHXHZGiCiy83mXz
HUsahAc9855prsC2n/ZuFzxF+CMf00/7WYFnzk1foNvQ4PbRrZ63JCqxYqj1
p2tnaLCzSdPvy5VK7PdZJXvlMg1OnJ4m65CqcPPLVXVh7jRQ80zezL2tCm+5
+HWAfJUGrrX6tdHGVTh/OXzj/ms0KH57wU/xShVmy835Bdykwd9KzYz2siq8
15VhJfSIBg+DI66ZHavG812/DKoCaaCQ1eO137kaF+zjp18PpoHH3lnRhRvV
WHHjkbW9oTRg6SjbpD2rxvxVXwpSo2igVDdKWf2jGteoLyVaxdBA8Qb1z/x0
Nb7zVCZofSwNGvsPDr7hqcETrmftPRJoYO6pUHOcUoO7Nv4RgCTivtG3gSeO
NTjCT3BuIpngQ7fbbnvU4INj9O/JKTTokjv2gXK/BpdWXS/my6DBuwi/33mJ
NcT5mdP5Uy4N4gUN12R01GDbL3Lmgfk0cJzP4LrHrsES+ga6um9pYPgn+Y/Y
WA0O3BQk8uo9DUKDLsp6rGFgt2rRMldM1K/4+jDPNgZW0dyRQS4n9O9yPl6B
GHgg9mRUewUNHFSGv+w8wMDH3Z5d3FVDA+/96s3Wtgws2F12YpRBg7QNJNG1
Lgxcpz+g97yOBk/cVklcdmfg3ZuVNvKwaND53met230GnnlwYFVRIw0G9zk3
rwtm4Dd/L45daKbB7PTMutP/MbBsTW51SxsNWi/RHuskMfBad50rCV9oYCP3
SqqkjIErum1sDvfQYPuuz+/UGQzsY+BrxP2VBgPDaiY2LAb+s7la+lw/DZrt
Seh3FwOn+g+t2zJAg0eLaQEHvjKw/fi66cbvNOAak399doCB22vM6rf+pMHW
Rwd060YYOITm/m7oFw3074mkiYwzsGH8kxexv2kgeIOXJTnNwBxr3gWbjtJA
XFQjqWuWgYvdu65zjNFg6LGhytFFBr7aM++Q/5cGc9l9VgErDKxmKGXmNEGD
s9Wm2724avFgLtq5cYoGwbGphbKra3HiFgf5hmka7Hdq+fpwTS3epaWq7vCP
Budv3H/7gDiPthtP7ZidpQFn5MuNhny12NXu496QeRqY/CfJ38Bfi9de9z8o
v0iDjh7HENH1tfjl40MWxUs0aDN98ZK0oRbvTpI8fXiFBqDudfAvwZ3F/S6D
HHSw3agefF+wFru1pF+5yUWHmV/xLl8I5v159abwKjpMvtr6Y4rgpOXd/qmr
6ZBsvcDTRvAeMZ6wPWvoEEZ+3OZBcJdq09P2tXRg9m4+8oWwf0Uv5tV5Xjr0
6V725yaY/6R9Fgc/HUwivnv/FajFry+rFEYJ0CE8x3X7CyJ+8J8sU9tAh+LW
yHIxIr8v8R+YFYJ0CPa8rmBG5O+R/6DdUpgOVttqLhwg9FnPNPv6R4QO9LS6
Z7yEfql9Ej/9xOhQtNu2LoTQV+9f3/gmCTq8Wzs900no3yOQvpAjSYc16U+0
Boj6COns3tC7mQ7xHt/5jWYYOPPI6o1XpeigPeRf9XyCgQ1cGmXXyRD5OwqV
f/zDwN6Rdtu3ydJh7pRk9f5BBhbNVIZ6OTo0k2RHsvsZOLtiwthegQ5xKurR
vT0MzB7zs3msRAcy/X1pQCsD3+Qxc5ZTIewJnTq9muhPcSkJ9yJVOlx9qN9g
QPTvgQNpfj/UiXhbHp6ULGHg73ZXQnw06VA7Gf4ytYCBb1/XiRGi0yGg9uC6
5SwGzktiZehuo4PxKfeHs4kMbFIS9bZtOx0kZiQaEmIYeLDlND6nTYegGwMB
a8MZeNPKeGukDh0eRITWq99l4PsnxedH99KBvUl2Zzkxv9Ju37j99tHBIfn7
8n8WDPzeP1Vgkz4dOsWe8WuYMPBI/i6ygREd/FIvXHmnzcDH1p82emZGsLd3
itgGBpavTIkys6KDWc72e7TcGtyoNpvUY02HwHPcP94n1WCvKKP887Z0eB+3
qZI3pgbXn/vV5G9PB9a6wFvrb9fgK4Kq67AzHVY1nOp9aliDsU22j4YHHXb2
C13qb67GLozlRx896aAivWqWXF6NhWmHYg5ep4MdinDWyK3GTqv+Fjh7E3o3
2CXmhhH7OIP2J9GXDvNBeTssTavxqdkCO8HHdPisbVhk8bEKr3JYfflZCB0a
j+zzv5FehbPrLW6phdEBNq+XvBRdhTkTZ54aPaGD+7fMI1VuVThVX7vN9ykd
9N0fpmuTq/B0RIn+eDIdbEZeVzrdqMRh1AqV1lI6jFzMKLNeW4FTta3W3Suj
w+21Mj71o+UY75saolUQ+dsEF69rK8d/Tiomh1fToSdkbu1MfDk+6B8oc6SB
Dl9ICVVR6uWY55u5aPNnop+aPxzba1yGfcIGllhTdKBYNppofvyAnSZXtdSp
aMFu6u3TFJ0CbJu+v9FaTQsCBLwZorP5+Li9X/0YVQtu7Yw72VmQjw2auGvE
aFpQ7Vf5oouajxUzuErsd2gBQ6DCakQqD/9w4Eie26cFdvM03DD6Bp9tXfBS
ttGC25PSmTXkFOyQO0F6FKoFSvO3Y5GNH7547+jigXAtoH5YZW3ffhd7Hi34
xP9EC14JWUzwR9/GAdOeIWFRWvBQtr9x8qoHzt45txCdoAWNpyauG51ei+fK
VzpfZ2gB/WnQdmFpPxTWyv+4iqEFHvukJRYEn6HYV5dc/Ou0YEhuU85700T0
yqNxn1G9FvF/2rd/cf9z9E48bL6+UQsu/nLK8PF9gXpOibi0dWiBl7l7i87U
K0QZ2LiPPaAF+14beVBYqUizwFs66YcWZHYdV650SkO7HnTPOQ5pQTSSE+Xm
SEcmlIScX8Na8DvP94gLLQNduUCSHh/XgulQJjkqNAvd3H13Lm9SCxY6ntPJ
itnogQC73WNaC7YlZSrpfchGMW9eBc3OagFfoPm7PUNv0EvfVc7F81pQf1vP
kW9PDso44qh3c1ELLkj893VPQA4qkK2R2rOsBWq5pJ/arTmodFJxbmVFC7bu
zn41uzkX/Q9coKh8
            "]]}}, {{{18., 0.}, {0., 148.23529411764704`}}, {0., 
          88.94117647058822}}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SubscriptBox[
              TagBox[
               StyleBox["\<\"J\"\>",
                FontSlant->"Italic"],
               StyleForm[#, FontSlant -> "Italic"]& ], "\<\"\[Nu]\"\>"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->15,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {72., 214.2}, {0, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SubscriptBox[
             TagBox[
              StyleBox["\<\"J\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ], "\<\"\[Nu]\"\>"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->15,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {72., 214.2}, {0, 0}, Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{360., 252.},
       PlotRange->{{0., 360.}, {0., 252.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{504, 396.},
       PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 252.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{1.53, 0.}, {0., 0.}}], 
         LineBox[{{3.06, 14.823529411764696`}, {0., 14.823529411764696`}}], 
         LineBox[{{1.53, 29.6470588235294}, {0., 29.6470588235294}}], 
         LineBox[{{1.53, 44.47058823529411}, {0., 44.47058823529411}}], 
         LineBox[{{1.53, 59.29411764705881}, {0., 59.29411764705881}}], 
         LineBox[{{1.53, 74.11764705882352}, {0., 74.11764705882352}}], 
         LineBox[{{3.06, 88.94117647058822}, {0., 88.94117647058822}}], 
         LineBox[{{1.53, 103.76470588235293`}, {0., 103.76470588235293`}}], 
         LineBox[{{1.53, 118.58823529411762`}, {0., 118.58823529411762`}}], 
         LineBox[{{1.53, 133.41176470588235`}, {0., 133.41176470588235`}}], 
         LineBox[{{1.53, 148.23529411764704`}, {0., 148.23529411764704`}}], 
         LineBox[{{3.06, 163.05882352941174`}, {0., 163.05882352941174`}}], 
         LineBox[{{1.53, 177.88235294117644`}, {0., 177.88235294117644`}}], 
         LineBox[{{1.53, 192.70588235294116`}, {0., 192.70588235294116`}}], 
         LineBox[{{1.53, 207.52941176470586`}, {0., 207.52941176470586`}}], 
         LineBox[{{1.53, 222.35294117647055`}, {0., 222.35294117647055`}}], 
         LineBox[{{3.06, 237.17647058823525`}, {0., 237.17647058823525`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{360., 0.}, {360., 252.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{358.47, 0.}, {360., 0.}}], 
         LineBox[{{356.94, 14.823529411764696`}, {360., 
          14.823529411764696`}}], 
         LineBox[{{358.47, 29.6470588235294}, {360., 29.6470588235294}}], 
         LineBox[{{358.47, 44.47058823529411}, {360., 44.47058823529411}}], 
         LineBox[{{358.47, 59.29411764705881}, {360., 59.29411764705881}}], 
         LineBox[{{358.47, 74.11764705882352}, {360., 74.11764705882352}}], 
         LineBox[{{356.94, 88.94117647058822}, {360., 88.94117647058822}}], 
         LineBox[{{358.47, 103.76470588235293`}, {360., 
          103.76470588235293`}}], 
         LineBox[{{358.47, 118.58823529411762`}, {360., 
          118.58823529411762`}}], 
         LineBox[{{358.47, 133.41176470588235`}, {360., 
          133.41176470588235`}}], 
         LineBox[{{358.47, 148.23529411764704`}, {360., 
          148.23529411764704`}}], 
         LineBox[{{356.94, 163.05882352941174`}, {360., 
          163.05882352941174`}}], 
         LineBox[{{358.47, 177.88235294117644`}, {360., 
          177.88235294117644`}}], 
         LineBox[{{358.47, 192.70588235294116`}, {360., 
          192.70588235294116`}}], 
         LineBox[{{358.47, 207.52941176470586`}, {360., 
          207.52941176470586`}}], 
         LineBox[{{358.47, 222.35294117647055`}, {360., 
          222.35294117647055`}}], 
         LineBox[{{356.94, 237.17647058823525`}, {360., 
          237.17647058823525`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {360., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 3.06}, {0., 0.}}], 
         LineBox[{{18., 1.53}, {18., 0.}}], LineBox[{{36., 1.53}, {36., 0.}}],
          LineBox[{{54., 1.53}, {54., 0.}}], 
         LineBox[{{72., 1.53}, {72., 0.}}], LineBox[{{90., 3.06}, {90., 0.}}],
          LineBox[{{108., 1.53}, {108., 0.}}], 
         LineBox[{{126., 1.53}, {126., 0.}}], 
         LineBox[{{144., 1.53}, {144., 0.}}], 
         LineBox[{{162., 1.53}, {162., 0.}}], 
         LineBox[{{180., 3.06}, {180., 0.}}], 
         LineBox[{{198., 1.53}, {198., 0.}}], 
         LineBox[{{216., 1.53}, {216., 0.}}], 
         LineBox[{{234., 1.53}, {234., 0.}}], 
         LineBox[{{252., 1.53}, {252., 0.}}], 
         LineBox[{{270., 3.06}, {270., 0.}}], 
         LineBox[{{288., 1.53}, {288., 0.}}], 
         LineBox[{{306., 1.53}, {306., 0.}}], 
         LineBox[{{324., 1.53}, {324., 0.}}], 
         LineBox[{{342., 1.53}, {342., 0.}}], 
         LineBox[{{360., 3.06}, {360., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 252.}, {360., 252.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 248.94}, {0., 252.}}], 
         LineBox[{{18., 250.47}, {18., 252.}}], 
         LineBox[{{36., 250.47}, {36., 252.}}], 
         LineBox[{{54., 250.47}, {54., 252.}}], 
         LineBox[{{72., 250.47}, {72., 252.}}], 
         LineBox[{{90., 248.94}, {90., 252.}}], 
         LineBox[{{108., 250.47}, {108., 252.}}], 
         LineBox[{{126., 250.47}, {126., 252.}}], 
         LineBox[{{144., 250.47}, {144., 252.}}], 
         LineBox[{{162., 250.47}, {162., 252.}}], 
         LineBox[{{180., 248.94}, {180., 252.}}], 
         LineBox[{{198., 250.47}, {198., 252.}}], 
         LineBox[{{216., 250.47}, {216., 252.}}], 
         LineBox[{{234., 250.47}, {234., 252.}}], 
         LineBox[{{252., 250.47}, {252., 252.}}], 
         LineBox[{{270., 248.94}, {270., 252.}}], 
         LineBox[{{288., 250.47}, {288., 252.}}], 
         LineBox[{{306., 250.47}, {306., 252.}}], 
         LineBox[{{324., 250.47}, {324., 252.}}], 
         LineBox[{{342., 250.47}, {342., 252.}}], 
         LineBox[{{360., 248.94}, {360., 252.}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 14.823529411764696`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 88.94117647058822}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 163.05882352941174`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 237.17647058823525`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {0, 1}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {90., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"10\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {180., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"15\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {270., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"20\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {360., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              StyleBox["\<\"x\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->15,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {180., -15.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 14.823529411764696`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 88.94117647058822}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 163.05882352941174`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 237.17647058823525`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {0, 1}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {90., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"10\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {180., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"15\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {270., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"20\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {360., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             StyleBox["\<\"x\"\>",
              FontSlant->"Italic"],
             StyleForm[#, FontSlant -> "Italic"]& ],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->15,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {180., -15.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{504, 396.},
       PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.7857142857142857,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{504, 396.},
  PlotRange->{{-72, 432}, {-72., 324.}}]], "Output",
 CellChangeTimes->{{3.5667608904853315`*^9, 3.566760906975355*^9}, {
   3.5667615855863047`*^9, 3.5667615983763227`*^9}, 3.5667683364552107`*^9, 
   3.566768383245276*^9, {3.5667684244053335`*^9, 3.566768449765369*^9}, {
   3.566932498591853*^9, 3.5669325171246853`*^9}, 3.5669385904304657`*^9, 
   3.5669503240486717`*^9, 3.5836992471752343`*^9, 3.5943060249254956`*^9, 
   3.594306319005907*^9},ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Supplement: 3D plot", "Subsection",
 CellChangeTimes->{{3.5670286429270935`*^9, 3.567028647854375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "plots", " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"FigGraphics", "[", 
        RowBox[{"Plot", "[", 
         RowBox[{
          RowBox[{"BesselJ", "[", 
           RowBox[{"0", ",", "x"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "0", ",", "20"}], "}"}], ",", 
          RowBox[{"PlotStyle", "\[Rule]", "Firebrick"}]}], "]"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"FigGraphics", "[", 
        RowBox[{"Plot", "[", 
         RowBox[{
          RowBox[{"BesselJ", "[", 
           RowBox[{"1", ",", "x"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "0", ",", "20"}], "}"}], ",", 
          RowBox[{"PlotStyle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Firebrick", ",", "Dashed"}], "}"}]}]}], "]"}], "]"}], 
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"include", " ", "surface", " ", "plot"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"FigInset", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ParametricPlot3D", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"r", "*", 
              RowBox[{"Cos", "[", "phi", "]"}]}], ",", 
             RowBox[{"r", "*", 
              RowBox[{"Sin", "[", "phi", "]"}]}], ",", 
             RowBox[{"BesselJ", "[", 
              RowBox[{"0", ",", "r"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"r", ",", "0", ",", "20"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"phi", ",", "0", ",", 
             RowBox[{"2", "*", "Pi"}]}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"BoxRatios", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"20", ",", "20", ",", "10"}], "}"}]}], ",", 
           RowBox[{"Axes", "\[Rule]", "None"}], ",", 
           RowBox[{"Boxed", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
           RowBox[{"MaxRecursion", "\[Rule]", "2"}], ",", 
           RowBox[{"Mesh", "\[Rule]", "Full"}], ",", 
           RowBox[{"NormalsFunction", "\[Rule]", "None"}]}], " ", 
          RowBox[{"(*", " ", 
           RowBox[{"PDF", " ", "friendly"}], " ", "*)"}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Scaled", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.55", ",", "0.95"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0.55", ",", "0.95"}], "}"}]}], "}"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"RegionExtension", "\[Rule]", 
          RowBox[{"Scaled", "[", "0.3", "]"}]}], ",", 
         RowBox[{"RegionDisplacement", "\[Rule]", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "0.075"}], ",", "0"}], "}"}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"XPlotRange", "->", 
      RowBox[{"{", 
       RowBox[{"0", ",", "20"}], "}"}]}], ",", 
     RowBox[{"XFrameLabel", "->", 
      RowBox[{"textit", "[", "\"\<x\>\"", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"YPlotRange", "->", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.6"}], ",", "1.1"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"YTicks", "->", 
      RowBox[{"LinTicks", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1", ",", "0.5", ",", "5"}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"FontSize", "\[Rule]", "15"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Background", "\[Rule]", "Moccasin"}]}], "\[IndentingNewLine]", 
    "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"CanvasSize", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"5", ",", "3.5"}], "}"}]}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.395095660953125*^9, 3.395095674*^9}, {
   3.395521201609375*^9, 3.395521219546875*^9}, {3.395521484265625*^9, 
   3.395521484265625*^9}, {3.5165608799375*^9, 3.516561289578125*^9}, {
   3.516561367203125*^9, 3.51656143996875*^9}, {3.5165615648125*^9, 
   3.51656159890625*^9}, {3.51656165578125*^9, 3.516561684609375*^9}, {
   3.516561736796875*^9, 3.51656176128125*^9}, {3.51656182196875*^9, 
   3.51656184021875*^9}, {3.516562109421875*^9, 3.516562176015625*^9}, {
   3.518120479046875*^9, 3.518120490453125*^9}, 3.518562728439125*^9, {
   3.5204484336875*^9, 3.52044843615625*^9}, 3.520448550328125*^9, 
   3.520448590953125*^9, {3.520448623734375*^9, 3.52044870559375*^9}, 
   3.5204487371875*^9, {3.5663380284029846`*^9, 3.5663380304465885`*^9}, {
   3.5663382102525043`*^9, 3.5663382784090242`*^9}, {3.5666831570648704`*^9, 
   3.5666831894037275`*^9}, {3.566683244128623*^9, 3.566683245064625*^9}, {
   3.566683290335904*^9, 3.5666833547328176`*^9}, {3.566684339205373*^9, 
   3.566684341061776*^9}, {3.5666886390420675`*^9, 3.5666886614374113`*^9}, {
   3.5667608876953278`*^9, 3.566760905005352*^9}, {3.566761579296296*^9, 
   3.5667615963663197`*^9}, {3.5667683037651644`*^9, 
   3.5667683344852076`*^9}, {3.566768377475268*^9, 3.56676847937541*^9}, {
   3.5669324352089415`*^9, 3.566932445192959*^9}, {3.56693381042207*^9, 
   3.566933814232075*^9}, {3.566933880002167*^9, 3.5669339322822404`*^9}, {
   3.566934028322375*^9, 3.566934070632434*^9}, {3.5669341409325323`*^9, 
   3.566934145142538*^9}, {3.5669444221289644`*^9, 3.5669444766090407`*^9}, 
   3.5669446515984573`*^9, 3.566944819295404*^9, {3.566957124668193*^9, 
   3.566957125089393*^9}, {3.583697500935187*^9, 3.5836975087451982`*^9}, {
   3.583697614315346*^9, 3.5836976569754057`*^9}, {3.583698073075588*^9, 
   3.583698077540595*^9}, {3.583698546321251*^9, 3.5836985474262524`*^9}, {
   3.5836987165964894`*^9, 3.5836987222714972`*^9}, {3.5836987529015403`*^9, 
   3.583698779776578*^9}, {3.583698900031746*^9, 3.5836989614918323`*^9}, {
   3.5836992128451853`*^9, 3.583699238440222*^9}, 3.583699797031151*^9}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
      GraphicsBox[
       {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
        RectangleBox[{0., 0.}, {360., 252.}]},
       Frame->False,
       ImageSize->{504, 396.},
       PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {360., 252.}]}, InsetBox[
      GraphicsBox[{GeometricTransformationBox[{{}, {}, 
          {RGBColor[0.698004, 0.133305, 0.133305], LineBox[CompressedData["
1:eJwVl3c81f8Xx8lI9ihlr2td4nJVSL1PohTfhtCSJFkhlYoSTSJKRWbJKpVR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            "]]}}, {{{18., 0.}, {0., 148.23529411764704`}}, {0., 
          88.94117647058822}}], GeometricTransformationBox[{{}, {}, 
          {RGBColor[0.698004, 0.133305, 0.133305], Dashing[{Small, Small}], 
           LineBox[CompressedData["
1:eJwVl3c8Vf8fx41SGWXTwL3WtS7u1VDS552yCpVSyghltERRoqGShKy+RkYa
ZMsqoXzsy+XapFBcRYlkZvud31/n8bznnPd4vce5H7LDZXNHLg4OjmBuDo7/
XxNuO/DQzsbtWbz1/2vQnqo2kskJ0g20eAw9PkQ6h1ZqSu+TSI9Q5xL/I07i
94SyxzKrSU/Rt9dT2x/JPEIXdT0v/ZNJQ6a+jE9rpJ+itgWX//7KFKG/duU9
dMk0tKabTRmVqUPLee+/rXAUoRfMRPffMp+RrqB9eGNSLZqKeavyLfgzMjDq
Tr3IV4cMnOsHWueI+5VDl9vd69AI9z+L4rYvyCBL8+mSLhNp65rtevSwB3Wp
njV91laPmt8sclHGvqGfPP4FpyYb0R2m2gHa6QG05Uz3Fc87rSg1t1AxI3IA
3dZJmg7JbkWtMXrcCg0DKLAwWdS3txXJO1t+kNz5He1lVUYN7WpDTG4/dQ6R
H+jS0W2sssk2JK7bLdxUM4jkYnTtDGw6UPabR90X1YeRqu9JmTUCXWhYeDj4
gP0wMtpT5flMqwtRrh3Yo/TfMGp+KXJm7aku9Hw334uBuWE0/IP1y/x1F4qo
C3Y6Vf0bxemWCpbs/oyuDYSOG1qPopKn78zi7b6gRL76+0L6f5Hpb9br7ns9
aI+uj7Wv7V/kv/HmIf1XPajHVXXb2PW/KH/YIehGZQ+SbA0abEj/i2rtDnUB
dy8KjzExDhAcRztaryTu9+1F9xUa1690j6MKe02Z8ctfkTNqeTpyZRIpyoR3
6gj3IY6XM8XdQZPoskqre4p0H4pZtaWHmTSJVERzrGdU+lBtnZN0Wuck2ibg
06K7rw8pHVt86bhrCiW8vC7mfqUP/XShZH7lnEafT8gUWtb3Id96ExZr0zQy
Cv57/m9HH5JUv/Lng9Y0Sl56YXy+rw8ZTX7QjHOcRuvn/AxWTfehtFvmb0/U
TSORKO/7TVv60fmIW6XNYTOoQfrv7FunfsQ1/fIbTptB29/v23bucj+KPVHL
8aZiBr2r0clfut6PmFtE9j2emkEPrCX1mAH9SDUllWFs+Q+9vjl86m9qP6pa
1/hT2/0fkujbYp6Z04+sL06uUwr8h1IOalKN3/ejYNoeE54P/5BpbOZZBUY/
Gilpa66QmUX8jhdKnQb6kZ/03Hiu9izqqHV8rzTcj7bclRZ5cWQWvWJOGtb/
7UcmBucs7tyfRV/99VbnLfWjrOblzzpDs8hhIF50tTgbGWjJL6hwzCHzEfcO
5mY2+hppvGXTxjlUekh+1I3MRuut/rOdPTCHMlIv8tiqsZHrD+WBguw5dFzV
SqsE2KjP9vPa8ro5NCgvjH7ps9HRrgB11vc5dK0zvWX8ABtp1w/d+LFpHqnI
Jl+NOMZGGfujE8e3zaPcHxPXVU6ykXSpQfXS4XnkVDk/Em/DRty5yYLiD+eR
OL1VXMiJja6pWGyXfTmP2CtGlcLn2ejnq1XW6h/nkfr52qY/l9ioMepMisHk
PKq/Nr6wzZONQFCEZb5+Ad2eWhJ74cVG+Y8qJmyVF5Aro8tv0IeNYm6S91w/
vYA8D909yXGPjXhnms/c915A3xMufWj3Y6Nbl30fhUYuoEeXHV3vP2Sjvz81
3sTlLKA1Wa2u/IFs5ODwrT2lfgE5pl37eDmYjdq7Q+bzBxdQ4pbzp7JC2MjQ
Yg+pjHMRvZKSMqgOYyM1o4QLXTsW0d+27QJ+/7HRs3KT8O/mi2iNGf23ShQb
Ceksvvt7aRGZsMSlMqPZyK8go2cxYBHx1a1NXvOUjWaoVlzrkhZRU9/9B7qx
bHQuhVdJDC8ii+ZT5aZxbNRDKjYlf1lEeQ6FVtrxbGQWe+4qdXoRxZ3dZLlE
cLnIxqc7BZdQd6RVcXwCG219XFuqr7qEZp6m+Ys/Y6PXPF7fjxgsod9Dj8rP
E7zRl8Jra7+EdhR1XX5KcPBcp8b5m0vo57/aqJcEL1/xt7gWvYT+qH7X8SfY
fWSbz728JfTUmddxP8HfHX88D2EtIbrWFclewt/xb//VxP5cQo3XU60PE1xr
uX/kNfcyMjkXpv2MiE+ndVIoX3oZXb58Jr+GyCf74KsdeOcyMl2f215H5Euq
NrepP7aM3rBsk1IIPSL2cN3/dHkZdcukqtjFsNHq97mpA4HLyMFQ2m2S0NOL
Zt84lryM1Han3rKPZKPhdMGphTLi/dB71ulP2Mhavmzj2p5ldOowEm8MZ6Om
hMtI9N8ykh2pLmgIZSM9CRlHkvAKOiJ8VO/1YzYqCGsMVKOuoEv/edWdCmIj
Cu/tHG2jFeRgIGUxHMBGsfepnfvPrKDu3pt/j/mz0Z1rwWSbpyuois79oMSX
jSbGdAzPFayg/AijqMJbbHT23O+Lnk0rSLzzwVCINxspqCv01HBxgPTVqltN
V4l+JPtRvmlzwFaj/JmnZwm9dodr3NbnAJpsTVaRHRv5Wz7bIWVOsP21yiJr
NuIKe29odYEDzHzoulbEfM0vjzh/SuCAajXnz/J6bPR+0/zla+kcINo2N2Gk
S8zT9jVeYoUckBMZ2GmqTcR3iRxwtJkDokymts1T2eh3j0VqExcnzJzyW/gq
wUbpsw45rhs44aXT+Fo+YTZyEXV7L7CFE45RtltJ8hP1PhhYe3AbJ/g16Qh+
WulHPcWlPxnOnCBrIxc9+KMfNcRQlMsaOKGdz67AJrMfBRZspZ3+TNi7bGbw
OqkfGTXv3bn8gxOS5rigJZ7Yh2usjXevcMKqqYcljcH96MO1sHPvaVzA8UBW
7PwFYn8dm0vLieICp29/pbfJ9aOLbjx5h15xgf/fE5uzN/YjlWCR4j9vuMCm
8UYPr2A/el1JZarVcUG3dROf22IfekZ3GE5d4AIun86K3219KESwXuWFHTdI
9bieKb3Vh4p2SL01c+WGLxunZoLd+9B328to0YcbPr02Qbsd+5BOlsixE9Hc
oBGq46VrQnxfjK1vCTRyw5/dH2wbJfvQvvujTTd0VsGefI6FCMtvaHZ6g6e5
+GrYxBm2y8anF8lJOaysyK2G7qqrqwutepHZ/oJHWbTVEFbd2tat04uSIyyf
rTVdDerlbY0PF3qQucYLRun91UB+HP/iilcPynKhb1IdXw3TX2f0+1y6kUP3
MczdwAN869kJkYqfEW9c/yX3zzzQ19Jsncn5GeWdct3ybZAHxnx6eeJ6uhD3
l4c3ijnXQLpG4GPOiC6U1FWs5b5jDbzdNRqyNP8JDXaQUr++XAOS5aEp3DWd
6HzzSFjRjbUgfcX2zU+9duRe7edwmcILkVsLA3O7WSjXjf+opLEAnLobw/w7
lYsaYkVuZB0XAP2zObu1IRcNVm1K1DsrACzuTcbJQTlo00bl3xfvCMDch8Dw
Uf1s5Feuf7/8rQAEXI2qPZCSio4L38k/L7sepnfmvfSej0Xz+eMiHxfWw8I+
H4vpwTD8wufCsOYJQQixzdu2wF+ENcvWzT60EQRd/Itp+aIIl61KXf3tjCBc
D/rPHbYV477H30mP3QRhIGD0XppVCZZ+bnPi1yNBEEISQ5UvP+LYqkNVLz4I
wo5U99Qn/OU4QmDrM2FZIahuan+deagay5q3ZpxTEgIP5UxDz/BqnBvlVlSm
LgRjfLTzE63VuFkmq91VRwg23nU7staiBq+nK/LVHxOC4FnpZ5EWDBx4XNLr
/kMh+P3ezLTZsA7fS1w8MjUiBK+Osql4tAEf1nzvrjopBK0qqz8ryLOwdPnV
cIc5ITgnefPb9lMsXMwebm5eLQyOZT8ij1ez8ITC50NZ0sKg0WE/ey+6ETtk
vjV1OiwMf80uHH4p1ow1dd0vJRwXhpppXQ1R9Wa8zFJ73G4tDF0b1sVYGjTj
2LFXDXrnhEG2//ZFy2vNuJUecVDmnjAMUQzmNdqb8d4iV+OufGH4sXyAKf2w
Ba8/oHJuQ7Ew3H86OZUS34J7vvwIMCgThu1tHy5y5rVgr0Xr2oIGYRBrG62Q
72nBOeigYfgPYeiZ+R6nrN6KSTUU/QMSIsR+KZsQqmvFf44PnL0rJQJZlW6F
4d2t+MPQM7/3ciKw0Lnp37fRVmy5TrxKUVMEFOsL7g4JteEwk1X7uI1FgLT+
tujzE22Yo60PPniLwPb0HOlXn9uw36/SF953RaD4kcvNg8NteB1HAtfOAMIe
KfVn4XwbFqaerHobKQKJsy9Ceja1Y4WHLYZvckRA+N6rRHPLdpye8Cb1UqEI
lEbdXZR0bsfqBY/XqZWKwDc995KXnu1Yu9+4PrVeBHwT20U5ItrxAZ0Ks5eD
IqDQOWbSx2jHjUeev7EbFYHAizYs3N6Oj7rcFpSZEgHDE+YqDv3t2DpyV2sc
pyicrXilNzbXjl3H8iwit4hCgGRbsLJSB55YHf7uqJwoLKfIPZbW6sDXt1yW
EFYRhfl9vnyduh3Y11j1c8gOURD7WGIbbN6Bn7x6ZR1gLgrsmVUBYjc6sGTx
3Y8GJ0Vhir0jQepeB45vPi292k4URqpE54YCO/Drpc19dy+JgkxlgUdlXAdW
EZ0H8BAFweMTj9tfdeA3Kl0vlr1F4Wd6Y19KRgd+f+K/Mz4BorD3OD81srgD
73a9UrUzVBTUnzLk35R34HK/wwqzkaIQYtxhHlTbgZm5/EMer0Qh48tBi8CO
DmxWO2yolS4KZP3falndHbjta23qeI4oDE8b743o78A9fA/Ou5aKQtwdG+qr
kQ5sJ3umXq1aFOL7yQJN4x34h/Zetd/1ojBqUbXz40wH/uO4NOr8WRS6/ziH
9a104Ks3u80U+0Th6y5ThtiqTjwbUfTm+6Ao1EZ2nRVY24k5yzzd7adEodrQ
aGrfhk7s33m0VWaBeB76/t0T7sS8ozStr5xiUKb+4IGfWCcO5Rb8L36tGLTr
h6UYSXZi0U1/pk5tEIPmkkmXpk2dOEazwWKjuBjcidjVISnViaUM09992iIG
Ng4Bs/IynfilTYBElJwYfJV9+m2S1IkVPZy8jqmIQcR4WfQD2U5M3fXtaKKm
GOholptUy3XirRyWGsPbxWDHLUZ7k3wn1qlp5t2mKwaZigK7kxU6sV6w8eCd
fWKwSXpPqL5iJzY2ryhnGouBSINXdw7BhyV1EsQOi8GZflP1IYJPfM33sjsu
BmOUssifBNsmqR3LsBaD0iP7SW8JdjyfrDHjIAZQV9ZjQvBFTWm+vefEoPLW
4y9vCH9XZ6IGgy6LwYbcq8pfiXi8P2yo6PQUA77KrM+fiHjv3gtIIN8UA7w4
uBBP5BNgxHnj4j0xOHFK5wWVTOi33vtYYYAYbD+2o/sRoUdU+4QGV6gYxLz+
VJJL6JUQe4HPNFIM3m58ZJG8uRMn2X0fjI4TgxoDpZKzGztxhqJNBfuFGCja
cnL8Fe/EeSMdCdRUMfD83bTDULQTF+WZ3fDKFgOFmNJr54U6cZkX41hlgRjQ
x5xaTq7vxI2rivhOlovBofyr6glrOnEHkzb0iiEG8me0rMe5O3FPWHrFH5YY
vC9zWBTi6MTDW+Jv+H0RA+PM22Pv/3XgcbaoRVOfGFy5rOWOJjvwbOpjzU1D
YpBYPlQR8acDr952Z+jNpBhEugdpP//egfkX/lXMz4mBsFNKyKlvHVi43O2Z
Poc4tPhv3sj+3IFJpg4W3fziMCGzeuvJRmJ+HPUreRTF4acBr9dwQQfep1r6
7IiaOEwKyJ4Vyu7AB8a3e8fTxYFpdcyeJ6UDW95SotGROHxx3LvaKqYDe0Ty
JdpYikORXKJ+nlcH9rHy8061FYfufD5eU7cOfI+8ZDF5Vhzg95POd84dOCzr
D/8jd3FwvSrNN2vRgTOrW7wLAsWhqet8yFbNDvx9Ovo430dxWDOunF7Q3Y5f
7tW62lspDnWt3zafbGrHpx83hr5hisOdx6zkmop2/EV+dd3RLnGg/dlRt5Ta
jluOXtGJnxQHJ4tr3f1X2nFprgmJqiIBP02c9r5ZbMM3l4Z2r2hKwGHZnCdL
I214p/H9ky07JODrJ99jkr1tuKCvKMJTXwI+3X20tuBDG07fQFldaicBcklR
SYE32nD0Jc5hs2gJeHD20cNfv1rxsaJ4HvIzCbi+4Qhj06dWLLxaW24ySQLs
GR0GW6pacUi8q3V0ngQYeMmvC09oxX713Y3fWBKQrXOiycisFbspv8t3WyUJ
f1b/cFZLacEHfpy/FeEuCV6n30nmajdjg1tymfu9JEGPaTDWT2rGemI9X2Zu
S8I+vZIjo2ub8S59U22rYEmgJC99VM5twirJGpNyKZLgcq3ypO1II+ZznHJ5
2yMJ6EK3bpIFCzd8v3Wsy3AjbOC/6dj1rw6bfQ9TlZbeBGDJGSj9rAIPVzr4
1mZthhs5VvXhiQlYJpwoTMFmmDJmarpFxOFjtmYWx0o2Q9fSqkd3HzzFpbM7
VfpqN8PBXh6HoxcjcQRVqP3fwGYIe5jMmegdiHWiMYWyaQuUz20Pn7nqgoLP
b2l64L8Frm/9W3Aj7gVSF+qU2ndaChL+TFhWK71Hg48H70U6SgE7beyXd9R7
lMD7b2joghQIJnok9XAXIf5VknnBXlJQpiNX/ry3CA3PnDToDJeC+HW1i4KP
S1ByT6/ruSop+DHZ9w1/KUVbUn/gUGVpOFFLee4bWYHa5Wfk2RrScF/EXWRX
TQUKesETuHW7NPyO+aVfMlOB5mMpxz7rSUNqof4+kROVqOvxuZ+y1tKwPtZP
d71YFXpydVTwXYg0xOtWyH56UI140bR9z6Q0pLP4AgW0a5HXXqW17+alYS1l
KNj5bC0a3GeVHcopAwM+6e7uYbWowqh8Xm+DDHQYWmk9GapF3uaPn6SpyECe
r8d67og69NtRofqavQw48HBs0PnERKdcLC8cdpGBa9nTPQ7LTFR7PkhI5bIM
+BdMGW5VqEdJl8dtem/KwIRmnn+rez2yvvFxZl+MDDCT07sneBpQQ7CFklCT
DKjqygxdJ7HQrtCAxuEOGbjneemdoB4LpYaXeFT1yMBf7uo+0zMs5BdFLr8+
LAPKqc83FSSxkHTzjNoYFwksuBZVlOQaUefnimoLaRK8bbDxvbK+CQlY9cRU
kElwYFRVUFOlCe3vmb6goUCCrInbjMf6TSjvq5LwOjUS8JByq5V8mlDIQIjt
h50ksD50d6SzvwkZjp76J2tBguSSVLerZs3omej9tjuWJJjmFF4ndrIZTelk
vOmxIoGqtvtf/zPN6HnggnOUAwnaL5Dtuq83o3lKfNc6NxIwPxQ17H/WjA4f
qipwukoCH8tktlNKM3p9bSSs8hoJuhXJHy1zmtHR6t3Gt26RIN/Xwy+jvBll
OvQW/Q0kwZ8e2y987GbEFbg6yjSEBPvXLIWk/2pGlrnUK+nhJLgozJ8oOd6M
VnPcVjkbQwKnoPbXDivNyJrymqc8jgSLDQ8D9/C0oDyzRrZUIglOPE188Yu/
BdkmSMd9SibBfa5sw6yNLaigyuD61jQSWOnW11TLtCDeEdej4ZkkuLUn9mSW
Qgsq3IX5DuaTYK+55fNfmi1IsOv0zdIyEhjNd24U129BTisPLTdXkcCR0yb2
tXEL+qCYs9WLQQJS7M61PGYt6JwnxyitkQTuQW9e0o63oLJ4pbqQFhJoXZqo
XzrZgsSrDif/bieBf8/X7hibFlQh/MImuZsE4ftxts7ZFiS5q24n1zcS5Cz6
Xdnn3IJc7cfFTrNJYBASLb3pfAuqCtg4UfKD0L8wowBfbEGbc/Y2Sv4iAaqZ
3771cgu68ulcuucICZbu6KVed29Btcvh/q1jJJBdqeILvNqCpBWLHTQmSdAU
Z+R4wbMFeZiy9wTPEPVlSBRtvt6CmB68m3/NEfUY5OCP82pBpHj6P/0lElzZ
e/zMrxst6FrlqbaXHGSQrhut4vFpQazhe29WuMkwu0jaMUmwvHBGkPUaMqyp
aSjLvtmCvHe2ORfxkiH14JFzO2+1oGa7hX3i68kw3BCu/YRgxQA50lUhMqi6
T23/QPDNNwcXm0TJ0KHgcKmA4NbOq11qkmTYYm/ww4dgpeW4gkebybB6VWiq
MMF3FKrCBqXJ0KyQWe5F+Os0Gbm4T5YMnF2hOtlEPGoeosbPFcjwYW02Od+7
Bd2L262wpESGsG2Ldx4S+XRVnOU8pUaGEybjDqpEvn/3ftl0S4MMH0lPZ4qv
taA15Ye2PqeToWZdmSuJ0Esaqk0rtxH23Qo6rQg9t+NdzoPaZFgSUdx1idDb
bE+O77rdZFgcVUg+RtTD8aNCrBoigzuHorzwpRb0X4kg64o+GY6uagvf4NKC
Mnf5D0YakWHjS8O4Q44tqLJoYeX9QeK+68E/jg4taKJwkL5yhAxb/+Sli1m3
oHU7rE1kLcgwfvsb7Y0lUZ93LY76lmSQf6a2R8aiBR0q+BATZEuGhU/tCvdN
iX7Voudl25Nh+9dJ8nWiX2/npdS3nCVD7Pfi73uJfs7MiViWuEDob/+F23o3
MQ9ZLmeTrpOB+7tSUpJSC5JV+3qL4U2GlMWixsNyLWhnxtHo4VtksCnPPtYu
1YJc0vYwNf3IwFQQqLIXbkE1yaKaH8PIELTScitmrhl9lQ807ntC6Del3Mg5
2YymX604cEeToUWuRWHfSDOSfzkcaZxAhmcLdYZmX5vRvWdlCx1pZJDQMpkM
KGtGsVLbxeYyyXBV96Hk2/fNKDc+Q31LDhlK/mWuKSb2SV9slL3DOzJMeiZl
mD1vRnuiLzL+VJBBkeffVPKtZnRcnN0nVEMG0YqGI3EezehS5In5rXVksBo7
eOT8hWYU/0SP6tNEhusLEhmRlsQ+C5V8sqaHDFwvj3Mo0JrR24AqW9I0GcRO
PJi6+64JpR6ol3w4SwbZ+VSFpoQmFMvf2jq6QAZH3YkPNX5NyDfsm0EJlyzU
bNDyenekCZnEzKsfF5SFwed36l4MNSJ2iuZKkKosXHNSYP/jbkQd53YUTajL
wojTXpbYIAvVqu65epIuC8mRtb8GGCyU9ebgkOJOWcjpLTWICGQhr0KnpnID
WZhJ2p6ux89C6xnxif/sZYFn0vqqKWcD4nz06qStoyxsiHX6+exrPZo6kC5S
7SILrLvalJSSevS5sfBhxGVZoJzxrOj1IL5fna2Xqbdk4aEo5+exASbaNbgW
zsTIgnjrxS0Cb+uQ02rPvsZGWbDNrfb0UWSgTTJ1nxZaZIE/+RCH83INatSW
alLqkIUfopacpM4atP1i9cd73bLQ0eUotuhXg3jaxOK2/5SFzC1V9i591Sj5
+TuLZ5xywBm7+717SBX6rjPLvLRVDnat7ly2YpajM1d83vLHysHdu/FDV98V
Ig1n1UYTe3m4UOAqTxpzw1/PyVzOOisPe9qtr79Mv46DL4oIrneRh7Cz5c+q
zt7Gv9wXjjS5ykM/R+z6Q8MP8Kub9R1HbsrDwMCDFkpqOJaIuNB7PFoeOLZb
lF+eeYZXPmSM2LHkAVc9eUsNzMTZOPFxebM8nA5UOJh7IgtbVzxRl22Xh4zS
+2ll8tm4iOHjNvBFHtLOWot5f3yDr7YenHL8KQ/ffvFmPPbIxUNDvxfOcyvA
tfzR3QlPCnCTsBqf504FuJ3TMEaLKcZ7Ll36RawgWC93UfjiWDHOZmQzKpAC
vP75Z+G4QQkOuUnzEzRQgCzBH1y7J0uwyeD2pQxzBSgQP6pGNf6ImUV7x9gX
FGBnT9lOzh8YV9udaDv8TAE2xD3/lHyhAm8ticm9/kIBktg+AlHhFThJ7Evo
syQFOK5juuZoYQX2Y1qbjKQrwHCS1RSNqxLrbXWoflioAE/ow2HekZW4bM2l
wtJmBRARP3V/LLcKl2Tfi1PjVoT++hu6B8tqMI+JxaZoHkXoapVya+qvwUd+
UZ5y8iqC5nDtXn5uBh6SY0V1CirCHntD9+z9DCzyVCLCV1oRmMPDc0FVDHzh
fmZA+05FSJNuOuD0rha/I91Zg3QVwezdq0KztlrMWXrEPw0UwUY2YGB4rBZH
z87cv22oCGPtcqd1lepw5aW9d5QsFEHMStFpX2Qd3mzZ6XnTTRGSC4wzY+2Y
2Gk6dWrwqiK4bf0ymujFxLkRPlePXFeE9NuF48fCmNiQRXJXvK0I0eNK9qxS
Jr6qd+Fic5AipFRGzo5L1OPSb7q/d4UqwsGS6tOXqfV43S3B88kRRLwSogOx
evU4sfCts/dTRcjzfH9z4UI9rlfjOCOfogji/nFDvcX1WJzZ2h+Srgin76SK
Mlj12N452W4uS5E4L72btO6rx/9eHLBtLFCEvU8Y8iGrGrCcRORJrwoi368F
wlzGDdi1wLmLXa0Izzu3PDI52YCLjuw6YVqnCPxS2n565xrwoeBvx2SbFWHf
uKCfZkAD9uFUOdzQqwijg10gVNGAB/fzdSn2E/YFXnp4NjXgwwEjp+9+VwQO
x5pjD3sasPyGN5e3/1aECtuOovzpBhxiHvYv7A+h168uwUZOFp6NdL/ze1wR
RArPvY8UIM4rW7aGPp9VBLtQwxQ1eRbebicmsbCgCIG+XxkL6iz8/NXMM4sV
RdDJjvp9fScLe6oUZfPyUGDc6MfsNVMWltbe0+ghQoERuxq/EHcWDvCROd4k
ToFg5nehqhssPFHK8VV5EwXWzDygv77Lwgz9ytGvJApk+T5f4xbGwvRHSZ47
5SkQ84Qr40Q0C8c3PFh6QqFAYfl7/DuBhd2OGgkYq1PgHaNbfmM6C3+JUo58
RaPAAxmnC3lvWHj/F16p5a0U+Oh2Z8NsAQtnS40kWWpTYPeda+uHi1h4oz1L
LV+HAhsO+zoFlLKwX1J2gQCigJDge/G2Chb+MxS620WPAttmpWWYNSxsqepe
VaFPAXONeN9LTBaucDU3kTKmgH/a4u6PLBZWy9Nqv25CPL968nhRMwtHTYta
tx6iwCNHiVb7Nhbm2DkzoHaUAq8PDOW962DhCzc/XXh4nAI2ztXLhZ9YuBO/
n+w/SYGrHnMljp9ZGLhjfXbbUCCeM2ccf2HhdAMf7mg7Ckzsm0+p6WZh0UDr
oPEzRPxs1tCNHha+zdIVMXGmQNXHVSWfCf4pKBP3+jwFXEus1QYJNj/GIcfp
SoEu/+uGiQR/jO5Pt3KnAMvii+RqgpW6K+jvPAh9UkezJAj7EdJJxYJeFJhb
vST6iYhn0f6B3gUfCigXb7fZ18XCTslOzOrbFNgfnBFl3cnCzT8NzUn3KFBy
zaxVtp2Fd6kpf/F+QAF9qylyVAsLJ13mdegIoACz4GjMu0YW3pD/+5dGMGHf
YJWxXz0Le880uAeGUuBe/W2jFQYLf9+ZPfc9ggJ/4rdkUqpY+H2Z27rYpxRo
SA6Y8y1hYdlV5uFT8RQoiz4nnPeOhYMNtTYeek6BdeERo2G5LGzfOK20KoUC
h+uvm1u+JvpZ6FOObToFPE/pCu99TvSzxXvtoiwKSJZZc3Q9ZWHeHm8j1wIK
HFoDvYLBxP3raQKhhRSYSmy+tvUBYU+4q/VNMRHvfY8DQreJeIy22YyXUWBl
ZBvvP1ci3oEzssJVxPsPhKgczkR+dyKG6AwKvPzh86/CltDr7Zi7B4sC/xzD
/nkS8xFxWHpHZDMFenlkzjntJ+rx22TxbRsF2otXzQvqEPWVTff/95mIl/p6
9j8KC5eHnI3zHqQAX0DgKuulBjyi/MQu7hcF3OOfryFPNGDJ6nKFDyOE/dNK
2i8GiX2yIJ2zNEEBnZ+hBW2NDXiLy+cq3xUK3HLJ11sd34C99pr98ZdUglM7
7s5/VG7AST0381M2K0GO09Bxo00NuOl6hlettBLsStzvEcbbgBWz13LzKijB
m4McmaeG63HbpkqJxzQlaN15x7DndT1Wn9qx98kBJYiX7uzGIvX4VKgTT4Gp
EtTmjZnpctTjByqR9e2HlYBcaf/GZ4SJe+wmLMRPKMGd1LsSu6uYOJCVef7p
GSXwirMrbXFj4h+vyf8l3lQC3Yrr3H6ldXjEr3+O21cJOk5YUTST6/CEw4vT
LveVYPDSo0dRQXWYQ4asSgtUgteHZc2fnKjDm6JJFRXRSiCgt1b6+EgtPvxQ
5u+PPCVYPyyBTNbV4g/OUiZqv5Qg43CdkY9IDa7U780NGyHef2TavHmiGjPl
EiSmx5Tg+b4ZtXvN1fjTty0DH2eUILBKgPtlcDWeOLHF+9AqZah+Sg3byVWN
lYw2p16RUQaWmfc1hYFK/J/SxlVFFsrwwKTj7cztcmxtq5gyYKkMo1a87PqT
5Vj+P60D662VYfe84k3vreW4YMU07IyDMlzEXbcdf5Xh9s57W9ZfVoZ8ka3u
t46UYZEHI1vPBCgDg2tBX2J7KY7ox44CJYS/GOnoOrUiHBbrxLAnqcCK9q2b
qSJZ+NR/No38QyqAUkVFLxyOR1vyeTdfGFaBCmn2V0pFAvrWUuhcN6oCrN/H
fRy0EtHZDcKc/lMq8I9n7BmJ9wVyDazRWuFUhRdbQqdih16he74aT8e3qMLc
+Y2O+k/SUNpFzrOd5qqQl3r74/ShPHQxKDtn63FVcJSiP3d7nYfU062WIk6q
goLtX8hczEN5Q2+jDtmpQvJcqKhDaj764HC+rvaSKpQ47o7NXixAzZZt6iUB
qtBunBvFFVOIZvcnzyWWqsKTpLX/3X3yAd0sSbxfVa4K2U69Cru7PyAOeqzA
rypVSDtlV5Ii+xGtkQkl0+tVobO70io05yMSn/MyrvqkChvkBwNCakuRVpbJ
059/ifi6FPjsPMqQq9iUNk1ODfxL+3R7r1SgiaA/FRaKalDYPlhAD69Anly/
TLyV1WCq67L6iTcV6OZYr12lhhp8EA2V5P9dgYLqGAEWu9UgsC7cXdquEqXe
iuu6YaEGL5QN5DOhCg380POqeKgGNQGzuqWfq5FeYuNLlSA10KZ6f/KcrEbP
LU+xIkLUYGskH+dv/hpkW+8ueyZSDT4eX8MhgGrQl5znDdyv1GBvwv1ipec1
qNVnmaRfqgb7L5lJBVowEG1b4MGscjWI5jvcvnSegcL+iF0Tq1aDs1RFR1Vf
BjKzp9b/qFcDyfFUvfw0BmIaWHv6f1aDkU/fbd3mGKhCqLiOMaUGWs9sTl4L
qkXkev0pjVk1GL94tMEtvhb5+rVIxyyoQQrnGZpsVi3a8+/nVRcuKrS0Nm1N
Y9Wi4h4J6XWCVMhkfFi1n68ObYx6ZeQuQgX9mYDB8Y11yOuQxtXP4lSQnN0Z
ZaFUh7ZXGNSmSVFBT0GtV3d/HcpL8bxyQJUK9UbdaSFedUjInjMhT50KR+Lc
I4f86pDbpseMTXQq5N5/azcdVofUHydt+a1Nhak+Uw2N1Dr02EDT8OhuKvzL
NeS0yq9DIysl7iWICsnUXYd1SutQ+pW2miADKiTmF/JtbKtD69ROj08aU+Gu
0kdT8d465PJjeLO1KRXAKaeQMViHFC253NWOUaHvCi40mKtDL3Vpm1n2hL2Q
TQ/zNzFRhRnv/YWzVNjYV+fWQmYi9umBYWUXKpQn7qnLVGIiuXuRxf6uVDih
OfosbhsT7X/iKvvWnQpprty8b3SY6GySYeCABxUGOWLwnb1MlFQzdxJ8iHyx
/KilCRNVfWotd71N+DurZWl/hIm+/8xQTrhLBTWz0UnF40y0at4vvN6PCird
d0rSTjGRPJ/t3NxDKvgm4fRftoS/LTvslYKowHVNqXTQgfBHFaw7HkKFbQa9
E8+dmCj5UEVM/n9U2GoxX2hyiYlq7OI42NFUuDj9W3+PGxMNunu4CMZRifPC
7r8jV5iI575p855nVHDcc6TQ0pOJFP9T1L70ggoGozvi715nIoPklcS4JCpY
zL967nyDiZzeda1hplDhZs1YDa8PE/kzci/PplPB88AW4Qs3meh1V+AnxWwq
XFlufhBwi/D/6wyyyKWCcpmV4pnbhP/53Sn3C6hgVJgzO08wD7/4hrxCKpzU
Ps91+A4TUaTGrvUVU2E5udbYgWAj9dqv60uJ+h7O66AR7IJeGOiWE/U9lp9V
SrwfcNg7+0IV0W/Xlj6vJTjV/qh4LIMKeMn5jCDhv/aK2u1aJhVcQi8f7SDi
/Xl/9eAMiwpz3NsLTngz0drIr6YKLVRI2nMvLNqLiZReF7492k6FBM6yyf+u
Ef4Lw6TufaKCbPnKr0MehP/acw9yvlCh12PmTq074f+z3ujXXipUOy9VLLsy
UdrwZguBfirY8giXT1xgIubC1Aed71Rwy+gISHJhomH+RvnzQ1TQvPBYWdSR
iXilU4JjhqnQ1EPO32vPRCoavlM1o1S4x5beTrVhogNw0nr6LxVmLudXdloy
0fkj9Cq5KSpoH8q9tOcYE6Vf/f7Ed54KX0et7Y0OEP78Pi5kL1HhveGXluH9
hL/IqDO9HOpgmHI68yBiItX3Rlq71qgDjUNsykiLiUzqyHEuvOpgYkR+/EON
iS5+meeKFlCHQ69Hh0CRiTIXM1snRdRBM85p71ZJJmoQ8N8lK6EOAnaTbg2C
TDQiffrl4U2E/aWVSrl1TKS2V+hKFkkd8i5r6QoS85X1wFPImaoOLPcJ74EO
Yn5329x7oKkO27pPJqc01CG1qf2Tr7TUoUG69ZB6JTHPDqIdfTvVYQGvib3/
pg6lovyYUwbqYN4bePzIgzr0cyZ23Q1jdfis9aBZzbsOUbLveUebqMO+xYOV
9a516PUWc+t2c3X4N6oVe+xEHUqa+ytjdlod/tvG3RupUIe+53SFXXRQh5Ys
4V9hknVIzqWMM8hRHb7KyAceJvbby87QAcYFdbi7vkZO+m8tSsxXT9nrpQ7+
dx4uz7yrRbGXLqpvC1eHsxG3bCt31qIv8scSj/6nDkJNNwo2KdeijT06glei
1cH7sBLaKVmLYg7wTWQnqMNyx+fMhmkGiqSkv1VKV4ehmi9S5tnEPu8f2r2l
Uh0iuyKfc4kx0EOLMwe5pwn7tEwz1+Jq9PJQj7XjrDrQ53s7hF9Uow/GFq7E
wQza/+3xu/mwGk3oGoYHcWlAvsNyxPOj1chaUfWTiKAGzEi92rv1VxWi/5tw
kFfVgI8Pp2Rb11WhrzH3vPXtNeA7z+/1RnIVaC5iISjlrAZoCzQ0buOuQKKP
PRLWuWjAmpKg3El2OTK+61TGctUAWslbh/4X5ajg3AGe4zc1YM+TZblQqXIU
uEs4wilaA0yt1NSC+MvQtp4XaQ9ZGvA7mLE3LboECaq7zL5p1oBOvtNTguYl
aOSOumFXmwZMculiHf4SlCRX8l3piwZI8ba79N4pRqIX2mWYgxrQpDBUcPZs
EZq/yX2Qh0MTRnZlCsnKFaLPfNvLjTZqwm2JunHHm3koRjkui3VQE45/HPE2
D32B7pQ9jjlYpAlvLKXanDnT8HBv2X9zxZpwNvpr55GXafj4wmRYygdN+GZg
mjqgl47Vtp96xF2mCeE7+1r+3cvAXRmK3iU1mmD2fPZw3nIWpkdjK9V2TShX
8jXwds/Fg5fGpfnGNMGa4rIvWPkdPhIkv7noryZ8PON38duVd/hD6gkJ5wlN
eCmXu2Ok5B1+MvBxQ+W0JkTfsX2mYVqI4WQgh88i8fwy/36ji+9x7H459vA6
Gox+sQ6VjC/GppstkpnyNDiZWrVa7mMpjvmuTmxOGoxs0Bjjmi3F37PWdo9Q
aBB4Z+ldOB3jm/BBcIMqDVbX8VYXvcY401Hu5lEaDfLEeZ9H6Jdh3pxx8x5d
Gtz4rtC0QC7Hx2/UX7qEaODXLTpYubscv9RLDlgGGhzc8P7M6RPleGeHZSlp
Pw1691Kfbwguxy7zWNnxAA2edl+JMJssx4z9IRx/jtNg5XHXHZGiCiy83mXz
HUsahAc9855prsC2n/ZuFzxF+CMf00/7WYFnzk1foNvQ4PbRrZ63JCqxYqj1
p2tnaLCzSdPvy5VK7PdZJXvlMg1OnJ4m65CqcPPLVXVh7jRQ80zezL2tCm+5
+HWAfJUGrrX6tdHGVTh/OXzj/ms0KH57wU/xShVmy835Bdykwd9KzYz2siq8
15VhJfSIBg+DI66ZHavG812/DKoCaaCQ1eO137kaF+zjp18PpoHH3lnRhRvV
WHHjkbW9oTRg6SjbpD2rxvxVXwpSo2igVDdKWf2jGteoLyVaxdBA8Qb1z/x0
Nb7zVCZofSwNGvsPDr7hqcETrmftPRJoYO6pUHOcUoO7Nv4RgCTivtG3gSeO
NTjCT3BuIpngQ7fbbnvU4INj9O/JKTTokjv2gXK/BpdWXS/my6DBuwi/33mJ
NcT5mdP5Uy4N4gUN12R01GDbL3Lmgfk0cJzP4LrHrsES+ga6um9pYPgn+Y/Y
WA0O3BQk8uo9DUKDLsp6rGFgt2rRMldM1K/4+jDPNgZW0dyRQS4n9O9yPl6B
GHgg9mRUewUNHFSGv+w8wMDH3Z5d3FVDA+/96s3Wtgws2F12YpRBg7QNJNG1
Lgxcpz+g97yOBk/cVklcdmfg3ZuVNvKwaND53met230GnnlwYFVRIw0G9zk3
rwtm4Dd/L45daKbB7PTMutP/MbBsTW51SxsNWi/RHuskMfBad50rCV9oYCP3
SqqkjIErum1sDvfQYPuuz+/UGQzsY+BrxP2VBgPDaiY2LAb+s7la+lw/DZrt
Seh3FwOn+g+t2zJAg0eLaQEHvjKw/fi66cbvNOAak399doCB22vM6rf+pMHW
Rwd060YYOITm/m7oFw3074mkiYwzsGH8kxexv2kgeIOXJTnNwBxr3gWbjtJA
XFQjqWuWgYvdu65zjNFg6LGhytFFBr7aM++Q/5cGc9l9VgErDKxmKGXmNEGD
s9Wm2724avFgLtq5cYoGwbGphbKra3HiFgf5hmka7Hdq+fpwTS3epaWq7vCP
Budv3H/7gDiPthtP7ZidpQFn5MuNhny12NXu496QeRqY/CfJ38Bfi9de9z8o
v0iDjh7HENH1tfjl40MWxUs0aDN98ZK0oRbvTpI8fXiFBqDudfAvwZ3F/S6D
HHSw3agefF+wFru1pF+5yUWHmV/xLl8I5v159abwKjpMvtr6Y4rgpOXd/qmr
6ZBsvcDTRvAeMZ6wPWvoEEZ+3OZBcJdq09P2tXRg9m4+8oWwf0Uv5tV5Xjr0
6V725yaY/6R9Fgc/HUwivnv/FajFry+rFEYJ0CE8x3X7CyJ+8J8sU9tAh+LW
yHIxIr8v8R+YFYJ0CPa8rmBG5O+R/6DdUpgOVttqLhwg9FnPNPv6R4QO9LS6
Z7yEfql9Ej/9xOhQtNu2LoTQV+9f3/gmCTq8Wzs900no3yOQvpAjSYc16U+0
Boj6COns3tC7mQ7xHt/5jWYYOPPI6o1XpeigPeRf9XyCgQ1cGmXXyRD5OwqV
f/zDwN6Rdtu3ydJh7pRk9f5BBhbNVIZ6OTo0k2RHsvsZOLtiwthegQ5xKurR
vT0MzB7zs3msRAcy/X1pQCsD3+Qxc5ZTIewJnTq9muhPcSkJ9yJVOlx9qN9g
QPTvgQNpfj/UiXhbHp6ULGHg73ZXQnw06VA7Gf4ytYCBb1/XiRGi0yGg9uC6
5SwGzktiZehuo4PxKfeHs4kMbFIS9bZtOx0kZiQaEmIYeLDlND6nTYegGwMB
a8MZeNPKeGukDh0eRITWq99l4PsnxedH99KBvUl2Zzkxv9Ju37j99tHBIfn7
8n8WDPzeP1Vgkz4dOsWe8WuYMPBI/i6ygREd/FIvXHmnzcDH1p82emZGsLd3
itgGBpavTIkys6KDWc72e7TcGtyoNpvUY02HwHPcP94n1WCvKKP887Z0eB+3
qZI3pgbXn/vV5G9PB9a6wFvrb9fgK4Kq67AzHVY1nOp9aliDsU22j4YHHXb2
C13qb67GLozlRx896aAivWqWXF6NhWmHYg5ep4MdinDWyK3GTqv+Fjh7E3o3
2CXmhhH7OIP2J9GXDvNBeTssTavxqdkCO8HHdPisbVhk8bEKr3JYfflZCB0a
j+zzv5FehbPrLW6phdEBNq+XvBRdhTkTZ54aPaGD+7fMI1VuVThVX7vN9ykd
9N0fpmuTq/B0RIn+eDIdbEZeVzrdqMRh1AqV1lI6jFzMKLNeW4FTta3W3Suj
w+21Mj71o+UY75saolUQ+dsEF69rK8d/Tiomh1fToSdkbu1MfDk+6B8oc6SB
Dl9ICVVR6uWY55u5aPNnop+aPxzba1yGfcIGllhTdKBYNppofvyAnSZXtdSp
aMFu6u3TFJ0CbJu+v9FaTQsCBLwZorP5+Li9X/0YVQtu7Yw72VmQjw2auGvE
aFpQ7Vf5oouajxUzuErsd2gBQ6DCakQqD/9w4Eie26cFdvM03DD6Bp9tXfBS
ttGC25PSmTXkFOyQO0F6FKoFSvO3Y5GNH7547+jigXAtoH5YZW3ffhd7Hi34
xP9EC14JWUzwR9/GAdOeIWFRWvBQtr9x8qoHzt45txCdoAWNpyauG51ei+fK
VzpfZ2gB/WnQdmFpPxTWyv+4iqEFHvukJRYEn6HYV5dc/Ou0YEhuU85700T0
yqNxn1G9FvF/2rd/cf9z9E48bL6+UQsu/nLK8PF9gXpOibi0dWiBl7l7i87U
K0QZ2LiPPaAF+14beVBYqUizwFs66YcWZHYdV650SkO7HnTPOQ5pQTSSE+Xm
SEcmlIScX8Na8DvP94gLLQNduUCSHh/XgulQJjkqNAvd3H13Lm9SCxY6ntPJ
itnogQC73WNaC7YlZSrpfchGMW9eBc3OagFfoPm7PUNv0EvfVc7F81pQf1vP
kW9PDso44qh3c1ELLkj893VPQA4qkK2R2rOsBWq5pJ/arTmodFJxbmVFC7bu
zn41uzkX/Q9coKh8
            "]]}}, {{{18., 0.}, {0., 148.23529411764704`}}, {0., 
          88.94117647058822}}], InsetBox[
         Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJxsXXlcTs/3FxWVLUQpVLKFqOzSc9sQIUsJRUX2srWQKNpkV6SobCHSIrTR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           "], {{
             {EdgeForm[None], GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJxNm3PcZUfWhe85595zk07SsZ2Obdu2bdu2MbFt27ZtTNBJx5nY7O95etX8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                 "]], Polygon3DBox[CompressedData["
1:eJwtm3fgV9Mfxu+953POF/nR0NCOijIykuyiQtlRSaI0UApJMlKJhhIqsyXK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                 "]], Polygon3DBox[CompressedData["
1:eJwt1neUFeUZB+ALC8QkKi2AYiIhxoMFE2MQEI30jksR6X3pLEvvbekWygIL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                 "]]}]}, {}, {}, {}, {}}, {{}, {}, {}, {
              Line3DBox[{1, 530, 227, 16, 1485, 370, 31, 1486, 376, 46, 1487, 
               382, 61, 1488, 388, 76, 1489, 394, 91, 1490, 400, 106, 1491, 
               406, 121, 1492, 412, 136, 1493, 418, 151, 1494, 424, 166, 1495,
                430, 181, 1496, 436, 196, 1468, 348, 554, 211}], 
              Line3DBox[{558, 805, 1101, 806, 559, 1680, 820, 1102, 821, 583, 
               836, 1768, 1103, 837, 595, 852, 1769, 1104, 853, 607, 868, 
               1771, 1105, 869, 619, 884, 1774, 1106, 885, 631, 900, 1778, 
               1107, 901, 643, 916, 1783, 1108, 917, 655, 932, 1789, 1109, 
               933, 667, 948, 1796, 1110, 949, 679, 964, 1803, 1111, 965, 691,
                980, 1810, 1112, 981, 703, 996, 1817, 1113, 997, 715, 1012, 
               1824, 1116, 1013, 1015}], 
              Line3DBox[{560, 1114, 1115, 1032, 807, 1088, 1832, 822, 1036, 
               823, 1089, 1833, 838, 1040, 839, 1090, 854, 1770, 1044, 855, 
               1091, 870, 1772, 1048, 871, 1092, 886, 1775, 1052, 887, 1093, 
               902, 1779, 1056, 903, 1094, 918, 1784, 1060, 919, 1095, 934, 
               1790, 1064, 935, 1096, 950, 1797, 1068, 951, 1097, 966, 1804, 
               1072, 967, 1098, 982, 1811, 1076, 983, 1099, 998, 1818, 1080, 
               999, 1100, 1014, 1825, 1084, 1118, 1117, 1018}], 
              Line3DBox[{561, 808, 1033, 809, 562, 1681, 824, 1037, 825, 584, 
               1692, 840, 1041, 841, 596, 1703, 856, 1045, 857, 608, 872, 
               1773, 1049, 873, 620, 888, 1776, 1053, 889, 632, 904, 1780, 
               1057, 905, 644, 920, 1785, 1061, 921, 656, 936, 1791, 1065, 
               937, 668, 952, 1798, 1069, 953, 680, 968, 1805, 1073, 969, 692,
                984, 1812, 1077, 985, 704, 1000, 1819, 1081, 1001, 716, 1016, 
               1826, 1085, 1017, 1019}], 
              Line3DBox[{563, 810, 811, 564, 1682, 826, 827, 585, 1693, 842, 
               843, 597, 1704, 858, 859, 609, 1714, 874, 875, 621, 890, 1777, 
               891, 633, 906, 1781, 907, 645, 922, 1786, 923, 657, 938, 1792, 
               939, 669, 954, 1799, 955, 681, 970, 1806, 971, 693, 986, 1813, 
               987, 705, 1002, 1820, 1003, 717, 1020, 1827, 1021, 1024}], 
              Line3DBox[{565, 812, 1034, 813, 566, 1683, 828, 1038, 829, 586, 
               1694, 844, 1042, 845, 598, 1705, 860, 1046, 861, 610, 1715, 
               876, 1050, 877, 622, 1724, 892, 1054, 893, 634, 908, 1782, 
               1058, 909, 646, 924, 1787, 1062, 925, 658, 940, 1793, 1066, 
               941, 670, 956, 1800, 1070, 957, 682, 972, 1807, 1074, 973, 694,
                988, 1814, 1078, 989, 706, 1004, 1821, 1082, 1005, 718, 1022, 
               1828, 1086, 1023, 727}], 
              Line3DBox[{567, 814, 815, 568, 1684, 830, 831, 587, 1695, 846, 
               847, 599, 1706, 862, 863, 611, 1716, 878, 879, 623, 1725, 894, 
               895, 635, 1733, 910, 911, 647, 926, 1788, 927, 659, 942, 1794, 
               943, 671, 958, 1801, 959, 683, 974, 1808, 975, 695, 990, 1815, 
               991, 707, 1006, 1822, 1007, 719, 1025, 1829, 1026, 728}], 
              Line3DBox[{569, 816, 1035, 817, 570, 1685, 832, 1039, 833, 588, 
               1696, 848, 1043, 849, 600, 1707, 864, 1047, 865, 612, 1717, 
               880, 1051, 881, 624, 1726, 896, 1055, 897, 636, 1734, 912, 
               1059, 913, 648, 1741, 928, 1063, 929, 660, 944, 1795, 1067, 
               945, 672, 960, 1802, 1071, 961, 684, 976, 1809, 1075, 977, 696,
                992, 1816, 1079, 993, 708, 1008, 1823, 1083, 1009, 720, 1027, 
               1830, 1087, 1028, 729}], 
              Line3DBox[{571, 735, 572, 1686, 740, 589, 1697, 745, 601, 1708, 
               750, 613, 1718, 755, 625, 1727, 760, 637, 1735, 765, 649, 1742,
                770, 661, 1748, 775, 673, 780, 1665, 685, 785, 1666, 697, 790,
                1668, 709, 795, 1671, 721, 800, 1675, 730}], 
              Line3DBox[{573, 736, 574, 1687, 741, 590, 1698, 746, 602, 1709, 
               751, 614, 1719, 756, 626, 1728, 761, 638, 1736, 766, 650, 1743,
                771, 662, 1749, 776, 674, 1754, 781, 686, 786, 1667, 698, 791,
                1669, 710, 796, 1672, 722, 801, 1676, 731}], 
              Line3DBox[{575, 737, 576, 1688, 742, 591, 1699, 747, 603, 1710, 
               752, 615, 1720, 757, 627, 1729, 762, 639, 1737, 767, 651, 1744,
                772, 663, 1750, 777, 675, 1755, 782, 687, 1759, 787, 699, 792,
                1670, 711, 797, 1673, 723, 802, 1677, 732}], 
              Line3DBox[{577, 738, 578, 1689, 743, 592, 1700, 748, 604, 1711, 
               753, 616, 1721, 758, 628, 1730, 763, 640, 1738, 768, 652, 1745,
                773, 664, 1751, 778, 676, 1756, 783, 688, 1760, 788, 700, 
               1763, 793, 712, 798, 1674, 724, 803, 1678, 733}], 
              Line3DBox[{579, 739, 580, 1690, 744, 593, 1701, 749, 605, 1712, 
               754, 617, 1722, 759, 629, 1731, 764, 641, 1739, 769, 653, 1746,
                774, 665, 1752, 779, 677, 1757, 784, 689, 1761, 789, 701, 
               1764, 794, 713, 1766, 799, 725, 804, 1679, 734}], 
              Line3DBox[{581, 818, 819, 582, 1691, 834, 835, 594, 1702, 850, 
               851, 606, 1713, 866, 867, 618, 1723, 882, 883, 630, 1732, 898, 
               899, 642, 1740, 914, 915, 654, 1747, 930, 931, 666, 1753, 946, 
               947, 678, 1758, 962, 963, 690, 1762, 978, 979, 702, 1765, 994, 
               995, 714, 1767, 1010, 1011, 726, 1029, 1831, 1030, 1031}], 
              Line3DBox[{15, 553, 238, 30, 1132, 375, 45, 1146, 381, 60, 1160,
                387, 75, 1174, 393, 90, 1188, 399, 105, 1202, 405, 120, 1216, 
               411, 135, 1230, 417, 150, 1244, 423, 165, 1258, 429, 180, 1272,
                435, 195, 1286, 441, 210, 1300, 447, 551, 225}]}, {
              Line3DBox[{1, 552, 362, 2, 558, 363, 3, 560, 230, 4, 561, 232, 
               5, 563, 366, 6, 565, 7, 567, 8, 569, 9, 571, 10, 573, 11, 575, 
               12, 577, 13, 579, 14, 581, 369, 549, 15}], 
              Line3DBox[{1132, 1323, 1691, 1632, 1131, 1690, 1579, 1130, 1689,
                1578, 1129, 1688, 1577, 1128, 1687, 1576, 1127, 1686, 1575, 
               1126, 1322, 1685, 1631, 1125, 1321, 1684, 1630, 1124, 1320, 
               1683, 1629, 1123, 1319, 1682, 1628, 1122, 1318, 1681, 1627, 
               1121, 1317, 1498, 1832, 1626, 1120, 1316, 1680, 1625, 1119, 
               1549, 1550, 1497, 1524, 1523, 1485}], 
              Line3DBox[{1146, 1332, 1702, 1639, 1145, 1701, 1584, 1144, 1700,
                1583, 1143, 1699, 1582, 1142, 1698, 1581, 1141, 1697, 1580, 
               1140, 1331, 1696, 1638, 1139, 1330, 1695, 1637, 1138, 1329, 
               1694, 1636, 1137, 1328, 1693, 1635, 1136, 1327, 1692, 1634, 
               1135, 1326, 1500, 1833, 1633, 1134, 1325, 1324, 1768, 1133, 
               1551, 1552, 1499, 1526, 1525, 1486}], 
              Line3DBox[{1160, 1342, 1713, 1645, 1159, 1712, 1589, 1158, 1711,
                1588, 1157, 1710, 1587, 1156, 1709, 1586, 1155, 1708, 1585, 
               1154, 1341, 1707, 1644, 1153, 1340, 1706, 1643, 1152, 1339, 
               1705, 1642, 1151, 1338, 1704, 1641, 1150, 1337, 1703, 1640, 
               1149, 1336, 1502, 1335, 1770, 1148, 1334, 1333, 1769, 1147, 
               1553, 1554, 1501, 1528, 1527, 1487}], 
              Line3DBox[{1174, 1353, 1723, 1650, 1173, 1722, 1594, 1172, 1721,
                1593, 1171, 1720, 1592, 1170, 1719, 1591, 1169, 1718, 1590, 
               1168, 1352, 1717, 1649, 1167, 1351, 1716, 1648, 1166, 1350, 
               1715, 1647, 1165, 1349, 1714, 1646, 1164, 1348, 1347, 1773, 
               1163, 1346, 1504, 1345, 1772, 1162, 1344, 1343, 1771, 1161, 
               1555, 1556, 1503, 1530, 1529, 1488}], 
              Line3DBox[{1188, 1365, 1732, 1654, 1187, 1731, 1599, 1186, 1730,
                1598, 1185, 1729, 1597, 1184, 1728, 1596, 1183, 1727, 1595, 
               1182, 1364, 1726, 1653, 1181, 1363, 1725, 1652, 1180, 1362, 
               1724, 1651, 1179, 1361, 1360, 1777, 1178, 1359, 1358, 1776, 
               1177, 1357, 1506, 1356, 1775, 1176, 1355, 1354, 1774, 1175, 
               1557, 1558, 1505, 1532, 1531, 1489}], 
              Line3DBox[{1202, 1378, 1740, 1657, 1201, 1739, 1604, 1200, 1738,
                1603, 1199, 1737, 1602, 1198, 1736, 1601, 1197, 1735, 1600, 
               1196, 1377, 1734, 1656, 1195, 1376, 1733, 1655, 1194, 1375, 
               1374, 1782, 1193, 1373, 1372, 1781, 1192, 1371, 1370, 1780, 
               1191, 1369, 1508, 1368, 1779, 1190, 1367, 1366, 1778, 1189, 
               1559, 1560, 1507, 1534, 1533, 1490}], 
              Line3DBox[{1216, 1392, 1747, 1659, 1215, 1746, 1609, 1214, 1745,
                1608, 1213, 1744, 1607, 1212, 1743, 1606, 1211, 1742, 1605, 
               1210, 1391, 1741, 1658, 1209, 1390, 1389, 1788, 1208, 1388, 
               1387, 1787, 1207, 1386, 1385, 1786, 1206, 1384, 1383, 1785, 
               1205, 1382, 1510, 1381, 1784, 1204, 1380, 1379, 1783, 1203, 
               1561, 1562, 1509, 1536, 1535, 1491}], 
              Line3DBox[{1230, 1407, 1753, 1660, 1229, 1752, 1614, 1228, 1751,
                1613, 1227, 1750, 1612, 1226, 1749, 1611, 1225, 1748, 1610, 
               1224, 1406, 1405, 1795, 1223, 1404, 1403, 1794, 1222, 1402, 
               1401, 1793, 1221, 1400, 1399, 1792, 1220, 1398, 1397, 1791, 
               1219, 1396, 1512, 1395, 1790, 1218, 1394, 1393, 1789, 1217, 
               1563, 1564, 1511, 1538, 1537, 1492}], 
              Line3DBox[{1244, 1422, 1758, 1661, 1243, 1757, 1618, 1242, 1756,
                1617, 1241, 1755, 1616, 1240, 1754, 1615, 1239, 1301, 1665, 
               1238, 1421, 1420, 1802, 1237, 1419, 1418, 1801, 1236, 1417, 
               1416, 1800, 1235, 1415, 1414, 1799, 1234, 1413, 1412, 1798, 
               1233, 1411, 1514, 1410, 1797, 1232, 1409, 1408, 1796, 1231, 
               1565, 1566, 1513, 1540, 1539, 1493}], 
              Line3DBox[{1258, 1437, 1762, 1662, 1257, 1761, 1621, 1256, 1760,
                1620, 1255, 1759, 1619, 1254, 1303, 1667, 1253, 1302, 1666, 
               1252, 1436, 1435, 1809, 1251, 1434, 1433, 1808, 1250, 1432, 
               1431, 1807, 1249, 1430, 1429, 1806, 1248, 1428, 1427, 1805, 
               1247, 1426, 1516, 1425, 1804, 1246, 1424, 1423, 1803, 1245, 
               1567, 1568, 1515, 1542, 1541, 1494}], 
              Line3DBox[{1272, 1452, 1765, 1663, 1271, 1764, 1623, 1270, 1763,
                1622, 1269, 1306, 1670, 1268, 1305, 1669, 1267, 1304, 1668, 
               1266, 1451, 1450, 1816, 1265, 1449, 1448, 1815, 1264, 1447, 
               1446, 1814, 1263, 1445, 1444, 1813, 1262, 1443, 1442, 1812, 
               1261, 1441, 1518, 1440, 1811, 1260, 1439, 1438, 1810, 1259, 
               1569, 1570, 1517, 1544, 1543, 1495}], 
              Line3DBox[{1286, 1467, 1767, 1664, 1285, 1766, 1624, 1284, 1310,
                1674, 1283, 1309, 1673, 1282, 1308, 1672, 1281, 1307, 1671, 
               1280, 1466, 1465, 1823, 1279, 1464, 1463, 1822, 1278, 1462, 
               1461, 1821, 1277, 1460, 1459, 1820, 1276, 1458, 1457, 1819, 
               1275, 1456, 1520, 1455, 1818, 1274, 1454, 1453, 1817, 1273, 
               1571, 1572, 1519, 1546, 1545, 1496}], 
              Line3DBox[{442, 212, 1015, 351, 213, 1018, 353, 214, 1019, 354, 
               215, 1024, 357, 216, 727, 217, 728, 218, 729, 219, 730, 220, 
               731, 221, 732, 222, 733, 223, 734, 224, 1031, 361, 555, 225}], 
              Line3DBox[{442, 550, 211}], 
              Line3DBox[{1300, 1484, 1483, 1831, 1299, 1315, 1679, 1298, 1314,
                1678, 1297, 1313, 1677, 1296, 1312, 1676, 1295, 1311, 1675, 
               1294, 1482, 1481, 1830, 1293, 1480, 1479, 1829, 1292, 1478, 
               1477, 1828, 1291, 1476, 1475, 1827, 1290, 1474, 1473, 1826, 
               1289, 1472, 1522, 1471, 1825, 1288, 1470, 1469, 1824, 1287, 
               1573, 1574, 1521, 1548, 1547, 1468}]}}}],
          Axes->None,
          BoxRatios->{20, 20, 10},
          Boxed->False,
          Method->{},
          
          PlotRange->{{-19.99999857142857, 
           19.999998571426556`}, {-19.999998571428065`, 
           19.999998571428065`}, {-0.40088692217045496`, 0.9999999999994897}},
          PlotRangePadding->{
            Scaled[0.02], 
            Scaled[0.02], 
            Scaled[0.02]}], {243., 189.}, 
         Center, {230.39999999999995`, 161.27999999999994`}]},
       Frame->False,
       ImageSize->{360., 252.},
       PlotRange->{{0., 360.}, {0., 252.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{504, 396.},
       PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 252.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{1.53, 0.}, {0., 0.}}], 
         LineBox[{{3.06, 14.823529411764696`}, {0., 14.823529411764696`}}], 
         LineBox[{{1.53, 29.6470588235294}, {0., 29.6470588235294}}], 
         LineBox[{{1.53, 44.47058823529411}, {0., 44.47058823529411}}], 
         LineBox[{{1.53, 59.29411764705881}, {0., 59.29411764705881}}], 
         LineBox[{{1.53, 74.11764705882352}, {0., 74.11764705882352}}], 
         LineBox[{{3.06, 88.94117647058822}, {0., 88.94117647058822}}], 
         LineBox[{{1.53, 103.76470588235293`}, {0., 103.76470588235293`}}], 
         LineBox[{{1.53, 118.58823529411762`}, {0., 118.58823529411762`}}], 
         LineBox[{{1.53, 133.41176470588235`}, {0., 133.41176470588235`}}], 
         LineBox[{{1.53, 148.23529411764704`}, {0., 148.23529411764704`}}], 
         LineBox[{{3.06, 163.05882352941174`}, {0., 163.05882352941174`}}], 
         LineBox[{{1.53, 177.88235294117644`}, {0., 177.88235294117644`}}], 
         LineBox[{{1.53, 192.70588235294116`}, {0., 192.70588235294116`}}], 
         LineBox[{{1.53, 207.52941176470586`}, {0., 207.52941176470586`}}], 
         LineBox[{{1.53, 222.35294117647055`}, {0., 222.35294117647055`}}], 
         LineBox[{{3.06, 237.17647058823525`}, {0., 237.17647058823525`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{360., 0.}, {360., 252.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{358.47, 0.}, {360., 0.}}], 
         LineBox[{{356.94, 14.823529411764696`}, {360., 
          14.823529411764696`}}], 
         LineBox[{{358.47, 29.6470588235294}, {360., 29.6470588235294}}], 
         LineBox[{{358.47, 44.47058823529411}, {360., 44.47058823529411}}], 
         LineBox[{{358.47, 59.29411764705881}, {360., 59.29411764705881}}], 
         LineBox[{{358.47, 74.11764705882352}, {360., 74.11764705882352}}], 
         LineBox[{{356.94, 88.94117647058822}, {360., 88.94117647058822}}], 
         LineBox[{{358.47, 103.76470588235293`}, {360., 
          103.76470588235293`}}], 
         LineBox[{{358.47, 118.58823529411762`}, {360., 
          118.58823529411762`}}], 
         LineBox[{{358.47, 133.41176470588235`}, {360., 
          133.41176470588235`}}], 
         LineBox[{{358.47, 148.23529411764704`}, {360., 
          148.23529411764704`}}], 
         LineBox[{{356.94, 163.05882352941174`}, {360., 
          163.05882352941174`}}], 
         LineBox[{{358.47, 177.88235294117644`}, {360., 
          177.88235294117644`}}], 
         LineBox[{{358.47, 192.70588235294116`}, {360., 
          192.70588235294116`}}], 
         LineBox[{{358.47, 207.52941176470586`}, {360., 
          207.52941176470586`}}], 
         LineBox[{{358.47, 222.35294117647055`}, {360., 
          222.35294117647055`}}], 
         LineBox[{{356.94, 237.17647058823525`}, {360., 
          237.17647058823525`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {360., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 3.06}, {0., 0.}}], 
         LineBox[{{18., 1.53}, {18., 0.}}], LineBox[{{36., 1.53}, {36., 0.}}],
          LineBox[{{54., 1.53}, {54., 0.}}], 
         LineBox[{{72., 1.53}, {72., 0.}}], LineBox[{{90., 3.06}, {90., 0.}}],
          LineBox[{{108., 1.53}, {108., 0.}}], 
         LineBox[{{126., 1.53}, {126., 0.}}], 
         LineBox[{{144., 1.53}, {144., 0.}}], 
         LineBox[{{162., 1.53}, {162., 0.}}], 
         LineBox[{{180., 3.06}, {180., 0.}}], 
         LineBox[{{198., 1.53}, {198., 0.}}], 
         LineBox[{{216., 1.53}, {216., 0.}}], 
         LineBox[{{234., 1.53}, {234., 0.}}], 
         LineBox[{{252., 1.53}, {252., 0.}}], 
         LineBox[{{270., 3.06}, {270., 0.}}], 
         LineBox[{{288., 1.53}, {288., 0.}}], 
         LineBox[{{306., 1.53}, {306., 0.}}], 
         LineBox[{{324., 1.53}, {324., 0.}}], 
         LineBox[{{342., 1.53}, {342., 0.}}], 
         LineBox[{{360., 3.06}, {360., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 252.}, {360., 252.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 248.94}, {0., 252.}}], 
         LineBox[{{18., 250.47}, {18., 252.}}], 
         LineBox[{{36., 250.47}, {36., 252.}}], 
         LineBox[{{54., 250.47}, {54., 252.}}], 
         LineBox[{{72., 250.47}, {72., 252.}}], 
         LineBox[{{90., 248.94}, {90., 252.}}], 
         LineBox[{{108., 250.47}, {108., 252.}}], 
         LineBox[{{126., 250.47}, {126., 252.}}], 
         LineBox[{{144., 250.47}, {144., 252.}}], 
         LineBox[{{162., 250.47}, {162., 252.}}], 
         LineBox[{{180., 248.94}, {180., 252.}}], 
         LineBox[{{198., 250.47}, {198., 252.}}], 
         LineBox[{{216., 250.47}, {216., 252.}}], 
         LineBox[{{234., 250.47}, {234., 252.}}], 
         LineBox[{{252., 250.47}, {252., 252.}}], 
         LineBox[{{270., 248.94}, {270., 252.}}], 
         LineBox[{{288., 250.47}, {288., 252.}}], 
         LineBox[{{306., 250.47}, {306., 252.}}], 
         LineBox[{{324., 250.47}, {324., 252.}}], 
         LineBox[{{342., 250.47}, {342., 252.}}], 
         LineBox[{{360., 248.94}, {360., 252.}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 14.823529411764696`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 88.94117647058822}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 163.05882352941174`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 237.17647058823525`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {0, 1}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {90., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"10\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {180., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"15\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {270., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"20\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {360., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              StyleBox["\<\"x\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->15,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {180., -15.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 14.823529411764696`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 88.94117647058822}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 163.05882352941174`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 237.17647058823525`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {0, 1}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {90., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"10\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {180., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"15\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {270., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"20\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {360., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             StyleBox["\<\"x\"\>",
              FontSlant->"Italic"],
             StyleForm[#, FontSlant -> "Italic"]& ],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->15,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {180., -15.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{504, 396.},
       PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.7857142857142857,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{504, 396.},
  PlotRange->{{-72, 432}, {-72., 324.}}]], "Output",
 CellChangeTimes->{
  3.583697533015232*^9, {3.583697576845293*^9, 3.583697657905407*^9}, 
   3.5836977292105064`*^9, {3.5836978135256243`*^9, 3.583697833660653*^9}, {
   3.5836980430805464`*^9, 3.58369807418559*^9}, 3.5836981252456617`*^9, 
   3.5836985487862544`*^9, 3.5836987234814987`*^9, {3.5836987552565436`*^9, 
   3.583698780631579*^9}, {3.5836989002417464`*^9, 3.583698957186826*^9}, 
   3.583698989991872*^9, {3.583699203575172*^9, 3.583699239295223*^9}, 
   3.594306026675498*^9, 
   3.5943063196459084`*^9},ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Bonus: Diagram illustrating scaled coordinates", "Subsection",
 CellChangeTimes->{{3.567038365273103*^9, 3.567038374263116*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "HIDDEN", " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"Figure", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"SetOptions", "[", 
         RowBox[{"FigCircle", ",", 
          RowBox[{"Radius", "\[Rule]", 
           RowBox[{"Canvas", "[", "5", "]"}]}], ",", 
          RowBox[{"LineColor", "\[Rule]", "Firebrick"}], ",", 
          RowBox[{"LineThickness", "\[Rule]", "2"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SetOptions", "[", 
         RowBox[{"FigArrow", ",", 
          RowBox[{"TextOrientation", "\[Rule]", "Horizontal"}], ",", 
          RowBox[{"FontSize", "\[Rule]", "12"}], ",", 
          RowBox[{"TextFrame", "\[Rule]", "True"}], ",", 
          RowBox[{"TextMargin", "\[Rule]", "2"}], ",", 
          RowBox[{"TextRoundingRadius", "\[Rule]", "4"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", "points", " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "FigCircle", "\[LeftDoubleBracket]", "\"\<pt\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"Scaled", "[", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], "]"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"FigArrow", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"FromHead", "[", 
             RowBox[{"Canvas", "[", 
              RowBox[{"{", 
               RowBox[{"10", ",", "10"}], "}"}], "]"}], "]"}], ",", 
            RowBox[{"FigAnchor", "[", 
             RowBox[{"\"\<pt\>\"", ",", "Right"}], "]"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"TailLabel", "\[Rule]", 
           RowBox[{"Row", "[", 
            RowBox[{"{", 
             RowBox[{"\"\<Scaled \>\"", ",", 
              RowBox[{"MultipletLabel", "[", 
               RowBox[{"{", 
                RowBox[{"0", ",", "0"}], "}"}], "]"}]}], "}"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"TextOffset", "\[Rule]", "Left"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "FigCircle", "\[LeftDoubleBracket]", "\"\<pt\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"Scaled", "[", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}], "]"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"FigArrow", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"FromHead", "[", 
             RowBox[{"Canvas", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "10"}], ",", "10"}], "}"}], "]"}], "]"}], ",", 
            RowBox[{"FigAnchor", "[", 
             RowBox[{"\"\<pt\>\"", ",", "Left"}], "]"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"TailLabel", "\[Rule]", 
           RowBox[{"Row", "[", 
            RowBox[{"{", 
             RowBox[{"\"\<Scaled \>\"", ",", 
              RowBox[{"MultipletLabel", "[", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "]"}]}], "}"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"TextOffset", "\[Rule]", "Right"}]}], "\[IndentingNewLine]",
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"inset", " ", "panel"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", "points", " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{
             "FigCircle", "\[LeftDoubleBracket]", "\"\<pt\>\"", 
              "\[RightDoubleBracket]"}], "[", 
             RowBox[{"Scaled", "[", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0"}], "}"}], "]"}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"FigArrow", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"FromHead", "[", 
                 RowBox[{"Canvas", "[", 
                  RowBox[{"{", 
                   RowBox[{"10", ",", "10"}], "}"}], "]"}], "]"}], ",", 
                RowBox[{"FigAnchor", "[", 
                 RowBox[{"\"\<pt\>\"", ",", "Right"}], "]"}]}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"TailLabel", "\[Rule]", 
               RowBox[{"Row", "[", 
                RowBox[{"{", 
                 RowBox[{"\"\<Scaled \>\"", ",", 
                  RowBox[{"MultipletLabel", "[", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], "]"}]}], "}"}], "]"}]}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"TextOffset", "\[Rule]", "Left"}]}], 
             "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
             "FigCircle", "\[LeftDoubleBracket]", "\"\<pt\>\"", 
              "\[RightDoubleBracket]"}], "[", 
             RowBox[{"Scaled", "[", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1"}], "}"}], "]"}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"FigArrow", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"FromHead", "[", 
                 RowBox[{"Canvas", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "10"}], ",", 
                    RowBox[{"-", "10"}]}], "}"}], "]"}], "]"}], ",", 
                RowBox[{"FigAnchor", "[", 
                 RowBox[{"\"\<pt\>\"", ",", "Left"}], "]"}]}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"TailLabel", "\[Rule]", 
               RowBox[{"Row", "[", 
                RowBox[{"{", 
                 RowBox[{"\"\<Scaled \>\"", ",", 
                  RowBox[{"MultipletLabel", "[", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}], "]"}]}], "}"}], "]"}]}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"TextOffset", "\[Rule]", "Right"}]}], 
             "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"PanelRegion", "->", 
           RowBox[{"Scaled", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0.55", ",", "0.95"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0.55", ",", "0.95"}], "}"}]}], "}"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"XPlotRange", "->", 
           RowBox[{"{", 
            RowBox[{"0", ",", "20"}], "}"}]}], ",", 
          RowBox[{"XFrameLabel", "\[Rule]", 
           RowBox[{"textit", "[", "\"\<x\>\"", "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"YPlotRange", "->", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "0.6"}], ",", "1.1"}], "}"}]}], ",", 
          RowBox[{"YFrameLabel", "\[Rule]", 
           RowBox[{"textit", "[", "\"\<y\>\"", "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"YTicks", "->", 
           RowBox[{"LinTicks", "[", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "1", ",", "0.5", ",", "5"}], "]"}]}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"FontSize", "\[Rule]", "12"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Background", "\[Rule]", "LightGray"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Clip", "\[Rule]", "False"}]}], "\[IndentingNewLine]", 
         "]"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"PanelRegion", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"72", "*", 
          RowBox[{"{", 
           RowBox[{"0", ",", "5"}], "}"}]}], ",", 
         RowBox[{"72", "*", 
          RowBox[{"{", 
           RowBox[{"0", ",", "3.5"}], "}"}]}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"XPlotRange", "->", 
       RowBox[{"{", 
        RowBox[{"0", ",", "20"}], "}"}]}], ",", 
      RowBox[{"XFrameLabel", "\[Rule]", 
       RowBox[{"textit", "[", "\"\<x\>\"", "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"YPlotRange", "->", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.6"}], ",", "1.1"}], "}"}]}], ",", 
      RowBox[{"YFrameLabel", "\[Rule]", 
       RowBox[{"textit", "[", "\"\<y\>\"", "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"YTicks", "->", 
       RowBox[{"LinTicks", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "1", ",", "0.5", ",", "5"}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FontSize", "\[Rule]", "15"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Background", "\[Rule]", "Moccasin"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Clip", "\[Rule]", "False"}]}], "\[IndentingNewLine]", "]"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"CanvasSize", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"5", ",", "3.5"}], "}"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.395095660953125*^9, 3.395095674*^9}, {
   3.395521201609375*^9, 3.395521219546875*^9}, {3.395521484265625*^9, 
   3.395521484265625*^9}, {3.5165608799375*^9, 3.516561289578125*^9}, {
   3.516561367203125*^9, 3.51656143996875*^9}, {3.5165615648125*^9, 
   3.51656159890625*^9}, {3.51656165578125*^9, 3.516561684609375*^9}, {
   3.516561736796875*^9, 3.51656176128125*^9}, {3.51656182196875*^9, 
   3.51656184021875*^9}, {3.516562109421875*^9, 3.516562176015625*^9}, {
   3.518120479046875*^9, 3.518120490453125*^9}, 3.518562728439125*^9, {
   3.5204484336875*^9, 3.52044843615625*^9}, 3.520448550328125*^9, 
   3.520448590953125*^9, {3.520448623734375*^9, 3.52044870559375*^9}, 
   3.5204487371875*^9, {3.5663380284029846`*^9, 3.5663380304465885`*^9}, {
   3.5663382102525043`*^9, 3.5663382784090242`*^9}, {3.5666831570648704`*^9, 
   3.5666831894037275`*^9}, {3.566683244128623*^9, 3.566683245064625*^9}, {
   3.566683290335904*^9, 3.5666833547328176`*^9}, {3.566684339205373*^9, 
   3.566684341061776*^9}, {3.5666886390420675`*^9, 3.5666886614374113`*^9}, {
   3.5666917561475773`*^9, 3.5666917734480076`*^9}, {3.566691823118495*^9, 
   3.566691824959298*^9}, {3.5667608376332426`*^9, 3.5667608629520874`*^9}, {
   3.566761619986353*^9, 3.566761620226353*^9}, {3.5667656061178107`*^9, 
   3.5667656332930584`*^9}, 3.5667740860714645`*^9, {3.56677859377411*^9, 
   3.566778600704119*^9}, {3.566778743564319*^9, 3.566779209814972*^9}, {
   3.566779244455021*^9, 3.5667794842003565`*^9}, {3.5667795258954144`*^9, 
   3.5667797311407022`*^9}, {3.5667799004559393`*^9, 3.566779990441065*^9}, {
   3.5667800400411344`*^9, 3.566780124751253*^9}, {3.566780188276342*^9, 
   3.5667802529014325`*^9}, {3.566780283336475*^9, 3.566780485221758*^9}, {
   3.566783015971702*^9, 3.5667832763205595`*^9}, {3.5669370891337957`*^9, 
   3.5669374044442415`*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
      GraphicsBox[
       {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
        RectangleBox[{0., 0.}, {360., 252.}]},
       Frame->False,
       ImageSize->{504, 396.},
       PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
      GraphicsBox[{{
         {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
          GraphicsBox[
           {EdgeForm[None], FaceForm[GrayLevel[0.85]], 
            RectangleBox[{198.00000000000003`, 138.60000000000002`}, \
{342., 239.39999999999998`}]},
           Frame->False,
           ImageSize->{504, 396.},
           PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
          GraphicsBox[{
            {EdgeForm[None], FaceForm[GrayLevel[0]], 
             GeometricTransformationBox[
              DiskBox[{198.00000000000003`, 138.60000000000002`}, 5, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[2], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             GeometricTransformationBox[
              CircleBox[{198.00000000000003`, 138.60000000000002`}, 5, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[2], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{213.00000000000003`, 148.60000000000002`}, {
              203.00000000000003`, 138.60000000000002`}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{}, {{209.36396103067895`, 140.72132034355965`}, {
               203.00000000000003`, 138.60000000000002`}, {
               205.12132034355966`, 144.96396103067895`}}}]}, 
            {EdgeForm[None], FaceForm[GrayLevel[0]], 
             GeometricTransformationBox[
              DiskBox[{342., 239.39999999999998`}, 5, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[2], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             GeometricTransformationBox[
              CircleBox[{342., 239.39999999999998`}, 5, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[2], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{327., 229.39999999999998`}, {337., 
              239.39999999999998`}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{}, {{330.6360389693211, 237.27867965644035`}, {337., 
               239.39999999999998`}, {334.87867965644034`, 
               233.03603896932105`}}}]}, InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox[
                 
                 TemplateBox[{
                  "\"Scaled \"",
                   TemplateBox[{"\"(\"", "0", "\",\"", "0", "\")\""}, 
                    "RowDefault"]},
                  "RowDefault"],
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->12,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{2, 2}, {2, 2}},
              FrameStyle->GrayLevel[0],
              RoundingRadius->{4, 4},
              
              StripOnInput->
               False], {213.00000000000003`, 148.60000000000002`}, {-1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox[
                 
                 TemplateBox[{
                  "\"Scaled \"",
                   TemplateBox[{"\"(\"", "1", "\",\"", "1", "\")\""}, 
                    "RowDefault"]},
                  "RowDefault"],
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->12,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{2, 2}, {2, 2}},
              FrameStyle->GrayLevel[0],
              RoundingRadius->{4, 4},
              StripOnInput->False], {327., 229.39999999999998`}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox[
                
                TemplateBox[{
                 "\"Scaled \"",
                  TemplateBox[{"\"(\"", "0", "\",\"", "0", "\")\""}, 
                   "RowDefault"]},
                 "RowDefault"],
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->12,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{2, 2}, {2, 2}},
              FrameStyle->None,
              RoundingRadius->{4, 4},
              
              StripOnInput->
               False], {213.00000000000003`, 148.60000000000002`}, {-1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox[
                
                TemplateBox[{
                 "\"Scaled \"",
                  TemplateBox[{"\"(\"", "1", "\",\"", "1", "\")\""}, 
                   "RowDefault"]},
                 "RowDefault"],
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->12,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{2, 2}, {2, 2}},
              FrameStyle->None,
              RoundingRadius->{4, 4},
              StripOnInput->False], {327., 229.39999999999998`}, {1, 0}, 
             Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{504, 396.},
           PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{504, 396.},
           PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
          GraphicsBox[{
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{198.00000000000003`, 138.60000000000002`}, {
              198.00000000000003`, 239.39999999999998`}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{198.61200000000002`, 138.60000000000002`}, {
              198.00000000000003`, 138.60000000000002`}}], 
             LineBox[{{199.22400000000002`, 144.5294117647059}, {
              198.00000000000003`, 144.5294117647059}}], 
             LineBox[{{198.61200000000002`, 150.4588235294118}, {
              198.00000000000003`, 150.4588235294118}}], 
             LineBox[{{198.61200000000002`, 156.38823529411766`}, {
              198.00000000000003`, 156.38823529411766`}}], 
             LineBox[{{198.61200000000002`, 162.31764705882355`}, {
              198.00000000000003`, 162.31764705882355`}}], 
             LineBox[{{198.61200000000002`, 168.24705882352941`}, {
              198.00000000000003`, 168.24705882352941`}}], 
             LineBox[{{199.22400000000002`, 174.1764705882353}, {
              198.00000000000003`, 174.1764705882353}}], 
             LineBox[{{198.61200000000002`, 180.1058823529412}, {
              198.00000000000003`, 180.1058823529412}}], 
             LineBox[{{198.61200000000002`, 186.03529411764706`}, {
              198.00000000000003`, 186.03529411764706`}}], 
             LineBox[{{198.61200000000002`, 191.96470588235294`}, {
              198.00000000000003`, 191.96470588235294`}}], 
             LineBox[{{198.61200000000002`, 197.8941176470588}, {
              198.00000000000003`, 197.8941176470588}}], 
             LineBox[{{199.22400000000002`, 203.8235294117647}, {
              198.00000000000003`, 203.8235294117647}}], 
             LineBox[{{198.61200000000002`, 209.75294117647059`}, {
              198.00000000000003`, 209.75294117647059`}}], 
             LineBox[{{198.61200000000002`, 215.68235294117645`}, {
              198.00000000000003`, 215.68235294117645`}}], 
             LineBox[{{198.61200000000002`, 221.61176470588234`}, {
              198.00000000000003`, 221.61176470588234`}}], 
             LineBox[{{198.61200000000002`, 227.54117647058823`}, {
              198.00000000000003`, 227.54117647058823`}}], 
             LineBox[{{199.22400000000002`, 233.4705882352941}, {
              198.00000000000003`, 233.4705882352941}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{342., 138.60000000000002`}, {342., 
              239.39999999999998`}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{341.388, 138.60000000000002`}, {342., 
              138.60000000000002`}}], 
             LineBox[{{340.776, 144.5294117647059}, {342., 
              144.5294117647059}}], 
             LineBox[{{341.388, 150.4588235294118}, {342., 
              150.4588235294118}}], 
             LineBox[{{341.388, 156.38823529411766`}, {342., 
              156.38823529411766`}}], 
             LineBox[{{341.388, 162.31764705882355`}, {342., 
              162.31764705882355`}}], 
             LineBox[{{341.388, 168.24705882352941`}, {342., 
              168.24705882352941`}}], 
             LineBox[{{340.776, 174.1764705882353}, {342., 
              174.1764705882353}}], 
             LineBox[{{341.388, 180.1058823529412}, {342., 
              180.1058823529412}}], 
             LineBox[{{341.388, 186.03529411764706`}, {342., 
              186.03529411764706`}}], 
             LineBox[{{341.388, 191.96470588235294`}, {342., 
              191.96470588235294`}}], 
             LineBox[{{341.388, 197.8941176470588}, {342., 
              197.8941176470588}}], 
             LineBox[{{340.776, 203.8235294117647}, {342., 
              203.8235294117647}}], 
             LineBox[{{341.388, 209.75294117647059`}, {342., 
              209.75294117647059`}}], 
             LineBox[{{341.388, 215.68235294117645`}, {342., 
              215.68235294117645`}}], 
             LineBox[{{341.388, 221.61176470588234`}, {342., 
              221.61176470588234`}}], 
             LineBox[{{341.388, 227.54117647058823`}, {342., 
              227.54117647058823`}}], 
             LineBox[{{340.776, 233.4705882352941}, {342., 
              233.4705882352941}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{198.00000000000003`, 138.60000000000002`}, {342., 
              138.60000000000002`}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{198.00000000000003`, 139.824}, {198.00000000000003`, 
              138.60000000000002`}}], 
             LineBox[{{205.20000000000002`, 139.21200000000002`}, {
              205.20000000000002`, 138.60000000000002`}}], 
             LineBox[{{212.40000000000003`, 139.21200000000002`}, {
              212.40000000000003`, 138.60000000000002`}}], 
             LineBox[{{219.60000000000002`, 139.21200000000002`}, {
              219.60000000000002`, 138.60000000000002`}}], 
             LineBox[{{226.8, 139.21200000000002`}, {226.8, 
              138.60000000000002`}}], 
             LineBox[{{234.00000000000003`, 139.824}, {234.00000000000003`, 
              138.60000000000002`}}], 
             LineBox[{{241.20000000000002`, 139.21200000000002`}, {
              241.20000000000002`, 138.60000000000002`}}], 
             LineBox[{{248.40000000000003`, 139.21200000000002`}, {
              248.40000000000003`, 138.60000000000002`}}], 
             LineBox[{{255.60000000000002`, 139.21200000000002`}, {
              255.60000000000002`, 138.60000000000002`}}], 
             LineBox[{{262.8, 139.21200000000002`}, {262.8, 
              138.60000000000002`}}], 
             LineBox[{{270., 139.824}, {270., 138.60000000000002`}}], 
             LineBox[{{277.20000000000005`, 139.21200000000002`}, {
              277.20000000000005`, 138.60000000000002`}}], 
             LineBox[{{284.40000000000003`, 139.21200000000002`}, {
              284.40000000000003`, 138.60000000000002`}}], 
             LineBox[{{291.6, 139.21200000000002`}, {291.6, 
              138.60000000000002`}}], 
             LineBox[{{298.8, 139.21200000000002`}, {298.8, 
              138.60000000000002`}}], 
             LineBox[{{306., 139.824}, {306., 138.60000000000002`}}], 
             LineBox[{{313.20000000000005`, 139.21200000000002`}, {
              313.20000000000005`, 138.60000000000002`}}], 
             LineBox[{{320.40000000000003`, 139.21200000000002`}, {
              320.40000000000003`, 138.60000000000002`}}], 
             LineBox[{{327.6, 139.21200000000002`}, {327.6, 
              138.60000000000002`}}], 
             LineBox[{{334.8, 139.21200000000002`}, {334.8, 
              138.60000000000002`}}], 
             LineBox[{{342., 139.824}, {342., 138.60000000000002`}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{198.00000000000003`, 239.39999999999998`}, {342., 
              239.39999999999998`}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{198.00000000000003`, 238.176}, {198.00000000000003`, 
              239.39999999999998`}}], 
             LineBox[{{205.20000000000002`, 238.78799999999998`}, {
              205.20000000000002`, 239.39999999999998`}}], 
             LineBox[{{212.40000000000003`, 238.78799999999998`}, {
              212.40000000000003`, 239.39999999999998`}}], 
             LineBox[{{219.60000000000002`, 238.78799999999998`}, {
              219.60000000000002`, 239.39999999999998`}}], 
             LineBox[{{226.8, 238.78799999999998`}, {226.8, 
              239.39999999999998`}}], 
             LineBox[{{234.00000000000003`, 238.176}, {234.00000000000003`, 
              239.39999999999998`}}], 
             LineBox[{{241.20000000000002`, 238.78799999999998`}, {
              241.20000000000002`, 239.39999999999998`}}], 
             LineBox[{{248.40000000000003`, 238.78799999999998`}, {
              248.40000000000003`, 239.39999999999998`}}], 
             LineBox[{{255.60000000000002`, 238.78799999999998`}, {
              255.60000000000002`, 239.39999999999998`}}], 
             LineBox[{{262.8, 238.78799999999998`}, {262.8, 
              239.39999999999998`}}], 
             LineBox[{{270., 238.176}, {270., 239.39999999999998`}}], 
             LineBox[{{277.20000000000005`, 238.78799999999998`}, {
              277.20000000000005`, 239.39999999999998`}}], 
             LineBox[{{284.40000000000003`, 238.78799999999998`}, {
              284.40000000000003`, 239.39999999999998`}}], 
             LineBox[{{291.6, 238.78799999999998`}, {291.6, 
              239.39999999999998`}}], 
             LineBox[{{298.8, 238.78799999999998`}, {298.8, 
              239.39999999999998`}}], 
             LineBox[{{306., 238.176}, {306., 239.39999999999998`}}], 
             LineBox[{{313.20000000000005`, 238.78799999999998`}, {
              313.20000000000005`, 239.39999999999998`}}], 
             LineBox[{{320.40000000000003`, 238.78799999999998`}, {
              320.40000000000003`, 239.39999999999998`}}], 
             LineBox[{{327.6, 238.78799999999998`}, {327.6, 
              239.39999999999998`}}], 
             LineBox[{{334.8, 238.78799999999998`}, {334.8, 
              239.39999999999998`}}], 
             LineBox[{{342., 238.176}, {342., 239.39999999999998`}}]}, 
            InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"-0.5\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 144.5294117647059}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 174.1764705882353}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.5\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 203.8235294117647}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"1.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 233.4705882352941}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox[
                 TagBox[
                  StyleBox["\<\"y\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ],
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->12,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {177.00000000000003`, 189.}, {0, -1}, 
             Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\" 0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->
               False], {198.00000000000003`, 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\" 5\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {234.00000000000003`, 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"10\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {270., 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"15\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {306., 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"20\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {342., 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox[
                 TagBox[
                  StyleBox["\<\"x\"\>",
                   FontSlant->"Italic"],
                  StyleForm[#, FontSlant -> "Italic"]& ],
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->12,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {270., 123.60000000000002`}, {0, 1}, 
             Automatic, {1., 0.}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"-0.5\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 144.5294117647059}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 174.1764705882353}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.5\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 203.8235294117647}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"1.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 233.4705882352941}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox[
                TagBox[
                 StyleBox["\<\"y\"\>",
                  FontSlant->"Italic"],
                 StyleForm[#, FontSlant -> "Italic"]& ],
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->12,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {177.00000000000003`, 189.}, {0, -1}, 
             Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\" 0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {198.00000000000003`, 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\" 5\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {234.00000000000003`, 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"10\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {270., 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"15\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {306., 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"20\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {342., 138.60000000000002`}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox[
                TagBox[
                 StyleBox["\<\"x\"\>",
                  FontSlant->"Italic"],
                 StyleForm[#, FontSlant -> "Italic"]& ],
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->12,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {270., 123.60000000000002`}, {0, 1}, 
             Automatic, {1., 0.}]},
           Frame->False,
           ImageSize->{504, 396.},
           PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], 
         GeometricTransformationBox[
          DiskBox[{0., 0.}, 5, {0., 6.283185307179586}], {{{1, 0}, {0, 1}}, {
           0., 0.}}]}, 
        {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[2], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         GeometricTransformationBox[
          CircleBox[{0., 0.}, 5, {0., 6.283185307179586}], {{{1, 0}, {0, 
           1}}, {0., 0.}}]}, 
        {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[2], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{15., 10.}, {5., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{11.363961030678928`, 2.1213203435596433`}, {5., 0.}, {
           7.121320343559642, 6.363961030678928}}}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], 
         GeometricTransformationBox[
          DiskBox[{360., 252.}, 5, {0., 6.283185307179586}], {{{1, 0}, {0, 
           1}}, {0., 0.}}]}, 
        {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[2], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         GeometricTransformationBox[
          CircleBox[{360., 252.}, 5, {0., 6.283185307179586}], {{{1, 0}, {0, 
           1}}, {0., 0.}}]}, 
        {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[2], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{345., 262.}, {355., 252.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{352.87867965644034`, 258.3639610306789}, {355., 
           252.}, {348.6360389693211, 254.12132034355963`}}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             
             TemplateBox[{
              "\"Scaled \"",
               TemplateBox[{"\"(\"", "0", "\",\"", "0", "\")\""}, 
                "RowDefault"]},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->GrayLevel[0],
          RoundingRadius->{4, 4},
          StripOnInput->False], {15., 10.}, {-1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             
             TemplateBox[{
              "\"Scaled \"",
               TemplateBox[{"\"(\"", "1", "\",\"", "1", "\")\""}, 
                "RowDefault"]},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->GrayLevel[0],
          RoundingRadius->{4, 4},
          StripOnInput->False], {345., 262.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            
            TemplateBox[{
             "\"Scaled \"",
              TemplateBox[{"\"(\"", "0", "\",\"", "0", "\")\""}, 
               "RowDefault"]},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{4, 4},
          StripOnInput->False], {15., 10.}, {-1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            
            TemplateBox[{
             "\"Scaled \"",
              TemplateBox[{"\"(\"", "1", "\",\"", "1", "\")\""}, 
               "RowDefault"]},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{4, 4},
          StripOnInput->False], {345., 262.}, {1, 0}, Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{504, 396.},
       PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{504, 396.},
       PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {432, 324.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 252.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{1.53, 0.}, {0., 0.}}], 
         LineBox[{{3.06, 14.823529411764696`}, {0., 14.823529411764696`}}], 
         LineBox[{{1.53, 29.6470588235294}, {0., 29.6470588235294}}], 
         LineBox[{{1.53, 44.47058823529411}, {0., 44.47058823529411}}], 
         LineBox[{{1.53, 59.29411764705881}, {0., 59.29411764705881}}], 
         LineBox[{{1.53, 74.11764705882352}, {0., 74.11764705882352}}], 
         LineBox[{{3.06, 88.94117647058822}, {0., 88.94117647058822}}], 
         LineBox[{{1.53, 103.76470588235293`}, {0., 103.76470588235293`}}], 
         LineBox[{{1.53, 118.58823529411762`}, {0., 118.58823529411762`}}], 
         LineBox[{{1.53, 133.41176470588235`}, {0., 133.41176470588235`}}], 
         LineBox[{{1.53, 148.23529411764704`}, {0., 148.23529411764704`}}], 
         LineBox[{{3.06, 163.05882352941174`}, {0., 163.05882352941174`}}], 
         LineBox[{{1.53, 177.88235294117644`}, {0., 177.88235294117644`}}], 
         LineBox[{{1.53, 192.70588235294116`}, {0., 192.70588235294116`}}], 
         LineBox[{{1.53, 207.52941176470586`}, {0., 207.52941176470586`}}], 
         LineBox[{{1.53, 222.35294117647055`}, {0., 222.35294117647055`}}], 
         LineBox[{{3.06, 237.17647058823525`}, {0., 237.17647058823525`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{360., 0.}, {360., 252.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{358.47, 0.}, {360., 0.}}], 
         LineBox[{{356.94, 14.823529411764696`}, {360., 
          14.823529411764696`}}], 
         LineBox[{{358.47, 29.6470588235294}, {360., 29.6470588235294}}], 
         LineBox[{{358.47, 44.47058823529411}, {360., 44.47058823529411}}], 
         LineBox[{{358.47, 59.29411764705881}, {360., 59.29411764705881}}], 
         LineBox[{{358.47, 74.11764705882352}, {360., 74.11764705882352}}], 
         LineBox[{{356.94, 88.94117647058822}, {360., 88.94117647058822}}], 
         LineBox[{{358.47, 103.76470588235293`}, {360., 
          103.76470588235293`}}], 
         LineBox[{{358.47, 118.58823529411762`}, {360., 
          118.58823529411762`}}], 
         LineBox[{{358.47, 133.41176470588235`}, {360., 
          133.41176470588235`}}], 
         LineBox[{{358.47, 148.23529411764704`}, {360., 
          148.23529411764704`}}], 
         LineBox[{{356.94, 163.05882352941174`}, {360., 
          163.05882352941174`}}], 
         LineBox[{{358.47, 177.88235294117644`}, {360., 
          177.88235294117644`}}], 
         LineBox[{{358.47, 192.70588235294116`}, {360., 
          192.70588235294116`}}], 
         LineBox[{{358.47, 207.52941176470586`}, {360., 
          207.52941176470586`}}], 
         LineBox[{{358.47, 222.35294117647055`}, {360., 
          222.35294117647055`}}], 
         LineBox[{{356.94, 237.17647058823525`}, {360., 
          237.17647058823525`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {360., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 3.06}, {0., 0.}}], 
         LineBox[{{18., 1.53}, {18., 0.}}], LineBox[{{36., 1.53}, {36., 0.}}],
          LineBox[{{54., 1.53}, {54., 0.}}], 
         LineBox[{{72., 1.53}, {72., 0.}}], LineBox[{{90., 3.06}, {90., 0.}}],
          LineBox[{{108., 1.53}, {108., 0.}}], 
         LineBox[{{126., 1.53}, {126., 0.}}], 
         LineBox[{{144., 1.53}, {144., 0.}}], 
         LineBox[{{162., 1.53}, {162., 0.}}], 
         LineBox[{{180., 3.06}, {180., 0.}}], 
         LineBox[{{198., 1.53}, {198., 0.}}], 
         LineBox[{{216., 1.53}, {216., 0.}}], 
         LineBox[{{234., 1.53}, {234., 0.}}], 
         LineBox[{{252., 1.53}, {252., 0.}}], 
         LineBox[{{270., 3.06}, {270., 0.}}], 
         LineBox[{{288., 1.53}, {288., 0.}}], 
         LineBox[{{306., 1.53}, {306., 0.}}], 
         LineBox[{{324., 1.53}, {324., 0.}}], 
         LineBox[{{342., 1.53}, {342., 0.}}], 
         LineBox[{{360., 3.06}, {360., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 252.}, {360., 252.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 248.94}, {0., 252.}}], 
         LineBox[{{18., 250.47}, {18., 252.}}], 
         LineBox[{{36., 250.47}, {36., 252.}}], 
         LineBox[{{54., 250.47}, {54., 252.}}], 
         LineBox[{{72., 250.47}, {72., 252.}}], 
         LineBox[{{90., 248.94}, {90., 252.}}], 
         LineBox[{{108., 250.47}, {108., 252.}}], 
         LineBox[{{126., 250.47}, {126., 252.}}], 
         LineBox[{{144., 250.47}, {144., 252.}}], 
         LineBox[{{162., 250.47}, {162., 252.}}], 
         LineBox[{{180., 248.94}, {180., 252.}}], 
         LineBox[{{198., 250.47}, {198., 252.}}], 
         LineBox[{{216., 250.47}, {216., 252.}}], 
         LineBox[{{234., 250.47}, {234., 252.}}], 
         LineBox[{{252., 250.47}, {252., 252.}}], 
         LineBox[{{270., 248.94}, {270., 252.}}], 
         LineBox[{{288., 250.47}, {288., 252.}}], 
         LineBox[{{306., 250.47}, {306., 252.}}], 
         LineBox[{{324., 250.47}, {324., 252.}}], 
         LineBox[{{342., 250.47}, {342., 252.}}], 
         LineBox[{{360., 248.94}, {360., 252.}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 14.823529411764696`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 88.94117647058822}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 163.05882352941174`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 237.17647058823525`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              StyleBox["\<\"y\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->15,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-25., 126.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {0, 1}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {90., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"10\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {180., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"15\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {270., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"20\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12.75,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {360., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              StyleBox["\<\"x\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->15,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {180., -15.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 14.823529411764696`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 88.94117647058822}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 163.05882352941174`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 237.17647058823525`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             StyleBox["\<\"y\"\>",
              FontSlant->"Italic"],
             StyleForm[#, FontSlant -> "Italic"]& ],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->15,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-25., 126.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {0, 1}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {90., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"10\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {180., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"15\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {270., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"20\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12.75,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {360., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             StyleBox["\<\"x\"\>",
              FontSlant->"Italic"],
             StyleForm[#, FontSlant -> "Italic"]& ],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->15,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {180., -15.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{504, 396.},
       PlotRange->{{-72, 432}, {-72., 324.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.7857142857142857,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{504, 396.},
  PlotRange->{{-72, 432}, {-72., 324.}}]], "Output",
 CellChangeTimes->{3.5836992559752464`*^9, 3.5943060290055013`*^9, 
  3.59430632086591*^9},ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tutorial 2: A molecular diagram", "Section",
 CellChangeTimes->{{3.566684389359461*^9, 3.566684390763463*^9}, {
  3.5666862960652*^9, 3.5666863162352285`*^9}, {3.566766098657476*^9, 
  3.566766102011482*^9}, {3.5670289676206303`*^9, 3.5670289760602446`*^9}, {
  3.584016472163845*^9, 3.5840164770154533`*^9}}],

Cell[CellGroupData[{

Cell["Main example figure", "Subsection",
 CellChangeTimes->{{3.5670286165104313`*^9, 3.5670286180236344`*^9}, {
  3.5670382083628836`*^9, 3.5670382091928844`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "axes", " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"FigAxis", "[", 
        RowBox[{"Bottom", ",", "0", ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "3"}], "}"}], ",", 
         RowBox[{"AxisLabel", "\[Rule]", 
          RowBox[{"textit", "[", "\"\<x\>\"", "]"}]}], ",", 
         RowBox[{"AxisLabelPosition", "\[Rule]", "0.9"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"FigAxis", "[", 
        RowBox[{"Left", ",", "0", ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "2"}], "}"}], ",", 
         RowBox[{"AxisLabel", "\[Rule]", 
          RowBox[{"textit", "[", "\"\<y\>\"", "]"}]}], ",", 
         RowBox[{"AxisLabelPosition", "\[Rule]", "0.9"}], ",", 
         RowBox[{"TextOrientation", "\[Rule]", "Horizontal"}], ",", 
         RowBox[{"TextOffset", "\[Rule]", "Right"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "particles", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"DefineStyle", "[", 
        RowBox[{"\"\<nucleus\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"FigCircle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"LineThickness", "\[Rule]", "2"}], ",", 
             RowBox[{"FillColor", "\[Rule]", "Firebrick"}], ",", 
             RowBox[{"Radius", "\[Rule]", 
              RowBox[{"Canvas", "[", "8", "]"}]}], ",", 
             RowBox[{"TextBuffer", "\[Rule]", "2"}]}], "}"}]}], "}"}]}], 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"DefineStyle", "[", 
        RowBox[{"\"\<electron\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"FigCircle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"LineThickness", "\[Rule]", "2"}], ",", 
             RowBox[{"FillColor", "\[Rule]", "Blue"}], ",", 
             RowBox[{"Radius", "\[Rule]", 
              RowBox[{"Canvas", "[", "4", "]"}]}]}], "}"}]}], "}"}]}], "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "FigCircle", "\[LeftDoubleBracket]", "\"\<beta\>\"", 
         "\[RightDoubleBracket]"}], "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.5", ",", "1"}], "}"}], ",", 
         RowBox[{"Style", "\[Rule]", "\"\<nucleus\>\""}], ",", 
         RowBox[{"RightLabel", "->", 
          RowBox[{"Subscript", "[", 
           RowBox[{
            RowBox[{"textbf", "[", "\"\<m\>\"", "]"}], ",", 
            "\"\<\[Beta]\>\""}], "]"}]}], ",", 
         RowBox[{"TextNudge", "\[Rule]", 
          RowBox[{"-", "4"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "FigCircle", "\[LeftDoubleBracket]", "\"\<alpha\>\"", 
         "\[RightDoubleBracket]"}], "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1.5"}], "}"}], ",", 
         RowBox[{"Style", "\[Rule]", "\"\<nucleus\>\""}], ",", 
         RowBox[{"LeftLabel", "->", 
          RowBox[{"Subscript", "[", 
           RowBox[{
            RowBox[{"textbf", "[", "\"\<m\>\"", "]"}], ",", 
            "\"\<\[Alpha]\>\""}], "]"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "FigCircle", "\[LeftDoubleBracket]", "\"\<e\>\"", 
         "\[RightDoubleBracket]"}], "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.45", ",", "1.45"}], "}"}], ",", 
         RowBox[{"Style", "\[Rule]", "\"\<electron\>\""}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"position", " ", "vectors"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"ScopeOptions", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SetOptions", "[", 
          RowBox[{"FigArrow", ",", 
           RowBox[{"LineThickness", "\[Rule]", "1.5"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"FigArrow", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}], ",", 
             RowBox[{"FigAnchor", "[", 
              RowBox[{"\"\<beta\>\"", ",", "Center"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"RightLabel", "\[Rule]", 
            RowBox[{"Subscript", "[", 
             RowBox[{
              RowBox[{"textbf", "[", "\"\<R\>\"", "]"}], ",", 
              "\"\<\[Beta]\>\""}], "]"}]}]}], "\[IndentingNewLine]", "]"}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"FigArrow", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}], ",", 
             RowBox[{"FigAnchor", "[", 
              RowBox[{"\"\<alpha\>\"", ",", "Center"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"RightLabel", "\[Rule]", 
            RowBox[{"Subscript", "[", 
             RowBox[{
              RowBox[{"textbf", "[", "\"\<R\>\"", "]"}], ",", 
              "\"\<\[Alpha]\>\""}], "]"}]}]}], "\[IndentingNewLine]", "]"}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
          "FigArrow", "\[LeftDoubleBracket]", "\"\<molaxis\>\"", 
           "\[RightDoubleBracket]"}], "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"FigAnchor", "[", 
              RowBox[{"\"\<beta\>\"", ",", "Center"}], "]"}], ",", 
             RowBox[{"FigAnchor", "[", 
              RowBox[{"\"\<alpha\>\"", ",", "Center"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"RightLabel", "\[Rule]", 
            RowBox[{"textbf", "[", "\"\<R\>\"", "]"}]}], ",", 
           RowBox[{"RightLabelPosition", "\[Rule]", "0.45"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"FigArrow", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}], ",", 
             RowBox[{"FigAnchor", "[", 
              RowBox[{"\"\<e\>\"", ",", "Center"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"RightLabel", "\[Rule]", 
            RowBox[{"Subscript", "[", 
             RowBox[{
              RowBox[{"textbf", "[", "\"\<r\>\"", "]"}], ",", 
              RowBox[{"textit", "[", "\"\<e\>\"", "]"}]}], "]"}]}], ",", 
           RowBox[{"RightLabelPosition", "\[Rule]", "0.7"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"LineDashing", "\[Rule]", "Dashed"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"FigArrow", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}], ",", 
             RowBox[{"CentroidPoint", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"FigAnchor", "[", 
                 RowBox[{"\"\<beta\>\"", ",", "Center"}], "]"}], ",", 
                RowBox[{"FigAnchor", "[", 
                 RowBox[{"\"\<alpha\>\"", ",", "Center"}], "]"}]}], "}"}], 
              "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"RightLabel", "\[Rule]", 
            RowBox[{"Subscript", "[", 
             RowBox[{
              RowBox[{"textbf", "[", "\"\<R\>\"", "]"}], ",", 
              "\"\<c.m.\>\""}], "]"}]}]}], "\[IndentingNewLine]", "]"}], 
         ";"}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"wave", " ", "functions"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "put", " ", "in", " ", "lower", " ", "layer", " ", "so", " ", "does", 
         " ", "not", " ", "block", " ", "circles", " ", "and", " ", 
         "arrows"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Module", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"theta", ",", "dtheta", ",", "pts"}], "}"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"calculate", " ", "wave", " ", "function", " ", "points"}], 
          " ", "*)"}], " ", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"dtheta", "=", 
           RowBox[{"AnchorAngle", "[", 
            RowBox[{"FigAnchor", "[", 
             RowBox[{"\"\<molaxis\>\"", ",", "Center"}], "]"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"pts", "=", 
           RowBox[{"0.6", "*", 
            RowBox[{"GrabPoints", "[", 
             RowBox[{"PolarPlot", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"3", "/", "2"}], "*", 
                 RowBox[{
                  RowBox[{"Cos", "[", "theta", "]"}], "^", "2"}]}], "-", 
                RowBox[{"1", "/", "2"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"theta", ",", "0", ",", 
                 RowBox[{"2", "*", "Pi"}]}], "}"}]}], "]"}], "]"}]}]}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
           "rotate", " ", "points", " ", "to", " ", "match", " ", "molecular",
             " ", "axis"}], " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"pts", "=", 
           RowBox[{
            RowBox[{"RotationTransform", "[", "dtheta", "]"}], "/@", 
            "pts"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
           "draw", " ", "centered", " ", "on", " ", "nuclei", " ", "alpha", 
            " ", "and", " ", "beta"}], " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"SetOptions", "[", 
           RowBox[{"FigPolygon", ",", 
            RowBox[{"FillColor", "\[Rule]", "LightGray"}], ",", 
            RowBox[{"Layer", "\[Rule]", "0.5"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"FigAnchor", "[", 
             RowBox[{"\"\<beta\>\"", ",", "Center"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"FigPolygon", "[", "pts", "]"}]}], "\[IndentingNewLine]", 
           "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"FigAnchor", "[", 
             RowBox[{"\"\<alpha\>\"", ",", "Center"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"FigPolygon", "[", "pts", "]"}]}], "\[IndentingNewLine]", 
           "]"}], ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"wave", " ", "function", " ", "label"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"FigArrow", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"FromHead", "[", 
            RowBox[{"{", 
             RowBox[{"0.2", ",", "0.2"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"RelativeTo", "[", 
            RowBox[{
             RowBox[{"FigAnchor", "[", 
              RowBox[{"\"\<beta\>\"", ",", "Center"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0.2", ",", "0.3"}], "}"}]}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"TailLabel", "->", 
          RowBox[{"Superscript", "[", 
           RowBox[{
            RowBox[{"Row", "[", 
             RowBox[{"{", 
              RowBox[{"\"\<|\[CapitalPsi](\>\"", ",", 
               RowBox[{"Subscript", "[", 
                RowBox[{
                 RowBox[{"textbf", "[", "\"\<r\>\"", "]"}], ",", 
                 RowBox[{"textit", "[", "\"\<e\>\"", "]"}]}], "]"}], ",", 
               "\"\<;\>\"", ",", 
               RowBox[{"Subscript", "[", 
                RowBox[{
                 RowBox[{"textbf", "[", "\"\<R\>\"", "]"}], ",", 
                 "\"\<\[Alpha]\>\""}], "]"}], ",", "\"\<,\>\"", ",", 
               RowBox[{"Subscript", "[", 
                RowBox[{
                 RowBox[{"textbf", "[", "\"\<R\>\"", "]"}], ",", 
                 "\"\<\[Beta]\>\""}], "]"}], ",", "\"\<)|\>\""}], "}"}], 
             "]"}], ",", "\"\<2\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"TextOrientation", "\[Rule]", "Horizontal"}], ",", 
         RowBox[{"TextOffset", "\[Rule]", "Bottom"}]}], "\[IndentingNewLine]",
         "]"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "3"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "2"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ExtendRange", "\[Rule]", "0.2"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Frame", "\[Rule]", "False"}]}], "\[IndentingNewLine]", "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"CanvasSize", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"6", ",", "4"}], "}"}]}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.566606440550431*^9, 3.5666073886155567`*^9}, {
   3.56660742013354*^9, 3.5666075047698402`*^9}, {3.5666095611437488`*^9, 
   3.566609667816736*^9}, {3.5666097574544935`*^9, 3.5666097790137315`*^9}, {
   3.566609824877812*^9, 3.5666098761619024`*^9}, {3.5666100641266327`*^9, 
   3.5666101709244204`*^9}, {3.5666102989226446`*^9, 
   3.5666103284378967`*^9}, {3.566610442240096*^9, 3.566610544014675*^9}, {
   3.5666106095503902`*^9, 3.5666106630428843`*^9}, {3.566610700108549*^9, 
   3.566610721620987*^9}, {3.566610753975444*^9, 3.5666111715569773`*^9}, {
   3.5666113976481743`*^9, 3.566611408614994*^9}, {3.566664756973214*^9, 
   3.566664763690817*^9}, {3.5666649252607985`*^9, 3.5666649454436083`*^9}, 
   3.5666650108921137`*^9, {3.5666833938264866`*^9, 3.5666835796384125`*^9}, {
   3.566925990238184*^9, 3.5669260102530193`*^9}, {3.566926978841322*^9, 
   3.5669269815557265`*^9}, {3.5670292525863304`*^9, 3.567029270604362*^9}, {
   3.5840202816649942`*^9, 3.5840202823349953`*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 360}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 432},
       PlotRange->{{-72, 504}, {-72, 360}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {432., 288.}]}, InsetBox[
      GraphicsBox[{
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0.85]], {}, 
         PolygonBox[CompressedData["
1:eJwUmnc81f8Xx2VESRkhI1mhkp1K6xQKRZKR3D1s5brLbEgolJBRlKxCyWpI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          "],
          VertexColors->Automatic,
          VertexTextureCoordinates->None]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0.85]], {}, 
         PolygonBox[CompressedData["
1:eJwUW3c8lW0YlmSlzJTIKGRHiYi6jVBkJXRs57zrvCgJlayQmaIhSipCkkQk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          "],
          VertexColors->Automatic,
          VertexTextureCoordinates->None]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{61.714285714285715`, 41.142857142857146`}, {
          380.2857142857143, 41.142857142857146`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{374.2857142857143, 44.142857142857146`}, {
           380.2857142857143, 41.142857142857146`}, {374.2857142857143, 
           38.142857142857146`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{61.714285714285715`, 41.142857142857146`}, {
          61.714285714285715`, 256.8571428571429}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{58.714285714285715`, 250.8571428571429}, {
           61.714285714285715`, 256.8571428571429}, {64.71428571428571, 
           250.8571428571429}}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {EdgeForm[None], FaceForm[RGBColor[0.698004, 0.133305, 0.133305]], 
         GeometricTransformationBox[
          DiskBox[{318.85714285714283`, 144.}, 8, {0., 
           6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         GeometricTransformationBox[
          CircleBox[{318.85714285714283`, 144.}, 8, {0., 
           6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {EdgeForm[None], FaceForm[RGBColor[0.698004, 0.133305, 0.133305]], 
         GeometricTransformationBox[
          DiskBox[{164.57142857142856`, 195.42857142857142`}, 8, {0., 
           6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         GeometricTransformationBox[
          CircleBox[{164.57142857142856`, 195.42857142857142`}, 8, {0., 
           6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {EdgeForm[None], FaceForm[RGBColor[0, 0, 1]], 
         GeometricTransformationBox[
          DiskBox[{210.85714285714283`, 190.28571428571428`}, 4, {0., 
           6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         GeometricTransformationBox[
          CircleBox[{210.85714285714283`, 190.28571428571428`}, 4, {0., 
           6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{61.714285714285715`, 41.142857142857146`}, {
          318.85714285714283`, 144.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{312.17211068276896`, 144.55708601453117`}, {
           318.85714285714283`, 144.}, {314.40045474089357`, 
           138.9862258692196}}}]}, 
        {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{61.714285714285715`, 41.142857142857146`}, {
          164.57142857142856`, 195.42857142857142`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{158.74707651106365`, 192.10037025122003`}, {
           164.57142857142856`, 195.42857142857142`}, {163.7393782770907, 
           188.77216907386867`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{318.85714285714283`, 144.}, {164.57142857142856`, 
          195.42857142857142`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{169.31484506168113`, 190.68515493831885`}, {
           164.57142857142856`, 195.42857142857142`}, {171.21221165778215`, 
           196.37725472662194`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{Small, Small}], 
         CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{61.714285714285715`, 41.142857142857146`}, {
          210.85714285714283`, 190.28571428571428`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{204.4931818264639, 188.16439394215465`}, {
           210.85714285714283`, 190.28571428571428`}, {208.7358225135832, 
           183.92175325503536`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{61.714285714285715`, 41.142857142857146`}, {
          241.7142857142857, 169.71428571428572`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{235.088170305888, 168.66805696559138`}, {
           241.71428571428572`, 169.71428571428575`}, {238.5755994682026, 
           163.78565613835096`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{359.99999999999994`, 195.42857142857144`}, {
          339.4285714285714, 174.85714285714286`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{345.7925324592503, 176.97846320070252`}, {
           339.4285714285714, 174.85714285714286`}, {341.54989177213105`, 
           181.22110388782178`}}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              StyleBox["\<\"x\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {348.42857142857144`, 41.142857142857146`}, {0, 1},
          Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              StyleBox["\<\"y\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {61.714285714285715`, 235.28571428571433`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SubscriptBox[
              TagBox[
               StyleBox["\<\"m\"\>",
                FontWeight->"Bold"],
               StyleForm[#, FontWeight -> "Bold"]& ], "\<\"\[Beta]\"\>"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {328.85714285714283`, 140.}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SubscriptBox[
              TagBox[
               StyleBox["\<\"m\"\>",
                FontWeight->"Bold"],
               StyleForm[#, FontWeight -> "Bold"]& ], "\<\"\[Alpha]\"\>"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {154.57142857142856`, 195.42857142857142`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SubscriptBox[
              TagBox[
               StyleBox["\<\"R\"\>",
                FontWeight->"Bold"],
               StyleForm[#, FontWeight -> "Bold"]& ], "\<\"\[Beta]\"\>"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {190.28571428571428`, 92.57142857142857}, {0, 1},
          Automatic, {0.9284766908852593, 0.3713906763541038}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SubscriptBox[
              TagBox[
               StyleBox["\<\"R\"\>",
                FontWeight->"Bold"],
               StyleForm[#, FontWeight -> "Bold"]& ], "\<\"\[Alpha]\"\>"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {113.14285714285714`, 118.28571428571428`}, {0, 1},
          Automatic, {0.554700196225229, 0.8320502943378437}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              StyleBox["\<\"R\"\>",
               FontWeight->"Bold"],
              StyleForm[#, FontWeight -> "Bold"]& ],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {249.42857142857142`, 167.14285714285714`}, {0, -1},
          Automatic, {0.9486832980505138, -0.3162277660168381}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SubscriptBox[
              TagBox[
               StyleBox["\<\"r\"\>",
                FontWeight->"Bold"],
               StyleForm[#, FontWeight -> "Bold"]& ], 
              TagBox[
               StyleBox["\<\"e\"\>",
                FontSlant->"Italic"],
               StyleForm[#, FontSlant -> "Italic"]& ]],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {166.1142857142857, 145.54285714285714`}, {0, 1},
          Automatic, {0.7071067811865475, 0.7071067811865476}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SubscriptBox[
              TagBox[
               StyleBox["\<\"R\"\>",
                FontWeight->"Bold"],
               StyleForm[#, FontWeight -> "Bold"]& ], "\<\"c.m.\"\>"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {151.71428571428572`, 105.42857142857143`}, {0, 1},
          Automatic, {0.8137334712067349, 0.5812381937190965}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TemplateBox[{"\"|\[CapitalPsi](\"", 
                 SubscriptBox[
                  TagBox[
                   StyleBox["\"r\"", FontWeight -> "Bold"], 
                   StyleForm[#, FontWeight -> "Bold"]& ], 
                  TagBox[
                   StyleBox["\"e\"", FontSlant -> "Italic"], 
                   StyleForm[#, FontSlant -> "Italic"]& ]], "\";\"", 
                 SubscriptBox[
                  TagBox[
                   StyleBox["\"R\"", FontWeight -> "Bold"], 
                   StyleForm[#, FontWeight -> "Bold"]& ], "\"\[Alpha]\""], 
                 "\",\"", 
                 SubscriptBox[
                  TagBox[
                   StyleBox["\"R\"", FontWeight -> "Bold"], 
                   StyleForm[#, FontWeight -> "Bold"]& ], "\"\[Beta]\""], 
                 "\")|\""}, "RowDefault"],"\"2\""},
              "Superscript"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {359.99999999999994`, 195.42857142857144`}, {0, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             StyleBox["\<\"x\"\>",
              FontSlant->"Italic"],
             StyleForm[#, FontSlant -> "Italic"]& ],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {348.42857142857144`, 41.142857142857146`}, {0, 1},
          Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             StyleBox["\<\"y\"\>",
              FontSlant->"Italic"],
             StyleForm[#, FontSlant -> "Italic"]& ],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {61.714285714285715`, 235.28571428571433`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SubscriptBox[
             TagBox[
              StyleBox["\<\"m\"\>",
               FontWeight->"Bold"],
              StyleForm[#, FontWeight -> "Bold"]& ], "\<\"\[Beta]\"\>"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {328.85714285714283`, 140.}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SubscriptBox[
             TagBox[
              StyleBox["\<\"m\"\>",
               FontWeight->"Bold"],
              StyleForm[#, FontWeight -> "Bold"]& ], "\<\"\[Alpha]\"\>"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {154.57142857142856`, 195.42857142857142`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SubscriptBox[
             TagBox[
              StyleBox["\<\"R\"\>",
               FontWeight->"Bold"],
              StyleForm[#, FontWeight -> "Bold"]& ], "\<\"\[Beta]\"\>"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {190.28571428571428`, 92.57142857142857}, {0, 1},
          Automatic, {0.9284766908852593, 0.3713906763541038}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SubscriptBox[
             TagBox[
              StyleBox["\<\"R\"\>",
               FontWeight->"Bold"],
              StyleForm[#, FontWeight -> "Bold"]& ], "\<\"\[Alpha]\"\>"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {113.14285714285714`, 118.28571428571428`}, {0, 1},
          Automatic, {0.554700196225229, 0.8320502943378437}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             StyleBox["\<\"R\"\>",
              FontWeight->"Bold"],
             StyleForm[#, FontWeight -> "Bold"]& ],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {249.42857142857142`, 167.14285714285714`}, {0, -1},
          Automatic, {0.9486832980505138, -0.3162277660168381}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SubscriptBox[
             TagBox[
              StyleBox["\<\"r\"\>",
               FontWeight->"Bold"],
              StyleForm[#, FontWeight -> "Bold"]& ], 
             TagBox[
              StyleBox["\<\"e\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ]],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {166.1142857142857, 145.54285714285714`}, {0, 1},
          Automatic, {0.7071067811865475, 0.7071067811865476}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SubscriptBox[
             TagBox[
              StyleBox["\<\"R\"\>",
               FontWeight->"Bold"],
              StyleForm[#, FontWeight -> "Bold"]& ], "\<\"c.m.\"\>"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {151.71428571428572`, 105.42857142857143`}, {0, 1},
          Automatic, {0.8137334712067349, 0.5812381937190965}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TemplateBox[{"\"|\[CapitalPsi](\"", 
                SubscriptBox[
                 TagBox[
                  StyleBox["\"r\"", FontWeight -> "Bold"], 
                  StyleForm[#, FontWeight -> "Bold"]& ], 
                 TagBox[
                  StyleBox["\"e\"", FontSlant -> "Italic"], 
                  StyleForm[#, FontSlant -> "Italic"]& ]], "\";\"", 
                SubscriptBox[
                 TagBox[
                  StyleBox["\"R\"", FontWeight -> "Bold"], 
                  StyleForm[#, FontWeight -> "Bold"]& ], "\"\[Alpha]\""], 
                "\",\"", 
                SubscriptBox[
                 TagBox[
                  StyleBox["\"R\"", FontWeight -> "Bold"], 
                  StyleForm[#, FontWeight -> "Bold"]& ], "\"\[Beta]\""], 
                "\")|\""}, "RowDefault"],"\"2\""},
             "Superscript"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {359.99999999999994`, 195.42857142857144`}, {0, -1},
          Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{432., 288.},
       PlotRange->{{0., 432.}, {0., 288.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 360}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 432},
       PlotRange->{{-72, 504}, {-72, 360}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 360}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 432},
       PlotRange->{{-72, 504}, {-72, 360}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->NCache[
    Rational[3, 4], 0.75],
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 432},
  PlotRange->{{-72, 504}, {-72, 360}}]], "Output",
 CellChangeTimes->{3.583699268070264*^9, 3.584018918711898*^9, 
  3.5840203046570263`*^9, 3.5943060314655046`*^9, 3.5943063220559115`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Rogues\[CloseCurlyQuote] gallery #1: Basic drawing shapes\
\>", "Subsection",
 CellChangeTimes->{{3.5670381242927656`*^9, 3.567038168052827*^9}, {
  3.5840143723485565`*^9, 3.5840143952025967`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SetOptions", "[", 
        RowBox[{"FigObject", ",", 
         RowBox[{"FontFamily", "\[Rule]", "\"\<Courier\>\""}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "FigLine", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"plain", " ", "segment"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"+", ".5"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"FigLine", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}], "}"}], ",", 
           RowBox[{"RightLabel", "\[Rule]", "\"\<FigLine\>\""}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"curved", ",", " ", 
         RowBox[{"with", " ", "arrowhead"}]}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", ".5"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"FigLine", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"0.75", "*", 
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{"x", "^", "3"}]}], "}"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"x", ",", 
               RowBox[{"-", "1"}], ",", "1", ",", "0.1"}], "}"}]}], "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"LineThickness", "\[Rule]", "2"}], ",", 
           RowBox[{"ShowHead", "\[Rule]", "True"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"RightLabel", "\[Rule]", "\"\<FigLine\>\""}], ",", 
           RowBox[{"RightLabelPosition", "\[Rule]", "0.7"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "FigPolygon", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"simple", " ", "shape"}], " ", "*)"}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", 
           RowBox[{"+", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"With", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"n", "=", "3"}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"FigPolygon", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"0.75", "*", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Cos", "[", 
                   RowBox[{"2", "*", "Pi", "*", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"i", "-", 
                    RowBox[{"1", "/", "4"}]}], ")"}], "/", "n"}]}], "]"}], 
                  ",", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"2", "*", "Pi", "*", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"i", "-", 
                    RowBox[{"1", "/", "4"}]}], ")"}], "/", "n"}]}], "]"}]}], 
                 "}"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"FillColor", "\[Rule]", "None"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"RightLabel", "\[Rule]", "\"\<FigPolygon\>\""}], ",", 
             RowBox[{"RightLabelPosition", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"2", ",", "0.5"}], "}"}]}]}], "\[IndentingNewLine]", 
            "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
        "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "grabbing", " ", "curve", " ", "from", " ", "mathematical", " ", 
         "plot"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", 
           RowBox[{"-", "0.75"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"With", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"n", "=", "3"}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"FigPolygon", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"PolarPlot", "[", 
              RowBox[{
               RowBox[{"1.25", "*", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"3", "/", "2"}], "*", 
                   RowBox[{
                    RowBox[{"Cos", "[", "theta", "]"}], "^", "2"}]}], "-", 
                  RowBox[{"1", "/", "2"}]}], ")"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"theta", ",", "0", ",", 
                 RowBox[{"2", "*", "Pi"}]}], "}"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"FillColor", "\[Rule]", "LightGray"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"RightLabel", "\[Rule]", "\"\<FigPolygon\>\""}], ",", 
             RowBox[{"RightLabelPosition", "\[Rule]", "0.25"}]}], 
            "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "FigRectangle", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "square", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6", ",", 
           RowBox[{"+", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"FigRectangle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], ",", 
           RowBox[{"Radius", "\[Rule]", 
            RowBox[{"Horizontal", "[", "0.5", "]"}]}], ",", 
           RowBox[{"FillColor", "\[Rule]", "None"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"BottomLabel", "\[Rule]", "\"\<FigRectangle\>\""}]}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"rectangle", ",", " ", "rotated"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6", ",", 
           RowBox[{"-", "0.75"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"FigRectangle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], ",", 
           RowBox[{"Radius", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0.4"}], "}"}]}], ",", 
           RowBox[{"Rotate", "\[Rule]", 
            RowBox[{"20", "*", "Degree"}]}], ",", 
           RowBox[{"FillColor", "\[Rule]", "LightGray"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"BottomLabel", "\[Rule]", "\"\<FigRectangle\>\""}]}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "FigCircle", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "circle", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"9", ",", 
           RowBox[{"+", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"FigCircle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], ",", 
           RowBox[{"Radius", "\[Rule]", 
            RowBox[{"Horizontal", "[", "0.5", "]"}]}], ",", 
           RowBox[{"FillColor", "\[Rule]", "None"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"BottomLabel", "\[Rule]", "\"\<FigCircle\>\""}]}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"ellipse", ",", " ", "rotated"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"9", ",", 
           RowBox[{"-", "0.75"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"FigCircle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], ",", 
           RowBox[{"Radius", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0.4"}], "}"}]}], ",", 
           RowBox[{"Rotate", "\[Rule]", 
            RowBox[{"20", "*", "Degree"}]}], ",", 
           RowBox[{"FillColor", "\[Rule]", "LightGray"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"BottomLabel", "\[Rule]", "\"\<FigCircle\>\""}]}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"pie", " ", "segment"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"11.5", ",", 
           RowBox[{"+", "0.5"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"FigCircle", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0"}], "}"}], ",", 
            RowBox[{"Radius", "\[Rule]", 
             RowBox[{"Horizontal", "[", "0.75", "]"}]}], ",", 
            RowBox[{"AngleRange", "\[Rule]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"30", ",", "120"}], "}"}], "*", "Degree"}]}], ",", 
            RowBox[{"CurveClosed", "\[Rule]", "True"}], ",", 
            RowBox[{"FillColor", "\[Rule]", "LightGray"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"CenterLabel", "\[Rule]", "\"\<FigCircle\>\""}], ",", 
            RowBox[{"TextOffset", "\[Rule]", "Top"}]}], "\[IndentingNewLine]",
            "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"arc", ",", " ", "rotated", ",", " ", 
         RowBox[{"with", " ", "arrowhead"}]}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"11.5", ",", 
           RowBox[{"-", "0.75"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"FigCircle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], ",", 
           RowBox[{"Radius", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0.4"}], "}"}]}], ",", 
           RowBox[{"Rotate", "\[Rule]", 
            RowBox[{"20", "*", "Degree"}]}], ",", 
           RowBox[{"AngleRange", "\[Rule]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"135", ",", 
               RowBox[{"360", "+", "45"}]}], "}"}], "*", "Degree"}]}], ",", 
           RowBox[{"FillColor", "\[Rule]", "None"}], ",", 
           RowBox[{"ShowHead", "\[Rule]", "True"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"BottomLabel", "\[Rule]", "\"\<FigCircle\>\""}]}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";"}],
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1.5"}], ",", "13"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ExtendRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0.5"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Frame", "\[Rule]", "False"}]}], "\[IndentingNewLine]", "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"CanvasSize", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"8", ",", "2.25"}], "}"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{"CanvasMargin", "\[Rule]", "0"}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.566606440550431*^9, 3.5666073886155567`*^9}, {
   3.56660742013354*^9, 3.5666075047698402`*^9}, {3.5666095611437488`*^9, 
   3.566609667816736*^9}, {3.5666097574544935`*^9, 3.5666097790137315`*^9}, {
   3.566609824877812*^9, 3.5666098761619024`*^9}, {3.5666100641266327`*^9, 
   3.5666101709244204`*^9}, {3.5666102989226446`*^9, 
   3.5666103284378967`*^9}, {3.566610442240096*^9, 3.566610544014675*^9}, {
   3.5666106095503902`*^9, 3.5666106630428843`*^9}, {3.566610700108549*^9, 
   3.566610721620987*^9}, {3.566610753975444*^9, 3.5666111715569773`*^9}, {
   3.5666113976481743`*^9, 3.566611408614994*^9}, {3.566664756973214*^9, 
   3.566664763690817*^9}, {3.5666649252607985`*^9, 3.5666649454436083`*^9}, 
   3.5666650108921137`*^9, {3.5666833938264866`*^9, 3.5666835796384125`*^9}, {
   3.566925990238184*^9, 3.5669260102530193`*^9}, {3.566926978841322*^9, 
   3.5669269815557265`*^9}, {3.5670292525863304`*^9, 3.567029270604362*^9}, {
   3.5670303464007683`*^9, 3.567030415340865*^9}, {3.5670304744509478`*^9, 
   3.5670305355410333`*^9}, {3.567030600211124*^9, 3.5670307720513644`*^9}, {
   3.5670309134015627`*^9, 3.5670312476020303`*^9}, {3.5670316063525324`*^9, 
   3.567032009813097*^9}, {3.5670320642081738`*^9, 3.5670320771381917`*^9}, {
   3.567032107588234*^9, 3.5670321084832354`*^9}, {3.567032150243294*^9, 
   3.5670325344488316`*^9}, {3.567033229689805*^9, 3.5670332471598296`*^9}, {
   3.5840144382742724`*^9, 3.584014622572996*^9}, {3.5943060997056007`*^9, 
   3.594306250935812*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{0, 0.}, {576, 162.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 162.},
       PlotRange->{{0, 576}, {0., 162.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {576., 162.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{19.862068965517246`, 101.25}, {99.31034482758622, 
          141.75}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQ3bfhzmWO07YODCCQYOfwQret5F6Sg8O578GPl/o6
O3Qwy9VbPHB0uOSbJBAx081B6+bWzkmxzg7Kt3/WZWl5Opxa5zvlzS0Xh6sV
L9UMJbwdslqeznOLcIOYV+XjwBNVu3LBVXeH3Z48TNrpvg5r9EW3/ArydJDW
v6vC9t3XwZd17b6QC14O5p2OCU8d/Bze3nI5uc7Xx0HdkGONTIyfA8R9vlD3
+Tnog5zn4e9wE+TAZD+oewMcTpbtmy9V7+ewQ+JSZbdioMPTC0q3f57wc+gE
uz/QwW3b579XIvwdIt9lAl0YBDFPOcBBE+yfYIdpzt05zy8HOPw6zNhvLxPi
kC/UfODUqUCo/0IcxEEWCgc7zJoJAqEOUixhfLo7Q6D+DYOYdyLMAQDWt43J

          "]]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{84.51641498513551, 86.5041506494276}, {
           89.37931034482759, 91.125}, {90.15825260947025, 
           84.4621741019029}}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], {}, 
         PolygonBox[{{178.75862068965517`, 151.875}, {152.9570362458705, 
          106.3125}, {204.56020513343984`, 106.3125}},
          VertexColors->Automatic,
          VertexTextureCoordinates->None]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0.85]], {}, 
         PolygonBox[CompressedData["
1:eJwUmnk4lG0UxmkhKZWyVCjRoigK2d0z1rHNkBBhFvNibCVtEpEUWSJbsiQh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          "],
          VertexColors->Automatic,
          VertexTextureCoordinates->None]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
         GeometricTransformationBox[
          RectangleBox[{278.0689655172414, 101.63793103448276`}, {317.79310344827593`, 141.36206896551724`},
           RoundingRadius->{0., 0.}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0.85]], 
         GeometricTransformationBox[
          RectangleBox[{258.2068965517242, 34.425}, {337.65517241379314`, 66.825},
           RoundingRadius->{0., 0.}], {{{
           0.9396926207859084, -0.3420201433256687}, {0.3420201433256687, 
           0.9396926207859084}}, {35.2822096320603, -98.84535404224448}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         GeometricTransformationBox[
          CircleBox[{417.1034482758621, 121.5}, 19.862068965517242`, {0., 
           6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0.85]], 
         GeometricTransformationBox[
          DiskBox[{417.1034482758621, 50.625}, {39.724137931034484`, 16.2}, {
           0., 6.283185307179586}], {{{
           0.9396926207859084, -0.3420201433256687}, {0.3420201433256687, 
           0.9396926207859084}}, {42.46918558253958, -139.60472008822762`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         GeometricTransformationBox[
          CircleBox[{417.1034482758621, 50.625}, {39.724137931034484`, 16.2}, \
{0., 6.283185307179586}], {{{0.9396926207859084, -0.3420201433256687}, {
           0.3420201433256687, 0.9396926207859084}}, {
           42.46918558253958, -139.60472008822762`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0.85]], 
         GeometricTransformationBox[
          DiskBox[{516.4137931034483, 101.25}, 29.793103448275865`, {
           0.5235987755982988, 2.0943951023931953`}], {{{1, 0}, {0, 1}}, {0., 
           0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         GeometricTransformationBox[
          
          CircleBox[{516.4137931034483, 50.625}, {39.724137931034484`, 16.2}, \
{2.356194490192345, 7.0685834705770345`}], {{{
           0.9396926207859084, -0.3420201433256687}, {0.3420201433256687, 
           0.9396926207859084}}, {48.458332207939065`, -173.5708584598802}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{544.772317425551, 67.76967148667296}, {
           538.8911287794392, 70.996375704423}, {545.0012053413063, 
           73.7653040906624}}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigLine\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {59.58620689655173, 121.5}, {0, 1}, 
         Automatic, {0.8909199524192396, 0.4541603663699638}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigLine\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {76.62938527990383, 66.53845819464827}, {0, 1},
          Automatic, {0.7330851206214689, 0.6801369023390852}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigPolygon\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {178.75862068965517`, 106.3125}, {0, 1}, 
         Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigPolygon\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {178.75878646972524`, 25.312568230585}, {0, 1},
          Automatic, {0.9999925449040291, -0.00386136457268858}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigRectangle\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {297.93103448275866`, 101.63793103448276`}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigRectangle\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {303.47176080463447`, 35.40197954326828}, {0, 1},
          Automatic, 
         NCache[{Cos[20 Degree], Sin[20 Degree]}, {0.9396926207859084, 
          0.3420201433256687}]], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigCircle\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {417.1034482758621, 101.63793103448276`}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigCircle\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {422.6441745977379, 35.40197954326828}, {0, 1},
          Automatic, 
         NCache[{Cos[20 Degree], Sin[20 Degree]}, {0.9396926207859084, 
          0.3420201433256687}]], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigCircle\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {516.4137931034483, 101.25}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigCircle\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {521.9545194253241, 35.401979543268254`}, {0, 1},
          Automatic, 
         NCache[{Cos[20 Degree], Sin[20 Degree]}, {0.9396926207859084, 
          0.3420201433256687}]], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigLine\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {59.58620689655173, 121.5}, {0, 1}, 
         Automatic, {0.8909199524192396, 0.4541603663699638}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigLine\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {76.62938527990383, 66.53845819464827}, {0, 1},
          Automatic, {0.7330851206214689, 0.6801369023390852}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigPolygon\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {178.75862068965517`, 106.3125}, {0, 1}, 
         Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigPolygon\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {178.75878646972524`, 25.312568230585}, {0, 1},
          Automatic, {0.9999925449040291, -0.00386136457268858}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigRectangle\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {297.93103448275866`, 101.63793103448276`}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigRectangle\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {303.47176080463447`, 35.40197954326828}, {0, 1},
          Automatic, 
         NCache[{Cos[20 Degree], Sin[20 Degree]}, {0.9396926207859084, 
          0.3420201433256687}]], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigCircle\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {417.1034482758621, 101.63793103448276`}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigCircle\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {422.6441745977379, 35.40197954326828}, {0, 1},
          Automatic, 
         NCache[{Cos[20 Degree], Sin[20 Degree]}, {0.9396926207859084, 
          0.3420201433256687}]], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigCircle\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {516.4137931034483, 101.25}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigCircle\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {521.9545194253241, 35.401979543268254`}, {0, 1},
          Automatic, 
         NCache[{Cos[20 Degree], Sin[20 Degree]}, {0.9396926207859084, 
          0.3420201433256687}]]},
       Frame->False,
       ImageSize->{576., 162.},
       PlotRange->{{0., 576.}, {0., 162.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0, 0.}, {576, 162.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 162.},
       PlotRange->{{0, 576}, {0., 162.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0, 0.}, {576, 162.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 162.},
       PlotRange->{{0, 576}, {0., 162.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.28125,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 162.},
  PlotRange->{{0, 576}, {0., 162.}}]], "Output",
 CellChangeTimes->{
  3.5836992774202766`*^9, {3.584014571701307*^9, 3.5840145900937395`*^9}, 
   3.5943060332155075`*^9, {3.594306102545604*^9, 3.5943061314556446`*^9}, {
   3.5943061631356893`*^9, 3.5943061870957227`*^9}, {3.5943062206257696`*^9, 
   3.594306240205797*^9}, 3.5943063229959126`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Rogues\[CloseCurlyQuote] gallery #2: Some fancier objects\
\>", "Subsection",
 CellChangeTimes->{{3.5670381242927656`*^9, 3.567038161162817*^9}, {
  3.584014401676608*^9, 3.584014404344213*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SetOptions", "[", 
        RowBox[{"FigObject", ",", 
         RowBox[{"FontFamily", "\[Rule]", "\"\<Courier\>\""}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "FigLabel", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"+", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{
           "FigLabel", "\[LeftDoubleBracket]", "\"\<labela\>\"", 
            "\[RightDoubleBracket]"}], "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0"}], "}"}], ",", 
            RowBox[{"Superscript", "[", 
             RowBox[{
              RowBox[{"Row", "[", 
               RowBox[{"{", 
                RowBox[{"\"\<|\[CapitalPsi](\>\"", ",", 
                 RowBox[{"Subscript", "[", 
                  RowBox[{
                   RowBox[{"textbf", "[", "\"\<r\>\"", "]"}], ",", 
                   RowBox[{"textit", "[", "\"\<e\>\"", "]"}]}], "]"}], ",", 
                 "\"\<;\>\"", ",", 
                 RowBox[{"Subscript", "[", 
                  RowBox[{
                   RowBox[{"textbf", "[", "\"\<R\>\"", "]"}], ",", 
                   "\"\<\[Alpha]\>\""}], "]"}], ",", "\"\<,\>\"", ",", 
                 RowBox[{"Subscript", "[", 
                  RowBox[{
                   RowBox[{"textbf", "[", "\"\<R\>\"", "]"}], ",", 
                   "\"\<\[Beta]\>\""}], "]"}], ",", "\"\<)|\>\""}], "}"}], 
               "]"}], ",", "\"\<2\>\""}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"TextBackground", "\[Rule]", "LightGray"}], ",", 
            RowBox[{"TextFrame", "\[Rule]", "False"}], ",", 
            RowBox[{"TextMargin", "\[Rule]", "2"}], ",", 
            RowBox[{"TextRoundingRadius", "\[Rule]", "2"}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"FigLabel", "[", 
           RowBox[{
           "\"\<labela\>\"", ",", "Bottom", ",", "\"\<FigLabel\>\"", ",", 
            RowBox[{"TextNudge", "\[Rule]", 
             RowBox[{"-", "10"}]}]}], "]"}], ";"}]}], "\[IndentingNewLine]", 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "0.75"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{
           "FigLabel", "\[LeftDoubleBracket]", "\"\<labelb\>\"", 
            "\[RightDoubleBracket]"}], "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"FigAnchor", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "0"}], "}"}], ",", 
              RowBox[{"20", "*", "Degree"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            "\"\<\[ScriptCapitalS]\[ScriptC]\[ScriptI]\[ScriptCapitalD]\
\[ScriptR]\[ScriptA]\[ScriptW]\>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
            RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
            RowBox[{"FontSize", "\[Rule]", "20"}], ",", "\[IndentingNewLine]", 
            RowBox[{"TextBackground", "\[Rule]", "Moccasin"}], ",", 
            RowBox[{"TextFrame", "\[Rule]", "True"}], ",", 
            RowBox[{"TextMargin", "\[Rule]", "2"}], ",", 
            RowBox[{"TextRoundingRadius", "\[Rule]", "2"}], ",", 
            RowBox[{"TextFrameColor", "\[Rule]", "Firebrick"}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"FigLabel", "[", 
           RowBox[{"\"\<labelb\>\"", ",", "Bottom", ",", "\"\<FigLabel\>\""}],
            "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "FigArrow", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", 
           RowBox[{"+", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"FigArrow", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}], "}"}], ",", 
           RowBox[{"RightLabel", "\[Rule]", "\"\<FigArrow\>\""}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"FigArrow", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "0.5"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "1"}], "/", "3"}], ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"+", "1"}], "/", "3"}], ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0.5"}], "}"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"ArrowType", "\[Rule]", "\"\<Block\>\""}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"TailRecess", "\[Rule]", "5"}], ",", "\[IndentingNewLine]", 
           RowBox[{"FillColor", "\[Rule]", "LightGray"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"RightLabel", "\[Rule]", "\"\<FigArrow\>\""}]}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"FigArrow", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0"}], "}"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"ArrowType", "\[Rule]", "\"\<Squiggle\>\""}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"RightLabel", "\[Rule]", "\"\<FigArrow\>\""}]}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "FigAxis", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"SetOptions", "[", 
        RowBox[{"FigAxis", ",", 
         RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6", ",", 
           RowBox[{"-", "0.5"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{
           "FigAxis", "\[LeftDoubleBracket]", "\"\<axisa\>\"", 
            "\[RightDoubleBracket]"}], "[", 
           RowBox[{"Left", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "2"}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{"AxisLabel", "\[Rule]", 
               RowBox[{"textit", "[", "\"\<y\>\"", "]"}]}], ",", 
              RowBox[{"AxisLabelPosition", "\[Rule]", "0.95"}], ","}], "*)"}],
             "\[IndentingNewLine]", 
            RowBox[{"AxisLabel", "\[Rule]", 
             RowBox[{"Row", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"textit", "[", "\"\<E\>\"", "]"}], ",", "\"\< \>\"", 
                ",", "\"\<(\>\"", ",", 
                RowBox[{"UnitsLabel", "[", "\"\<MeV\>\"", "]"}], ",", 
                "\"\<)\>\""}], "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"HeadExtension", "\[Rule]", "15"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Ticks", "\[Rule]", "LogTicks"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"FigLabel", "[", 
           RowBox[{"\"\<axisa\>\"", ",", "Tail", ",", "\"\<FigAxis\>\"", ",", 
            RowBox[{"TextNudge", "\[Rule]", 
             RowBox[{"-", "15"}]}], ",", 
            RowBox[{"TextOrientation", "\[Rule]", "Horizontal"}], ",", 
            RowBox[{"TextOffset", "\[Rule]", "Top"}]}], "]"}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "FigBracket", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"SetOptions", "[", 
        RowBox[{"FigBracket", ",", 
         RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
         RowBox[{"EndLength", "\[Rule]", "2"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"8.5", ",", "0.75"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{
           "FigLine", "\[LeftDoubleBracket]", "\"\<line\>\"", 
            "\[RightDoubleBracket]"}], "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{"x", "^", "3"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{"-", "1"}], ",", "1", ",", "0.1"}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"Color", "\[Rule]", "DimGray"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "FigBracket", "\[LeftDoubleBracket]", "\"\<bracketa\>\"", 
            "\[RightDoubleBracket]"}], "[", 
           RowBox[{"Bottom", ",", 
            RowBox[{"-", "1.2"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
            RowBox[{"BracketLabel", "->", "\"\<Domain\>\""}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"FigBracket", "[", 
           RowBox[{"Right", ",", 
            RowBox[{"+", "1.2"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
            RowBox[{"BracketLabel", "->", "\"\<Range\>\""}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"FigLabel", "[", 
           RowBox[{
           "\"\<bracketa\>\"", ",", "\"\<Bracket\>\"", ",", 
            "\"\<FigBracket\>\"", ",", 
            RowBox[{"TextNudge", "\[Rule]", 
             RowBox[{"-", "20"}]}]}], "]"}], ";"}]}], "\[IndentingNewLine]", 
        "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "FigRule", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"11", ",", "0.0"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"FigLine", "[", 
           RowBox[{
            RowBox[{"Plot", "[", 
             RowBox[{
              RowBox[{"Sin", "[", 
               RowBox[{"2", "*", "Pi", "*", "x"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"x", ",", "0", ",", "1"}], "}"}]}], "]"}], ",", 
            RowBox[{"Color", "\[Rule]", "DimGray"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"FigRule", "[", 
           RowBox[{"Horizontal", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "0.5"}], ",", "1.5"}], "}"}], ",", 
            RowBox[{"LineThickness", "\[Rule]", "2"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"RightLabel", "->", "\"\<FigRule\>\""}], ",", 
            RowBox[{"TextBackground", "\[Rule]", "Automatic"}], ",", 
            RowBox[{"TextBuffer", "\[Rule]", "3"}]}], "]"}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1.5"}], ",", "13"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ExtendRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0.5"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Frame", "\[Rule]", "False"}]}], "\[IndentingNewLine]", "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"CanvasSize", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"8", ",", "2.25"}], "}"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{"CanvasMargin", "\[Rule]", "0"}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.566606440550431*^9, 3.5666073886155567`*^9}, {
   3.56660742013354*^9, 3.5666075047698402`*^9}, {3.5666095611437488`*^9, 
   3.566609667816736*^9}, {3.5666097574544935`*^9, 3.5666097790137315`*^9}, {
   3.566609824877812*^9, 3.5666098761619024`*^9}, {3.5666100641266327`*^9, 
   3.5666101709244204`*^9}, {3.5666102989226446`*^9, 
   3.5666103284378967`*^9}, {3.566610442240096*^9, 3.566610544014675*^9}, {
   3.5666106095503902`*^9, 3.5666106630428843`*^9}, {3.566610700108549*^9, 
   3.566610721620987*^9}, {3.566610753975444*^9, 3.5666111715569773`*^9}, {
   3.5666113976481743`*^9, 3.566611408614994*^9}, {3.566664756973214*^9, 
   3.566664763690817*^9}, {3.5666649252607985`*^9, 3.5666649454436083`*^9}, 
   3.5666650108921137`*^9, {3.5666833938264866`*^9, 3.5666835796384125`*^9}, {
   3.566925990238184*^9, 3.5669260102530193`*^9}, {3.566926978841322*^9, 
   3.5669269815557265`*^9}, {3.5670292525863304`*^9, 3.567029270604362*^9}, {
   3.5670303464007683`*^9, 3.567030415340865*^9}, {3.5670304744509478`*^9, 
   3.5670305355410333`*^9}, {3.567030600211124*^9, 3.5670307720513644`*^9}, {
   3.5670309134015627`*^9, 3.5670312476020303`*^9}, {3.5670316063525324`*^9, 
   3.567032009813097*^9}, {3.5670320642081738`*^9, 3.5670320771381917`*^9}, {
   3.567032107588234*^9, 3.5670321084832354`*^9}, {3.567032150243294*^9, 
   3.5670325344488316`*^9}, {3.567032834509252*^9, 3.5670328446542664`*^9}, {
   3.567032916929367*^9, 3.567032918014369*^9}, {3.5670329527844176`*^9, 
   3.5670330377195363`*^9}, {3.567033082634599*^9, 3.5670332236047964`*^9}, {
   3.567033255989842*^9, 3.567033285509883*^9}, {3.5670333542799797`*^9, 
   3.5670334718962755`*^9}, {3.5670335173194733`*^9, 
   3.5670337003422847`*^9}, {3.567033761510724*^9, 3.5670338869039*^9}, {
   3.567033990117987*^9, 3.567034121348753*^9}, {3.5670342269178743`*^9, 
   3.5670343586597238`*^9}, {3.5670345133975744`*^9, 3.567034530307542*^9}, {
   3.5670348751062627`*^9, 3.567034941440057*^9}, {3.567034986799651*^9, 
   3.5670350958903046`*^9}, {3.5670351556072097`*^9, 3.56703533233992*^9}, {
   3.567035419341273*^9, 3.5670354305732927`*^9}, {3.5670354801345797`*^9, 
   3.5670355238614564`*^9}, {3.5670356877309475`*^9, 
   3.5670357455602493`*^9}, {3.5670359045869284`*^9, 3.567035958875024*^9}, {
   3.5670360455487757`*^9, 3.567036238536715*^9}, {3.567036308487238*^9, 
   3.567036475423131*^9}, {3.5670379300828867`*^9, 3.567037935371296*^9}, {
   3.567038002302595*^9, 3.5670380474126577`*^9}, {3.5840146670954742`*^9, 
   3.5840146917903175`*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{0, 0.}, {576, 162.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 162.},
       PlotRange->{{0, 576}, {0., 162.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {576., 162.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{139.0344827586207, 121.5}, {218.48275862068965`, 162.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{211.77475780706433`, 161.94779765903795`}, {
           218.48275862068965`, 162.}, {214.4997200052841, 
           156.60227794452248`}}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0.85]], 
         PolygonBox[{{144.5249352993842, 100.19884306708096`}, {
          141.48782873674355`, 96.22694380763778}, {164.67095831403742`, 
          78.5}, {192.84628306527293`, 78.5}, {215.23503279067816`, 
          95.61952249510966}, {217.05729672826254`, 93.23638293944376}, {
          218.48275862068965`, 101.25}, {210.37566229045316`, 
          101.97456131021873`}, {212.19792622803752`, 99.59142175455283}, {
          191.15371693472707`, 83.5}, {166.36352444458328`, 83.5}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJxdlX1IVFEUxDcJk4jIiBKJLAmJkJIyi4i4lUmIpEhI9IV73/14d8sKsagM
kbAIEQkJCwmTkDCJspAoCQupsJASC6mQsCgRETERNSkr8SHMLDyWw+HcM2fm
j98qeSJXR4VCoff/v+n/htjq4vhwWISmfyJdRMp+1Gb0Uz0SFgkx1zoKSoL6
d1hkux0Fp1qCOlqKuE6R0/4zqBdJkTcRSslI3D1Tx0uRU1XzJzYzqFdLcfHX
srR6G9TrpLh5J2Ho09mg3iJn9pcG9U7qZ9F8Hr2fT/sjpK9Iov4Sifddlnh/
lRRfx/2NVXOC+oYUD6pbq8pf7pqpb0vRv/7Z/c2VQd0kReO8v++eHA7qFima
CnTU0KagfiFFcXT/64NxQf1WinBeb2xSdFB/DPaHgvob9QdpfozeD3m4f76H
+pZ4qH+Fh/et8fD+DR76s81D/zI89DfHQ/8PeJiP8jC/4x7me8bD/C9Qv4Lm
q+n9OtrfSPqaSX8r3ddO93eRPz3kXx/5O0z+T3qYz1yF+S1UmG+cwvwTqZ9M
82kK3xcK92cq1LdPof4jCu/zFd5fqNCf8wr9u6TQ3ysK/a9RmE+9wvzuKcz3
scL826jfQfPd9H4v7R8gfaOkf4rui9F4/2KN/izX6F+SRn9TNPq/VWM+6Rrz
26sx3/0a85fUP0bzp+n9UtpfTvqukv5auq+B7n+o0Z+nGv17pdHfTo3+f9aY
z3eN+Q1pzHdCY/5RBvsLDM4vNfj+SoP71xrUl2pQ/3aD9+0xeH+uQX8OGfTP
GPT3pEH/zxnMp8xgfpUG871uMP9b1L9L84/o/ee0/w3p+0D6v9B9/XT/CPnz
m/yLtsR/S/y3xH9L/LfEf0v8p34WzefR+/m0P0L6iizx3xL/LfHfEv8t8d8S
/y3x3xL/LfHfEv8t8Z/6gzQ/Ru+HfOK/T/z3if8+8d8n/vvEf5/47xP/feK/
T/z3if8+8d8n/lO/guar6f062t9I+ppJfyvd1073d5E/PeRfH/k7TP5P+sR/
R/x3xH9H/Kd+Ms2nOeK/I/474r8j/jvivyP+O+K/I/474r8j/jvivyP+O+K/
I/5Tv4Pmu+n9Xto/QPpGSf8U3RcTmb0/eTy1rTD76Gz9DyHOr6o=
          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{212.48275862068965`, 43.5}, {218.48275862068965`, 
           40.5}, {212.48275862068965`, 37.5}}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{297.93103448275866`, 60.75}, {297.93103448275866`, 
          156.75}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{294.93103448275866`, 150.75}, {297.93103448275866`, 
           156.75}, {300.93103448275866`, 150.75}}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{301.62103448275866`, 60.75}, {297.93103448275866`, 
          60.75}}], 
         LineBox[{{299.7760344827587, 72.94171482439124}, {
          297.93103448275866`, 72.94171482439124}}], 
         LineBox[{{299.7760344827587, 80.07341081614632}, {
          297.93103448275866`, 80.07341081614632}}], 
         LineBox[{{299.7760344827587, 85.13342964878247}, {
          297.93103448275866`, 85.13342964878247}}], 
         LineBox[{{299.7760344827587, 89.05828517560876}, {
          297.93103448275866`, 89.05828517560876}}], 
         LineBox[{{299.7760344827587, 92.26512564053756}, {
          297.93103448275866`, 92.26512564053756}}], 
         LineBox[{{299.7760344827587, 94.9764706205774}, {297.93103448275866`,
           94.9764706205774}}], 
         LineBox[{{299.7760344827587, 97.32514447317371}, {
          297.93103448275866`, 97.32514447317371}}], 
         LineBox[{{299.7760344827587, 99.39682163229264}, {
          297.93103448275866`, 99.39682163229264}}], 
         LineBox[{{301.62103448275866`, 101.25}, {297.93103448275866`, 
          101.25}}], 
         LineBox[{{299.7760344827587, 113.44171482439124`}, {
          297.93103448275866`, 113.44171482439124`}}], 
         LineBox[{{299.7760344827587, 120.57341081614632`}, {
          297.93103448275866`, 120.57341081614632`}}], 
         LineBox[{{299.7760344827587, 125.63342964878247`}, {
          297.93103448275866`, 125.63342964878247`}}], 
         LineBox[{{299.7760344827587, 129.55828517560877`}, {
          297.93103448275866`, 129.55828517560877`}}], 
         LineBox[{{299.7760344827587, 132.76512564053758`}, {
          297.93103448275866`, 132.76512564053758`}}], 
         LineBox[{{299.7760344827587, 135.4764706205774}, {
          297.93103448275866`, 135.4764706205774}}], 
         LineBox[{{299.7760344827587, 137.8251444731737}, {
          297.93103448275866`, 137.8251444731737}}], 
         LineBox[{{299.7760344827587, 139.89682163229264`}, {
          297.93103448275866`, 139.89682163229264`}}], 
         LineBox[{{301.62103448275866`, 141.75}, {297.93103448275866`, 
          141.75}}]}, 
        {RGBColor[0.333333, 0.333333, 0.333333], AbsoluteThickness[1], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQnd3ydJ5bRJkDAwjsCHSIrl254Or0Mof7/r3T88pC
HLzLchelXC9zMO90THi6IszBOt9wyWexcofc579XfoyLcNDO+Lq0Kazc4fHS
2UcUVkQ6SCfuXC44rRxi3pQoB54okIHlDuqGHGtkjKId/gQ5rtYXrXDYUzJZ
gmVStMMbb9a1+0IqHFTZGqc6H452uONycp3vlAqHowobijKuRjucse3dcOdy
BcS8G9EOe8wCN2ULVzpYgxx4K9phjb7oll9BlQ63f9Zl7XkT7TBH4+bWzkmV
Di7dOc9/y8Y49CrO3S5xqdLh5rnvwY9rYxxqpUAOrIKYJxPrkCusutsssMpB
NirF+j57nEMsz8s9RydUOUyRYAnjC4x38AU570KVQwrIwuYEB9t/BQce81c7
CEZYbjkxJ9FB97vJoSL/aoh5f5IcAKiJjrw=
          "]]}, 
        {RGBColor[0.333333, 0.333333, 0.333333], AbsoluteThickness[1], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{357.5172413793104, 62.775}, {436.96551724137936`, 
          62.775}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{{355.5172413793104, 65.775}, {357.5172413793104, 62.775}, {
          357.5172413793104, 62.775}}, {{438.96551724137936`, 65.775}, {
          436.96551724137936`, 62.775}, {436.96551724137936`, 62.775}}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{444.91034482758624`, 70.875}, {444.91034482758624`, 
          151.875}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{{441.91034482758624`, 68.875}, {444.91034482758624`, 
          70.875}, {444.91034482758624`, 70.875}}, {{441.91034482758624`, 
          153.875}, {444.91034482758624`, 151.875}, {444.91034482758624`, 
          151.875}}}]}, 
        {RGBColor[0.333333, 0.333333, 0.333333], AbsoluteThickness[1], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[CompressedData["
1:eJwV1nk8VG0UB3DKnqWEUFIiKmsUIR3cIVu2sc8MUURZi2TpXoUiS1GkQpIW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          "]]}, 
        {RGBColor[0.333333, 0.333333, 0.333333], AbsoluteThickness[1], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{476.6896551724138, 81.}, {556.1379310344828, 81.}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TemplateBox[{"\"|\[CapitalPsi](\"", 
                 SubscriptBox[
                  TagBox[
                   StyleBox["\"r\"", FontWeight -> "Bold"], 
                   StyleForm[#, FontWeight -> "Bold"]& ], 
                  TagBox[
                   StyleBox["\"e\"", FontSlant -> "Italic"], 
                   StyleForm[#, FontSlant -> "Italic"]& ]], "\";\"", 
                 SubscriptBox[
                  TagBox[
                   StyleBox["\"R\"", FontWeight -> "Bold"], 
                   StyleForm[#, FontWeight -> "Bold"]& ], "\"\[Alpha]\""], 
                 "\",\"", 
                 SubscriptBox[
                  TagBox[
                   StyleBox["\"R\"", FontWeight -> "Bold"], 
                   StyleForm[#, FontWeight -> "Bold"]& ], "\"\[Beta]\""], 
                 "\")|\""}, "RowDefault"],"\"2\""},
              "Superscript"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[0.85],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{2, 2},
          StripOnInput->False], {59.58620689655173, 121.5}, {0, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigLabel\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {59.58620689655173, 97.5}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"\[ScriptCapitalS]\[ScriptC]\[ScriptI]\[ScriptCapitalD]\
\[ScriptR]\[ScriptA]\[ScriptW]\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->"Bold",
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->RGBColor[1., 0.894101, 0.709799],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->RGBColor[0.698004, 0.133305, 0.133305],
          RoundingRadius->{2, 2},
          StripOnInput->False], {59.58620689655173, 50.625}, {0, 0}, 
         Automatic, 
         NCache[{Cos[20 Degree], Sin[20 Degree]}, {0.9396926207859084, 
          0.3420201433256687}]], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigLabel\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {63.51943854479692, 39.818534860962046`}, {0, 1},
          Automatic, 
         NCache[{Cos[20 Degree], Sin[20 Degree]}, {0.9396926207859084, 
          0.3420201433256687}]], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigArrow\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {178.75862068965517`, 141.75}, {0, 1}, 
         Automatic, {0.8909199524192396, 0.454160366369964}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigArrow\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {181.25862068965517`, 78.5}, {0, 1}, 
         Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigArrow\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {178.75862068965517`, 38.}, {0, 1}, 
         Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              SuperscriptBox["10", "0"],
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {297.93103448275866`, 60.75}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              SuperscriptBox["10", "1"],
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {297.93103448275866`, 101.25}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              SuperscriptBox["10", "2"],
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {297.93103448275866`, 141.75}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"E\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" \"","\"(\"",
               TemplateBox[{"\"MeV\""}, "RowDefault"],"\")\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {275.93103448275866`, 108.75}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigAxis\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {297.93103448275866`, 45.75}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Domain\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {397.2413793103449, 62.775}, {0, 1}, 
         Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Range\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {444.91034482758624`, 111.375}, {0, 1}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigBracket\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {397.2413793103449, 42.775}, {0, 1}, 
         Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"FigRule\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Courier",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {516.4137931034483, 78.}, {0, 1}, Automatic, {
         1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TemplateBox[{"\"|\[CapitalPsi](\"", 
                SubscriptBox[
                 TagBox[
                  StyleBox["\"r\"", FontWeight -> "Bold"], 
                  StyleForm[#, FontWeight -> "Bold"]& ], 
                 TagBox[
                  StyleBox["\"e\"", FontSlant -> "Italic"], 
                  StyleForm[#, FontSlant -> "Italic"]& ]], "\";\"", 
                SubscriptBox[
                 TagBox[
                  StyleBox["\"R\"", FontWeight -> "Bold"], 
                  StyleForm[#, FontWeight -> "Bold"]& ], "\"\[Alpha]\""], 
                "\",\"", 
                SubscriptBox[
                 TagBox[
                  StyleBox["\"R\"", FontWeight -> "Bold"], 
                  StyleForm[#, FontWeight -> "Bold"]& ], "\"\[Beta]\""], 
                "\")|\""}, "RowDefault"],"\"2\""},
             "Superscript"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{2, 2},
          StripOnInput->False], {59.58620689655173, 121.5}, {0, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigLabel\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {59.58620689655173, 97.5}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"\[ScriptCapitalS]\[ScriptC]\[ScriptI]\[ScriptCapitalD]\
\[ScriptR]\[ScriptA]\[ScriptW]\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->"Bold",
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{2, 2},
          StripOnInput->False], {59.58620689655173, 50.625}, {0, 0}, 
         Automatic, 
         NCache[{Cos[20 Degree], Sin[20 Degree]}, {0.9396926207859084, 
          0.3420201433256687}]], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigLabel\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {63.51943854479692, 39.818534860962046`}, {0, 1},
          Automatic, 
         NCache[{Cos[20 Degree], Sin[20 Degree]}, {0.9396926207859084, 
          0.3420201433256687}]], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigArrow\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {178.75862068965517`, 141.75}, {0, 1}, 
         Automatic, {0.8909199524192396, 0.454160366369964}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigArrow\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {181.25862068965517`, 78.5}, {0, 1}, 
         Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigArrow\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {178.75862068965517`, 38.}, {0, 1}, 
         Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             SuperscriptBox["10", "0"],
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {297.93103448275866`, 60.75}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             SuperscriptBox["10", "1"],
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {297.93103448275866`, 101.25}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             SuperscriptBox["10", "2"],
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {297.93103448275866`, 141.75}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"E\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" \"","\"(\"",
              TemplateBox[{"\"MeV\""}, "RowDefault"],"\")\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {275.93103448275866`, 108.75}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigAxis\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {297.93103448275866`, 45.75}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Domain\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {397.2413793103449, 62.775}, {0, 1}, 
         Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Range\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {444.91034482758624`, 111.375}, {0, 1}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigBracket\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {397.2413793103449, 42.775}, {0, 1}, 
         Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"FigRule\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Courier",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {516.4137931034483, 78.}, {0, 1}, Automatic, {
         1., 0.}]},
       Frame->False,
       ImageSize->{576., 162.},
       PlotRange->{{0., 576.}, {0., 162.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0, 0.}, {576, 162.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 162.},
       PlotRange->{{0, 576}, {0., 162.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0, 0.}, {576, 162.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 162.},
       PlotRange->{{0, 576}, {0., 162.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.28125,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 162.},
  PlotRange->{{0, 576}, {0., 162.}}]], "Output",
 CellChangeTimes->{3.58369928705029*^9, 3.5840146426970315`*^9, 
  3.5943063239459143`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Bonus: The left and right sides of a curve\
\>", "Subsection",
 CellChangeTimes->{{3.51588560665625*^9, 3.5158856106875*^9}, {
  3.515969705828125*^9, 3.5159697070625*^9}, {3.516320198671875*^9, 
  3.516320206578125*^9}, {3.520947127421875*^9, 3.520947161296875*^9}, {
  3.520947249859375*^9, 3.520947314578125*^9}, {3.520947355859375*^9, 
  3.520947392546875*^9}, {3.520982806109375*^9, 3.520982815359375*^9}, {
  3.5840217325406322`*^9, 3.584021734677836*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Module", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"pts", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"4", ",", 
         RowBox[{"+", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"5", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Figure", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"spline", " ", "curve"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{
          "FigBSpline", "\[LeftDoubleBracket]", "\"\<curve\>\"", 
           "\[RightDoubleBracket]"}], "[", "\[IndentingNewLine]", 
          RowBox[{"pts", ",", "\[IndentingNewLine]", 
           RowBox[{"ShowHead", "\[Rule]", "True"}], ",", 
           RowBox[{"LineThickness", "\[Rule]", "2"}]}], "\[IndentingNewLine]",
           "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", "labels", " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"With", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"n", "=", "8"}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"FigLabel", "[", 
                RowBox[{
                "\"\<curve\>\"", ",", "Left", ",", "\"\<Left\>\"", ",", 
                 RowBox[{"Position", "\[Rule]", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"i", "+", 
                    RowBox[{"0.3", "*", 
                    RowBox[{"DiscreteDelta", "[", "i", "]"}]}]}], ")"}], "/", 
                   "n"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
               RowBox[{"FigLabel", "[", 
                RowBox[{
                "\"\<curve\>\"", ",", "Right", ",", "\"\<Right\>\"", ",", 
                 RowBox[{"Position", "\[Rule]", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"i", "+", 
                    RowBox[{"0.3", "*", 
                    RowBox[{"DiscreteDelta", "[", "i", "]"}]}]}], ")"}], "/", 
                   "n"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", "}"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0", ",", 
               RowBox[{"n", "-", "1"}]}], "}"}]}], "\[IndentingNewLine]", 
            "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]",
          "\[IndentingNewLine]", 
         RowBox[{"(*", " ", "insect", " ", "*)"}], "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
          "FigAnchor", "\[LeftDoubleBracket]", "\"\<point\>\"", 
           "\[RightDoubleBracket]"}], "[", 
          RowBox[{"\"\<curve\>\"", ",", "Center", ",", 
           RowBox[{"7.7", "/", "8"}]}], "]"}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"SetOptions", "[", 
          RowBox[{"FigCircle", ",", 
           RowBox[{"FillColor", "\[Rule]", "Brown"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"note", ":", " ", 
            RowBox[{"rotating", " ", "a", " ", "circle", " ", 
             RowBox[{"doesn", "'"}], "t", " ", "change", " ", "its", " ", 
             "appearance"}]}], ",", " ", 
           RowBox[{
           "but", " ", "it", " ", "does", " ", "rotate", " ", "the", " ", 
            "zero", " ", "point", " ", "for", " ", "the", " ", "polar", " ", 
            "angle"}], ",", " ", 
           RowBox[{
           "which", " ", "we", " ", "use", " ", "that", " ", "to", " ", 
            "determine", " ", "anchors", " ", "below"}]}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
          "FigCircle", "\[LeftDoubleBracket]", "\"\<circle2\>\"", 
           "\[RightDoubleBracket]"}], "[", 
          RowBox[{"\"\<point\>\"", ",", 
           RowBox[{"AnchorOffset", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"+", "1"}], ",", "0"}], "}"}]}], ",", 
           RowBox[{"Radius", "\[Rule]", 
            RowBox[{"Canvas", "[", 
             RowBox[{"{", 
              RowBox[{"5", ",", "4"}], "}"}], "]"}]}], ",", 
           RowBox[{"Rotate", "\[Rule]", "Automatic"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
          "FigCircle", "\[LeftDoubleBracket]", "\"\<circle1\>\"", 
           "\[RightDoubleBracket]"}], "[", 
          RowBox[{"\"\<point\>\"", ",", 
           RowBox[{"AnchorOffset", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0"}], "}"}]}], ",", 
           RowBox[{"Radius", "\[Rule]", 
            RowBox[{"Canvas", "[", 
             RowBox[{"{", 
              RowBox[{"5", ",", "4"}], "}"}], "]"}]}], ",", 
           RowBox[{"Rotate", "\[Rule]", "Automatic"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"FigCircle", "[", 
          RowBox[{
           RowBox[{"FigAnchor", "[", 
            RowBox[{"\"\<circle1\>\"", ",", "Normal", ",", 
             RowBox[{"{", 
              RowBox[{"\"\<Angle\>\"", ",", 
               RowBox[{"30", "*", "Degree"}]}], "}"}]}], "]"}], ",", 
           RowBox[{"AnchorOffset", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "0.5"}], ",", "0"}], "}"}]}], ",", 
           RowBox[{"Radius", "\[Rule]", 
            RowBox[{"Canvas", "[", "2", "]"}]}], ",", 
           RowBox[{"Rotate", "\[Rule]", "Automatic"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"FigCircle", "[", 
          RowBox[{
           RowBox[{"FigAnchor", "[", 
            RowBox[{"\"\<circle1\>\"", ",", "Normal", ",", 
             RowBox[{"{", 
              RowBox[{"\"\<Angle\>\"", ",", 
               RowBox[{
                RowBox[{"-", "30"}], "*", "Degree"}]}], "}"}]}], "]"}], ",", 
           RowBox[{"AnchorOffset", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "0.5"}], ",", "0"}], "}"}]}], ",", 
           RowBox[{"Radius", "\[Rule]", 
            RowBox[{"Canvas", "[", "2", "]"}]}], ",", 
           RowBox[{"Rotate", "\[Rule]", "Automatic"}]}], "]"}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"SetOptions", "[", 
          RowBox[{"FigAnchorMarker", ",", 
           RowBox[{"ShowPoint", "\[Rule]", "False"}], ",", 
           RowBox[{"Length", "\[Rule]", "4"}], ",", 
           RowBox[{"LineColor", "\[Rule]", "Black"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"FigAnchorMarker", "[", 
          RowBox[{"FigAnchor", "[", 
           RowBox[{"\"\<circle1\>\"", ",", "Normal", ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Angle\>\"", ",", 
              RowBox[{"60", "*", "Degree"}]}], "}"}]}], "]"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"FigAnchorMarker", "[", 
          RowBox[{"FigAnchor", "[", 
           RowBox[{"\"\<circle1\>\"", ",", "Normal", ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Angle\>\"", ",", 
              RowBox[{
               RowBox[{"-", "60"}], "*", "Degree"}]}], "}"}]}], "]"}], "]"}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"FigAnchorMarker", "[", 
          RowBox[{"FigAnchor", "[", 
           RowBox[{"\"\<circle2\>\"", ",", "Normal", ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Angle\>\"", ",", 
              RowBox[{"120", "*", "Degree"}]}], "}"}]}], "]"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"FigAnchorMarker", "[", 
          RowBox[{"FigAnchor", "[", 
           RowBox[{"\"\<circle2\>\"", ",", "Normal", ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Angle\>\"", ",", 
              RowBox[{
               RowBox[{"-", "120"}], "*", "Degree"}]}], "}"}]}], "]"}], "]"}],
          ";", "\[IndentingNewLine]", 
         RowBox[{"FigAnchorMarker", "[", 
          RowBox[{"FigAnchor", "[", 
           RowBox[{"\"\<circle2\>\"", ",", "Normal", ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Angle\>\"", ",", 
              RowBox[{"60", "*", "Degree"}]}], "}"}]}], "]"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"FigAnchorMarker", "[", 
          RowBox[{"FigAnchor", "[", 
           RowBox[{"\"\<circle2\>\"", ",", "Normal", ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Angle\>\"", ",", 
              RowBox[{
               RowBox[{"-", "60"}], "*", "Degree"}]}], "}"}]}], "]"}], "]"}], 
         ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "5"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "2"}], "}"}]}], "}"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"ExtendRange", "\[Rule]", "0.05"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Frame", "\[Rule]", "False"}]}], "\[IndentingNewLine]", "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"CanvasSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"6", ",", "2"}], "}"}]}], ",", 
     RowBox[{"CanvasMargin", "\[Rule]", "0"}]}], "\[IndentingNewLine]", 
    "]"}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.515601352421875*^9, 3.515601361703125*^9}, {
   3.515601394078125*^9, 3.515601395*^9}, 3.51560144603125*^9, {
   3.5156015883125*^9, 3.51560172590625*^9}, {3.515601812375*^9, 
   3.5156019316875*^9}, {3.515601997234375*^9, 3.515602306484375*^9}, {
   3.5156025189375*^9, 3.5156025544375*^9}, {3.51560259134375*^9, 
   3.515602618640625*^9}, {3.515602670984375*^9, 3.515602731359375*^9}, {
   3.51560282990625*^9, 3.515602925953125*^9}, {3.515602987703125*^9, 
   3.5156029978125*^9}, {3.515603104828125*^9, 3.515603331109375*^9}, {
   3.515603383359375*^9, 3.515603525515625*^9}, {3.515603676296875*^9, 
   3.515603679015625*^9}, {3.51560378965625*^9, 3.515603815234375*^9}, {
   3.515603856765625*^9, 3.515603950234375*^9}, {3.515603988265625*^9, 
   3.5156043331875*^9}, {3.515604582421875*^9, 3.5156046225*^9}, {
   3.515604676390625*^9, 3.51560472778125*^9}, {3.51560522321875*^9, 
   3.515605308390625*^9}, {3.515605398875*^9, 3.51560544678125*^9}, {
   3.515605492796875*^9, 3.515605523578125*^9}, 3.515605560265625*^9, {
   3.515605634*^9, 3.5156056699375*^9}, {3.515608844578125*^9, 
   3.51560885446875*^9}, {3.515608888015625*^9, 3.51560896025*^9}, {
   3.515609174828125*^9, 3.515609236203125*^9}, 3.51560931628125*^9, {
   3.515616598046875*^9, 3.51561662071875*^9}, {3.5156166625625*^9, 
   3.515616669234375*^9}, {3.5156169183125*^9, 3.51561714725*^9}, {
   3.51561728340625*^9, 3.515617350609375*^9}, {3.515617573078125*^9, 
   3.515617578859375*^9}, {3.515617895984375*^9, 3.515617900765625*^9}, {
   3.515617946609375*^9, 3.515617995359375*^9}, {3.515618027796875*^9, 
   3.5156181498125*^9}, {3.515618227*^9, 3.51561822975*^9}, {
   3.515618325859375*^9, 3.5156183261875*^9}, {3.5156184155625*^9, 
   3.515618416328125*^9}, {3.51562302709375*^9, 3.51562304259375*^9}, {
   3.515623202578125*^9, 3.515623202984375*^9}, {3.515623270125*^9, 
   3.515623436328125*^9}, {3.515623476390625*^9, 3.51562350496875*^9}, {
   3.51562358996875*^9, 3.5156235901875*^9}, {3.515623640984375*^9, 
   3.51562365121875*^9}, {3.51562368709375*^9, 3.515623687453125*^9}, {
   3.51562385821875*^9, 3.515623860109375*^9}, {3.515623939203125*^9, 
   3.515623949421875*^9}, {3.51562407634375*^9, 3.515624139453125*^9}, {
   3.515624183671875*^9, 3.515624185421875*^9}, 3.515624230578125*^9, 
   3.51562427596875*^9, {3.515624357546875*^9, 3.51562439778125*^9}, {
   3.515624705421875*^9, 3.515624841265625*^9}, {3.51568390253125*^9, 
   3.515683912953125*^9}, {3.515683973125*^9, 3.51568397346875*^9}, {
   3.515684075984375*^9, 3.51568407834375*^9}, {3.515684188703125*^9, 
   3.51568420559375*^9}, {3.51568448671875*^9, 3.5156845144375*^9}, {
   3.515684570984375*^9, 3.51568459165625*^9}, {3.5156852955625*^9, 
   3.515685299984375*^9}, {3.515686177234375*^9, 3.51568621375*^9}, {
   3.515686278546875*^9, 3.5156862790625*^9}, {3.515686343203125*^9, 
   3.515686343640625*^9}, {3.515687554515625*^9, 3.515687555015625*^9}, {
   3.51570608871875*^9, 3.515706089*^9}, 3.515706153984375*^9, {
   3.51586156028125*^9, 3.51586156975*^9}, {3.5158856523125*^9, 
   3.51588568125*^9}, {3.51588571690625*^9, 3.515885756546875*^9}, {
   3.51588597790625*^9, 3.515886070421875*^9}, {3.515886209296875*^9, 
   3.515886213703125*^9}, {3.5158866984375*^9, 3.51588670328125*^9}, {
   3.515886734328125*^9, 3.515886737265625*^9}, {3.51588700421875*^9, 
   3.515887033578125*^9}, {3.515887175625*^9, 3.51588743053125*^9}, {
   3.515936522125*^9, 3.515936522890625*^9}, {3.51593658940625*^9, 
   3.515936623265625*^9}, 3.515936677765625*^9, {3.515936844796875*^9, 
   3.515936899109375*^9}, {3.5159381190625*^9, 3.515938193140625*^9}, {
   3.515964943109375*^9, 3.51596494353125*^9}, {3.51596756115625*^9, 
   3.515967604375*^9}, {3.515967674546875*^9, 3.515967675703125*^9}, {
   3.515967715703125*^9, 3.515967716515625*^9}, {3.51596881715625*^9, 
   3.51596881815625*^9}, {3.515968882078125*^9, 3.515968882578125*^9}, {
   3.515969046671875*^9, 3.515969047703125*^9}, {3.515969103796875*^9, 
   3.51596924578125*^9}, 3.515969355921875*^9, 3.515969390765625*^9, {
   3.515969677671875*^9, 3.5159696816875*^9}, {3.516294094796875*^9, 
   3.516294102125*^9}, {3.51632000915625*^9, 3.516320032765625*^9}, {
   3.51632013028125*^9, 3.516320180734375*^9}, {3.518019506140625*^9, 
   3.5180195073125*^9}, {3.5181165450625*^9, 3.518116623359375*^9}, {
   3.518116710796875*^9, 3.5181167381875*^9}, {3.518116796796875*^9, 
   3.5181168219375*^9}, {3.51856184807975*^9, 3.51856185364225*^9}, {
   3.52027792346875*^9, 3.52027792428125*^9}, {3.520947136859375*^9, 
   3.520947219171875*^9}, {3.52094733503125*^9, 3.52094733771875*^9}, {
   3.520977208578125*^9, 3.520977226140625*^9}, {3.520977269046875*^9, 
   3.520977557890625*^9}, {3.52097760034375*^9, 3.520977671515625*^9}, {
   3.52097780146875*^9, 3.52097806240625*^9}, {3.520978097484375*^9, 
   3.52097819603125*^9}, {3.520978228109375*^9, 3.520978520265625*^9}, {
   3.520978616625*^9, 3.520978688375*^9}, {3.52097874415625*^9, 
   3.52097874584375*^9}, {3.520978779015625*^9, 3.520978915296875*^9}, {
   3.566340637242453*^9, 3.566340698808541*^9}, {3.5840153416742597`*^9, 
   3.5840153472122693`*^9}, {3.5840154614200697`*^9, 
   3.5840155407774096`*^9}, {3.584015572663865*^9, 3.584015573085066*^9}, {
   3.58401642385056*^9, 3.5840164245369616`*^9}, {3.584021754661471*^9, 
   3.5840217631478863`*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{0, 0}, {432, 144}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{432, 144},
       PlotRange->{{0, 432}, {0, 144}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {431.99999999999994`, 144.}]}, 
     InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         BSplineCurveBox[{{19.636363636363626`, 72.}, {117.8181818181818, 
          202.9090909090909}, {215.99999999999994`, -58.90909090909091}, {
          314.18181818181813`, 137.45454545454544`}, {412.3636363636363, 
          6.545454545454546}},
          SplineClosed->False,
          SplineDegree->Automatic,
          SplineKnots->Automatic,
          SplineWeights->Automatic]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{411.16363636363633`, 13.145454545454545`}, {
           412.3636363636363, 6.545454545454546}, {406.3636363636363, 
           9.545454545454545}}}]}, 
        {EdgeForm[None], FaceForm[RGBColor[0.6, 0.4, 0.2]], 
         GeometricTransformationBox[
          DiskBox[{386.08042613636354`, 32.27906249999998}, {5., 4.}, {0., 
           6.283185307179586}], {{{0.6790491713980263, 
           0.7340927889740191}, {-0.7340927889740191, 0.6790491713980263}}, {
           101.82175980238719`, 297.44931259146085`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         GeometricTransformationBox[
          CircleBox[{386.08042613636354`, 32.27906249999998}, {5., 4.}, {0., 
           6.283185307179586}], {{{0.6790491713980263, 
           0.7340927889740191}, {-0.7340927889740191, 0.6790491713980263}}, {
           101.82175980238719`, 297.44931259146085`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {EdgeForm[None], FaceForm[RGBColor[0.6, 0.4, 0.2]], 
         GeometricTransformationBox[
          DiskBox[{396.08042613636354`, 32.27906249999998}, {5., 4.}, {0., 
           6.283185307179586}], {{{0.6790491713980263, 
           0.7340927889740191}, {-0.7340927889740191, 0.6790491713980263}}, {
           101.82175980238719`, 297.44931259146085`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         GeometricTransformationBox[
          CircleBox[{396.08042613636354`, 32.27906249999998}, {5., 4.}, {0., 
           6.283185307179586}], {{{0.6790491713980263, 
           0.7340927889740191}, {-0.7340927889740191, 0.6790491713980263}}, {
           101.82175980238719`, 297.44931259146085`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {EdgeForm[None], FaceForm[RGBColor[0.6, 0.4, 0.2]], 
         GeometricTransformationBox[
          DiskBox[{399.8842267355491, 26.78798187799356}, 2, {0., 
           6.283185307179586}], {{{0.9802259991114456, 
           0.19788125395289052`}, {-0.19788125395289052`, 
           0.9802259991114456}}, {2.5866976090144362`, 79.46141654591759}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         GeometricTransformationBox[
          CircleBox[{399.8842267355491, 26.78798187799356}, 2, {0., 
           6.283185307179586}], {{{0.9802259991114456, 
           0.19788125395289052`}, {-0.19788125395289052`, 
           0.9802259991114456}}, {2.5866976090144362`, 79.46141654591759}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {EdgeForm[None], FaceForm[RGBColor[0.6, 0.4, 0.2]], 
         GeometricTransformationBox[
          DiskBox[{396.947855579653, 24.071785192401478`}, 2, {0., 
           6.283185307179586}], {{{0.12103537741218368`, 
           0.9926481941829594}, {-0.9926481941829594, 
           0.12103537741218368`}}, {324.1293433420275, 
           414.19517141841186`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         GeometricTransformationBox[
          CircleBox[{396.947855579653, 24.071785192401478`}, 2, {0., 
           6.283185307179586}], {{{0.12103537741218368`, 
           0.9926481941829594}, {-0.9926481941829594, 
           0.12103537741218368`}}, {324.1293433420275, 
           414.19517141841186`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{398.71626693779467`, 29.12566191409269}, {
          402.5209650619431, 30.360276098403432`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{393.6303229059029, 24.421071251297008`}, {
          392.1035030210029, 20.723934380815486`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{388.5305293668242, 40.137053748702954`}, {
          390.05734925172425`, 43.834190619184476`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{383.44458533493247`, 35.43246308590727}, {379.639887210784,
           34.19784890159653}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{391.92577522381436`, 36.466589803832846`}, {
          395.7304733479628, 37.70120398814359}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{386.8398311919226, 31.761999141037165`}, {
          385.3130113070226, 28.064862270555643`}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Left\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {40.91957386363635, 97.19514204545455}, {0, -1},
          Automatic, {0.6968627349615357, 0.7172045235648813}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Right\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {40.91957386363635, 97.19514204545455}, {0, 1},
          Automatic, {0.6968627349615357, 0.7172045235648813}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Left\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {84.83522727272727, 126.9715909090909}, {0, -1},
          Automatic, {0.9560542081957355, 0.2931899571800256}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Right\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {84.83522727272727, 126.9715909090909}, {0, 1},
          Automatic, {0.9560542081957355, 0.2931899571800256}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Left\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {136.2272727272727, 119.04545454545455`}, {0, -1},
          Automatic, {0.8574929257125441, -0.5144957554275266}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Right\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {136.2272727272727, 119.04545454545455`}, {0, 1},
          Automatic, {0.8574929257125441, -0.5144957554275266}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Left\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {178.4147727272727, 83.50568181818181}, {0, -1},
          Automatic, {0.7211047102874315, -0.6928260941977283}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Right\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {178.4147727272727, 83.50568181818181}, {0, 1},
          Automatic, {0.7211047102874315, -0.6928260941977283}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Left\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {215.99999999999994`, 55.63636363636363}, {0, -1},
          Automatic, {0.9486832980505138, -0.3162277660168381}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Right\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {215.99999999999994`, 55.63636363636363}, {0, 1},
          Automatic, {0.9486832980505138, -0.3162277660168381}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Left\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {253.5852272727272, 59.4715909090909}, {0, -1},
          Automatic, {0.9370821148326491, 0.3491090231729477}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Right\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {253.5852272727272, 59.4715909090909}, {0, 1},
          Automatic, {0.9370821148326491, 0.3491090231729477}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Left\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {295.7727272727272, 74.04545454545453}, {0, -1},
          Automatic, {0.9805806756909202, 0.19611613513818396`}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Right\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {295.7727272727272, 74.04545454545453}, {0, 1},
          Automatic, {0.9805806756909202, 0.19611613513818396`}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Left\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {347.1647727272727, 67.14204545454545}, {0, -1},
          Automatic, {0.8968058847750245, -0.4424242364890122}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Right\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {347.1647727272727, 67.14204545454545}, {0, 1},
          Automatic, {0.8968058847750245, -0.4424242364890122}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Left\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {40.91957386363635, 97.19514204545455}, {0, -1},
          Automatic, {0.6968627349615357, 0.7172045235648813}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Right\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {40.91957386363635, 97.19514204545455}, {0, 1},
          Automatic, {0.6968627349615357, 0.7172045235648813}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Left\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {84.83522727272727, 126.9715909090909}, {0, -1},
          Automatic, {0.9560542081957355, 0.2931899571800256}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Right\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {84.83522727272727, 126.9715909090909}, {0, 1},
          Automatic, {0.9560542081957355, 0.2931899571800256}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Left\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {136.2272727272727, 119.04545454545455`}, {0, -1},
          Automatic, {0.8574929257125441, -0.5144957554275266}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Right\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {136.2272727272727, 119.04545454545455`}, {0, 1},
          Automatic, {0.8574929257125441, -0.5144957554275266}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Left\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {178.4147727272727, 83.50568181818181}, {0, -1},
          Automatic, {0.7211047102874315, -0.6928260941977283}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Right\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {178.4147727272727, 83.50568181818181}, {0, 1},
          Automatic, {0.7211047102874315, -0.6928260941977283}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Left\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {215.99999999999994`, 55.63636363636363}, {0, -1},
          Automatic, {0.9486832980505138, -0.3162277660168381}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Right\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {215.99999999999994`, 55.63636363636363}, {0, 1},
          Automatic, {0.9486832980505138, -0.3162277660168381}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Left\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {253.5852272727272, 59.4715909090909}, {0, -1},
          Automatic, {0.9370821148326491, 0.3491090231729477}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Right\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {253.5852272727272, 59.4715909090909}, {0, 1},
          Automatic, {0.9370821148326491, 0.3491090231729477}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Left\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {295.7727272727272, 74.04545454545453}, {0, -1},
          Automatic, {0.9805806756909202, 0.19611613513818396`}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Right\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {295.7727272727272, 74.04545454545453}, {0, 1},
          Automatic, {0.9805806756909202, 0.19611613513818396`}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Left\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {347.1647727272727, 67.14204545454545}, {0, -1},
          Automatic, {0.8968058847750245, -0.4424242364890122}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Right\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {347.1647727272727, 67.14204545454545}, {0, 1},
          Automatic, {0.8968058847750245, -0.4424242364890122}]},
       Frame->False,
       ImageSize->{431.99999999999994`, 144.},
       PlotRange->{{0., 431.99999999999994`}, {0., 144.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0, 0}, {432, 144}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{432, 144},
       PlotRange->{{0, 432}, {0, 144}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0, 0}, {432, 144}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{432, 144},
       PlotRange->{{0, 432}, {0, 144}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->NCache[
    Rational[1, 3], 0.3333333333333333],
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{432, 144},
  PlotRange->{{0, 432}, {0, 144}}]], "Output",
 CellChangeTimes->{{3.520978318234375*^9, 3.520978412953125*^9}, 
   3.5209784795*^9, {3.5209785116875*^9, 3.520978523046875*^9}, 
   3.520978650453125*^9, 3.5209787109375*^9, 3.520978748796875*^9, {
   3.520978787515625*^9, 3.52097882715625*^9}, {3.520978863671875*^9, 
   3.52097887346875*^9}, 3.5663407019435453`*^9, {3.5840153262458324`*^9, 
   3.5840153485070715`*^9}, 3.584015542571412*^9, 3.584015574223868*^9, 
   3.5840164257693634`*^9, 3.584021764302288*^9, 3.5943063248259153`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Miscellany", "Section",
 CellChangeTimes->{{3.600716365511056*^9, 3.6007163673830585`*^9}}],

Cell["\<\
These may yet make it into tutorials...\
\>", "Text",
 CellChangeTimes->{{3.6007163699414635`*^9, 3.60071637966028*^9}}],

Cell[CellGroupData[{

Cell["\<\
Panel layout: Using nested Multipanels to arrange multipanel figures into a \
larger figure\
\>", "Subsection",
 CellChangeTimes->{{3.600716383154687*^9, 3.600716417552747*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"outer", " ", 
     RowBox[{"multipanel", " ", "--"}], " ", "this", " ", "is", " ", "a", 
     " ", "\"\<meta-multipanel\>\""}], ",", " ", 
    RowBox[{
    "each", " ", "panel", " ", "of", " ", "which", " ", "will", " ", 
     "contain", " ", "a", " ", "multipanel"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Multipanel", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"panel", " ", "of", " ", "outer", " ", 
       RowBox[{"multipanel", " ", "--"}], " ", "holds", " ", "an", " ", 
       "inner", " ", "multipanel"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"FigurePanel", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"inner", " ", "multipanel"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"Multipanel", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"panel", " ", "of", " ", "inner", " ", "multipanel"}], 
            " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", "All"}], 
            "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Dimensions", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"2", ",", "2"}], "}"}]}]}], "\[IndentingNewLine]", "]"}], 
        "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", "All"}], 
      "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Dimensions", "->", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}]}], ",", 
    RowBox[{"XPanelGaps", "\[Rule]", "0.05"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Ticks", "\[Rule]", "None"}], ",", 
    RowBox[{"PanelLetter", "\[Rule]", "None"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Background", "\[Rule]", "Moccasin"}]}], "\[IndentingNewLine]", 
   "]"}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.6007156663792276`*^9, 3.600715820273498*^9}, {
  3.600716076925149*^9, 3.6007161014171915`*^9}, {3.600716432887574*^9, 
  3.600716530528146*^9}, {3.6007166034894733`*^9, 3.600716626078313*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[
       {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
        RectangleBox[{0., 0.}, {210.7317073170732, 306.}]},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {210.7317073170732, 306.}]}, 
     InsetBox[
      GraphicsBox[{{
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], 
          RectangleBox[{0., 153.}, {105.3658536585366, 306.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{105.3658536585366, 153.},
           
           PlotRange->{{0., 105.3658536585366}, {153., 
            306.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox[
                 TemplateBox[{"\"(\"","\"a\"","\")\""},
                  "RowDefault"],
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->16,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {15., 291.}, {0, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               TagBox[
                TemplateBox[{"\"(\"","\"a\"","\")\""},
                 "RowDefault"],
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->16,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {15., 291.}, {0, 0}, Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{0., 153.}, {0., 306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{1.291829268292683, 153.}, {0., 153.}}], 
             LineBox[{{0.6459146341463415, 160.65}, {0., 160.65}}], 
             LineBox[{{0.6459146341463415, 168.3}, {0., 168.3}}], 
             LineBox[{{0.6459146341463415, 175.95}, {0., 175.95}}], 
             LineBox[{{1.291829268292683, 183.6}, {0., 183.6}}], 
             LineBox[{{0.6459146341463415, 191.25}, {0., 191.25}}], 
             LineBox[{{0.6459146341463415, 198.9}, {0., 198.9}}], 
             LineBox[{{0.6459146341463415, 206.55}, {0., 206.55}}], 
             LineBox[{{1.291829268292683, 214.2}, {0., 214.2}}], 
             LineBox[{{0.6459146341463415, 221.85000000000002`}, {0., 
              221.85000000000002`}}], 
             LineBox[{{0.6459146341463415, 229.5}, {0., 229.5}}], 
             LineBox[{{0.6459146341463415, 237.15}, {0., 237.15}}], 
             LineBox[{{1.291829268292683, 244.8}, {0., 244.8}}], 
             LineBox[{{0.6459146341463415, 252.45000000000002`}, {0., 
              252.45000000000002`}}], 
             LineBox[{{0.6459146341463415, 260.1}, {0., 260.1}}], 
             LineBox[{{0.6459146341463415, 267.75}, {0., 267.75}}], 
             LineBox[{{1.291829268292683, 275.4}, {0., 275.4}}], 
             LineBox[{{0.6459146341463415, 283.05}, {0., 283.05}}], 
             LineBox[{{0.6459146341463415, 290.70000000000005`}, {0., 
              290.70000000000005`}}], 
             LineBox[{{0.6459146341463415, 298.35}, {0., 298.35}}], 
             LineBox[{{1.291829268292683, 306.}, {0., 306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{105.3658536585366, 153.}, {105.3658536585366, 306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{104.0740243902439, 153.}, {105.3658536585366, 153.}}], 
             LineBox[{{104.71993902439026`, 160.65}, {105.3658536585366, 
              160.65}}], 
             LineBox[{{104.71993902439026`, 168.3}, {105.3658536585366, 
              168.3}}], 
             LineBox[{{104.71993902439026`, 175.95}, {105.3658536585366, 
              175.95}}], 
             LineBox[{{104.0740243902439, 183.6}, {105.3658536585366, 
              183.6}}], 
             LineBox[{{104.71993902439026`, 191.25}, {105.3658536585366, 
              191.25}}], 
             LineBox[{{104.71993902439026`, 198.9}, {105.3658536585366, 
              198.9}}], 
             LineBox[{{104.71993902439026`, 206.55}, {105.3658536585366, 
              206.55}}], 
             LineBox[{{104.0740243902439, 214.2}, {105.3658536585366, 
              214.2}}], 
             LineBox[{{104.71993902439026`, 221.85000000000002`}, {
              105.3658536585366, 221.85000000000002`}}], 
             LineBox[{{104.71993902439026`, 229.5}, {105.3658536585366, 
              229.5}}], 
             LineBox[{{104.71993902439026`, 237.15}, {105.3658536585366, 
              237.15}}], 
             LineBox[{{104.0740243902439, 244.8}, {105.3658536585366, 
              244.8}}], 
             LineBox[{{104.71993902439026`, 252.45000000000002`}, {
              105.3658536585366, 252.45000000000002`}}], 
             LineBox[{{104.71993902439026`, 260.1}, {105.3658536585366, 
              260.1}}], 
             LineBox[{{104.71993902439026`, 267.75}, {105.3658536585366, 
              267.75}}], 
             LineBox[{{104.0740243902439, 275.4}, {105.3658536585366, 
              275.4}}], 
             LineBox[{{104.71993902439026`, 283.05}, {105.3658536585366, 
              283.05}}], 
             LineBox[{{104.71993902439026`, 290.70000000000005`}, {
              105.3658536585366, 290.70000000000005`}}], 
             LineBox[{{104.71993902439026`, 298.35}, {105.3658536585366, 
              298.35}}], 
             LineBox[{{104.0740243902439, 306.}, {105.3658536585366, 306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{0., 153.}, {105.3658536585366, 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{0., 154.29182926829267`}, {0., 153.}}], 
             LineBox[{{5.26829268292683, 153.64591463414635`}, {
              5.26829268292683, 153.}}], 
             LineBox[{{10.53658536585366, 153.64591463414635`}, {
              10.53658536585366, 153.}}], 
             LineBox[{{15.804878048780491`, 153.64591463414635`}, {
              15.804878048780491`, 153.}}], 
             LineBox[{{21.07317073170732, 154.29182926829267`}, {
              21.07317073170732, 153.}}], 
             LineBox[{{26.34146341463415, 153.64591463414635`}, {
              26.34146341463415, 153.}}], 
             LineBox[{{31.609756097560982`, 153.64591463414635`}, {
              31.609756097560982`, 153.}}], 
             LineBox[{{36.87804878048781, 153.64591463414635`}, {
              36.87804878048781, 153.}}], 
             LineBox[{{42.14634146341464, 154.29182926829267`}, {
              42.14634146341464, 153.}}], 
             LineBox[{{47.41463414634147, 153.64591463414635`}, {
              47.41463414634147, 153.}}], 
             LineBox[{{52.6829268292683, 153.64591463414635`}, {
              52.6829268292683, 153.}}], 
             LineBox[{{57.95121951219513, 153.64591463414635`}, {
              57.95121951219513, 153.}}], 
             LineBox[{{63.219512195121965`, 154.29182926829267`}, {
              63.219512195121965`, 153.}}], 
             LineBox[{{68.4878048780488, 153.64591463414635`}, {
              68.4878048780488, 153.}}], 
             LineBox[{{73.75609756097562, 153.64591463414635`}, {
              73.75609756097562, 153.}}], 
             LineBox[{{79.02439024390246, 153.64591463414635`}, {
              79.02439024390246, 153.}}], 
             LineBox[{{84.29268292682929, 154.29182926829267`}, {
              84.29268292682929, 153.}}], 
             LineBox[{{89.56097560975611, 153.64591463414635`}, {
              89.56097560975611, 153.}}], 
             LineBox[{{94.82926829268294, 153.64591463414635`}, {
              94.82926829268294, 153.}}], 
             LineBox[{{100.09756097560977`, 153.64591463414635`}, {
              100.09756097560977`, 153.}}], 
             LineBox[{{105.3658536585366, 154.29182926829267`}, {
              105.3658536585366, 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{0., 306.}, {105.3658536585366, 306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{0., 304.7081707317073}, {0., 306.}}], 
             LineBox[{{5.26829268292683, 305.3540853658537}, {
              5.26829268292683, 306.}}], 
             LineBox[{{10.53658536585366, 305.3540853658537}, {
              10.53658536585366, 306.}}], 
             LineBox[{{15.804878048780491`, 305.3540853658537}, {
              15.804878048780491`, 306.}}], 
             LineBox[{{21.07317073170732, 304.7081707317073}, {
              21.07317073170732, 306.}}], 
             LineBox[{{26.34146341463415, 305.3540853658537}, {
              26.34146341463415, 306.}}], 
             LineBox[{{31.609756097560982`, 305.3540853658537}, {
              31.609756097560982`, 306.}}], 
             LineBox[{{36.87804878048781, 305.3540853658537}, {
              36.87804878048781, 306.}}], 
             LineBox[{{42.14634146341464, 304.7081707317073}, {
              42.14634146341464, 306.}}], 
             LineBox[{{47.41463414634147, 305.3540853658537}, {
              47.41463414634147, 306.}}], 
             LineBox[{{52.6829268292683, 305.3540853658537}, {
              52.6829268292683, 306.}}], 
             LineBox[{{57.95121951219513, 305.3540853658537}, {
              57.95121951219513, 306.}}], 
             LineBox[{{63.219512195121965`, 304.7081707317073}, {
              63.219512195121965`, 306.}}], 
             LineBox[{{68.4878048780488, 305.3540853658537}, {
              68.4878048780488, 306.}}], 
             LineBox[{{73.75609756097562, 305.3540853658537}, {
              73.75609756097562, 306.}}], 
             LineBox[{{79.02439024390246, 305.3540853658537}, {
              79.02439024390246, 306.}}], 
             LineBox[{{84.29268292682929, 304.7081707317073}, {
              84.29268292682929, 306.}}], 
             LineBox[{{89.56097560975611, 305.3540853658537}, {
              89.56097560975611, 306.}}], 
             LineBox[{{94.82926829268294, 305.3540853658537}, {
              94.82926829268294, 306.}}], 
             LineBox[{{100.09756097560977`, 305.3540853658537}, {
              100.09756097560977`, 306.}}], 
             LineBox[{{105.3658536585366, 304.7081707317073}, {
              105.3658536585366, 306.}}]}, InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 153.}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.2\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 183.6}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.4\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 214.2}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.6\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 244.8}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.8\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 275.4}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"1.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 306.}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 153.}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.2\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 183.6}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.4\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 214.2}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.6\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 244.8}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.8\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 275.4}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"1.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 306.}, {1, 0}, Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], 
          RectangleBox[{105.3658536585366, 153.}, {210.7317073170732, 306.}]},
          InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{105.3658536585366, 153.},
           
           PlotRange->{{105.3658536585366, 210.7317073170732}, {153., 
            306.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox[
                 TemplateBox[{"\"(\"","\"b\"","\")\""},
                  "RowDefault"],
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->16,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {120.3658536585366, 291.}, {0, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox[
                TemplateBox[{"\"(\"","\"b\"","\")\""},
                 "RowDefault"],
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->16,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {120.3658536585366, 291.}, {0, 0}, 
             Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{105.3658536585366, 153.}, {105.3658536585366, 306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{106.65768292682928`, 153.}, {105.3658536585366, 
              153.}}], 
             LineBox[{{106.01176829268293`, 160.65}, {105.3658536585366, 
              160.65}}], 
             LineBox[{{106.01176829268293`, 168.3}, {105.3658536585366, 
              168.3}}], 
             LineBox[{{106.01176829268293`, 175.95}, {105.3658536585366, 
              175.95}}], 
             LineBox[{{106.65768292682928`, 183.6}, {105.3658536585366, 
              183.6}}], 
             LineBox[{{106.01176829268293`, 191.25}, {105.3658536585366, 
              191.25}}], 
             LineBox[{{106.01176829268293`, 198.9}, {105.3658536585366, 
              198.9}}], 
             LineBox[{{106.01176829268293`, 206.55}, {105.3658536585366, 
              206.55}}], 
             LineBox[{{106.65768292682928`, 214.2}, {105.3658536585366, 
              214.2}}], 
             LineBox[{{106.01176829268293`, 221.85000000000002`}, {
              105.3658536585366, 221.85000000000002`}}], 
             LineBox[{{106.01176829268293`, 229.5}, {105.3658536585366, 
              229.5}}], 
             LineBox[{{106.01176829268293`, 237.15}, {105.3658536585366, 
              237.15}}], 
             LineBox[{{106.65768292682928`, 244.8}, {105.3658536585366, 
              244.8}}], 
             LineBox[{{106.01176829268293`, 252.45000000000002`}, {
              105.3658536585366, 252.45000000000002`}}], 
             LineBox[{{106.01176829268293`, 260.1}, {105.3658536585366, 
              260.1}}], 
             LineBox[{{106.01176829268293`, 267.75}, {105.3658536585366, 
              267.75}}], 
             LineBox[{{106.65768292682928`, 275.4}, {105.3658536585366, 
              275.4}}], 
             LineBox[{{106.01176829268293`, 283.05}, {105.3658536585366, 
              283.05}}], 
             LineBox[{{106.01176829268293`, 290.70000000000005`}, {
              105.3658536585366, 290.70000000000005`}}], 
             LineBox[{{106.01176829268293`, 298.35}, {105.3658536585366, 
              298.35}}], 
             LineBox[{{106.65768292682928`, 306.}, {105.3658536585366, 
              306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{210.7317073170732, 153.}, {210.7317073170732, 306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{209.4398780487805, 153.}, {210.7317073170732, 153.}}], 
             LineBox[{{210.08579268292684`, 160.65}, {210.7317073170732, 
              160.65}}], 
             LineBox[{{210.08579268292684`, 168.3}, {210.7317073170732, 
              168.3}}], 
             LineBox[{{210.08579268292684`, 175.95}, {210.7317073170732, 
              175.95}}], 
             LineBox[{{209.4398780487805, 183.6}, {210.7317073170732, 
              183.6}}], 
             LineBox[{{210.08579268292684`, 191.25}, {210.7317073170732, 
              191.25}}], 
             LineBox[{{210.08579268292684`, 198.9}, {210.7317073170732, 
              198.9}}], 
             LineBox[{{210.08579268292684`, 206.55}, {210.7317073170732, 
              206.55}}], 
             LineBox[{{209.4398780487805, 214.2}, {210.7317073170732, 
              214.2}}], 
             LineBox[{{210.08579268292684`, 221.85000000000002`}, {
              210.7317073170732, 221.85000000000002`}}], 
             LineBox[{{210.08579268292684`, 229.5}, {210.7317073170732, 
              229.5}}], 
             LineBox[{{210.08579268292684`, 237.15}, {210.7317073170732, 
              237.15}}], 
             LineBox[{{209.4398780487805, 244.8}, {210.7317073170732, 
              244.8}}], 
             LineBox[{{210.08579268292684`, 252.45000000000002`}, {
              210.7317073170732, 252.45000000000002`}}], 
             LineBox[{{210.08579268292684`, 260.1}, {210.7317073170732, 
              260.1}}], 
             LineBox[{{210.08579268292684`, 267.75}, {210.7317073170732, 
              267.75}}], 
             LineBox[{{209.4398780487805, 275.4}, {210.7317073170732, 
              275.4}}], 
             LineBox[{{210.08579268292684`, 283.05}, {210.7317073170732, 
              283.05}}], 
             LineBox[{{210.08579268292684`, 290.70000000000005`}, {
              210.7317073170732, 290.70000000000005`}}], 
             LineBox[{{210.08579268292684`, 298.35}, {210.7317073170732, 
              298.35}}], 
             LineBox[{{209.4398780487805, 306.}, {210.7317073170732, 306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{105.3658536585366, 153.}, {210.7317073170732, 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{105.3658536585366, 154.29182926829267`}, {
              105.3658536585366, 153.}}], 
             LineBox[{{110.63414634146342`, 153.64591463414635`}, {
              110.63414634146342`, 153.}}], 
             LineBox[{{115.90243902439025`, 153.64591463414635`}, {
              115.90243902439025`, 153.}}], 
             LineBox[{{121.17073170731709`, 153.64591463414635`}, {
              121.17073170731709`, 153.}}], 
             LineBox[{{126.43902439024392`, 154.29182926829267`}, {
              126.43902439024392`, 153.}}], 
             LineBox[{{131.70731707317074`, 153.64591463414635`}, {
              131.70731707317074`, 153.}}], 
             LineBox[{{136.97560975609758`, 153.64591463414635`}, {
              136.97560975609758`, 153.}}], 
             LineBox[{{142.2439024390244, 153.64591463414635`}, {
              142.2439024390244, 153.}}], 
             LineBox[{{147.51219512195124`, 154.29182926829267`}, {
              147.51219512195124`, 153.}}], 
             LineBox[{{152.78048780487808`, 153.64591463414635`}, {
              152.78048780487808`, 153.}}], 
             LineBox[{{158.0487804878049, 153.64591463414635`}, {
              158.0487804878049, 153.}}], 
             LineBox[{{163.31707317073173`, 153.64591463414635`}, {
              163.31707317073173`, 153.}}], 
             LineBox[{{168.58536585365857`, 154.29182926829267`}, {
              168.58536585365857`, 153.}}], 
             LineBox[{{173.85365853658539`, 153.64591463414635`}, {
              173.85365853658539`, 153.}}], 
             LineBox[{{179.1219512195122, 153.64591463414635`}, {
              179.1219512195122, 153.}}], 
             LineBox[{{184.39024390243907`, 153.64591463414635`}, {
              184.39024390243907`, 153.}}], 
             LineBox[{{189.65853658536588`, 154.29182926829267`}, {
              189.65853658536588`, 153.}}], 
             LineBox[{{194.9268292682927, 153.64591463414635`}, {
              194.9268292682927, 153.}}], 
             LineBox[{{200.19512195121953`, 153.64591463414635`}, {
              200.19512195121953`, 153.}}], 
             LineBox[{{205.46341463414637`, 153.64591463414635`}, {
              205.46341463414637`, 153.}}], 
             LineBox[{{210.7317073170732, 154.29182926829267`}, {
              210.7317073170732, 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{105.3658536585366, 306.}, {210.7317073170732, 306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{105.3658536585366, 304.7081707317073}, {
              105.3658536585366, 306.}}], 
             LineBox[{{110.63414634146342`, 305.3540853658537}, {
              110.63414634146342`, 306.}}], 
             LineBox[{{115.90243902439025`, 305.3540853658537}, {
              115.90243902439025`, 306.}}], 
             LineBox[{{121.17073170731709`, 305.3540853658537}, {
              121.17073170731709`, 306.}}], 
             LineBox[{{126.43902439024392`, 304.7081707317073}, {
              126.43902439024392`, 306.}}], 
             LineBox[{{131.70731707317074`, 305.3540853658537}, {
              131.70731707317074`, 306.}}], 
             LineBox[{{136.97560975609758`, 305.3540853658537}, {
              136.97560975609758`, 306.}}], 
             LineBox[{{142.2439024390244, 305.3540853658537}, {
              142.2439024390244, 306.}}], 
             LineBox[{{147.51219512195124`, 304.7081707317073}, {
              147.51219512195124`, 306.}}], 
             LineBox[{{152.78048780487808`, 305.3540853658537}, {
              152.78048780487808`, 306.}}], 
             LineBox[{{158.0487804878049, 305.3540853658537}, {
              158.0487804878049, 306.}}], 
             LineBox[{{163.31707317073173`, 305.3540853658537}, {
              163.31707317073173`, 306.}}], 
             LineBox[{{168.58536585365857`, 304.7081707317073}, {
              168.58536585365857`, 306.}}], 
             LineBox[{{173.85365853658539`, 305.3540853658537}, {
              173.85365853658539`, 306.}}], 
             LineBox[{{179.1219512195122, 305.3540853658537}, {
              179.1219512195122, 306.}}], 
             LineBox[{{184.39024390243907`, 305.3540853658537}, {
              184.39024390243907`, 306.}}], 
             LineBox[{{189.65853658536588`, 304.7081707317073}, {
              189.65853658536588`, 306.}}], 
             LineBox[{{194.9268292682927, 305.3540853658537}, {
              194.9268292682927, 306.}}], 
             LineBox[{{200.19512195121953`, 305.3540853658537}, {
              200.19512195121953`, 306.}}], 
             LineBox[{{205.46341463414637`, 305.3540853658537}, {
              205.46341463414637`, 306.}}], 
             LineBox[{{210.7317073170732, 304.7081707317073}, {
              210.7317073170732, 306.}}]}},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{0., 0.}, {105.3658536585366, 153.}]}, 
         InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{105.3658536585366, 153.},
           
           PlotRange->{{0., 105.3658536585366}, {0., 
            153.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox[
                 TemplateBox[{"\"(\"","\"c\"","\")\""},
                  "RowDefault"],
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->16,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {15., 138.}, {0, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               TagBox[
                TemplateBox[{"\"(\"","\"c\"","\")\""},
                 "RowDefault"],
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->16,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {15., 138.}, {0, 0}, Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{1.291829268292683, 0.}, {0., 0.}}], 
             LineBox[{{0.6459146341463415, 7.65}, {0., 7.65}}], 
             LineBox[{{0.6459146341463415, 15.3}, {0., 15.3}}], 
             LineBox[{{0.6459146341463415, 22.950000000000003`}, {0., 
              22.950000000000003`}}], 
             LineBox[{{1.291829268292683, 30.6}, {0., 30.6}}], 
             LineBox[{{0.6459146341463415, 38.25}, {0., 38.25}}], 
             LineBox[{{0.6459146341463415, 45.900000000000006`}, {0., 
              45.900000000000006`}}], 
             LineBox[{{0.6459146341463415, 53.550000000000004`}, {0., 
              53.550000000000004`}}], 
             LineBox[{{1.291829268292683, 61.2}, {0., 61.2}}], 
             LineBox[{{0.6459146341463415, 68.85000000000001}, {0., 
              68.85000000000001}}], 
             LineBox[{{0.6459146341463415, 76.5}, {0., 76.5}}], 
             LineBox[{{0.6459146341463415, 84.15}, {0., 84.15}}], 
             LineBox[{{1.291829268292683, 91.80000000000001}, {0., 
              91.80000000000001}}], 
             LineBox[{{0.6459146341463415, 99.45000000000002}, {0., 
              99.45000000000002}}], 
             LineBox[{{0.6459146341463415, 107.10000000000001`}, {0., 
              107.10000000000001`}}], 
             LineBox[{{0.6459146341463415, 114.75000000000001`}, {0., 
              114.75000000000001`}}], 
             LineBox[{{1.291829268292683, 122.4}, {0., 122.4}}], 
             LineBox[{{0.6459146341463415, 130.05}, {0., 130.05}}], 
             LineBox[{{0.6459146341463415, 137.70000000000002`}, {0., 
              137.70000000000002`}}], 
             LineBox[{{0.6459146341463415, 145.35000000000002`}, {0., 
              145.35000000000002`}}], 
             LineBox[{{1.291829268292683, 153.}, {0., 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{105.3658536585366, 0.}, {105.3658536585366, 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{104.0740243902439, 0.}, {105.3658536585366, 0.}}], 
             LineBox[{{104.71993902439026`, 7.65}, {105.3658536585366, 
              7.65}}], 
             LineBox[{{104.71993902439026`, 15.3}, {105.3658536585366, 
              15.3}}], 
             LineBox[{{104.71993902439026`, 22.950000000000003`}, {
              105.3658536585366, 22.950000000000003`}}], 
             LineBox[{{104.0740243902439, 30.6}, {105.3658536585366, 30.6}}], 
             LineBox[{{104.71993902439026`, 38.25}, {105.3658536585366, 
              38.25}}], 
             LineBox[{{104.71993902439026`, 45.900000000000006`}, {
              105.3658536585366, 45.900000000000006`}}], 
             LineBox[{{104.71993902439026`, 53.550000000000004`}, {
              105.3658536585366, 53.550000000000004`}}], 
             LineBox[{{104.0740243902439, 61.2}, {105.3658536585366, 61.2}}], 
             LineBox[{{104.71993902439026`, 68.85000000000001}, {
              105.3658536585366, 68.85000000000001}}], 
             LineBox[{{104.71993902439026`, 76.5}, {105.3658536585366, 
              76.5}}], 
             LineBox[{{104.71993902439026`, 84.15}, {105.3658536585366, 
              84.15}}], 
             LineBox[{{104.0740243902439, 91.80000000000001}, {
              105.3658536585366, 91.80000000000001}}], 
             LineBox[{{104.71993902439026`, 99.45000000000002}, {
              105.3658536585366, 99.45000000000002}}], 
             LineBox[{{104.71993902439026`, 107.10000000000001`}, {
              105.3658536585366, 107.10000000000001`}}], 
             LineBox[{{104.71993902439026`, 114.75000000000001`}, {
              105.3658536585366, 114.75000000000001`}}], 
             LineBox[{{104.0740243902439, 122.4}, {105.3658536585366, 
              122.4}}], 
             LineBox[{{104.71993902439026`, 130.05}, {105.3658536585366, 
              130.05}}], 
             LineBox[{{104.71993902439026`, 137.70000000000002`}, {
              105.3658536585366, 137.70000000000002`}}], 
             LineBox[{{104.71993902439026`, 145.35000000000002`}, {
              105.3658536585366, 145.35000000000002`}}], 
             LineBox[{{104.0740243902439, 153.}, {105.3658536585366, 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{0., 0.}, {105.3658536585366, 0.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{0., 1.291829268292683}, {0., 0.}}], 
             LineBox[{{5.26829268292683, 0.6459146341463415}, {
              5.26829268292683, 0.}}], 
             LineBox[{{10.53658536585366, 0.6459146341463415}, {
              10.53658536585366, 0.}}], 
             LineBox[{{15.804878048780491`, 0.6459146341463415}, {
              15.804878048780491`, 0.}}], 
             LineBox[{{21.07317073170732, 1.291829268292683}, {
              21.07317073170732, 0.}}], 
             LineBox[{{26.34146341463415, 0.6459146341463415}, {
              26.34146341463415, 0.}}], 
             LineBox[{{31.609756097560982`, 0.6459146341463415}, {
              31.609756097560982`, 0.}}], 
             LineBox[{{36.87804878048781, 0.6459146341463415}, {
              36.87804878048781, 0.}}], 
             LineBox[{{42.14634146341464, 1.291829268292683}, {
              42.14634146341464, 0.}}], 
             LineBox[{{47.41463414634147, 0.6459146341463415}, {
              47.41463414634147, 0.}}], 
             LineBox[{{52.6829268292683, 0.6459146341463415}, {
              52.6829268292683, 0.}}], 
             LineBox[{{57.95121951219513, 0.6459146341463415}, {
              57.95121951219513, 0.}}], 
             LineBox[{{63.219512195121965`, 1.291829268292683}, {
              63.219512195121965`, 0.}}], 
             LineBox[{{68.4878048780488, 0.6459146341463415}, {
              68.4878048780488, 0.}}], 
             LineBox[{{73.75609756097562, 0.6459146341463415}, {
              73.75609756097562, 0.}}], 
             LineBox[{{79.02439024390246, 0.6459146341463415}, {
              79.02439024390246, 0.}}], 
             LineBox[{{84.29268292682929, 1.291829268292683}, {
              84.29268292682929, 0.}}], 
             LineBox[{{89.56097560975611, 0.6459146341463415}, {
              89.56097560975611, 0.}}], 
             LineBox[{{94.82926829268294, 0.6459146341463415}, {
              94.82926829268294, 0.}}], 
             LineBox[{{100.09756097560977`, 0.6459146341463415}, {
              100.09756097560977`, 0.}}], 
             LineBox[{{105.3658536585366, 1.291829268292683}, {
              105.3658536585366, 0.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{0., 153.}, {105.3658536585366, 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{0., 151.70817073170733`}, {0., 153.}}], 
             LineBox[{{5.26829268292683, 152.35408536585365`}, {
              5.26829268292683, 153.}}], 
             LineBox[{{10.53658536585366, 152.35408536585365`}, {
              10.53658536585366, 153.}}], 
             LineBox[{{15.804878048780491`, 152.35408536585365`}, {
              15.804878048780491`, 153.}}], 
             LineBox[{{21.07317073170732, 151.70817073170733`}, {
              21.07317073170732, 153.}}], 
             LineBox[{{26.34146341463415, 152.35408536585365`}, {
              26.34146341463415, 153.}}], 
             LineBox[{{31.609756097560982`, 152.35408536585365`}, {
              31.609756097560982`, 153.}}], 
             LineBox[{{36.87804878048781, 152.35408536585365`}, {
              36.87804878048781, 153.}}], 
             LineBox[{{42.14634146341464, 151.70817073170733`}, {
              42.14634146341464, 153.}}], 
             LineBox[{{47.41463414634147, 152.35408536585365`}, {
              47.41463414634147, 153.}}], 
             LineBox[{{52.6829268292683, 152.35408536585365`}, {
              52.6829268292683, 153.}}], 
             LineBox[{{57.95121951219513, 152.35408536585365`}, {
              57.95121951219513, 153.}}], 
             LineBox[{{63.219512195121965`, 151.70817073170733`}, {
              63.219512195121965`, 153.}}], 
             LineBox[{{68.4878048780488, 152.35408536585365`}, {
              68.4878048780488, 153.}}], 
             LineBox[{{73.75609756097562, 152.35408536585365`}, {
              73.75609756097562, 153.}}], 
             LineBox[{{79.02439024390246, 152.35408536585365`}, {
              79.02439024390246, 153.}}], 
             LineBox[{{84.29268292682929, 151.70817073170733`}, {
              84.29268292682929, 153.}}], 
             LineBox[{{89.56097560975611, 152.35408536585365`}, {
              89.56097560975611, 153.}}], 
             LineBox[{{94.82926829268294, 152.35408536585365`}, {
              94.82926829268294, 153.}}], 
             LineBox[{{100.09756097560977`, 152.35408536585365`}, {
              100.09756097560977`, 153.}}], 
             LineBox[{{105.3658536585366, 151.70817073170733`}, {
              105.3658536585366, 153.}}]}, InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 0.}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.2\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 30.6}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.4\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 61.2}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.6\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 91.80000000000001}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.8\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 122.4}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"1.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 153.}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {0., -1.}, {0, 1}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.2\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {21.07317073170732, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.4\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {42.14634146341464, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.6\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {63.219512195121965`, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.8\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {84.29268292682929, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"1.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {105.3658536585366, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 0.}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.2\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 30.6}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.4\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 61.2}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.6\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 91.80000000000001}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.8\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 122.4}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"1.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {-1., 153.}, {1, 0}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {0., -1.}, {0, 1}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.2\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {21.07317073170732, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.4\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {42.14634146341464, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.6\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {63.219512195121965`, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.8\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {84.29268292682929, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"1.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {105.3658536585366, -1.}, {0, 1}, 
             Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], 
          RectangleBox[{105.3658536585366, 0.}, {210.7317073170732, 153.}]}, 
         InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{105.3658536585366, 153.},
           
           PlotRange->{{105.3658536585366, 210.7317073170732}, {0., 
            153.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox[
                 TemplateBox[{"\"(\"","\"d\"","\")\""},
                  "RowDefault"],
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->16,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {120.3658536585366, 138.}, {0, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox[
                TemplateBox[{"\"(\"","\"d\"","\")\""},
                 "RowDefault"],
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->16,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {120.3658536585366, 138.}, {0, 0}, 
             Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{105.3658536585366, 0.}, {105.3658536585366, 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{106.65768292682928`, 0.}, {105.3658536585366, 0.}}], 
             LineBox[{{106.01176829268293`, 7.65}, {105.3658536585366, 
              7.65}}], 
             LineBox[{{106.01176829268293`, 15.3}, {105.3658536585366, 
              15.3}}], 
             LineBox[{{106.01176829268293`, 22.950000000000003`}, {
              105.3658536585366, 22.950000000000003`}}], 
             LineBox[{{106.65768292682928`, 30.6}, {105.3658536585366, 
              30.6}}], 
             LineBox[{{106.01176829268293`, 38.25}, {105.3658536585366, 
              38.25}}], 
             LineBox[{{106.01176829268293`, 45.900000000000006`}, {
              105.3658536585366, 45.900000000000006`}}], 
             LineBox[{{106.01176829268293`, 53.550000000000004`}, {
              105.3658536585366, 53.550000000000004`}}], 
             LineBox[{{106.65768292682928`, 61.2}, {105.3658536585366, 
              61.2}}], 
             LineBox[{{106.01176829268293`, 68.85000000000001}, {
              105.3658536585366, 68.85000000000001}}], 
             LineBox[{{106.01176829268293`, 76.5}, {105.3658536585366, 
              76.5}}], 
             LineBox[{{106.01176829268293`, 84.15}, {105.3658536585366, 
              84.15}}], 
             LineBox[{{106.65768292682928`, 91.80000000000001}, {
              105.3658536585366, 91.80000000000001}}], 
             LineBox[{{106.01176829268293`, 99.45000000000002}, {
              105.3658536585366, 99.45000000000002}}], 
             LineBox[{{106.01176829268293`, 107.10000000000001`}, {
              105.3658536585366, 107.10000000000001`}}], 
             LineBox[{{106.01176829268293`, 114.75000000000001`}, {
              105.3658536585366, 114.75000000000001`}}], 
             LineBox[{{106.65768292682928`, 122.4}, {105.3658536585366, 
              122.4}}], 
             LineBox[{{106.01176829268293`, 130.05}, {105.3658536585366, 
              130.05}}], 
             LineBox[{{106.01176829268293`, 137.70000000000002`}, {
              105.3658536585366, 137.70000000000002`}}], 
             LineBox[{{106.01176829268293`, 145.35000000000002`}, {
              105.3658536585366, 145.35000000000002`}}], 
             LineBox[{{106.65768292682928`, 153.}, {105.3658536585366, 
              153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{210.7317073170732, 0.}, {210.7317073170732, 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{209.4398780487805, 0.}, {210.7317073170732, 0.}}], 
             LineBox[{{210.08579268292684`, 7.65}, {210.7317073170732, 
              7.65}}], 
             LineBox[{{210.08579268292684`, 15.3}, {210.7317073170732, 
              15.3}}], 
             LineBox[{{210.08579268292684`, 22.950000000000003`}, {
              210.7317073170732, 22.950000000000003`}}], 
             LineBox[{{209.4398780487805, 30.6}, {210.7317073170732, 30.6}}], 
             LineBox[{{210.08579268292684`, 38.25}, {210.7317073170732, 
              38.25}}], 
             LineBox[{{210.08579268292684`, 45.900000000000006`}, {
              210.7317073170732, 45.900000000000006`}}], 
             LineBox[{{210.08579268292684`, 53.550000000000004`}, {
              210.7317073170732, 53.550000000000004`}}], 
             LineBox[{{209.4398780487805, 61.2}, {210.7317073170732, 61.2}}], 
             LineBox[{{210.08579268292684`, 68.85000000000001}, {
              210.7317073170732, 68.85000000000001}}], 
             LineBox[{{210.08579268292684`, 76.5}, {210.7317073170732, 
              76.5}}], 
             LineBox[{{210.08579268292684`, 84.15}, {210.7317073170732, 
              84.15}}], 
             LineBox[{{209.4398780487805, 91.80000000000001}, {
              210.7317073170732, 91.80000000000001}}], 
             LineBox[{{210.08579268292684`, 99.45000000000002}, {
              210.7317073170732, 99.45000000000002}}], 
             LineBox[{{210.08579268292684`, 107.10000000000001`}, {
              210.7317073170732, 107.10000000000001`}}], 
             LineBox[{{210.08579268292684`, 114.75000000000001`}, {
              210.7317073170732, 114.75000000000001`}}], 
             LineBox[{{209.4398780487805, 122.4}, {210.7317073170732, 
              122.4}}], 
             LineBox[{{210.08579268292684`, 130.05}, {210.7317073170732, 
              130.05}}], 
             LineBox[{{210.08579268292684`, 137.70000000000002`}, {
              210.7317073170732, 137.70000000000002`}}], 
             LineBox[{{210.08579268292684`, 145.35000000000002`}, {
              210.7317073170732, 145.35000000000002`}}], 
             LineBox[{{209.4398780487805, 153.}, {210.7317073170732, 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{105.3658536585366, 0.}, {210.7317073170732, 0.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{105.3658536585366, 1.291829268292683}, {
              105.3658536585366, 0.}}], 
             LineBox[{{110.63414634146342`, 0.6459146341463415}, {
              110.63414634146342`, 0.}}], 
             LineBox[{{115.90243902439025`, 0.6459146341463415}, {
              115.90243902439025`, 0.}}], 
             LineBox[{{121.17073170731709`, 0.6459146341463415}, {
              121.17073170731709`, 0.}}], 
             LineBox[{{126.43902439024392`, 1.291829268292683}, {
              126.43902439024392`, 0.}}], 
             LineBox[{{131.70731707317074`, 0.6459146341463415}, {
              131.70731707317074`, 0.}}], 
             LineBox[{{136.97560975609758`, 0.6459146341463415}, {
              136.97560975609758`, 0.}}], 
             LineBox[{{142.2439024390244, 0.6459146341463415}, {
              142.2439024390244, 0.}}], 
             LineBox[{{147.51219512195124`, 1.291829268292683}, {
              147.51219512195124`, 0.}}], 
             LineBox[{{152.78048780487808`, 0.6459146341463415}, {
              152.78048780487808`, 0.}}], 
             LineBox[{{158.0487804878049, 0.6459146341463415}, {
              158.0487804878049, 0.}}], 
             LineBox[{{163.31707317073173`, 0.6459146341463415}, {
              163.31707317073173`, 0.}}], 
             LineBox[{{168.58536585365857`, 1.291829268292683}, {
              168.58536585365857`, 0.}}], 
             LineBox[{{173.85365853658539`, 0.6459146341463415}, {
              173.85365853658539`, 0.}}], 
             LineBox[{{179.1219512195122, 0.6459146341463415}, {
              179.1219512195122, 0.}}], 
             LineBox[{{184.39024390243907`, 0.6459146341463415}, {
              184.39024390243907`, 0.}}], 
             LineBox[{{189.65853658536588`, 1.291829268292683}, {
              189.65853658536588`, 0.}}], 
             LineBox[{{194.9268292682927, 0.6459146341463415}, {
              194.9268292682927, 0.}}], 
             LineBox[{{200.19512195121953`, 0.6459146341463415}, {
              200.19512195121953`, 0.}}], 
             LineBox[{{205.46341463414637`, 0.6459146341463415}, {
              205.46341463414637`, 0.}}], 
             LineBox[{{210.7317073170732, 1.291829268292683}, {
              210.7317073170732, 0.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{105.3658536585366, 153.}, {210.7317073170732, 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{105.3658536585366, 151.70817073170733`}, {
              105.3658536585366, 153.}}], 
             LineBox[{{110.63414634146342`, 152.35408536585365`}, {
              110.63414634146342`, 153.}}], 
             LineBox[{{115.90243902439025`, 152.35408536585365`}, {
              115.90243902439025`, 153.}}], 
             LineBox[{{121.17073170731709`, 152.35408536585365`}, {
              121.17073170731709`, 153.}}], 
             LineBox[{{126.43902439024392`, 151.70817073170733`}, {
              126.43902439024392`, 153.}}], 
             LineBox[{{131.70731707317074`, 152.35408536585365`}, {
              131.70731707317074`, 153.}}], 
             LineBox[{{136.97560975609758`, 152.35408536585365`}, {
              136.97560975609758`, 153.}}], 
             LineBox[{{142.2439024390244, 152.35408536585365`}, {
              142.2439024390244, 153.}}], 
             LineBox[{{147.51219512195124`, 151.70817073170733`}, {
              147.51219512195124`, 153.}}], 
             LineBox[{{152.78048780487808`, 152.35408536585365`}, {
              152.78048780487808`, 153.}}], 
             LineBox[{{158.0487804878049, 152.35408536585365`}, {
              158.0487804878049, 153.}}], 
             LineBox[{{163.31707317073173`, 152.35408536585365`}, {
              163.31707317073173`, 153.}}], 
             LineBox[{{168.58536585365857`, 151.70817073170733`}, {
              168.58536585365857`, 153.}}], 
             LineBox[{{173.85365853658539`, 152.35408536585365`}, {
              173.85365853658539`, 153.}}], 
             LineBox[{{179.1219512195122, 152.35408536585365`}, {
              179.1219512195122, 153.}}], 
             LineBox[{{184.39024390243907`, 152.35408536585365`}, {
              184.39024390243907`, 153.}}], 
             LineBox[{{189.65853658536588`, 151.70817073170733`}, {
              189.65853658536588`, 153.}}], 
             LineBox[{{194.9268292682927, 152.35408536585365`}, {
              194.9268292682927, 153.}}], 
             LineBox[{{200.19512195121953`, 152.35408536585365`}, {
              200.19512195121953`, 153.}}], 
             LineBox[{{205.46341463414637`, 152.35408536585365`}, {
              205.46341463414637`, 153.}}], 
             LineBox[{{210.7317073170732, 151.70817073170733`}, {
              210.7317073170732, 153.}}]}, InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {105.3658536585366, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.2\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {126.43902439024392`, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.4\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {147.51219512195124`, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.6\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {168.58536585365857`, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.8\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {189.65853658536588`, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"1.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {210.7317073170732, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {105.3658536585366, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.2\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {126.43902439024392`, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.4\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {147.51219512195124`, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.6\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {168.58536585365857`, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.8\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {189.65853658536588`, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"1.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {210.7317073170732, -1.}, {0, 1}, 
             Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}},
       Frame->False,
       ImageSize->{210.7317073170732, 306.},
       PlotRange->{{0., 210.7317073170732}, {0., 306.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{210.7317073170732, 0.}, {210.7317073170732, 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 0.}, {210.7317073170732, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 306.}, {210.7317073170732, 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[
       {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
        RectangleBox[{221.26829268292687`, 0.}, {432., 306.}]},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{221.26829268292687`, 0.}, {432., 306.}]}, 
     InsetBox[
      GraphicsBox[{{
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], 
          RectangleBox[{221.26829268292687`, 153.}, \
{326.6341463414634, 306.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{105.36585365853654`, 153.},
           
           PlotRange->{{221.26829268292687`, 326.6341463414634}, {153., 
            306.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox[
                 TemplateBox[{"\"(\"","\"a\"","\")\""},
                  "RowDefault"],
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->16,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {236.26829268292687`, 291.}, {0, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox[
                TemplateBox[{"\"(\"","\"a\"","\")\""},
                 "RowDefault"],
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->16,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {236.26829268292687`, 291.}, {0, 0}, 
             Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{221.26829268292687`, 153.}, {221.26829268292687`, 
              306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{222.56012195121954`, 153.}, {221.26829268292687`, 
              153.}}], 
             LineBox[{{221.91420731707322`, 160.65}, {221.26829268292687`, 
              160.65}}], 
             LineBox[{{221.91420731707322`, 168.3}, {221.26829268292687`, 
              168.3}}], 
             LineBox[{{221.91420731707322`, 175.95}, {221.26829268292687`, 
              175.95}}], 
             LineBox[{{222.56012195121954`, 183.6}, {221.26829268292687`, 
              183.6}}], 
             LineBox[{{221.91420731707322`, 191.25}, {221.26829268292687`, 
              191.25}}], 
             LineBox[{{221.91420731707322`, 198.9}, {221.26829268292687`, 
              198.9}}], 
             LineBox[{{221.91420731707322`, 206.55}, {221.26829268292687`, 
              206.55}}], 
             LineBox[{{222.56012195121954`, 214.2}, {221.26829268292687`, 
              214.2}}], 
             LineBox[{{221.91420731707322`, 221.85000000000002`}, {
              221.26829268292687`, 221.85000000000002`}}], 
             LineBox[{{221.91420731707322`, 229.5}, {221.26829268292687`, 
              229.5}}], 
             LineBox[{{221.91420731707322`, 237.15}, {221.26829268292687`, 
              237.15}}], 
             LineBox[{{222.56012195121954`, 244.8}, {221.26829268292687`, 
              244.8}}], 
             LineBox[{{221.91420731707322`, 252.45000000000002`}, {
              221.26829268292687`, 252.45000000000002`}}], 
             LineBox[{{221.91420731707322`, 260.1}, {221.26829268292687`, 
              260.1}}], 
             LineBox[{{221.91420731707322`, 267.75}, {221.26829268292687`, 
              267.75}}], 
             LineBox[{{222.56012195121954`, 275.4}, {221.26829268292687`, 
              275.4}}], 
             LineBox[{{221.91420731707322`, 283.05}, {221.26829268292687`, 
              283.05}}], 
             LineBox[{{221.91420731707322`, 290.70000000000005`}, {
              221.26829268292687`, 290.70000000000005`}}], 
             LineBox[{{221.91420731707322`, 298.35}, {221.26829268292687`, 
              298.35}}], 
             LineBox[{{222.56012195121954`, 306.}, {221.26829268292687`, 
              306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{326.6341463414634, 153.}, {326.6341463414634, 306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{325.3423170731707, 153.}, {326.6341463414634, 153.}}], 
             LineBox[{{325.9882317073171, 160.65}, {326.6341463414634, 
              160.65}}], 
             LineBox[{{325.9882317073171, 168.3}, {326.6341463414634, 
              168.3}}], 
             LineBox[{{325.9882317073171, 175.95}, {326.6341463414634, 
              175.95}}], 
             LineBox[{{325.3423170731707, 183.6}, {326.6341463414634, 
              183.6}}], 
             LineBox[{{325.9882317073171, 191.25}, {326.6341463414634, 
              191.25}}], 
             LineBox[{{325.9882317073171, 198.9}, {326.6341463414634, 
              198.9}}], 
             LineBox[{{325.9882317073171, 206.55}, {326.6341463414634, 
              206.55}}], 
             LineBox[{{325.3423170731707, 214.2}, {326.6341463414634, 
              214.2}}], 
             LineBox[{{325.9882317073171, 221.85000000000002`}, {
              326.6341463414634, 221.85000000000002`}}], 
             LineBox[{{325.9882317073171, 229.5}, {326.6341463414634, 
              229.5}}], 
             LineBox[{{325.9882317073171, 237.15}, {326.6341463414634, 
              237.15}}], 
             LineBox[{{325.3423170731707, 244.8}, {326.6341463414634, 
              244.8}}], 
             LineBox[{{325.9882317073171, 252.45000000000002`}, {
              326.6341463414634, 252.45000000000002`}}], 
             LineBox[{{325.9882317073171, 260.1}, {326.6341463414634, 
              260.1}}], 
             LineBox[{{325.9882317073171, 267.75}, {326.6341463414634, 
              267.75}}], 
             LineBox[{{325.3423170731707, 275.4}, {326.6341463414634, 
              275.4}}], 
             LineBox[{{325.9882317073171, 283.05}, {326.6341463414634, 
              283.05}}], 
             LineBox[{{325.9882317073171, 290.70000000000005`}, {
              326.6341463414634, 290.70000000000005`}}], 
             LineBox[{{325.9882317073171, 298.35}, {326.6341463414634, 
              298.35}}], 
             LineBox[{{325.3423170731707, 306.}, {326.6341463414634, 306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{221.26829268292687`, 153.}, {326.6341463414634, 
              153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{221.26829268292687`, 154.29182926829267`}, {
              221.26829268292687`, 153.}}], 
             LineBox[{{226.53658536585368`, 153.64591463414635`}, {
              226.53658536585368`, 153.}}], 
             LineBox[{{231.80487804878052`, 153.64591463414635`}, {
              231.80487804878052`, 153.}}], 
             LineBox[{{237.07317073170736`, 153.64591463414635`}, {
              237.07317073170736`, 153.}}], 
             LineBox[{{242.34146341463418`, 154.29182926829267`}, {
              242.34146341463418`, 153.}}], 
             LineBox[{{247.609756097561, 153.64591463414635`}, {
              247.609756097561, 153.}}], 
             LineBox[{{252.87804878048783`, 153.64591463414635`}, {
              252.87804878048783`, 153.}}], 
             LineBox[{{258.1463414634147, 153.64591463414635`}, {
              258.1463414634147, 153.}}], 
             LineBox[{{263.4146341463415, 154.29182926829267`}, {
              263.4146341463415, 153.}}], 
             LineBox[{{268.6829268292683, 153.64591463414635`}, {
              268.6829268292683, 153.}}], 
             LineBox[{{273.95121951219517`, 153.64591463414635`}, {
              273.95121951219517`, 153.}}], 
             LineBox[{{279.219512195122, 153.64591463414635`}, {
              279.219512195122, 153.}}], 
             LineBox[{{284.4878048780488, 154.29182926829267`}, {
              284.4878048780488, 153.}}], 
             LineBox[{{289.7560975609756, 153.64591463414635`}, {
              289.7560975609756, 153.}}], 
             LineBox[{{295.0243902439024, 153.64591463414635`}, {
              295.0243902439024, 153.}}], 
             LineBox[{{300.2926829268293, 153.64591463414635`}, {
              300.2926829268293, 153.}}], 
             LineBox[{{305.5609756097561, 154.29182926829267`}, {
              305.5609756097561, 153.}}], 
             LineBox[{{310.82926829268297`, 153.64591463414635`}, {
              310.82926829268297`, 153.}}], 
             LineBox[{{316.0975609756098, 153.64591463414635`}, {
              316.0975609756098, 153.}}], 
             LineBox[{{321.3658536585366, 153.64591463414635`}, {
              321.3658536585366, 153.}}], 
             LineBox[{{326.6341463414634, 154.29182926829267`}, {
              326.6341463414634, 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{221.26829268292687`, 306.}, {326.6341463414634, 
              306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{221.26829268292687`, 304.7081707317073}, {
              221.26829268292687`, 306.}}], 
             LineBox[{{226.53658536585368`, 305.3540853658537}, {
              226.53658536585368`, 306.}}], 
             LineBox[{{231.80487804878052`, 305.3540853658537}, {
              231.80487804878052`, 306.}}], 
             LineBox[{{237.07317073170736`, 305.3540853658537}, {
              237.07317073170736`, 306.}}], 
             LineBox[{{242.34146341463418`, 304.7081707317073}, {
              242.34146341463418`, 306.}}], 
             LineBox[{{247.609756097561, 305.3540853658537}, {
              247.609756097561, 306.}}], 
             LineBox[{{252.87804878048783`, 305.3540853658537}, {
              252.87804878048783`, 306.}}], 
             LineBox[{{258.1463414634147, 305.3540853658537}, {
              258.1463414634147, 306.}}], 
             LineBox[{{263.4146341463415, 304.7081707317073}, {
              263.4146341463415, 306.}}], 
             LineBox[{{268.6829268292683, 305.3540853658537}, {
              268.6829268292683, 306.}}], 
             LineBox[{{273.95121951219517`, 305.3540853658537}, {
              273.95121951219517`, 306.}}], 
             LineBox[{{279.219512195122, 305.3540853658537}, {
              279.219512195122, 306.}}], 
             LineBox[{{284.4878048780488, 304.7081707317073}, {
              284.4878048780488, 306.}}], 
             LineBox[{{289.7560975609756, 305.3540853658537}, {
              289.7560975609756, 306.}}], 
             LineBox[{{295.0243902439024, 305.3540853658537}, {
              295.0243902439024, 306.}}], 
             LineBox[{{300.2926829268293, 305.3540853658537}, {
              300.2926829268293, 306.}}], 
             LineBox[{{305.5609756097561, 304.7081707317073}, {
              305.5609756097561, 306.}}], 
             LineBox[{{310.82926829268297`, 305.3540853658537}, {
              310.82926829268297`, 306.}}], 
             LineBox[{{316.0975609756098, 305.3540853658537}, {
              316.0975609756098, 306.}}], 
             LineBox[{{321.3658536585366, 305.3540853658537}, {
              321.3658536585366, 306.}}], 
             LineBox[{{326.6341463414634, 304.7081707317073}, {
              326.6341463414634, 306.}}]}, InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 153.}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.2\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 183.6}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.4\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 214.2}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.6\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 244.8}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.8\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 275.4}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"1.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 306.}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 153.}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.2\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 183.6}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.4\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 214.2}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.6\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 244.8}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.8\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 275.4}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"1.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 306.}, {1, 0}, 
             Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], 
          RectangleBox[{326.6341463414634, 153.}, {432., 306.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{105.3658536585366, 153.},
           PlotRange->{{326.6341463414634, 432.}, {153., 
            306.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox[
                 TemplateBox[{"\"(\"","\"b\"","\")\""},
                  "RowDefault"],
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->16,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {341.6341463414634, 291.}, {0, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox[
                TemplateBox[{"\"(\"","\"b\"","\")\""},
                 "RowDefault"],
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->16,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {341.6341463414634, 291.}, {0, 0}, 
             Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{326.6341463414634, 153.}, {326.6341463414634, 306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{327.9259756097561, 153.}, {326.6341463414634, 153.}}], 
             LineBox[{{327.28006097560973`, 160.65}, {326.6341463414634, 
              160.65}}], 
             LineBox[{{327.28006097560973`, 168.3}, {326.6341463414634, 
              168.3}}], 
             LineBox[{{327.28006097560973`, 175.95}, {326.6341463414634, 
              175.95}}], 
             LineBox[{{327.9259756097561, 183.6}, {326.6341463414634, 
              183.6}}], 
             LineBox[{{327.28006097560973`, 191.25}, {326.6341463414634, 
              191.25}}], 
             LineBox[{{327.28006097560973`, 198.9}, {326.6341463414634, 
              198.9}}], 
             LineBox[{{327.28006097560973`, 206.55}, {326.6341463414634, 
              206.55}}], 
             LineBox[{{327.9259756097561, 214.2}, {326.6341463414634, 
              214.2}}], 
             LineBox[{{327.28006097560973`, 221.85000000000002`}, {
              326.6341463414634, 221.85000000000002`}}], 
             LineBox[{{327.28006097560973`, 229.5}, {326.6341463414634, 
              229.5}}], 
             LineBox[{{327.28006097560973`, 237.15}, {326.6341463414634, 
              237.15}}], 
             LineBox[{{327.9259756097561, 244.8}, {326.6341463414634, 
              244.8}}], 
             LineBox[{{327.28006097560973`, 252.45000000000002`}, {
              326.6341463414634, 252.45000000000002`}}], 
             LineBox[{{327.28006097560973`, 260.1}, {326.6341463414634, 
              260.1}}], 
             LineBox[{{327.28006097560973`, 267.75}, {326.6341463414634, 
              267.75}}], 
             LineBox[{{327.9259756097561, 275.4}, {326.6341463414634, 
              275.4}}], 
             LineBox[{{327.28006097560973`, 283.05}, {326.6341463414634, 
              283.05}}], 
             LineBox[{{327.28006097560973`, 290.70000000000005`}, {
              326.6341463414634, 290.70000000000005`}}], 
             LineBox[{{327.28006097560973`, 298.35}, {326.6341463414634, 
              298.35}}], 
             LineBox[{{327.9259756097561, 306.}, {326.6341463414634, 306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{432., 153.}, {432., 306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{430.7081707317073, 153.}, {432., 153.}}], 
             LineBox[{{431.3540853658537, 160.65}, {432., 160.65}}], 
             LineBox[{{431.3540853658537, 168.3}, {432., 168.3}}], 
             LineBox[{{431.3540853658537, 175.95}, {432., 175.95}}], 
             LineBox[{{430.7081707317073, 183.6}, {432., 183.6}}], 
             LineBox[{{431.3540853658537, 191.25}, {432., 191.25}}], 
             LineBox[{{431.3540853658537, 198.9}, {432., 198.9}}], 
             LineBox[{{431.3540853658537, 206.55}, {432., 206.55}}], 
             LineBox[{{430.7081707317073, 214.2}, {432., 214.2}}], 
             LineBox[{{431.3540853658537, 221.85000000000002`}, {432., 
              221.85000000000002`}}], 
             LineBox[{{431.3540853658537, 229.5}, {432., 229.5}}], 
             LineBox[{{431.3540853658537, 237.15}, {432., 237.15}}], 
             LineBox[{{430.7081707317073, 244.8}, {432., 244.8}}], 
             LineBox[{{431.3540853658537, 252.45000000000002`}, {432., 
              252.45000000000002`}}], 
             LineBox[{{431.3540853658537, 260.1}, {432., 260.1}}], 
             LineBox[{{431.3540853658537, 267.75}, {432., 267.75}}], 
             LineBox[{{430.7081707317073, 275.4}, {432., 275.4}}], 
             LineBox[{{431.3540853658537, 283.05}, {432., 283.05}}], 
             LineBox[{{431.3540853658537, 290.70000000000005`}, {432., 
              290.70000000000005`}}], 
             LineBox[{{431.3540853658537, 298.35}, {432., 298.35}}], 
             LineBox[{{430.7081707317073, 306.}, {432., 306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{326.6341463414634, 153.}, {432., 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{326.6341463414634, 154.29182926829267`}, {
              326.6341463414634, 153.}}], 
             LineBox[{{331.9024390243902, 153.64591463414635`}, {
              331.9024390243902, 153.}}], 
             LineBox[{{337.1707317073171, 153.64591463414635`}, {
              337.1707317073171, 153.}}], 
             LineBox[{{342.4390243902439, 153.64591463414635`}, {
              342.4390243902439, 153.}}], 
             LineBox[{{347.7073170731707, 154.29182926829267`}, {
              347.7073170731707, 153.}}], 
             LineBox[{{352.9756097560976, 153.64591463414635`}, {
              352.9756097560976, 153.}}], 
             LineBox[{{358.2439024390244, 153.64591463414635`}, {
              358.2439024390244, 153.}}], 
             LineBox[{{363.5121951219512, 153.64591463414635`}, {
              363.5121951219512, 153.}}], 
             LineBox[{{368.780487804878, 154.29182926829267`}, {
              368.780487804878, 153.}}], 
             LineBox[{{374.0487804878049, 153.64591463414635`}, {
              374.0487804878049, 153.}}], 
             LineBox[{{379.3170731707317, 153.64591463414635`}, {
              379.3170731707317, 153.}}], 
             LineBox[{{384.5853658536585, 153.64591463414635`}, {
              384.5853658536585, 153.}}], 
             LineBox[{{389.8536585365854, 154.29182926829267`}, {
              389.8536585365854, 153.}}], 
             LineBox[{{395.1219512195122, 153.64591463414635`}, {
              395.1219512195122, 153.}}], 
             LineBox[{{400.390243902439, 153.64591463414635`}, {
              400.390243902439, 153.}}], 
             LineBox[{{405.6585365853659, 153.64591463414635`}, {
              405.6585365853659, 153.}}], 
             LineBox[{{410.9268292682927, 154.29182926829267`}, {
              410.9268292682927, 153.}}], 
             LineBox[{{416.1951219512195, 153.64591463414635`}, {
              416.1951219512195, 153.}}], 
             LineBox[{{421.4634146341464, 153.64591463414635`}, {
              421.4634146341464, 153.}}], 
             LineBox[{{426.7317073170732, 153.64591463414635`}, {
              426.7317073170732, 153.}}], 
             LineBox[{{432., 154.29182926829267`}, {432., 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{326.6341463414634, 306.}, {432., 306.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{326.6341463414634, 304.7081707317073}, {
              326.6341463414634, 306.}}], 
             LineBox[{{331.9024390243902, 305.3540853658537}, {
              331.9024390243902, 306.}}], 
             LineBox[{{337.1707317073171, 305.3540853658537}, {
              337.1707317073171, 306.}}], 
             LineBox[{{342.4390243902439, 305.3540853658537}, {
              342.4390243902439, 306.}}], 
             LineBox[{{347.7073170731707, 304.7081707317073}, {
              347.7073170731707, 306.}}], 
             LineBox[{{352.9756097560976, 305.3540853658537}, {
              352.9756097560976, 306.}}], 
             LineBox[{{358.2439024390244, 305.3540853658537}, {
              358.2439024390244, 306.}}], 
             LineBox[{{363.5121951219512, 305.3540853658537}, {
              363.5121951219512, 306.}}], 
             LineBox[{{368.780487804878, 304.7081707317073}, {
              368.780487804878, 306.}}], 
             LineBox[{{374.0487804878049, 305.3540853658537}, {
              374.0487804878049, 306.}}], 
             LineBox[{{379.3170731707317, 305.3540853658537}, {
              379.3170731707317, 306.}}], 
             LineBox[{{384.5853658536585, 305.3540853658537}, {
              384.5853658536585, 306.}}], 
             LineBox[{{389.8536585365854, 304.7081707317073}, {
              389.8536585365854, 306.}}], 
             LineBox[{{395.1219512195122, 305.3540853658537}, {
              395.1219512195122, 306.}}], 
             LineBox[{{400.390243902439, 305.3540853658537}, {
              400.390243902439, 306.}}], 
             LineBox[{{405.6585365853659, 305.3540853658537}, {
              405.6585365853659, 306.}}], 
             LineBox[{{410.9268292682927, 304.7081707317073}, {
              410.9268292682927, 306.}}], 
             LineBox[{{416.1951219512195, 305.3540853658537}, {
              416.1951219512195, 306.}}], 
             LineBox[{{421.4634146341464, 305.3540853658537}, {
              421.4634146341464, 306.}}], 
             LineBox[{{426.7317073170732, 305.3540853658537}, {
              426.7317073170732, 306.}}], 
             LineBox[{{432., 304.7081707317073}, {432., 306.}}]}},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], 
          RectangleBox[{221.26829268292687`, 0.}, {326.6341463414634, 153.}]},
          InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{105.36585365853654`, 153.},
           
           PlotRange->{{221.26829268292687`, 326.6341463414634}, {0., 
            153.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox[
                 TemplateBox[{"\"(\"","\"c\"","\")\""},
                  "RowDefault"],
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->16,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {236.26829268292687`, 138.}, {0, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox[
                TemplateBox[{"\"(\"","\"c\"","\")\""},
                 "RowDefault"],
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->16,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {236.26829268292687`, 138.}, {0, 0}, 
             Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{221.26829268292687`, 0.}, {221.26829268292687`, 
              153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{222.56012195121954`, 0.}, {221.26829268292687`, 0.}}], 
             LineBox[{{221.91420731707322`, 7.65}, {221.26829268292687`, 
              7.65}}], 
             LineBox[{{221.91420731707322`, 15.3}, {221.26829268292687`, 
              15.3}}], 
             LineBox[{{221.91420731707322`, 22.950000000000003`}, {
              221.26829268292687`, 22.950000000000003`}}], 
             LineBox[{{222.56012195121954`, 30.6}, {221.26829268292687`, 
              30.6}}], 
             LineBox[{{221.91420731707322`, 38.25}, {221.26829268292687`, 
              38.25}}], 
             LineBox[{{221.91420731707322`, 45.900000000000006`}, {
              221.26829268292687`, 45.900000000000006`}}], 
             LineBox[{{221.91420731707322`, 53.550000000000004`}, {
              221.26829268292687`, 53.550000000000004`}}], 
             LineBox[{{222.56012195121954`, 61.2}, {221.26829268292687`, 
              61.2}}], 
             LineBox[{{221.91420731707322`, 68.85000000000001}, {
              221.26829268292687`, 68.85000000000001}}], 
             LineBox[{{221.91420731707322`, 76.5}, {221.26829268292687`, 
              76.5}}], 
             LineBox[{{221.91420731707322`, 84.15}, {221.26829268292687`, 
              84.15}}], 
             LineBox[{{222.56012195121954`, 91.80000000000001}, {
              221.26829268292687`, 91.80000000000001}}], 
             LineBox[{{221.91420731707322`, 99.45000000000002}, {
              221.26829268292687`, 99.45000000000002}}], 
             LineBox[{{221.91420731707322`, 107.10000000000001`}, {
              221.26829268292687`, 107.10000000000001`}}], 
             LineBox[{{221.91420731707322`, 114.75000000000001`}, {
              221.26829268292687`, 114.75000000000001`}}], 
             LineBox[{{222.56012195121954`, 122.4}, {221.26829268292687`, 
              122.4}}], 
             LineBox[{{221.91420731707322`, 130.05}, {221.26829268292687`, 
              130.05}}], 
             LineBox[{{221.91420731707322`, 137.70000000000002`}, {
              221.26829268292687`, 137.70000000000002`}}], 
             LineBox[{{221.91420731707322`, 145.35000000000002`}, {
              221.26829268292687`, 145.35000000000002`}}], 
             LineBox[{{222.56012195121954`, 153.}, {221.26829268292687`, 
              153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{326.6341463414634, 0.}, {326.6341463414634, 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{325.3423170731707, 0.}, {326.6341463414634, 0.}}], 
             LineBox[{{325.9882317073171, 7.65}, {326.6341463414634, 7.65}}], 
             LineBox[{{325.9882317073171, 15.3}, {326.6341463414634, 15.3}}], 
             LineBox[{{325.9882317073171, 22.950000000000003`}, {
              326.6341463414634, 22.950000000000003`}}], 
             LineBox[{{325.3423170731707, 30.6}, {326.6341463414634, 30.6}}], 
             LineBox[{{325.9882317073171, 38.25}, {326.6341463414634, 
              38.25}}], 
             LineBox[{{325.9882317073171, 45.900000000000006`}, {
              326.6341463414634, 45.900000000000006`}}], 
             LineBox[{{325.9882317073171, 53.550000000000004`}, {
              326.6341463414634, 53.550000000000004`}}], 
             LineBox[{{325.3423170731707, 61.2}, {326.6341463414634, 61.2}}], 
             LineBox[{{325.9882317073171, 68.85000000000001}, {
              326.6341463414634, 68.85000000000001}}], 
             LineBox[{{325.9882317073171, 76.5}, {326.6341463414634, 76.5}}], 
             LineBox[{{325.9882317073171, 84.15}, {326.6341463414634, 
              84.15}}], 
             LineBox[{{325.3423170731707, 91.80000000000001}, {
              326.6341463414634, 91.80000000000001}}], 
             LineBox[{{325.9882317073171, 99.45000000000002}, {
              326.6341463414634, 99.45000000000002}}], 
             LineBox[{{325.9882317073171, 107.10000000000001`}, {
              326.6341463414634, 107.10000000000001`}}], 
             LineBox[{{325.9882317073171, 114.75000000000001`}, {
              326.6341463414634, 114.75000000000001`}}], 
             LineBox[{{325.3423170731707, 122.4}, {326.6341463414634, 
              122.4}}], 
             LineBox[{{325.9882317073171, 130.05}, {326.6341463414634, 
              130.05}}], 
             LineBox[{{325.9882317073171, 137.70000000000002`}, {
              326.6341463414634, 137.70000000000002`}}], 
             LineBox[{{325.9882317073171, 145.35000000000002`}, {
              326.6341463414634, 145.35000000000002`}}], 
             LineBox[{{325.3423170731707, 153.}, {326.6341463414634, 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{221.26829268292687`, 0.}, {326.6341463414634, 0.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{221.26829268292687`, 1.2918292682926826`}, {
              221.26829268292687`, 0.}}], 
             LineBox[{{226.53658536585368`, 0.6459146341463413}, {
              226.53658536585368`, 0.}}], 
             LineBox[{{231.80487804878052`, 0.6459146341463413}, {
              231.80487804878052`, 0.}}], 
             LineBox[{{237.07317073170736`, 0.6459146341463413}, {
              237.07317073170736`, 0.}}], 
             LineBox[{{242.34146341463418`, 1.2918292682926826`}, {
              242.34146341463418`, 0.}}], 
             LineBox[{{247.609756097561, 0.6459146341463413}, {
              247.609756097561, 0.}}], 
             LineBox[{{252.87804878048783`, 0.6459146341463413}, {
              252.87804878048783`, 0.}}], 
             LineBox[{{258.1463414634147, 0.6459146341463413}, {
              258.1463414634147, 0.}}], 
             LineBox[{{263.4146341463415, 1.2918292682926826`}, {
              263.4146341463415, 0.}}], 
             LineBox[{{268.6829268292683, 0.6459146341463413}, {
              268.6829268292683, 0.}}], 
             LineBox[{{273.95121951219517`, 0.6459146341463413}, {
              273.95121951219517`, 0.}}], 
             LineBox[{{279.219512195122, 0.6459146341463413}, {
              279.219512195122, 0.}}], 
             LineBox[{{284.4878048780488, 1.2918292682926826`}, {
              284.4878048780488, 0.}}], 
             LineBox[{{289.7560975609756, 0.6459146341463413}, {
              289.7560975609756, 0.}}], 
             LineBox[{{295.0243902439024, 0.6459146341463413}, {
              295.0243902439024, 0.}}], 
             LineBox[{{300.2926829268293, 0.6459146341463413}, {
              300.2926829268293, 0.}}], 
             LineBox[{{305.5609756097561, 1.2918292682926826`}, {
              305.5609756097561, 0.}}], 
             LineBox[{{310.82926829268297`, 0.6459146341463413}, {
              310.82926829268297`, 0.}}], 
             LineBox[{{316.0975609756098, 0.6459146341463413}, {
              316.0975609756098, 0.}}], 
             LineBox[{{321.3658536585366, 0.6459146341463413}, {
              321.3658536585366, 0.}}], 
             LineBox[{{326.6341463414634, 1.2918292682926826`}, {
              326.6341463414634, 0.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{221.26829268292687`, 153.}, {326.6341463414634, 
              153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{221.26829268292687`, 151.70817073170733`}, {
              221.26829268292687`, 153.}}], 
             LineBox[{{226.53658536585368`, 152.35408536585365`}, {
              226.53658536585368`, 153.}}], 
             LineBox[{{231.80487804878052`, 152.35408536585365`}, {
              231.80487804878052`, 153.}}], 
             LineBox[{{237.07317073170736`, 152.35408536585365`}, {
              237.07317073170736`, 153.}}], 
             LineBox[{{242.34146341463418`, 151.70817073170733`}, {
              242.34146341463418`, 153.}}], 
             LineBox[{{247.609756097561, 152.35408536585365`}, {
              247.609756097561, 153.}}], 
             LineBox[{{252.87804878048783`, 152.35408536585365`}, {
              252.87804878048783`, 153.}}], 
             LineBox[{{258.1463414634147, 152.35408536585365`}, {
              258.1463414634147, 153.}}], 
             LineBox[{{263.4146341463415, 151.70817073170733`}, {
              263.4146341463415, 153.}}], 
             LineBox[{{268.6829268292683, 152.35408536585365`}, {
              268.6829268292683, 153.}}], 
             LineBox[{{273.95121951219517`, 152.35408536585365`}, {
              273.95121951219517`, 153.}}], 
             LineBox[{{279.219512195122, 152.35408536585365`}, {
              279.219512195122, 153.}}], 
             LineBox[{{284.4878048780488, 151.70817073170733`}, {
              284.4878048780488, 153.}}], 
             LineBox[{{289.7560975609756, 152.35408536585365`}, {
              289.7560975609756, 153.}}], 
             LineBox[{{295.0243902439024, 152.35408536585365`}, {
              295.0243902439024, 153.}}], 
             LineBox[{{300.2926829268293, 152.35408536585365`}, {
              300.2926829268293, 153.}}], 
             LineBox[{{305.5609756097561, 151.70817073170733`}, {
              305.5609756097561, 153.}}], 
             LineBox[{{310.82926829268297`, 152.35408536585365`}, {
              310.82926829268297`, 153.}}], 
             LineBox[{{316.0975609756098, 152.35408536585365`}, {
              316.0975609756098, 153.}}], 
             LineBox[{{321.3658536585366, 152.35408536585365`}, {
              321.3658536585366, 153.}}], 
             LineBox[{{326.6341463414634, 151.70817073170733`}, {
              326.6341463414634, 153.}}]}, InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 0.}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.2\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 30.6}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.4\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 61.2}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.6\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {220.26829268292687`, 91.80000000000001}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.8\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 122.4}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"1.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 153.}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {221.26829268292687`, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.2\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {242.34146341463418`, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.4\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {263.4146341463415, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.6\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {284.4878048780488, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.8\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {305.5609756097561, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"1.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {326.6341463414634, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 0.}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.2\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 30.6}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.4\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 61.2}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.6\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              
              StripOnInput->
               False], {220.26829268292687`, 91.80000000000001}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.8\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 122.4}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"1.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {220.26829268292687`, 153.}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {221.26829268292687`, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.2\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {242.34146341463418`, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.4\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {263.4146341463415, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.6\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {284.4878048780488, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.8\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {305.5609756097561, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"1.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {326.6341463414634, -1.}, {0, 1}, 
             Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], 
          RectangleBox[{326.6341463414634, 0.}, {432., 153.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{105.3658536585366, 153.},
           
           PlotRange->{{326.6341463414634, 432.}, {0., 
            153.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox[
                 TemplateBox[{"\"(\"","\"d\"","\")\""},
                  "RowDefault"],
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->16,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {341.6341463414634, 138.}, {0, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox[
                TemplateBox[{"\"(\"","\"d\"","\")\""},
                 "RowDefault"],
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->16,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {341.6341463414634, 138.}, {0, 0}, 
             Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{326.6341463414634, 0.}, {326.6341463414634, 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{327.9259756097561, 0.}, {326.6341463414634, 0.}}], 
             LineBox[{{327.28006097560973`, 7.65}, {326.6341463414634, 
              7.65}}], 
             LineBox[{{327.28006097560973`, 15.3}, {326.6341463414634, 
              15.3}}], 
             LineBox[{{327.28006097560973`, 22.950000000000003`}, {
              326.6341463414634, 22.950000000000003`}}], 
             LineBox[{{327.9259756097561, 30.6}, {326.6341463414634, 30.6}}], 
             LineBox[{{327.28006097560973`, 38.25}, {326.6341463414634, 
              38.25}}], 
             LineBox[{{327.28006097560973`, 45.900000000000006`}, {
              326.6341463414634, 45.900000000000006`}}], 
             LineBox[{{327.28006097560973`, 53.550000000000004`}, {
              326.6341463414634, 53.550000000000004`}}], 
             LineBox[{{327.9259756097561, 61.2}, {326.6341463414634, 61.2}}], 
             LineBox[{{327.28006097560973`, 68.85000000000001}, {
              326.6341463414634, 68.85000000000001}}], 
             LineBox[{{327.28006097560973`, 76.5}, {326.6341463414634, 
              76.5}}], 
             LineBox[{{327.28006097560973`, 84.15}, {326.6341463414634, 
              84.15}}], 
             LineBox[{{327.9259756097561, 91.80000000000001}, {
              326.6341463414634, 91.80000000000001}}], 
             LineBox[{{327.28006097560973`, 99.45000000000002}, {
              326.6341463414634, 99.45000000000002}}], 
             LineBox[{{327.28006097560973`, 107.10000000000001`}, {
              326.6341463414634, 107.10000000000001`}}], 
             LineBox[{{327.28006097560973`, 114.75000000000001`}, {
              326.6341463414634, 114.75000000000001`}}], 
             LineBox[{{327.9259756097561, 122.4}, {326.6341463414634, 
              122.4}}], 
             LineBox[{{327.28006097560973`, 130.05}, {326.6341463414634, 
              130.05}}], 
             LineBox[{{327.28006097560973`, 137.70000000000002`}, {
              326.6341463414634, 137.70000000000002`}}], 
             LineBox[{{327.28006097560973`, 145.35000000000002`}, {
              326.6341463414634, 145.35000000000002`}}], 
             LineBox[{{327.9259756097561, 153.}, {326.6341463414634, 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{432., 0.}, {432., 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{430.7081707317073, 0.}, {432., 0.}}], 
             LineBox[{{431.3540853658537, 7.65}, {432., 7.65}}], 
             LineBox[{{431.3540853658537, 15.3}, {432., 15.3}}], 
             LineBox[{{431.3540853658537, 22.950000000000003`}, {432., 
              22.950000000000003`}}], 
             LineBox[{{430.7081707317073, 30.6}, {432., 30.6}}], 
             LineBox[{{431.3540853658537, 38.25}, {432., 38.25}}], 
             LineBox[{{431.3540853658537, 45.900000000000006`}, {432., 
              45.900000000000006`}}], 
             LineBox[{{431.3540853658537, 53.550000000000004`}, {432., 
              53.550000000000004`}}], 
             LineBox[{{430.7081707317073, 61.2}, {432., 61.2}}], 
             LineBox[{{431.3540853658537, 68.85000000000001}, {432., 
              68.85000000000001}}], 
             LineBox[{{431.3540853658537, 76.5}, {432., 76.5}}], 
             LineBox[{{431.3540853658537, 84.15}, {432., 84.15}}], 
             LineBox[{{430.7081707317073, 91.80000000000001}, {432., 
              91.80000000000001}}], 
             LineBox[{{431.3540853658537, 99.45000000000002}, {432., 
              99.45000000000002}}], 
             LineBox[{{431.3540853658537, 107.10000000000001`}, {432., 
              107.10000000000001`}}], 
             LineBox[{{431.3540853658537, 114.75000000000001`}, {432., 
              114.75000000000001`}}], 
             LineBox[{{430.7081707317073, 122.4}, {432., 122.4}}], 
             LineBox[{{431.3540853658537, 130.05}, {432., 130.05}}], 
             LineBox[{{431.3540853658537, 137.70000000000002`}, {432., 
              137.70000000000002`}}], 
             LineBox[{{431.3540853658537, 145.35000000000002`}, {432., 
              145.35000000000002`}}], 
             LineBox[{{430.7081707317073, 153.}, {432., 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{326.6341463414634, 0.}, {432., 0.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{326.6341463414634, 1.291829268292683}, {
              326.6341463414634, 0.}}], 
             LineBox[{{331.9024390243902, 0.6459146341463415}, {
              331.9024390243902, 0.}}], 
             LineBox[{{337.1707317073171, 0.6459146341463415}, {
              337.1707317073171, 0.}}], 
             LineBox[{{342.4390243902439, 0.6459146341463415}, {
              342.4390243902439, 0.}}], 
             LineBox[{{347.7073170731707, 1.291829268292683}, {
              347.7073170731707, 0.}}], 
             LineBox[{{352.9756097560976, 0.6459146341463415}, {
              352.9756097560976, 0.}}], 
             LineBox[{{358.2439024390244, 0.6459146341463415}, {
              358.2439024390244, 0.}}], 
             LineBox[{{363.5121951219512, 0.6459146341463415}, {
              363.5121951219512, 0.}}], 
             LineBox[{{368.780487804878, 1.291829268292683}, {
              368.780487804878, 0.}}], 
             LineBox[{{374.0487804878049, 0.6459146341463415}, {
              374.0487804878049, 0.}}], 
             LineBox[{{379.3170731707317, 0.6459146341463415}, {
              379.3170731707317, 0.}}], 
             LineBox[{{384.5853658536585, 0.6459146341463415}, {
              384.5853658536585, 0.}}], 
             LineBox[{{389.8536585365854, 1.291829268292683}, {
              389.8536585365854, 0.}}], 
             LineBox[{{395.1219512195122, 0.6459146341463415}, {
              395.1219512195122, 0.}}], 
             LineBox[{{400.390243902439, 0.6459146341463415}, {
              400.390243902439, 0.}}], 
             LineBox[{{405.6585365853659, 0.6459146341463415}, {
              405.6585365853659, 0.}}], 
             LineBox[{{410.9268292682927, 1.291829268292683}, {
              410.9268292682927, 0.}}], 
             LineBox[{{416.1951219512195, 0.6459146341463415}, {
              416.1951219512195, 0.}}], 
             LineBox[{{421.4634146341464, 0.6459146341463415}, {
              421.4634146341464, 0.}}], 
             LineBox[{{426.7317073170732, 0.6459146341463415}, {
              426.7317073170732, 0.}}], 
             LineBox[{{432., 1.291829268292683}, {432., 0.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{326.6341463414634, 153.}, {432., 153.}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{326.6341463414634, 151.70817073170733`}, {
              326.6341463414634, 153.}}], 
             LineBox[{{331.9024390243902, 152.35408536585365`}, {
              331.9024390243902, 153.}}], 
             LineBox[{{337.1707317073171, 152.35408536585365`}, {
              337.1707317073171, 153.}}], 
             LineBox[{{342.4390243902439, 152.35408536585365`}, {
              342.4390243902439, 153.}}], 
             LineBox[{{347.7073170731707, 151.70817073170733`}, {
              347.7073170731707, 153.}}], 
             LineBox[{{352.9756097560976, 152.35408536585365`}, {
              352.9756097560976, 153.}}], 
             LineBox[{{358.2439024390244, 152.35408536585365`}, {
              358.2439024390244, 153.}}], 
             LineBox[{{363.5121951219512, 152.35408536585365`}, {
              363.5121951219512, 153.}}], 
             LineBox[{{368.780487804878, 151.70817073170733`}, {
              368.780487804878, 153.}}], 
             LineBox[{{374.0487804878049, 152.35408536585365`}, {
              374.0487804878049, 153.}}], 
             LineBox[{{379.3170731707317, 152.35408536585365`}, {
              379.3170731707317, 153.}}], 
             LineBox[{{384.5853658536585, 152.35408536585365`}, {
              384.5853658536585, 153.}}], 
             LineBox[{{389.8536585365854, 151.70817073170733`}, {
              389.8536585365854, 153.}}], 
             LineBox[{{395.1219512195122, 152.35408536585365`}, {
              395.1219512195122, 153.}}], 
             LineBox[{{400.390243902439, 152.35408536585365`}, {
              400.390243902439, 153.}}], 
             LineBox[{{405.6585365853659, 152.35408536585365`}, {
              405.6585365853659, 153.}}], 
             LineBox[{{410.9268292682927, 151.70817073170733`}, {
              410.9268292682927, 153.}}], 
             LineBox[{{416.1951219512195, 152.35408536585365`}, {
              416.1951219512195, 153.}}], 
             LineBox[{{421.4634146341464, 152.35408536585365`}, {
              421.4634146341464, 153.}}], 
             LineBox[{{426.7317073170732, 152.35408536585365`}, {
              426.7317073170732, 153.}}], 
             LineBox[{{432., 151.70817073170733`}, {432., 153.}}]}, InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {326.6341463414634, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.2\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {347.7073170731707, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.4\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {368.780487804878, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.6\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {389.8536585365854, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"0.8\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {410.9268292682927, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"1.0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->13.6,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {432., -1.}, {0, 1}, Automatic, {1, 0}], 
            InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {326.6341463414634, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.2\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {347.7073170731707, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.4\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {368.780487804878, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.6\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {389.8536585365854, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"0.8\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {410.9268292682927, -1.}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"1.0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->13.6,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {432., -1.}, {0, 1}, Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}},
       Frame->False,
       ImageSize->{210.73170731707313`, 306.},
       PlotRange->{{221.26829268292687`, 432.}, {0., 
        306.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{221.26829268292687`, 0.}, {221.26829268292687`, 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{432., 0.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{221.26829268292687`, 0.}, {432., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{221.26829268292687`, 306.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.78125,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 450.},
  PlotRange->{{-72, 504}, {-72., 378.}}]], "Output",
 CellChangeTimes->{
  3.6007156738516407`*^9, 3.6007157050048957`*^9, {3.6007157431937623`*^9, 
   3.6007157625377965`*^9}, {3.6007157947830534`*^9, 
   3.6007158215995007`*^9}, {3.600716079499153*^9, 3.600716105005198*^9}, 
   3.6007166472787504`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->None,
WindowSize->{1912, 1092},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
PageHeaders->{{None, None, None}, {None, None, None}},
PrintingOptions->{"FacingPages"->False,
"FirstPageHeader"->True,
"PrintCellBrackets"->False,
"PrintMultipleHorizontalPages"->False,
"PrintRegistrationMarks"->False,
"PrintingMargins"->{{71.875, 71.875}, {53.875, 53.875}}},
ShowSelection->True,
Magnification->1.25,
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 466, 8, 69, "Text"],
Cell[1014, 30, 806, 14, 55, "Text"],
Cell[CellGroupData[{
Cell[1845, 48, 41, 0, 88, "Section"],
Cell[1889, 50, 569, 12, 34, "Text"],
Cell[CellGroupData[{
Cell[2483, 66, 224, 4, 35, "Input"],
Cell[2710, 72, 42364, 786, 133, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[45123, 864, 108, 3, 88, "Section"],
Cell[CellGroupData[{
Cell[45256, 871, 164, 2, 46, "Subsection"],
Cell[CellGroupData[{
Cell[45445, 877, 7625, 163, 1026, "Input"],
Cell[53073, 1042, 152519, 2997, 641, 136001, 2726, "CachedBoxData", \
"BoxData", "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[205641, 4045, 109, 1, 57, "Subsection"],
Cell[CellGroupData[{
Cell[205775, 4050, 6319, 127, 815, "Input"],
Cell[212097, 4179, 147705, 2639, 641, 132208, 2384, "CachedBoxData", \
"BoxData", "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[359851, 6824, 134, 1, 46, "Subsection"],
Cell[CellGroupData[{
Cell[360010, 6829, 11414, 249, 1312, "Input"],
Cell[371427, 7080, 82860, 1980, 513, 74554, 1843, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[454348, 9067, 315, 4, 88, "Section"],
Cell[CellGroupData[{
Cell[454688, 9075, 164, 2, 46, "Subsection"],
Cell[CellGroupData[{
Cell[454877, 9081, 14632, 320, 1818, "Input"],
Cell[469512, 9403, 91886, 1789, 558, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[561447, 11198, 208, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[561680, 11206, 14416, 313, 2214, "Input"],
Cell[576099, 11521, 55481, 1143, 221, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[631629, 12670, 204, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[631858, 12678, 15976, 334, 1906, "Input"],
Cell[647837, 13014, 48711, 1194, 221, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[696597, 14214, 472, 8, 46, "Subsection"],
Cell[CellGroupData[{
Cell[697094, 14226, 15253, 303, 1136, "Input"],
Cell[712350, 14531, 36772, 953, 198, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[749183, 15491, 97, 1, 88, "Section"],
Cell[749283, 15494, 130, 3, 34, "Text"],
Cell[CellGroupData[{
Cell[749438, 15501, 187, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[749650, 15509, 2478, 51, 586, "Input"],
Cell[752131, 15562, 207309, 4663, 581, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
